package fme;

import java.util.*;
import javax.swing.*;
import java.lang.*;
import java.io.*;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.helpers.DefaultHandler;

import fme.XMLParser.xml_tag_handler;

import javax.xml.parsers.SAXParser;
import java.util.zip.*;
import java.util.Vector;


//------------------------------------------------------------------------------
// Registo - conjunto de campos.
//------------------------------------------------------------------------------

class CBRegisto extends XMLDataHandler implements CBData_Comum {

   //String tag;
   Vector Campos = new Vector();
   boolean started = false;
   
   public void add(CHCampo c) {
     Campos.addElement(c);
   }

   public void xmlValue(String path, String tag, String v) {
     //JOptionPane.showMessageDialog(null, "popo: xml-Value " + tag + " = " + v);

     CHCampo c = getByName(tag);
     if (c == null) return;
     if ( ! c.xml_enabled ) return;
     //c.v = v;
     c.setStringValue(v);
     //FILIPA
//     c.vldOnline();
   }

   public CHCampo getByName(String s) {
     int i;
     for(i=0; i<Campos.size(); i++) {
       String tag;
       tag = ((CHCampo)(Campos.elementAt(i))).tag;
       if(tag.equals(s)) return (CHCampo)(Campos.elementAt(i));
     }
     return null;
   }

   public String xmlPrintBegin(){
     return super.xmlPrintBegin() + "\n";
   }

   public String xmlPrint() {
	 
     String s = new String();
     int i;
     //s = "<" + tag +">";
     s = "";
     CHCampo c;
     for(i = 0;  i < Campos.size(); i++) {
       c = (CHCampo) Campos.elementAt(i);
       if ( c.xml_enabled ) {
         s += _lib.xml_encode(c.tag, c.v);
       }
       if ( c.dh != null ) {
           s += c.dh.on_xml ( c.tag );
       }
     }
     return s;
   }

   void extract() {
     for(int i=0; i < Campos.size(); i++) {
       ((CHCampo) (Campos.elementAt(i))).extract();
     }
   }

   void Clear () {
     for(int i=0; i < Campos.size(); i++) {
       ((CHCampo) (Campos.elementAt(i))).clear();
     }
   }

   void on_update ( String tag ) {
   }


   
   String on_xml ( String tag ) {
     return "";
   }

   CHValid_Grp validar() {
     return null;
   }

   public void on_external_update ( String tag ) {
	   
   }
   
   public void locate ( CHValid_Msg m ) {
/*
     // JOptionPane.showMessageDialog( null, "ir para o campo: " + m.tag);
     String s = fmeFrame.Paginas.getTag();
     //JOptionPane.showMessageDialog( null, "pagina actual: " + s);

     if ( getPagina() == null ) {
       //JOptionPane.showMessageDialog(null, "pgina indefinida.");
       return;
     }

     if ( ! s.equals( getPagina() ) ) {
       //JOptionPane.showMessageDialog(null, "teria que mudar de pgina.");
       fmeFrame.Paginas.GoTo( getPagina() );
     }

     CHCampo c = this.getByName(m.tag);
     c.set_focus();
*/
   }

   public String getParam ( String param ) {
     return null;
   }

   public String getPagina () {
     return null;
   }

   boolean isEmpty () {
     for(int i=0; i < Campos.size(); i++) {
       CHCampo c = ((CHCampo) (Campos.elementAt(i)));
       if ( ! c.isEmpty() ) return false;
     }
     return true;
   }

}

 //------------------------------------------------------------
 // interface ler xml
 //-----------------------------------------------------------
 class XMLDataHandler {

   String tag;
   XMLParser xml_dh;
   
   public void xmlBegin(String path) {
     //JOptionPane.showMessageDialog(null, "default: xml-Begin " + path);
   }

   public void xmlEnd(String path) {
     //JOptionPane.showMessageDialog(null, "default: xml-End " + path );
   }

   public void xmlValue(String path, String tag, String v) {
     //JOptionPane.showMessageDialog(null, "default: xml-Value " + tag + " = " + v);
   }

   public String xmlPrintBegin() {
     return "<" + tag + ">";
   }

   public String xmlPrintEnd() {
     return "</" + tag + ">\n";
   }

   public String xmlPrint() {
     return "\n";
   }

   XMLDataHandler getHandler ( String path ) {
	   return null;
   }
   
 }

 //-----------------------------------------------------------------------------
 // XMLParser
 //-----------------------------------------------------------------------------

 class XMLParser {

   Vector tlist = new Vector();
   Stack stk = new Stack();
   //CBData cdata; 
   XMLDataHandler cdata;
   
   class xml_tag_handler {
     public String path;
     public XMLDataHandler handler;
     xml_tag_handler(String p, XMLDataHandler o) {
       path = p;
       handler = o;
     }
   }

   XMLParser(CBData_Noconfig d) {
	     cdata = d;
	     //JOptionPane.showMessageDialog(null, "XMLReader inicializado!");
	     tlist.add(new xml_tag_handler("//fme", d));
   }
   
   XMLParser(CBData d) {
     cdata = d;
     //JOptionPane.showMessageDialog(null, "XMLReader inicializado!");
     tlist.add(new xml_tag_handler("//fme", d));
     
     tlist.add(new xml_tag_handler("//fme/Parametros", d.Params));
     tlist.add(new xml_tag_handler("//fme/Declaracoes", d.Decl));

     tlist.add(new xml_tag_handler("//fme/Promotor", d.Promotor));
     tlist.add(new xml_tag_handler("//fme/Contacto", d.Contacto));
     tlist.add(new xml_tag_handler("//fme/Consultora", d.Consultora));
     tlist.add(new xml_tag_handler("//fme/PromCae", d.PromCae));
     tlist.add(new xml_tag_handler("//fme/PromLocal", d.PromLocal));

     tlist.add(new xml_tag_handler("//fme/Assoc", d.Assoc));
     tlist.add(new xml_tag_handler("//fme/RegimeIVA", d.IVA));
     
     tlist.add(new xml_tag_handler("//fme/RecomPME", d.RecomPME));
     tlist.add(new xml_tag_handler("//fme/Socios", d.Socios));
     tlist.add(new xml_tag_handler("//fme/Part", d.Participacoes));
     tlist.add(new xml_tag_handler("//fme/Dimensao", d.Dimensao));
     tlist.add(new xml_tag_handler("//fme/ParamProj", d.ParamProj));
     tlist.add(new xml_tag_handler("//fme/NivQual", d.NivQual));
     tlist.add(new xml_tag_handler("//fme/AutonomiaFinanc", d.AutoFin));

     tlist.add(new xml_tag_handler("//fme/TxtEvolucao", d.TxtEvolucao));
     tlist.add(new xml_tag_handler("//fme/TxtProdutos", d.TxtProdutos));

     tlist.add(new xml_tag_handler("//fme/Mercados", d.Mercados));
     tlist.add(new xml_tag_handler("//fme/Balanco", d.Balanco));
     tlist.add(new xml_tag_handler("//fme/DR", d.DR));
     tlist.add(new xml_tag_handler("//fme/PTrabalho", d.PTrabalho));

     tlist.add(new xml_tag_handler("//fme/EstrutIDT", d.EstrutIDT));
     tlist.add(new xml_tag_handler("//fme/PessoalIDT", d.PessoalIDT));
     tlist.add(new xml_tag_handler("//fme/ProdIDT", d.ProdIDT));
     tlist.add(new xml_tag_handler("//fme/InovaIDT", d.InovaIDT));
     tlist.add(new xml_tag_handler("//fme/RegPropIDT", d.RegPropIDT));
     tlist.add(new xml_tag_handler("//fme/OutrasIDT", d.OutrasIDT));
     tlist.add(new xml_tag_handler("//fme/CompetFin", d.CompetFin));

     tlist.add(new xml_tag_handler("//fme/Responsavel", d.Responsavel));
     tlist.add(new xml_tag_handler("//fme/DadosProjecto", d.DadosProjecto));
//   tlist.add(new xml_tag_handler("//fme/Tipologia", d.Tipologia));
     tlist.add(new xml_tag_handler("//fme/ProjCae", d.ProjCae));
     tlist.add(new xml_tag_handler("//fme/AreasTecno", d.AreasTecno));
     tlist.add(new xml_tag_handler("//fme/RedesIntID", d.RedesIntID));

     tlist.add(new xml_tag_handler("//fme/CaractProj1", d.CaractProj1));
     tlist.add(new xml_tag_handler("//fme/CaractProj2", d.CaractProj2));
     tlist.add(new xml_tag_handler("//fme/CaractProj3", d.CaractProj3));
     tlist.add(new xml_tag_handler("//fme/PlanoImpl", d.PlanoImpl));
     tlist.add(new xml_tag_handler("//fme/Professores", d.Professores));
     tlist.add(new xml_tag_handler("//fme/Fundamenta", d.Fundamenta));
     tlist.add(new xml_tag_handler("//fme/Incentivo75", d.Incentivo75));
     tlist.add(new xml_tag_handler("//fme/Estrutur75", d.Estrutur75));

     tlist.add(new xml_tag_handler("//fme/Tecnicos", d.Tecnicos));
     tlist.add(new xml_tag_handler("//fme/SubContrat", d.SubContrat));
     tlist.add(new xml_tag_handler("//fme/PessoalSC", d.PessoalSC));

     tlist.add(new xml_tag_handler("//fme/Caracteriza", d.Caracteriza));
     tlist.add(new xml_tag_handler("//fme/ActLista", d.ActLista));

     tlist.add(new xml_tag_handler("//fme/DescFisicaEmp", d.Emp));
     tlist.add(new xml_tag_handler("//fme/Areas", d.Areas));
     tlist.add(new xml_tag_handler("//fme/Capacidade", d.Capacidade));

     tlist.add(new xml_tag_handler("//fme/TxtAccoes", d.TxtAccoes));
     tlist.add(new xml_tag_handler("//fme/TxtJustifIncentivo", d.TxtJustifIncentivo));

     tlist.add(new xml_tag_handler("//fme/TxtCritQual", d.TxtCritQual));
     tlist.add(new xml_tag_handler("//fme/TxtCritConjunto", d.TxtCritConjunto));
     tlist.add(new xml_tag_handler("//fme/TxtCritInov", d.TxtCritInov));
     tlist.add(new xml_tag_handler("//fme/TxtCritInov_A", d.TxtCritInov_A));
     tlist.add(new xml_tag_handler("//fme/TxtCritInov_B", d.TxtCritInov_B));
     tlist.add(new xml_tag_handler("//fme/TxtCritInov_C", d.TxtCritInov_C));
     tlist.add(new xml_tag_handler("//fme/TxtCritInov_D", d.TxtCritInov_D));
     
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj1", d.TxtAccoesConj1));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj2", d.TxtAccoesConj2));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj3", d.TxtAccoesConj3));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj4", d.TxtAccoesConj4));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj5", d.TxtAccoesConj5));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj6", d.TxtAccoesConj6));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesConj7", d.TxtAccoesConj7));

     tlist.add(new xml_tag_handler("//fme/TxtAccoesInov1", d.TxtAccoesInov1));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesInov2", d.TxtAccoesInov2));
     tlist.add(new xml_tag_handler("//fme/TxtAccoesInov3", d.TxtAccoesInov3));

     tlist.add(new xml_tag_handler("//fme/TxtCritPME", d.TxtCritPME));
          
     tlist.add(new xml_tag_handler("//fme/Coop", d.Coop));
     tlist.add(new xml_tag_handler("//fme/ListaCoop", d.ListaCoop));
     
     tlist.add(new xml_tag_handler("//fme/EntExt", d.EntExt));
     tlist.add(new xml_tag_handler("//fme/TxtEntExt", d.EntExtTxt));
     tlist.add(new xml_tag_handler("//fme/EquipaCoord", d.EquipaCoord));
     tlist.add(new xml_tag_handler("//fme/TxtEquipaCoord", d.EquipaCoordTxt));

     tlist.add(new xml_tag_handler("//fme/Inv", d.QInv));
     tlist.add(new xml_tag_handler("//fme/TxtQInv", d.TxtQInv));
     tlist.add(new xml_tag_handler("//fme/Conjuntos", d.CaracConjuntos));
     tlist.add(new xml_tag_handler("//fme/PME", d.PME));
     tlist.add(new xml_tag_handler("//fme/Financ", d.Finan));
     tlist.add(new xml_tag_handler("//fme/TxtFinanc", d.FinanTxt));
     tlist.add(new xml_tag_handler("//fme/QuadrosTecn", d.QuadrosTecn));
     tlist.add(new xml_tag_handler("//fme/QuadrosTecn_Conj", d.QuadrosTecn_Conj));
     tlist.add(new xml_tag_handler("//fme/TxtQuadrosTecn", d.QuadrosTecnTxt));
//     tlist.add(new xml_tag_handler("//fme/FSE", d.FSE));
     
     tlist.add(new xml_tag_handler("//fme/Major", d.Major));
     tlist.add(new xml_tag_handler("//fme/MajorCoop", d.MajorCoop));
     tlist.add(new xml_tag_handler("//fme/MajorIDT", d.MajorIDT));

     tlist.add(new xml_tag_handler("//fme/RHumIDT", d.RHumIDT));
     tlist.add(new xml_tag_handler("//fme/DespesasIDT", d.DespesasIDT));
     tlist.add(new xml_tag_handler("//fme/ServicosIDT", d.ServicosIDT));
     tlist.add(new xml_tag_handler("//fme/ProjQuadroIDT", d.ProjQuadroIDT));
     tlist.add(new xml_tag_handler("//fme/PropIntelectual", d.PropIntelectual));
     tlist.add(new xml_tag_handler("//fme/BalTecnol", d.BalTecnol));
     tlist.add(new xml_tag_handler("//fme/OutrosIndic", d.OutrosIndic));
     
     tlist.add(new xml_tag_handler("//fme/AmbitoCentro", d.AmbitoCentro));
     tlist.add(new xml_tag_handler("//fme/EmpresasCentro", d.EmpresasCentro));

     tlist.add(new xml_tag_handler("//fme/ProjIDT", d.ProjIDT));
     tlist.add(new xml_tag_handler("//fme/TxtProjIDT", d.ProjIDTTxt));
     tlist.add(new xml_tag_handler("//fme/TxtProjIDT2", d.ProjIDTTxt2));
     tlist.add(new xml_tag_handler("//fme/TecnicosCentro", d.TecnicosCentro));

     tlist.add(new xml_tag_handler("//fme/TxtSistGestao", d.SistGestaoTxt));
     tlist.add(new xml_tag_handler("//fme/EquipCentro", d.EquipCentro));

     tlist.add(new xml_tag_handler("//fme/ActivIDT", d.ActivIDT));
     tlist.add(new xml_tag_handler("//fme/TxtActivIDT", d.ActivIDTTxt));

     tlist.add(new xml_tag_handler("//fme/QuadroSC", d.QuadroSC));

     tlist.add(new xml_tag_handler("//fme/Indicadores", d.IndicGerais));
     tlist.add(new xml_tag_handler("//fme/IndicadoresIDT", d.IndicIDT));
     tlist.add(new xml_tag_handler("//fme/TxtIndic", d.IndicTxt));

     /*     
     tlist.add(new xml_tag_handler("//sider-dta/DadosGerais", d.DadosGerais));
     tlist.add(new xml_tag_handler("//sider-dta/Prom", d.Promotor));
     tlist.add(new xml_tag_handler("//sider-dta/Prom/Contacto", d.Contacto));
     tlist.add(new xml_tag_handler("//sider-dta/Prom/Consultora", d.Consultora));
     tlist.add(new xml_tag_handler("//sider-dta/Prom/CAEs", d.PromCae));
     tlist.add(new xml_tag_handler("//sider-dta/Prom/Estabs", d.PromLocal));
     
     tlist.add(new xml_tag_handler("//sider-dta/Prom/Textos", d.PromTxt));
                
     tlist.add(new xml_tag_handler("//sider-dta/Proj", d.DadosProjecto));     
          
     tlist.add(new xml_tag_handler("//sider-dta/Proj/CAEs", d.ProjCae));

     //tlist.add(new xml_tag_handler("//sider-dta/Emp/Receitas", d.Receitas ));
  
     tlist.add(new xml_tag_handler("//sider-dta/Inv", d.QInv));

     tlist.add(new xml_tag_handler("//sider-dta/Contas", d.Contas));
     tlist.add(new xml_tag_handler("//sider-dta/Contas/Financ", d.Finan));
     tlist.add(new xml_tag_handler("//sider-dta/Contas/Balanco", d.Balanco));
     tlist.add(new xml_tag_handler("//sider-dta/Contas/Demo", d.DR));
*/
   }

   // procurar path ou entregar ao corrente
   public void xmlBegin(String path) {
     int i;
     for (i = 0; i < tlist.size(); i++) {
       String s = ( (xml_tag_handler) (tlist.elementAt(i))).path;
       if (path.equals(s)) {
         stk.push(tlist.elementAt(i));
         //JOptionPane.showMessageDialog(null, "push: " + path);
         return;
       }
     }
     //o corrente pode indicar um novo handler...
     
     XMLDataHandler h = ( (xml_tag_handler) (stk.peek())).handler.getHandler(path);
     if ( h != null ) {
    	 //JOptionPane.showMessageDialog(null, "habemus handler para " + path );
    	 xml_tag_handler xtg = new xml_tag_handler ( path, h);
    	 stk.push( xtg );
    	 return;
     }
     
     //xml_tag_handler h = new xml_tag_handler ()
     ( (xml_tag_handler) (stk.peek())).handler.xmlBegin(path);
     //JOptionPane.showMessageDialog(null, "xml-Begin " + path);
   }

   public void xmlEnd(String path) {
     //JOptionPane.showMessageDialog(null, "xml-End " + path );
     //((xml_tag_handler)(tlist.elementAt(0))).handler.xmlEnd(path);
     String s = ( (xml_tag_handler) (stk.peek())).path;
     if (path.equals(s)) {
       //JOptionPane.showMessageDialog(null, "pop: " + path);
       stk.pop();
       return;
     }
     ( (xml_tag_handler) (stk.peek())).handler.xmlEnd(path);
   }

   public void xmlValue(String path, String tag, String v) {
     //JOptionPane.showMessageDialog(null, "xml-Value " + tag + " = " + v);
     //v = _lib.xml_decode(v);
     if (stk.size() >= 1) {
       String s = ( (xml_tag_handler) (stk.peek())).path;
       //JOptionPane.showMessageDialog(null, "VALOR: " + path);
       ( (xml_tag_handler) (stk.peek())).handler.xmlValue(path, tag, v);
     }
     //((xml_tag_handler)(tlist.elementAt(0))).handler.xmlValue(path, tag, v);
   }

   public String xmlSave(String path) {
     int i;
     for (i = 0; i < tlist.size(); i++) {
       String s = ( (xml_tag_handler) (tlist.elementAt(i))).path;
       //JOptionPane.showMessageDialog(null, "xml-save: " + path + " i= " + Integer.toString(i));
       if (path.equals(s))break;
     }
     if (i == tlist.size())return "?";
     //System.out.print(path+"\n");
     //JOptionPane.showMessageDialog(null, "xml-save: " + path);
     // begin, corpo
     String xml;
     xml = ( (xml_tag_handler) (tlist.elementAt(i))).handler.xmlPrintBegin();
     xml = xml + ( (xml_tag_handler) (tlist.elementAt(i))).handler.xmlPrint();
     // interiores
     for (int k = 0; k < tlist.size(); k++) {
       String s = ( (xml_tag_handler) (tlist.elementAt(k))).path;
       //JOptionPane.showMessageDialog(null, "xml-save: " + path + " i= " + Integer.toString(i));
       if (s.startsWith(path) && s.lastIndexOf('/') == path.length()) {
         //JOptionPane.showMessageDialog(null, "xml-save REC: " + path + " + " + s);
         xml = xml + xmlSave(s);
       }
     }
     // end
     xml = xml + ( (xml_tag_handler) (tlist.elementAt(i))).handler.xmlPrintEnd();
     //JOptionPane.showMessageDialog(null, "xml-Save string: " + xml );

     return xml;
   }

   public void saveInFile(File file) {
     String path = file.getAbsolutePath();
     String extensao = (new XmlFileFilter()).getExtension();
     String xml;
     String dir = path.substring(0, path.length() - file.getName().length() - 1);

     Random x = new Random();
     int n = x.nextInt() % 9999;
     n = n < 0 ? -n : n;
     String s = "0000" + n;
     s = s.substring(s.length() - 4);
     xml = file.getName().substring(0, file.getName().length() - extensao.length()) + s + ".xml";

     // Escreve o XML
     try {
       //File outfile = new File(new File(".").getCanonicalPath() + "\\" + xml);
       File outfile = new File(dir + "\\" + xml);

       //JOptionPane.showMessageDialog(null, "Saving...");
       FileWriter out = new FileWriter(outfile);
       out.write("<?xml version='1.0' encoding='ISO-8859-1'?>\n");
       out.write(xmlSave("//fme"));
       out.flush();
       out.close();
       //JOptionPane.showMessageDialog(null, "Saving...done!");

       try {
         // Cria o ZIP
         final int BUFFER = 2048;
         byte data[] = new byte[BUFFER];
         File f_zip = new File(path);
         File f_xml = new File(new File(".").getCanonicalPath());

         FileOutputStream dest = new FileOutputStream(f_zip);
         ZipOutputStream zip_out = new ZipOutputStream(new BufferedOutputStream(dest));

         String files[] = {dir + "\\"+ xml};
         for (int i = 0; i < files.length; i++) {
//           System.out.println("Adding to zip: " + files[i]);
           FileInputStream fi = new FileInputStream(files[i]);
           BufferedInputStream origin = new BufferedInputStream(fi, BUFFER);
           //ZipEntry entry = new ZipEntry(new File(files[i]).getName());
           ZipEntry entry = new ZipEntry("fme.xml");
           //entry = new ZipEntry("formulario.xml");
           zip_out.putNextEntry(entry);
           int count;
           while ( (count = origin.read(data, 0, BUFFER)) != -1)
             zip_out.write(data, 0, count);
           origin.close();
         }
         zip_out.close();
         //apaga o ficheiro temporrio
         outfile.delete();
       }
       catch (IOException e2) {
         e2.printStackTrace();
         JOptionPane.showMessageDialog(null, "Erro a criar o ficheiro Zip!");
       }
     }
     catch (IOException e1) {
       e1.printStackTrace();
       JOptionPane.showMessageDialog(null, "Erro a criar o ficheiro Xml!");
     }
     fme.fmeFrame.LastFile = file;
   }

   public static void Open(File file) {
     String path = file.getAbsolutePath();
     String extensao = (new XmlFileFilter()).getExtension();
     String xml;

     if (! file.getAbsolutePath().endsWith(extensao)) {
       path += extensao;
       xml = file.getName() + ".xml" ;
       file.renameTo(new File(path));
     }
     else {
       xml = file.getName().substring(0, file.getName().length()-extensao.length()) + ".xml";
     }

     if (! (new File(path)).exists()){
       JOptionPane.showMessageDialog(null, path + "\nO ficheiro no foi encontrado!");
       return;
     }


     //Ler do ficheiro ZIP

     try {
       // Open the ZIP file
       ZipInputStream in = new ZipInputStream(new FileInputStream(path));

       // Get the first entry
       ZipEntry entry = in.getNextEntry();

       // Open the output file
       File xml_ = new File(xml);
       OutputStream out = new FileOutputStream(xml_);

       // Transfer bytes from the ZIP file to the output file
       byte[] buf = new byte[1024];
       int len;
       while ( (len = in.read(buf)) > 0) {
         out.write(buf, 0, len);
       }

       // Close the streams
       out.close();
       in.close();

       // Ler o XML
       DefaultHandler handler = new CParse();
       SAXParserFactory factory = SAXParserFactory.newInstance();
       try {
    	 SAXParser saxParser = factory.newSAXParser();
         saxParser.parse(new File(xml), handler);
       } catch (Throwable t) {
         JOptionPane.showMessageDialog(null, "Erro ao abrir ficheiro!");
         t.printStackTrace();
       }
       //JOptionPane.showMessageDialog(null, "lido!");
       xml_.delete();

     } catch (IOException e) {
    	 System.out.print(e);
     }
     fme.fmeFrame.LastFile = file;
   }

 }

 //-----------------------------------------------------------------------------
 // CBTabela - DADOS
 //-----------------------------------------------------------------------------

class CHTabColModel {
  String col_tag;
  boolean xml_enabled;
  boolean editable;
  boolean visible;
  String col_name;
  CFType vld;
  int t_col;                //coluna da jTabela
  String autocalc;
  boolean disable_row_calc;
  boolean is_check;

  CHTabColModel ( String _tag, String _name, boolean _xml, boolean _editable, boolean _visible, CFType _v ) {
    col_tag = _tag;
    col_name = "<html><div align='center'>" + _name + "</div></html>";
    xml_enabled = _xml;
    editable  = _editable;
    visible = _visible;
    vld = _v;
    autocalc = null;
    disable_row_calc = false;
    is_check = false;
  }

}


class CBTabela extends XMLDataHandler implements CBData_Comum {

  CHTabColModel [] cols;
  Vector dados = new Vector();
  int df_nlines;
  int keyCol;
  int idx_xml;
  CHTabela handler = null;
  boolean force_xml = false;
  GroupableTableHeaderUI ui = null;
  boolean started = false;
  
  public CBTabela() {
    idx_xml = -1;
    keyCol = -1;
  }


  void init_handler ( JTable _j ) {
    handler = new CHTabela();
    _init_handler( _j);

  }

  void init_handler ( CHTabela _handler, JTable _j) {
	    handler = _handler;
	    _init_handler (_j);
	  }
  void init_handler ( CHTabela _handler, JTable _j1, JTable _j2) {
	    handler = _handler;
	    _init_handler (_j1);
	    _init_handler (_j2);
	  }
  
  void _init_handler( JTable _j) {
    _j.setCellSelectionEnabled(false);
    _j.setRowSelectionAllowed(true);
    _j.setColumnSelectionAllowed(false);

    int nt_cols = 0;
    for ( int i = 0; i< cols.length; i ++) {
      if ( cols[i].visible ) cols[i].t_col = nt_cols++;
    }
    handler.cdx = new int [nt_cols];
    int n=0;
    for ( int i = 0; i< cols.length; i ++) {
      if ( cols[i].visible ) handler.cdx[n++] = i;
    }
    handler.setup( _j, this);
  }

  
  public String xmlPrint() {
    if (!started) return "";
    int i, j;
    int nRows = dados.size();
    int nCols = cols.length;
    String xml = new String();

    //JOptionPane.showMessageDialog(null, tag + ": so " + nRows + " linhas.");

    //xml = "<" + tag + ">";
    xml = "";
    for (i = 0; i < nRows; i++) {
      String xml_reg = new String();
      boolean has_data = false;
      xml_reg = "<Reg>\n";
      for (j = 0; j < nCols; j++) {
        if (cols[j].xml_enabled) {
          //JOptionPane.showMessageDialog(null, "col (" + j + ")" );
          String v;
          v = ( (String[]) dados.elementAt(i))[j];
          if ( ( force_xml || cols[j].editable ) && v.length() > 0)  has_data = true;
          xml_reg += _lib.xml_encode(cols[j].col_tag, v);
          xml_reg += on_xml( cols[j].col_tag, i, v);
        }
      }
      
      xml_reg += xmlPrintInternal( i );
      
      xml_reg += "</Reg>\n";
      if (has_data) xml += "\n" + xml_reg;
    }
    return xml;
  }

  String xmlPrintInternal( int row ) {
	  return "";
  }
    
  public void xmlBegin(String path) {
    //JOptionPane.showMessageDialog(null,"col_tabela: " + path  );	  
    idx_xml++;
    if (idx_xml >= dados.size()) add_row();
  }

  public void xmlValue(String path, String tag, String v) {

    String _v = v;
     //JOptionPane.showMessageDialog(null,"col_tabela: " + path + "/" + tag );
     //int i = dados.size()-1;
     int i = idx_xml; //estava -1 ???
     //JOptionPane.showMessageDialog(null,"xmlValue aponta para :  " + i );
     int j = getColIndex(tag);
     if (j < 0)return;

     if (j == keyCol) {
       //JOptionPane.showMessageDialog( null,"key: " + v + " para " + dados.size() + " matches" );
       for (int k = 0; k < dados.size(); k++) {
         //JOptionPane.showMessageDialog( null,"key: " + v + " vs codigo: " + ( (String[]) dados.elementAt(k))[keyCol] );
         if ( v.equals( ( (String[]) dados.elementAt(k))[keyCol]) ) {
           //JOptionPane.showMessageDialog(null, "match key de : " + ( (String[]) dados.elementAt(k))[1]);
           idx_xml = k;
           //JOptionPane.showMessageDialog(null, "idx_xml para :  " + idx_xml);
           return; // TESTE : big bug
         }
       }
     }

     //if ( ! cols[j].editable) return;
     if ( ! cols[j].xml_enabled ) return;
     //if ( tag.equals("n_ordem")) JOptionPane.showMessageDialog(null,"em: " + tag + " linha " + Integer.toString(i)  + "coluna " + Integer.toString(j) + " : " + v );

     // insert para limpar 0 esprios... vs 23-Ago-2005
     if ( v.equals("0") && cols[j].vld != null && cols[j].vld instanceof CFType_ValorS ) {
       //JOptionPane.showMessageDialog(null, "limpando " + v);
       v = "";
     }

     //FILIPA
     //PATH LEITURA FICHEIRO
     if ( handler instanceof CHTabQuadro && ((CHTabQuadro) handler).row_vld[i] != null ) {
         ( (CHTabQuadro) handler).row_vld[i].setString(v);
         v = ( (CHTabQuadro) handler).row_vld[i].getString();
         //JOptionPane.showMessageDialog(null, "limpando " + _v + " para " + v);
     }
     else if ( cols[j].vld != null ) {
       cols[j].vld.setString(v);
       v = cols[j].vld.getString();
       //JOptionPane.showMessageDialog(null, "limpando " + _v + " para " + v);
     }

     ( (String[]) dados.elementAt(i))[j] = v;

     //JOptionPane.showMessageDialog(null, "valor de " + tag + " para a linha " + Integer.toString(i)  + "coluna " + Integer.toString(j) + " : " + v );
     this.on_update(tag, i, v);
  }

   CHTabColModel getCol(String name) {
     for (int i = 0; i < cols.length; i++) {
       if (cols[i].col_tag.equals(name)) return cols[i];
     }
     return null;
   }

   int getColIndex (String name) {
     for (int i = 0; i < cols.length; i++) {
       if (cols[i].col_tag.equals(name))return i;
     }
     return -1;
   }

   int getColIndexByName (String name) {
	     for (int i = 0; i < cols.length; i++) {
	       if (cols[i].col_name.equals(name))return i;
	     }
	     return -1;
	   }

   void setColValue(String name, int i, String v) {
     int n = getColIndex(name);
     ( (String[]) dados.elementAt(i))[n] = v;
   }

   String getColValue(String name, int i) {
     int n = getColIndex(name);
     return ( (String[]) dados.elementAt(i))[n];
   }

   public void add_row() {
     String[] col = new String[cols.length];
     for (int j = 0; j < cols.length; j++)
       col[j] = "";
     dados.addElement(col);
   }

   public void ins_row_at(int n) { ins_row_at(n, true); }
   public void ins_row_at(int n, boolean remove_empty) {
     String[] col = new String[cols.length];
     for (int j = 0; j < cols.length; j++)
       col[j] = "";
     dados.insertElementAt(col, n);
     if (!remove_empty) return;
     for ( int i = dados.size()-1; i >n ; i-- ) {
       if ( this.isRowEmpty(i)) {
         //JOptionPane.showMessageDialog(null, "uma vazia..");
         del_row_at(i);
         break;
       }
     }
     int x = dados.size();
     //JOptionPane.showMessageDialog(null, "Size =  " + x);
   }

  public void del_row_at(int n) {
    dados.removeElementAt(n);
    if ( dados.size() < df_nlines ) {
      String[] col = new String[cols.length];
      for (int j = 0; j < cols.length; j++)
        col[j] = "";
      dados.addElement(col);
    }
  }

  void init_dados( int n ) {
     df_nlines = n;
     dados = new Vector();
     for (int i = 0; i < df_nlines; i++) {
       String[] col = new String[cols.length];
       for (int j = 0; j < cols.length; j++) {
         if ( cols[j].editable ) col[j] = "";
         if ( col[j] == null ) col[j] = "";
       }
       dados.addElement(col);
     }
  }

   public void Clear() {
	 this.handler.__garbage_stop_editing();
     for (int i = 0; i < dados.size(); i++)
       clearRow(i);
     idx_xml = -1;
     //init_handler(handler, handler.j);
     handler.j.repaint();
   }

   void clearRow( int i ) {
     for (int j = 0; j < cols.length; j++) {
       if (cols[j].editable) ( (String[]) dados.elementAt(i))[j] = "";
       if ( ((String[]) dados.elementAt(i))[j] == null ) ((String[]) dados.elementAt(i))[j] = "";
       on_update( cols[j].col_tag, i, "" );
     }
   }

   void on_update(String colname, int nRow, String v) {
   }

   public void on_external_update ( String tag ) {
  }
   
   String on_xml(String colname, int row, String v) {
     return "";
   }

   void validar() {
   }

   double getSum(String colName) {
     double v = 0;
     int n = getColIndex(colName);
     int classe = getColIndex("classe");
     int poc = getColIndex("poc");
     int i;
     String s;
     int nRows = dados.size();

     for (i = 0; i < nRows; i++) {
       s = ( (String[]) dados.elementAt(i))[n];
       if (s.length() > 0) {
         if (colName.equals("elegivel") &&
                 ((String[]) dados.elementAt(i))[classe].equals("999"))  // Despesa no elegvel
           continue;
         v = _lib.round(v + Double.parseDouble(s));
       }
     }
     return v;
   }

   double getSum(String colName, String ano) {
     double v = 0;
     int n = getColIndex(colName);
     int classe = getColIndex("classe");
     int poc = getColIndex("poc");
     int calend = getColIndex("calendario");
     int i;
     String s;
     int nRows = dados.size();

     for (i = 0; i < nRows; i++) {
       s = ( (String[]) dados.elementAt(i))[n];
       if (s.length() > 0) {
         if (colName.equals("elegivel") &&
             ((String[]) dados.elementAt(i))[classe].equals("999"))  // Despesa no elegvel
           continue;

         String s1 = ( (String[]) dados.elementAt(i))[calend];
         if ( s1.length() > 0 && s1.substring(0,4).equals(ano))
           v = _lib.round(v + Double.parseDouble(s));
       }
     }
     return v;
   }


   double getMax(String colName) {
     double v = 0;
     int n = getColIndex(colName);

     int i, j;
     String s;
     int nRows = dados.size();

     for (i = 0; i < nRows; i++) {
       s = ( (String[]) dados.elementAt(i))[n];
       if (s.length() > 0) {
         double vx = Double.parseDouble(s);
         if ( vx > v ) v = vx;
       }
     }
     return v;
   }

   boolean isUnique(String colName) {
     int n = getColIndex(colName);

     String s;
     int i, k;
     int nRows = dados.size();

     for (i = 0; i < nRows; i++) {
       for (k = i + 1; k < nRows; k++) {
         String s1 = ( (String[]) dados.elementAt(i))[n];
         String s2 = ( (String[]) dados.elementAt(k))[n];
         //JOptionPane.showMessageDialog(null, s1 + " vs " + s2 );
         if (s1.length() > 0 && s1.equals(s2))return false;
       }
     }
     return true;
   }

   // 1 linha incompleta
  TabError isIncomplet(String mask) {

    int nRows = dados.size();
    int i;
    for (i = 0; i < nRows; i++) {
      TabError e = isIncomplet ( i, mask );
      if (e != null ) return e;
    }
    return null;
  }

  TabError isIncomplet ( int row, String mask ) {
    int nCols = cols.length;
    boolean has_line = false;
    int j;
    String s;
    for (j = 0; j < nCols && !has_line; j++) {
      s = ( (String[]) dados.elementAt(row))[j];
      if (s != null && s.length() > 0){
        has_line = true;
      }
    }
    
    for (j = 0; j < nCols; j++) {
      s = ( (String[]) dados.elementAt(row))[j];
	  //JOptionPane.showMessageDialog(null, "S('"+j+"') = '"+s+"'");
      if (has_line && s.length() == 0 && mask.charAt(j) == 'R')
        return new TabError ( row, j, 'R', cols[j].col_tag, cols[j].col_name);
      if (s.length()> 0 && mask.charAt(j) == 'N')
        return new TabError ( row, j, 'N', cols[j].col_tag, cols[j].col_name);
    }
    return null;
  }

  TabError [] isIncompletAll ( int row, String mask ) {
    int nCols = cols.length;
    boolean has_line = false;
    int j;
    String s;
    for (j = 0; j < nCols && !has_line; j++) {
      s = ( (String[]) dados.elementAt(row))[j];
      if (s != null && s.length() > 0){
        has_line = true;
      }
    }
    TabError elist[] = new TabError[nCols];
    int nErros = 0;
    for (j = 0; j < nCols; j++) {
      s = ( (String[]) dados.elementAt(row))[j];
      if (has_line && s.length() == 0 && mask.charAt(j) == 'R')
        elist[nErros++] = new TabError ( row, j, 'R', cols[j].col_tag, cols[j].col_name);
      if (s.length()> 0 && mask.charAt(j) == 'N')
          elist[nErros++] = new TabError ( row, j, 'N', cols[j].col_tag, cols[j].col_name);
    }
    //JOptionPane.showMessageDialog(null, "So " + nErros + " erros.");
    TabError rlist[] = new TabError[nErros];
    System.arraycopy( elist, 0, rlist, 0, nErros);
    return rlist;
  }

  // s colunas editveis !!
  boolean isRowEmpty ( int row ) {

    String s;
    for (int j = 0; j < cols.length; j++) {
      if ( cols[j].editable ) {
        s = ( (String[]) dados.elementAt(row))[j];
        if (s.length() > 0)return false;
      }
    }
    return true;
  }

  boolean isEmpty() {
    int nRows = dados.size();
    int nCols = cols.length;
    String s;
    int i, j;

    for (i = 0; i < nRows; i++)
      if ( ! isRowEmpty ( i ) ) return false;
    return true;
  }

  int lookup(String colName, String key) {
    int n = getColIndex(colName);

    int i, j;
    String s;
    int nRows = dados.size();

    for (i = 0; i < nRows; i++) {
      s = ( (String[]) dados.elementAt(i))[n];
      if (s.length() > 0 && s.equals(key))
        return i;
    }
    return -1;
  }

  public void locate ( CHValid_Msg m ) {

/*
    //JOptionPane.showMessageDialog( null, "ir para o campo: " + m.tag);
    String s = fmeFrame.Paginas.getTag();
    //JOptionPane.showMessageDialog( null, "pagina actual: " + s);

    if ( getPagina() == null ) {
      //JOptionPane.showMessageDialog(null, "pgina indefinida.");
      return;
    }

    if ( ! s.equals( getPagina() ) ) {
      //JOptionPane.showMessageDialog(null, "teria que mudar de pgina.");
//      fmeFrame.Paginas.GoTo( getPagina() );
    }

    this.handler.j.requestFocus();
    if ( m.row >= 0 && m.col >= 0 ) {
      handler.j.setColumnSelectionInterval(m.col, m.col);
      handler.j.setRowSelectionInterval(m.row, m.row);
      if ( handler.j.isCellEditable(m.row, m.col) ) handler.j.editCellAt(m.row, m.col);
    }
*/
  }

  public String getPagina() {
    return null;
  }

  void numerar ( int nCol ) {
    int n = 1;
    for ( int i=0; i < dados.size(); i++ ) {
     if ( !isRowEmpty (i) ) ((String[]) dados.elementAt(i))[nCol] = Integer.toString(n++);
     else ((String[]) dados.elementAt(i))[nCol]="";
    }
  }



  //------------------------------------
  // AUTOCALC
  //------------------------------------

  void autocalc () {
    for ( int i = 0; i < cols.length; i++ ) {
      if ( cols[i].autocalc != null ) {
        String formula = cols[i].autocalc;
        if ( formula.startsWith("$soma")) {
          String conta = formula.substring(6, formula.length()-1);
          //JOptionPane.showMessageDialog(null, "Conta: <" + conta + ">" );
          _autocalc_soma ( i, conta);
        }
        if ( formula.startsWith("$perc")) {
          String conta = formula.substring(6, formula.length()-1);
          //JOptionPane.showMessageDialog(null, "Conta: <" + conta + ">" );
          _autocalc_perc ( i, conta);
        }
      }
    }

    // FACADA...

    if ( handler != null && handler instanceof CHTabQuadro ) {
      _autocalc_rows();
    }
  }

  void _autocalc_soma(int nCol, String formula) {
    String termos[] = formula.split(",");
    long l;
    //JOptionPane.showMessageDialog(null, "formula: " + formula);
    for ( int r = 0; r < dados.size(); r++ ) {

      double v = 0, sv = 0;
      for ( int t =0; t < termos.length; t++ ) {
    	  //JOptionPane.showMessageDialog(null, termos[t]);
      	if (termos[t].equals("+x")) continue;
    	if (termos[t].equals("-x")) continue;
        int n = Integer.parseInt( termos[t].substring(1) );
        char conta = termos[t].charAt(0);

        sv = 0;

        String s =( (String[]) dados.elementAt(r))[n];
        if (s.length() > 0 ) sv = Double.parseDouble(s);

        if (s.length() > 0 && conta == '+' ) v = v + sv;
        if (s.length() > 0 && conta == '-' ) v = v - sv;

        if ( v != 0 ) v = _lib.round(v);

     }
     //JOptionPane.showMessageDialog(null, "linha " + r + " soma " + v);
     //( (String[]) dados.elementAt(r))[nCol] = Double.toString(v);
     //this.handler.setStringValueAt( Double.toString(v), r, nCol);

     //( (String[]) dados.elementAt(r))[nCol] = Double.toString(v);

     /*
     Float x = new Float(v);
     long l = (long)( (x.floatValue() + 0.005 ) * 100 );
     x = new Float(  ((double) l)/100 );

     ( (String[]) dados.elementAt(r))[nCol] = _lib.to_string(x.doubleValue());
      */
     if ( v == 0 )
       ( (String[]) dados.elementAt(r))[nCol] = "";
     else
       ( (String[]) dados.elementAt(r))[nCol] = _lib.to_string( v);
    }
  }

  void _autocalc_perc(int nCol, String formula) {
    String termos[] = formula.split(",");
    double base = 0;
    if ( termos[1].charAt(0) == '@' ) {
      String s = getParam( termos[1].substring(1) );
      if ( s.length() > 0 ) base = Double.parseDouble(s);
      //JOptionPane.showMessageDialog(null, "TOTAL: " +  base);
    }

    for ( int r = 0; r < dados.size(); r++ ) {

      double v = 0;
      if (base != 0) {
        int n = Integer.parseInt(termos[0].substring(1));
        String s = ( (String[]) dados.elementAt(r))[n];
        if ( s.length() > 0 ) v = Double.parseDouble(s);
        v = v / base;
      }
      //( (String[]) dados.elementAt(r))[nCol] = Double.toString(v);
      // por o valor
      //this.handler.setStringValueAt( Double.toString(v), r, nCol);
      //( (String[]) dados.elementAt(r))[nCol] = Double.toString(v*100);
      if ( v == 0 )
        ( (String[]) dados.elementAt(r))[nCol] = "";
      else
        ( (String[]) dados.elementAt(r))[nCol] = _lib.to_string(v*100);
    }
  }

  void _autocalc_rows () {
    CHTabQuadro h = (CHTabQuadro) handler;
//  for ( int i = 0; i < cols.length; i++ ) {
    for ( int i = 0; i < h.row_autocalc.length; i++ ) {
      if ( h.row_autocalc[i] != null ) {
        String formula = h.row_autocalc[i];
        //JOptionPane.showMessageDialog(null, "formula = " + h.row_autocalc[i] );
        if ( formula.startsWith("$soma")) {
          String conta = formula.substring(6, formula.length()-1);
          //JOptionPane.showMessageDialog(null, "linha " + i + " Conta: <" + conta + ">" );
          _autocalc_rows_soma ( i, conta);
        }
      }
    }
  }

  void _autocalc_rows_soma(int nRow, String formula) {
    String termos[] = formula.split(",");
    long l;
    for ( int c = 0; c < cols.length; c++ ) {

      if ( cols[c].vld == null ) continue;
      if ( cols[c].disable_row_calc ) continue;
      //JOptionPane.showMessageDialog(null, "conta coluna" + c );

      double v = 0, sv = 0;
      String msg = "";
      for ( int t =0; t < termos.length; t++ ) {
    	  //JOptionPane.showMessageDialog(null,termos[t]);
    	  if(termos[t].equals("+x")) continue;
    	  if(termos[t].equals("-x")) continue;
        int n = Integer.parseInt( termos[t].substring(1) );
        char conta = termos[t].charAt(0);


        //JOptionPane.showMessageDialog(null, "conta " + conta + " com termo " + n);

        String s =( (String[]) dados.elementAt(n))[c];
        //JOptionPane.showMessageDialog(null, "Somar " + c + "," + n + " : " + s);

        sv = 0;
        if (s.length() > 0 ) sv = Double.parseDouble(s);

        if ( sv != 0 ) sv = _lib.round(sv);

        //if (s.length() > 0 && conta == '+' ) v = v + Double.parseDouble(s);
        //if (s.length() > 0 && conta == '-' ) v = v - Double.parseDouble(s);

        if (s.length() > 0 && conta == '+' ) v = v + sv;
        if (s.length() > 0 && conta == '-' ) v = v - sv;

        if ( v != 0 ) v = _lib.round(v);
        /*
        if ( s.length()  > 0 ) {
           JOptionPane.showMessageDialog(null, "autucalc  " + nRow + ": " + formula);
           JOptionPane.showMessageDialog(null, "valor: " + v + " + " + sv);
           JOptionPane.showMessageDialog(null, "em string: " + _lib.to_string(v));
         }
         */
     }
     //JOptionPane.showMessageDialog(null, "linha " + nRow + " soma " + v);
     // por o valor...

     //String s = Double.toString(v);
     //if ( v == (int) v ) s = Integer.toString( (int) v);
     //( (String[]) dados.elementAt(nRow))[c] = s;

     if ( v == 0 )
       ( (String[]) dados.elementAt(nRow))[c] = "";
     else
       ( (String[]) dados.elementAt(nRow))[c] = _lib.to_string(v);


     //( (String[]) dados.elementAt(nRow))[c] = Double.toString(v);
     //this.handler.setStringValueAt( Double.toString(v), nRow, c);

    }
  }

  public String getParam ( String param ) {
    return null;
  }

  //--------------------------------------------------
  // operaes
  //--------------------------------------------------

  boolean on_del_row() { return on_del_row(false); }
  boolean on_del_row(boolean cascade) {
    handler.__garbage_stop_editing();
    int n = handler.j.getSelectedRow();
    int m = handler.j.getRowCount();
    if(n < m && n != -1){
      Object[] options = {"   Sim   ", "   No   "};
      int q = JOptionPane.showOptionDialog(null,
                                       "<html>A linha seleccionada "+
                                       (cascade? "<strong><u>e toda a informao associada</u></strong> ": "")+
                                       "ser eliminada. Pretende continuar?</html>",
                                       "Apagar Linha",
                                       JOptionPane.YES_NO_OPTION,
                                       JOptionPane.QUESTION_MESSAGE,
                                       null,
                                       options,
                                       options[1]);
      if (q == JOptionPane.YES_OPTION) {
        del_row_at(n);
        handler.j.revalidate();
        handler.j.repaint();
        return true;
      }
    }
    else {
      JOptionPane.showMessageDialog(null,
                                       "No seleccionou nenhuma linha na tabela!",
                                       "Apagar Linha",
                                       JOptionPane.INFORMATION_MESSAGE,
                                       null);
    }
    return false;
  }

  boolean on_add_row() {
    add_row();
    handler.j.revalidate();
    handler.j.repaint();
    return true;
  }
  
  boolean on_ins_row() { return on_ins_row(true); }
  boolean on_ins_row(boolean remove_empty) {
    handler.__garbage_stop_editing();
    int n = handler.j.getSelectedRow();
    if (n >= 0) {
      ins_row_at(n, remove_empty);
      handler.j.revalidate();
      handler.j.repaint();
      return true;
    }
    return false;
  }

  boolean on_up_row() {
    handler.__garbage_stop_editing();
    int n = handler.j.getSelectedRow();
    if (n >= 1) {
      String[] line_1 = (String[]) dados.elementAt(n-1);
      String[] line_2 = (String[]) dados.elementAt(n);
      dados.setElementAt(line_2, n-1);
      dados.setElementAt(line_1, n);

      handler.j.revalidate();
      handler.j.repaint();
      return true;
    }
    return false;
  }

  boolean on_copy_row() {
    handler.__garbage_stop_editing();
    int n = handler.j.getSelectedRow();
    if (n >= 0) {
      ins_row_at(n+1);
      String[] col_ = (String[]) dados.elementAt(n);
      String[] col = new String[cols.length];
      for (int j = 0; j < cols.length; j++)
        col[j] = col_[j];
      dados.setElementAt(col, n+1);
      handler.j.revalidate();
      handler.j.repaint();

      return true;
    }
    return false;
  }

  // getAs...

  double getAsValue (  int i, int j ) {
    String s =( (String[]) dados.elementAt(i))[j];
    //if ( s.length() == 0 ) return 0;
    //return CFLib.VLD_VALOR.get_double(s);
    //return _lib.get_double(s);
    return _lib.to_double(s);
  }

  void on_row( int i ) {
	JOptionPane.showMessageDialog(null, "on row " + i );  
  }

}

class TabError {
  int row;
  int col;
  char tipo;
  String tag;
  String title;

  TabError ( int _row, int _col, char _tipo, String _tag, String _title ) {
    row = _row;
    col = _col;
    tipo = _tipo;
    tag = _tag;
    title = _title;
  }

  String msg ( String formatR, String formatN ) {
    String m = "";
    if ( tipo == 'R' ) m = formatR;
    if ( tipo == 'N' ) m = formatN;
    m = m.replaceAll("%L", Integer.toString(row+1));
    title = title.replaceAll("\n", " ");
    title = title.replaceAll("<br>", " ");
    title = title.replaceAll("<html>", "");
    title = title.replaceAll("</html>", "");
    title = title.replaceAll("<div align='center'>", "");
    title = title.replaceAll("</div>", "");
    m = m.replaceAll("%T", title);
    return m;
  }

  String msg ( String formatR ) {
    return msg ( formatR, "");
  }
}


