package fme;

import java.util.*;
import java.io.*;
import javax.swing.*;

public class CTabelas {

  static Vector Tabelas = new Vector();

  static CTabela SimNao; // = new CTabela("SimNao");
  static CTabela Genero; // = new CTabela("Genero");
  static CTabela Dimensao; // = new CTabela("SimNao");

  static CTabela Distritos; // = new CTabela("Distritos");
  static CTabela Concelhos; // = new CTabela("Concelhos");
  static CTabela Freguesias;// = new CTabela("Freguesias");
  static CTabela NUTS_II; // = new CTabela("NUTS_II");
  static CTabela Pais; // = new CTabela("Pais");
  static CTabela Cae; // = new CTabela("Cae");

  static CTabela SistemaIncentivos; // = new CTabela("SistemaIncentivos");
  static CTabela Modalidades; // = new CTabela("Modalidades");

  static CTabela CaracJur; // = new CTabela("CaracJur");
  static CTabela TipoPart; // = new CTabela("TipoPart");
  static CTabela AreasFunc; // = new CTabela("AreasFunc");
  static CTabela AreasInv; // = new CTabela("AreasInv");
  static CTabela TipoMercado; // = new CTabela("TipoMercado");
  static CTabela NiveisQual; // = new CTabela("NiveisQual");

  static CTabela GrupoEmpreend; // = new CTabela("GrupoEmpreend");
  static CTabela Empreendimentos; // = new CTabela("Empreendimentos");
  static CTabela RegimeConstrucao; // = new CTabela("RegimeConstrucao");
  static CTabela ImpCustos; // = new CTabela("ImpCustos");
  
  static CTabela Rubricas; // = new CTabela("Rubricas");
  static CTabela TipoDesp; // = new CTabela("TipoDesp");
  static CTabela TipoProj; // = new CTabela("TipoProj");
  
  static CTabela AreasTecno;
  static CTabela SitActRPI;
  static CTabela AmbitoRPI;
  static CTabela TipoRPI;
  static CTabela ClassIDT;
  static CTabela Vinculo;

  static CTabelaF1 ConcelhosF1; // = new CTabelaF1 ( Concelhos );
  static CTabelaF2 ConcelhosF2; // = new CTabelaF2 ( Concelhos );
  static CTabelaF1 FreguesiasF1;// = new CTabelaF1 ( Freguesias );
  static CTabelaF1 EmpreendimentosF1; // = new CTabelaF1 ( Empreendimentos );

  static CEstabs Estabs; // = new CEstabs();
  static CTabelaF1 EstabsF1; // = new CEstabs();
  static CEmpresas Empresas; // = new CEstabs();
  static CEntExt EntExt; // = new CEstabs();

  static CRecursoInt RecursoInt;
  static CRecursoExt RecursoExt;
  static CActividades Actividades;
  static CEntidades Entidades;

  static CProjIDT ProjIDT; // = new CEstabs();
  static CActivIDT ActivIDT; // = new CEstabs();

  static CTarefas Tarefas; // = new CEstabs();
  static CTabelaF1 TarefasF1; // = new CEstabs();
  //static CTabela TipoLink = new CTabela("TipoLink");

  public CTabelas() {

	//tabelas fixas
	Tabelas.addElement(Dimensao = new CTabela("Dimensao") );
	Tabelas.addElement(SimNao = new CTabela("SimNao") );
	Tabelas.addElement(Genero = new CTabela("Genero") );
	Tabelas.addElement(Distritos = new CTabela("Distritos"));
    Tabelas.addElement(Concelhos = new CTabela("Concelhos"));
    Tabelas.addElement(Freguesias = new CTabela("Freguesias"));
	Tabelas.addElement(NUTS_II = new CTabela("NUTS_II"));
	Tabelas.addElement(Pais = new CTabela("Pais"));
	Tabelas.addElement(Cae = new CTabela("Cae"));

    Tabelas.addElement(SistemaIncentivos = new CTabela("SistemaIncentivos") );
    Tabelas.addElement(Modalidades = new CTabela("Modalidades"));

	//Tabelas.addElement(CaracJur = new CTabela("CaracJur"));
    Tabelas.addElement(TipoPart = new CTabela("TipoPart"));
    Tabelas.addElement(AreasFunc = new CTabela("AreasFunc"));
    Tabelas.addElement(AreasInv = new CTabela("AreasInv"));    
    Tabelas.addElement(TipoMercado = new CTabela("TipoMercado"));
    Tabelas.addElement(NiveisQual = new CTabela("NiveisQual"));
	Tabelas.addElement(Rubricas = new CTabela("Rubricas"));
	
    Tabelas.addElement(Empreendimentos = new CTabela("Empreendimentos"));
    Tabelas.addElement(GrupoEmpreend = new CTabela("GrupoEmpreend"));
    Tabelas.addElement(RegimeConstrucao = new CTabela("RegimeConstrucao"));
    Tabelas.addElement(ImpCustos = new CTabela("ImpCustos"));
    
    Tabelas.addElement(AreasTecno = new CTabela("AreasTecno"));
    Tabelas.addElement(SitActRPI = new CTabela("SitActRPI"));
    Tabelas.addElement(AmbitoRPI = new CTabela("AmbitoRPI"));
    Tabelas.addElement(TipoRPI = new CTabela("TipoRPI"));
    Tabelas.addElement(ClassIDT = new CTabela("ClassIDT"));
    Tabelas.addElement(Vinculo = new CTabela("Vinculo"));

    // subtabelas
    Tabelas.addElement(ConcelhosF1 = new CTabelaF1 ( Concelhos ));
    Tabelas.addElement(ConcelhosF2  = new CTabelaF2 ( Concelhos ));
    Tabelas.addElement(FreguesiasF1 = new CTabelaF1 ( Freguesias) );
    Tabelas.addElement(EmpreendimentosF1 = new CTabelaF1 ( Empreendimentos ));
  
    // estabs, empresas (dinmicas)
    Tabelas.addElement(Empresas = new CEmpresas());
    Tabelas.addElement(Estabs = new CEstabs());
    Tabelas.addElement(EstabsF1 = new CTabelaF1(Estabs));
    Tabelas.addElement(EntExt = new CEntExt());

    Tabelas.addElement(RecursoInt = new CRecursoInt());
    Tabelas.addElement(RecursoExt = new CRecursoExt());
    Tabelas.addElement(Actividades = new CActividades());
    Tabelas.addElement(Entidades = new CEntidades());

    Tabelas.addElement(ProjIDT = new CProjIDT());
    Tabelas.addElement(ActivIDT = new CActivIDT());

    Tabelas.addElement(Tarefas = new CTarefas());
    Tabelas.addElement(TarefasF1 = new CTabelaF1(Tarefas));
  }

  public static void mount_cfg_table ( String id, String filename ) {
	//JOptionPane.showMessageDialog(null, "TAB " + id + "=" + filename);
	  if (id.equals("TipoDesp"))
	    Tabelas.addElement(TipoDesp = new CTabela(id, filename));	  
	  if (id.equals("TipoProj"))
		    Tabelas.addElement(TipoProj = new CTabela(id, filename));	  
	  if (id.equals("CaracJur"))
		    Tabelas.addElement(CaracJur = new CTabela(id, filename));	  
  }
  
  public static CTabela getTabByName(String _name) {
    int i;
    CTabela ctab;
    for(i = 0; i < Tabelas.size(); i++) {
      ctab = (CTabela) Tabelas.elementAt(i);
      if ( ctab.name.equals(_name) )
        return ctab;
    }
    JOptionPane.showMessageDialog(null, "tabela " + _name + " ?");
    return null;
  }
}

//------------------------------------------------------------------------------
// CTab - abstract + tabela genrica
//------------------------------------------------------------------------------

class CTabela {

    String name;
    String [] titles;
    Vector data_table = new Vector();
    int cCol, dCol;

  public CTabela() {
  }

  public CTabela(String nome) {
    _init_tab(nome);
    cCol = 0;
    dCol = 1;
  }

  public CTabela(String nome, String filename) {
	    _init_tab(nome, filename);
	    cCol = 0;
	    dCol = 1;
	  }
  
  /*  
   public CTabela(String nome, int c, int d) {
    _init_tab(nome);
    cCol = c;
    dCol = c;
  } */

  //--------------------------------------------
  // acesso
  //--------------------------------------------

  public String getCodeFromIndex(int idx) {
    return getColFromIndex(idx, cCol);
  }

  public String getDesignFromIndex(int idx) {
    return getColFromIndex(idx, dCol);
  }

  public String getColFromIndex(int idx, int nCol) {
    String[] item;
    item = (String[]) data_table.elementAt(idx-1);
    //item = (String[]) data_table.elementAt(idx);
    return item[nCol];
  }

  String lookup(String codigo) {
    return lookup(cCol, codigo, dCol);
  }

  String lookup(int _cCol, String codigo, int _dCol) {
    int i;
    String[] item;
    for(i = 0; i < data_table.size(); i++) {
      item = (String[]) data_table.elementAt(i);
      if(item[_cCol].equals(codigo))
          return item[_dCol];
    }
    return null;
  }

  int getIndexFromCode(String codigo) {
    //JOptionPane.showMessageDialog( null, "procurar codigo " + codigo  );
    return getIndexFromCol(cCol, codigo);
  }

  int getIndexFromDesign(String codigo) {
    return getIndexFromCol(dCol, codigo);
  }

  String getCodeFromDesign(String codigo) {
    int n = getIndexFromCol(dCol, codigo);
    return getCodeFromIndex(n);
  }

  int getIndexFromCol(int col, String codigo) {
    //JOptionPane.showMessageDialog( null, "procurar codigo " + codigo + " codigo " + Integer.toString(col)  );
    if(codigo == null || codigo.length() == 0) return 0;
    int i;
    String[] item;
    for(i = 0; i < data_table.size(); i++) {
      item = (String[]) data_table.elementAt(i);
      if(item[col].equals(codigo))
          return i;
    }
    return 0;
  }

  String getDesign ( String code ) {
    int n = this.getIndexFromCode (code);
    return this.getDesignFromIndex(n+1);
  }

  //--------------------------------------------
  // servio
  //--------------------------------------------

  public boolean _populateComboBox(JComboBox cbo) {
    return _populateComboBox(cbo, dCol);
  }

  public boolean _populateComboBox(JComboBox cbo, int nCol) {
     cbo.removeAllItems(); 
     cbo.addItem("");		
     int i;
     String[] item;
     for(i = 0; i < data_table.size(); i++) {
         item = (String[]) data_table.elementAt(i);
         cbo.addItem(item[nCol]);
     }
     return true;
  }

  //-----------------------------------------
  // inicializao
  //-----------------------------------------

  public boolean _init_tab(String tabname ) {
	  return _init_tab ( tabname, tabname+".tab");
  }

  public boolean _init_tab(String tabname, String filename) {

    //String x = this.getClass().getResource(tabname + ".tab").toString();
    //JOptionPane.showMessageDialog(null, "tabela: " + x);

    name = tabname;
    /*
    File f = new File(tabname + ".tab");
    if(! f.exists()) {
        //JOptionPane.showMessageDialog(null, "Ficheiro no existe: " + tabname);
        return false;
    }
    */

    try {
       //BufferedReader in = new BufferedReader(new FileReader(f));
       BufferedReader in = new BufferedReader(
//          new InputStreamReader ( this.getClass().getResourceAsStream(tabname + ".tab") )
             new InputStreamReader ( this.getClass().getResourceAsStream( filename ) )
       );
       String s;

       s = in.readLine();
       if(s == null) return false;
       titles = explode(s);

       while(true) {
         s = in.readLine();
         if(s == null) break;
         //JOptionPane.showMessageDialog(null, "linha: " + s);

         data_table.add(explode(s));
       }
     }
     catch(IOException e1) { }

     //JOptionPane.showMessageDialog(null, "tabela: " + tabname);

     return true;
  }


  public String[] explode(String s) {
    int n_elem = 0;
    String[] temp = new String[20];
    int i = s.indexOf('|', 0);
    //JOptionPane.showMessageDialog(null, "i = " + String.valueOf(i));
    while(i > 0) {
      temp[n_elem] = new String(s.substring(0, i));
      //JOptionPane.showMessageDialog(null, "campo: " + temp[n_elem]);
      n_elem++;
      s = s.substring(i+1);
      i = s.indexOf('|', 0);
    }
    if(s.length() > 0) {
      temp[n_elem] = new String(s);
      //JOptionPane.showMessageDialog(null, "campo: " + temp[n_elem]);
      n_elem ++;
    }

    String [] a_row = new String[n_elem];
     for(i = 0; i < n_elem; i++)
       a_row[i] = temp[i];

    return a_row;
  }

}

class CTabelaF1 extends CTabela {
  CTabela base;
  /*
  String name;
  String [] titles;
  Vector data_table = new Vector();
  int cCol, dCol;
  */

  CTabelaF1 ( CTabela _base ) {
    base = _base;
    name  = base.name + "F1";  //PSSIMO, preguia...
    titles = base.titles;
    data_table = base.data_table;
    cCol = base.cCol;
    dCol = base.dCol;
  }

  public void clear_filter () {
    data_table = base.data_table;
  }
  
  public void clear_combo () {
	  data_table = new Vector();
  }

  public boolean set_filter (int nfCol, String key) {
    data_table = new Vector();
    String[] item;
    for(int i = 0; i < base.data_table.size(); i++) {
      item = (String[]) base.data_table.elementAt(i);
      if ( item[nfCol].equals(key) ) data_table.addElement( item);
    }
    return true;
  }

}

class CTabelaF2 extends CTabela {
	  CTabela base;
	  /*
	  String name;
	  String [] titles;
	  Vector data_table = new Vector();
	  int cCol, dCol;
	  */

	  CTabelaF2 ( CTabela _base ) {
	    base = _base;
	    name  = base.name + "F2";  //PSSIMO, preguia...
	    titles = base.titles;
	    data_table = base.data_table;
	    cCol = base.cCol;
	    dCol = base.dCol;
	  }

	  public void clear_filter () {
	    data_table = base.data_table;
	  }
	  
	  public void clear_combo () {
		  data_table = new Vector();
	  }

	  public boolean set_filter (int nfCol, String key) {
	    data_table = new Vector();
	    String[] item;
	    for(int i = 0; i < base.data_table.size(); i++) {
	      item = (String[]) base.data_table.elementAt(i);
	      if ( item[nfCol].equals(key) ) data_table.addElement( item);
	    }
	    return true;
	  }

	}
//------------------------------------------------------------------------------

class CEstabs extends CTabela {
  //String name;
  //String [] titles;
  //Vector data_table = new Vector();
  //int cCol, dCol;
	  CTabela base;

  JComboBox j;

  CEstabs ( ) {
    name = "Estabs";

    cCol = 0;
    dCol = 1;

    String[] d = new String[3];
    d[0] = "";
    d[1] = "";
    d[2] = "";
    data_table.add( d );

    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
    j = null;
  }

  public boolean _populateComboBox(JComboBox cbo, int cCol) {
	  
	int n = data_table.size();
	int m = this.dCol;
	
    //JOptionPane.showMessageDialog(null, "populate estabs..." + n + "," + m);
	//System.out.print("populate estabs..." + n + "," + m + "\n");
    j = cbo;
	//System.out.print("cbo=" + cbo.getName() + "\n");

    return super._populateComboBox( cbo, 0);
  }

  public boolean _populateComboBox(JComboBox cbo) {
    j = cbo;
    return super._populateComboBox( cbo);
  }

  void refresh() {

  //  System.out.print( "refresh estabs...\n");

	data_table.clear();
	//ACTUALIZAR A TABELA
	//-USAR A MESMA ORDEM
	//-APAGAR AS QUE ESTO A MAIS (=> CONFIRMAR LINHAS DO QUADRO INV!!!)
	//-ACRESCENTAR AS QUE FALTEM
	//-UPDATE
	  
    //APAGAR OS QUE ESTO A MAIS
	//QUE, DEPOIS DE FAZER AS VALIDAES NO UPDATE, S PODE SER UM DO FIM !!!
	//VALIDAES NO UPDATE:
	//- no deixar acrescentar de a linha anterior estiver vazia
	//- no deixar apagar se a seguintes estiver cheia
	//(neste caso s interessa o campo design, que  o que faz a numerao)  

	data_table.removeAllElements();
/*	int k = data_table.size();
	for ( ; k > CBData.PromLocal.dados.size(); k--  ) {
		data_table.removeElementAt(k-1);
	}
	*/ 
    String[] d = new String[4];
    d[0] = "";
    d[1] = "";
    d[2] = "";
    d[3] = "";
    //data_table.add(d);
    //JOptionPane.showMessageDialog(null, "so: " + CBData.PromLocal.dados.size() + " estabs.");    
    
    for (int i = 0; i < CBData.PromLocal.dados.size(); i++) {
      
      String n_estab = CBData.PromLocal.getColValue("n_estab", i);
      if ( n_estab.length() > 0) {
        //JOptionPane.showMessageDialog(null, "add estab " + n_estab);
        d = new String[4];
        d[0] = n_estab;
//        d[1] = CBData.PromLocal.getColValue("n_estab", i) + " - " +
//        	   CBData.PromLocal.getColValue("concelho_d", i);
//        d[1] = CBData.PromLocal.getColValue("concelho_d", i);
        d[1] = CBData.PromLocal.getColValue("estab", i);
        d[2] = CBData.PromLocal.getColValue("concelho", i);
        d[3] = "0";
        
 //       if ( i >= data_table.size())
        	//ACRESCENTAR AS QUE FALTAM
        	data_table.add(d);
   //     else {
        	//UPDATE DOS J EXISTENTES
  //      	((String[]) (data_table.elementAt(i)))[0] = d[0];
   //     	((String[]) (data_table.elementAt(i)))[1] = d[1];
    //    	((String[]) (data_table.elementAt(i)))[2] = d[2];
    //    }
       // JOptionPane.showMessageDialog(null, d);
      }
    }

    if (CBData.ListaCoop.started) {
        for (int j = 0; j < CBData.ListaCoop.dados.size(); j++) {
	        //System.out.print("lista coop "+(j)+"\n");
	    	CBTabela_PromLocal tab = ((CBTabela_PromLocal) CBData.ListaCoop.Lista_PromLocal.elementAt(j));
	        for (int i = 0; i < tab.dados.size(); i++) {
	
	        	String n_estab = tab.getColValue("n_estab", i);
	        	if ( n_estab.length() > 0) {
	           // System.out.print("    estab  "+(i+1)+"\n");
	          //JOptionPane.showMessageDialog(null, "add estab " + n_estab);
	        		d = new String[4];
	        		d[0] = n_estab;
	          //	d[1] = tab.getColValue("n_estab", i) + " - " + tab.getColValue("concelho_d", i);
	        		d[1] = tab.getColValue("estab", i);
	        		d[2] = tab.getColValue("concelho", i);
	        		d[3] = (j+1)+"";
	          
	      //    if ( i >= data_table.size())
	          	//ACRESCENTAR AS QUE FALTAM
	        		data_table.add(d);
	        //  else {
	          	//UPDATE DOS J EXISTENTES
	          //	((String[]) (data_table.elementAt(i)))[0] = d[0];
	          //	((String[]) (data_table.elementAt(i)))[1] = d[1];
	          //	((String[]) (data_table.elementAt(i)))[2] = d[2];
	        //  }
	         // JOptionPane.showMessageDialog(null, d);
	        	}
	        }
	    }
    }
/*    
	System.out.print("inicio\n");
    for (int k=0;k<data_table.size();k++){
    	String[] x = (String[]) data_table.elementAt(k);
    	System.out.print(x[1]+"\n");
    }
	System.out.print("fim\n");
  */  
    
	if ( CBData.QInv.started && CBData.QInv.cboEstabs != null )  {
		CBData.QInv.cboEstabs.removeAllItems();
		CBData.QInv.cboEstabs.addItem("");
		//JOptionPane.showMessageDialog(null, data_table.size());
		for(int i = 0; i < data_table.size(); i++) {
			String[] item = (String[]) data_table.elementAt(i);
			CBData.QInv.cboEstabs.addItem( item[0]);
		}
	}
	
	if ( CBData.QuadrosTecn.started && CBData.QuadrosTecn.cboEstabs != null )  {
		CBData.QuadrosTecn.cboEstabs.removeAllItems();
		CBData.QuadrosTecn.cboEstabs.addItem("");
		for(int i = 0; i < data_table.size(); i++) {
			String[] item = (String[]) data_table.elementAt(i);
			CBData.QuadrosTecn.cboEstabs.addItem( item[0]);
		}
	}	
	
	//if (j != null) {
      //JOptionPane.showMessageDialog(null, "refresh estabs..." + data_table.size() + " itens");
      //super._populateComboBox(j);
      //_populateComboBox(j, 1);
    //}
  }
}


class CEmpresas extends CTabela {

	JComboBox j;

	  CEmpresas () {
	    name = "Empresas";

	    cCol = 0;
	    dCol = 1;

	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    data_table.add( d );
	    
	    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
	    j = null;
	  }

	  public boolean _populateComboBox(JComboBox cbo, int cCol) {
		  
		int n = data_table.size();
		int m = this.dCol;		
	    j = cbo;
	    return super._populateComboBox( cbo, 0);
	  }

	  public boolean _populateComboBox(JComboBox cbo) {
	    j = cbo;
	    return super._populateComboBox( cbo);
	  }

	  void refresh() {

		int k = data_table.size();
		for ( ; k > CBData.ListaCoop.dados.size(); k--  ) {
			data_table.removeElementAt(k-1);
		}
		 
	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    
	    for (int i = 0; i < CBData.ListaCoop.dados.size(); i++) {
	      
	      String n_empresa = CBData.ListaCoop.getColValue("n_ordem", i);
	      if ( n_empresa.length() > 0) {
	        //JOptionPane.showMessageDialog(null, "add estab " + n_estab);
	        d = new String[2];
	        d[0] = n_empresa;
	        d[1] = CBData.ListaCoop.getColValue("n_ordem", i) + " - " +
	        	   CBData.ListaCoop.getColValue("nome", i);	        
	        if ( i >= data_table.size())
	        	//ACRESCENTAR AS QUE FALTAM
	        	data_table.add(d);
	        else {
	        	//UPDATE DOS J EXISTENTES
	        	((String[]) (data_table.elementAt(i)))[0] = d[0];
	        	((String[]) (data_table.elementAt(i)))[1] = d[1];
	        }
	       // JOptionPane.showMessageDialog(null, d);
	      }
	    }
	    //data_table.remove(1);
	    
	    //Promotor Principal
        d = new String[2];
        d[0] = "0";
        d[1] = "0 - " +	CBData.Promotor.getByName("nome").v;	        
    	data_table.insertElementAt(d, 0);
 
		if ( CBData.QInv.started && CBData.QInv.cboEmpresas != null )  {
			CBData.QInv.cboEmpresas.removeAllItems();
			CBData.QInv.cboEmpresas.addItem("");
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QInv.cboEmpresas.addItem( item[1]);
			}
		}

		if ( CBData.QuadrosTecn.started && CBData.QuadrosTecn.cboEmpresas != null )  {
			CBData.QuadrosTecn.cboEmpresas.removeAllItems();
			CBData.QuadrosTecn.cboEmpresas.addItem("");
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QuadrosTecn.cboEmpresas.addItem( item[1]);
			}
		}

	}
}


class CEntExt extends CTabela {
	  //String name;
	  //String [] titles;
	  //Vector data_table = new Vector();
	  //int cCol, dCol;
		  CTabela base;

	  JComboBox j;

	  CEntExt ( ) {
	    name = "EntExt";

	    cCol = 0;
	    dCol = 1;

	    String[] d = new String[3];
	    d[0] = "";
	    d[1] = "";
	    d[2] = "";
	    data_table.add( d );

	    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
	    j = null;
	  }

	  public boolean _populateComboBox(JComboBox cbo, int cCol) {
		  
		int n = data_table.size();
		int m = this.dCol;
		
	    //JOptionPane.showMessageDialog(null, "populate estabs..." + n + "," + m);
		//System.out.print("populate estabs..." + n + "," + m + "\n");
	    j = cbo;
		//System.out.print("cbo=" + cbo.getName() + "\n");

	    return super._populateComboBox( cbo, 0);
	  }

	  public boolean _populateComboBox(JComboBox cbo) {
	    j = cbo;
	    return super._populateComboBox( cbo);
	  }

	  void refresh() {

	  //  System.out.print( "refresh estabs...\n");

		data_table.clear();
		//ACTUALIZAR A TABELA
		//-USAR A MESMA ORDEM
		//-APAGAR AS QUE ESTO A MAIS (=> CONFIRMAR LINHAS DO QUADRO INV!!!)
		//-ACRESCENTAR AS QUE FALTEM
		//-UPDATE
		  
	    //APAGAR OS QUE ESTO A MAIS
		//QUE, DEPOIS DE FAZER AS VALIDAES NO UPDATE, S PODE SER UM DO FIM !!!
		//VALIDAES NO UPDATE:
		//- no deixar acrescentar de a linha anterior estiver vazia
		//- no deixar apagar se a seguintes estiver cheia
		//(neste caso s interessa o campo design, que  o que faz a numerao)  

		data_table.removeAllElements();
	/*	int k = data_table.size();
		for ( ; k > CBData.PromLocal.dados.size(); k--  ) {
			data_table.removeElementAt(k-1);
		}
		*/ 
	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    //data_table.add(d);
	    //JOptionPane.showMessageDialog(null, "so: " + CBData.PromLocal.dados.size() + " estabs.");    
	    
	    for (int i = 0; i < CBData.EntExt.dados.size(); i++) {
	      
	      String n_ordem = CBData.EntExt.getColValue("n_ordem", i);
	      if ( n_ordem.length() > 0) {
	        //JOptionPane.showMessageDialog(null, "add estab " + n_estab);
	        d = new String[2];
	        d[0] = n_ordem;
	        d[1] = CBData.EntExt.getColValue("design", i);
	        //System.out.print(d[1]+"\n");
	        data_table.add(d);
	      }
	    }

		if ( CBData.EquipaCoord.started && CBData.EquipaCoord.cboEntExt != null )  {
			CBData.EquipaCoord.cboEntExt.removeAllItems();
			CBData.EquipaCoord.cboEntExt.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.EquipaCoord.cboEntExt.addItem( item[0]);
			}
		}
	  }
	}


class CEntidades extends CTabela {
	JComboBox j; //a tabela s pode ser utilizada "automticamente" uma vez

	CEntidades () {
		name = "Entidades";
		cCol = 0;
		dCol = 1;
		j = null;
	}
	public boolean _populateComboBox(JComboBox cbo, int nCol) {
		j = cbo;
		return super._populateComboBox(cbo, nCol);
	}
	public boolean _populateComboBox(JComboBox cbo) {
		j = cbo;
		return super._populateComboBox(cbo);
	}
	void refresh() {
		data_table.clear();
	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";

		for (int i = 0; i < CBData.SubContrat.dados.size(); i++) {
			String n_ordem = CBData.SubContrat.getColValue("n_ordem", i);
			if ( n_ordem.length() > 0) {
				d = new String[2];
				d[0] = n_ordem;
				d[1] = CBData.SubContrat.getColValue("design", i);	        
				data_table.add(d);
			}
		}
		if (j != null) {
			super._populateComboBox(j, dCol);
		}
/*		if ( CBData.QuadroSC.started && CBData.QuadroSC.cboEntid != null )  {
			CBData.QuadroSC.cboEntid.removeAllItems();
			CBData.QuadroSC.cboEntid.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QuadroSC.cboEntid.addItem( item[0]);
			}
		}*/

	}
}


class CActividades extends CTabela {
	JComboBox j;

	CActividades () {
		name = "Actividades";
		cCol = 0;
		dCol = 1;
		j = null;
	}
	public boolean _populateComboBox(JComboBox cbo, int nCol) {
		j = cbo;
		return super._populateComboBox(cbo, nCol);
	}
	public boolean _populateComboBox(JComboBox cbo) {
		j = cbo;
		return super._populateComboBox(cbo);
	}
	void refresh() {
		data_table.clear();
		for (int i = 0; i < CBData.ActLista.dados.size(); i++) {
			String n_ordem = CBData.ActLista.getColValue("n_ordem", i);
			String activ_d = CBData.ActLista.getColValue("activ_d", i);
			if ( activ_d.length() > 0) {
				String[] d = new String[2];
				d[0] = n_ordem;
				d[1] = activ_d;
				//d[1] = n_ordem + " - " + activ_d;	        
				data_table.add(d);
			}
		}
		if (j != null) {
			super._populateComboBox(j, dCol);
		}

		if ( CBData.QInv.started && CBData.QInv.cboActiv != null )  {
			CBData.QInv.cboActiv.removeAllItems();
			CBData.QInv.cboActiv.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QInv.cboActiv.addItem( item[0]);
			}
		}
	}
}

class CRecursoInt extends CTabela {
	CRecursoInt () {
		name = "RecursoInt";
		cCol = 0;
		dCol = 1;
	}
	void refresh() {
		data_table.clear();
		for (int i = 0; i < CBData.Tecnicos.dados.size(); i++) {
			String n_ordem = CBData.Tecnicos.getColValue("n_ordem", i);
			String nome = CBData.Tecnicos.getColValue("nome", i);
			if ( nome.length() > 0) {
				String[] d = new String[2];
				d[0] = n_ordem;
				d[1] = nome;	        
				data_table.add(d);
			}
		}
	}
}

class CRecursoExt extends CTabela {
	CRecursoExt () {
		name = "RecursoExt";
		cCol = 0;
		dCol = 1;
	}
	void refresh() {
		data_table.clear();
		for (int i = 0; i < CBData.PessoalSC.dados.size(); i++) {
			String n_ordem = CBData.PessoalSC.getColValue("n_ordem", i);
			String nome = CBData.PessoalSC.getColValue("nome", i);
			if ( nome.length() > 0) {
				String[] d = new String[2];
				d[0] = n_ordem;
				d[1] = nome;	        
				data_table.add(d);
			}
		}
	}
}

class CProjIDT extends CTabela {
	  //String name;
	  //String [] titles;
	  //Vector data_table = new Vector();
	  //int cCol, dCol;
		  CTabela base;

	  JComboBox j;

	  CProjIDT ( ) {
	    name = "ProjIDT";

	    cCol = 0;
	    dCol = 1;

	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    data_table.add( d );

	    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
	    j = null;
	  }

	  public boolean _populateComboBox(JComboBox cbo, int cCol) {
		  
		int n = data_table.size();
		int m = this.dCol;
		
	    //JOptionPane.showMessageDialog(null, "populate estabs..." + n + "," + m);
		//System.out.print("populate estabs..." + n + "," + m + "\n");
	    j = cbo;
		//System.out.print("cbo=" + cbo.getName() + "\n");

	    return super._populateComboBox( cbo, 0);
	  }

	  public boolean _populateComboBox(JComboBox cbo) {
	    j = cbo;
	    return super._populateComboBox( cbo);
	  }

	  void refresh() {

	  //  System.out.print( "refresh estabs...\n");

		data_table.clear();
		//ACTUALIZAR A TABELA
		//-USAR A MESMA ORDEM
		//-APAGAR AS QUE ESTO A MAIS (=> CONFIRMAR LINHAS DO QUADRO INV!!!)
		//-ACRESCENTAR AS QUE FALTEM
		//-UPDATE
		  
	    //APAGAR OS QUE ESTO A MAIS
		//QUE, DEPOIS DE FAZER AS VALIDAES NO UPDATE, S PODE SER UM DO FIM !!!
		//VALIDAES NO UPDATE:
		//- no deixar acrescentar de a linha anterior estiver vazia
		//- no deixar apagar se a seguintes estiver cheia
		//(neste caso s interessa o campo design, que  o que faz a numerao)  

		data_table.removeAllElements();
	/*	int k = data_table.size();
		for ( ; k > CBData.PromLocal.dados.size(); k--  ) {
			data_table.removeElementAt(k-1);
		}
		*/ 
	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    //data_table.add(d);
	    //JOptionPane.showMessageDialog(null, "so: " + CBData.PromLocal.dados.size() + " estabs.");    
	    
	    for (int i = 0; i < CBData.ProjIDT.dados.size(); i++) {
	      
	      String n_ordem = CBData.ProjIDT.getColValue("n_ordem", i);
	      if ( n_ordem.length() > 0) {
	        //JOptionPane.showMessageDialog(null, "add estab: "+CBData.ProjIDT.getColValue("id_proj", i));
	        d = new String[2];
	        d[0] = n_ordem;
	        d[1] = CBData.ProjIDT.getColValue("design", i);
	        
	 //       if ( i >= data_table.size())
	        	//ACRESCENTAR AS QUE FALTAM
	        	data_table.add(d);
	   //     else {
	        	//UPDATE DOS J EXISTENTES
	  //      	((String[]) (data_table.elementAt(i)))[0] = d[0];
	   //     	((String[]) (data_table.elementAt(i)))[1] = d[1];
	    //    	((String[]) (data_table.elementAt(i)))[2] = d[2];
	    //    }
	       // JOptionPane.showMessageDialog(null, d);
	      }
	    }
	    
		if ( CBData.ActivIDT.started && CBData.ActivIDT.cboProj != null )  {
			CBData.ActivIDT.cboProj.removeAllItems();
			CBData.ActivIDT.cboProj.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.ActivIDT.cboProj.addItem( item[0]);
			}
		}
		
		//if (j != null) {
	      //JOptionPane.showMessageDialog(null, "refresh estabs..." + data_table.size() + " itens");
	      //super._populateComboBox(j);
	      //_populateComboBox(j, 1);
	    //}
	  }
}

class CActivIDT extends CTabela {
	  //String name;
	  //String [] titles;
	  //Vector data_table = new Vector();
	  //int cCol, dCol;
		  CTabela base;

	  JComboBox j;

	  CActivIDT ( ) {
	    name = "ActivIDT";

	    cCol = 0;
	    dCol = 1;

	    String[] d = new String[2];
	    d[0] = "";
	    d[1] = "";
	    data_table.add( d );

	    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
	    j = null;
	  }

	  public boolean _populateComboBox(JComboBox cbo, int cCol) {
		  
		int n = data_table.size();
		int m = this.dCol;
		
	    //JOptionPane.showMessageDialog(null, "populate estabs..." + n + "," + m);
		//System.out.print("populate estabs..." + n + "," + m + "\n");
	    j = cbo;
		//System.out.print("cbo=" + cbo.getName() + "\n");

	    return super._populateComboBox( cbo, 0);
	  }

	  public boolean _populateComboBox(JComboBox cbo) {
	    j = cbo;
	    return super._populateComboBox( cbo);
	  }

	  void refresh() {

	  //  System.out.print( "refresh estabs...\n");

		data_table.clear();
		//ACTUALIZAR A TABELA
		//-USAR A MESMA ORDEM
		//-APAGAR AS QUE ESTO A MAIS (=> CONFIRMAR LINHAS DO QUADRO INV!!!)
		//-ACRESCENTAR AS QUE FALTEM
		//-UPDATE
		  
	    //APAGAR OS QUE ESTO A MAIS
		//QUE, DEPOIS DE FAZER AS VALIDAES NO UPDATE, S PODE SER UM DO FIM !!!
		//VALIDAES NO UPDATE:
		//- no deixar acrescentar de a linha anterior estiver vazia
		//- no deixar apagar se a seguintes estiver cheia
		//(neste caso s interessa o campo design, que  o que faz a numerao)  

		data_table.removeAllElements();
	/*	int k = data_table.size();
		for ( ; k > CBData.PromLocal.dados.size(); k--  ) {
			data_table.removeElementAt(k-1);
		}
		*/ 
	    String[] d = new String[1];
	    d[0] = "";
	    //d[1] = "";
	    //data_table.add(d);
	    //JOptionPane.showMessageDialog(null, "so: " + CBData.PromLocal.dados.size() + " estabs.");    
	    
	    for (int i = 0; i < CBData.ActivIDT.dados.size(); i++) {
	      
	      String n_ordem = CBData.ActivIDT.getColValue("n_ordem", i);
	      if ( n_ordem.length() > 0) {
	        //JOptionPane.showMessageDialog(null, "add estab: "+CBData.ProjIDT.getColValue("id_proj", i));
	        d = new String[2];
	        //d[0] = n_ordem;
	        d[0] = CBData.ActivIDT.getColValue("n_ordem", i);
	        d[1] = CBData.ActivIDT.getColValue("design", i);
	        
	 //       if ( i >= data_table.size())
	        	//ACRESCENTAR AS QUE FALTAM
	        	data_table.add(d);
	   //     else {
	        	//UPDATE DOS J EXISTENTES
	  //      	((String[]) (data_table.elementAt(i)))[0] = d[0];
	   //     	((String[]) (data_table.elementAt(i)))[1] = d[1];
	    //    	((String[]) (data_table.elementAt(i)))[2] = d[2];
	    //    }
	       // JOptionPane.showMessageDialog(null, d);
	      }
	    }
	    
		if ( CBData.QuadroSC.started && CBData.QuadroSC.cboActiv != null )  {
			CBData.QuadroSC.cboActiv.removeAllItems();
			CBData.QuadroSC.cboActiv.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QuadroSC.cboActiv.addItem( item[0]);
			}
		}
		if ( CBData.QInv.started && CBData.QInv.cboActivIDT != null )  {
			CBData.QInv.cboActivIDT.removeAllItems();
			CBData.QInv.cboActivIDT.addItem("");
			//JOptionPane.showMessageDialog(null, data_table.size());
			for(int i = 0; i < data_table.size(); i++) {
				String[] item = (String[]) data_table.elementAt(i);
				CBData.QInv.cboActivIDT.addItem( item[0]);
			}
		}
		
		//if (j != null) {
	      //JOptionPane.showMessageDialog(null, "refresh estabs..." + data_table.size() + " itens");
	      //super._populateComboBox(j);
	      //_populateComboBox(j, 1);
	    //}
	  }
}

class CTarefas extends CTabela {
	  //String name;
	  //String [] titles;
	  //Vector data_table = new Vector();
	  //int cCol, dCol;
		  CTabela base;

	  JComboBox j;

	  CTarefas ( ) {
	    name = "Tarefas";

	    cCol = 0;
	    dCol = 1;

	    String[] d = new String[3];
	    d[0] = "";
	    d[1] = "";
	    d[2] = "";
	    data_table.add( d );

	    //JOptionPane.showMessageDialog(null, "Estabs inicializado...");
	    j = null;
	  }

	  public boolean _populateComboBox(JComboBox cbo, int cCol) {
		  
		int n = data_table.size();
		int m = this.dCol;
		
	    //JOptionPane.showMessageDialog(null, "populate estabs..." + n + "," + m);
		//System.out.print("populate estabs..." + n + "," + m + "\n");
	    j = cbo;
		//System.out.print("cbo=" + cbo.getName() + "\n");

	    return super._populateComboBox( cbo, 0);
	  }

	  public boolean _populateComboBox(JComboBox cbo) {
	    j = cbo;
	    return super._populateComboBox( cbo);
	  }

	  void refresh() {

	  //  System.out.print( "refresh estabs...\n");

		data_table.clear();
		//ACTUALIZAR A TABELA
		//-USAR A MESMA ORDEM
		//-APAGAR AS QUE ESTO A MAIS (=> CONFIRMAR LINHAS DO QUADRO INV!!!)
		//-ACRESCENTAR AS QUE FALTEM
		//-UPDATE
		  
	    //APAGAR OS QUE ESTO A MAIS
		//QUE, DEPOIS DE FAZER AS VALIDAES NO UPDATE, S PODE SER UM DO FIM !!!
		//VALIDAES NO UPDATE:
		//- no deixar acrescentar de a linha anterior estiver vazia
		//- no deixar apagar se a seguintes estiver cheia
		//(neste caso s interessa o campo design, que  o que faz a numerao)  

		data_table.removeAllElements();
	    String[] d = new String[4];
	    d[0] = "";
	    d[1] = "";
	    d[2] = "";
	    d[3] = "";
	    
	    if (CBData.ActLista.started) {
	        for (int j = 0; j < CBData.ActLista.dados.size(); j++) {
		        //System.out.print("tarefa "+(j+1)+"\n");
		    	CBTabela_ActTarefas tab = ((CBTabela_ActTarefas) CBData.ActLista.Lista_Tarefas.elementAt(j));
		        for (int i = 0; i < tab.dados.size(); i++) {
		
		        	String n_ordem = tab.getColValue("n_ordem", i);
		        	if ( n_ordem.length() > 0) {
		        		d = new String[3];
		        		d[0] = n_ordem;
		        		d[1] = tab.getColValue("tarefa_d", i);
		        		d[2] = (j+1)+"";
		          
		        		data_table.add(d);
		        	}
		        }
	        }
	    }
	    if ( CBData.ActLista.started )  {
	    	for (int j=0; j<CBData.ActLista.dados.size();j++){
	    		CBTabela_ActResultados res = ((CBTabela_ActResultados) CBData.ActLista.Lista_Resultados.elementAt(j));
				res.cboTarefas.removeAllItems();
				res.cboTarefas.addItem("");
				//JOptionPane.showMessageDialog(null, data_table.size());
				for(int i = 0; i < data_table.size(); i++) {
					String[] item = (String[]) data_table.elementAt(i);
					res.cboTarefas.addItem( item[0]);
				}
	    	}
		}
		
	  }
	}


