package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_ActLista extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ActLista = null;
	private JLabel jLabel_ActLista = null;
	private JScrollPane jScrollPane_ActLista = null;
	private JTableX jTable_ActLista = null;
	private JButton jButton_ActListaCopy = null;
	private JButton jButton_ActListaUp = null;
	private JButton jButton_ActListaAdd = null;
	private JButton jButton_ActListaIns = null;
	private JButton jButton_ActListaDel = null;

	private JPanel jPanel_Caracteriza = null;
	private JLabel jLabel_Caracteriza = null;
	private JScrollPane jScrollPane_Caracteriza = null;
	private JTextArea jTextArea_Caracteriza = null;

	String tag = "";

	public Frame_ActLista() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,860);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_ActLista, 30);
		up_component(jPanel_Caracteriza, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ActLista(), null);
			jContentPane.add(getJPanel_Caracteriza(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_ActLista() {
		if (jPanel_ActLista == null) {
			jLabel_ActLista = new JLabel();
			jLabel_ActLista.setBounds(new Rectangle(12, 10, 415, 18));
			jLabel_ActLista.setText("Descrio das Actividades de I&DT");
			jLabel_ActLista.setFont(fmeFrame.letra_bold);

			jButton_ActListaCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ActListaCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActListaCopy.addMouseListener(new Frame_ActLista_jButton_ActListaCopy_mouseAdapter(this));
			jButton_ActListaCopy.setToolTipText("Copiar Linha");
			jButton_ActListaCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ActListaUp = new JButton(fmeFrame.subirLinha);
			jButton_ActListaUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActListaUp.addMouseListener(new Frame_ActLista_jButton_ActListaUp_mouseAdapter(this));
			jButton_ActListaUp.setToolTipText("Trocar Linhas");
			jButton_ActListaUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ActListaAdd = new JButton(fmeFrame.novaLinha);
			jButton_ActListaAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActListaAdd.addMouseListener(new Frame_ActLista_jButton_ActListaAdd_mouseAdapter(this));
			jButton_ActListaAdd.setToolTipText("Nova Linha");
			jButton_ActListaAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ActListaIns = new JButton(fmeFrame.inserirLinha);
			jButton_ActListaIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActListaIns.addMouseListener(new Frame_ActLista_jButton_ActListaIns_mouseAdapter(this));
			jButton_ActListaIns.setToolTipText("Inserir Linha");
			jButton_ActListaIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ActListaDel = new JButton(fmeFrame.apagarLinha);
			jButton_ActListaDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActListaDel.addMouseListener(new Frame_ActLista_jButton_ActListaDel_mouseAdapter(this));
			jButton_ActListaDel.setToolTipText("Apagar Linha");
			jButton_ActListaDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ActLista = new JPanel();
			jPanel_ActLista.setLayout(null);
			jPanel_ActLista.setBounds(new Rectangle(15, 50, 640, 312));
			jPanel_ActLista.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActLista.add(jLabel_ActLista, null);
//			jPanel_ActLista.add(jButton_ActListaCopy, null);
//			jPanel_ActLista.add(jButton_ActListaUp, null);
			jPanel_ActLista.add(jButton_ActListaAdd, null);
			jPanel_ActLista.add(jButton_ActListaIns, null);
			jPanel_ActLista.add(jButton_ActListaDel, null);
			jPanel_ActLista.add(getJScrollPane_ActLista(), null);
		}
		return jPanel_ActLista;
	}
	public JScrollPane getJScrollPane_ActLista() {
		if (jScrollPane_ActLista == null) {
			jScrollPane_ActLista = new JScrollPane();
			jScrollPane_ActLista.setBounds(new Rectangle(16, 36, 606, 261));
			jScrollPane_ActLista.setViewportView(getJTable_ActLista());
			jScrollPane_ActLista.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActLista.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActLista.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActLista;
	}
	public JTable getJTable_ActLista() {
		if (jTable_ActLista == null) {
			jTable_ActLista = new JTableX(40, jScrollPane_ActLista.getWidth());
			jTable_ActLista.setFont(fmeFrame.letra);
			jTable_ActLista.setRowHeight(18);
			jTable_ActLista.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActLista.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActLista;
	}
	void jButton_ActListaCopy_mouseClicked(MouseEvent e) {
		CBData.ActLista.on_copy_row();
	}
	void jButton_ActListaUp_mouseClicked(MouseEvent e) {
		CBData.ActLista.on_up_row();
	}
	void jButton_ActListaAdd_mouseClicked(MouseEvent e) {
		CBData.ActLista.on_add_row();
	}
	void jButton_ActListaDel_mouseClicked(MouseEvent e) {
		if (CBData.ActLista.del_ins_ok("Apagar")){
			CBData.ActLista.on_del_row();
		}
	}
	void jButton_ActListaIns_mouseClicked(MouseEvent e) {
		if (CBData.ActLista.del_ins_ok("Inserir")){
			CBData.ActLista.on_ins_row();
		}
	}

	private JPanel getJPanel_Caracteriza() {
		if (jPanel_Caracteriza == null) {
			jLabel_Caracteriza = new JLabel();
			jLabel_Caracteriza.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Caracteriza.setText("Caracterizao e fundamentao das actividades");
			jLabel_Caracteriza.setFont(fmeFrame.letra_bold);

			jPanel_Caracteriza = new JPanel();
			jPanel_Caracteriza.setLayout(null);
			jPanel_Caracteriza.setBounds(new Rectangle(15, 372, 640, 474));
			jPanel_Caracteriza.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Caracteriza.setName("caracteriza_texto");
			jPanel_Caracteriza.add(jLabel_Caracteriza, null);
			jPanel_Caracteriza.add(getJScrollPane_Caracteriza(), null);
		}
		return jPanel_Caracteriza;
	}
	private JScrollPane getJScrollPane_Caracteriza() {
		if (jScrollPane_Caracteriza == null) {
			jScrollPane_Caracteriza = new JScrollPane();
			jScrollPane_Caracteriza.setBounds(new Rectangle(15, 35, 609, 420));
			jScrollPane_Caracteriza.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Caracteriza.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Caracteriza.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Caracteriza.setViewportView(getJTextArea_Caracteriza());
		}
		return jScrollPane_Caracteriza;
	}
	public JTextArea getJTextArea_Caracteriza() {
		if (jTextArea_Caracteriza == null) {
			jTextArea_Caracteriza = new JTextArea();
			jTextArea_Caracteriza.setFont(fmeFrame.letra);
			jTextArea_Caracteriza.setLineWrap(true);
			jTextArea_Caracteriza.setWrapStyleWord(true);
			jTextArea_Caracteriza.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Caracteriza;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_ActLista.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		if (!fmeFrame.contexto.equals("toolbar"))
			CBData.ActLista.Clear();
		CBData.Caracteriza.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.ActLista.validar(null));
		grp.add_grp(CBData.Caracteriza.validar(null));
		return grp;
	}
}

class Frame_ActLista_jButton_ActListaCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActLista adaptee;
	
	Frame_ActLista_jButton_ActListaCopy_mouseAdapter(Frame_ActLista adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActListaCopy_mouseClicked(e);
	}	
}

class Frame_ActLista_jButton_ActListaUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActLista adaptee;
	
	Frame_ActLista_jButton_ActListaUp_mouseAdapter(Frame_ActLista adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActListaUp_mouseClicked(e);
	}
}

class Frame_ActLista_jButton_ActListaAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActLista adaptee;

	Frame_ActLista_jButton_ActListaAdd_mouseAdapter(Frame_ActLista adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActListaAdd_mouseClicked(e);
	}
}

class Frame_ActLista_jButton_ActListaDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActLista adaptee;

	Frame_ActLista_jButton_ActListaDel_mouseAdapter(Frame_ActLista adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActListaDel_mouseClicked(e);
	}
}

class Frame_ActLista_jButton_ActListaIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActLista adaptee;

	Frame_ActLista_jButton_ActListaIns_mouseAdapter(Frame_ActLista adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActListaIns_mouseClicked(e);
	}
}
