package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_ActRecursos extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ActRecursosInt = null;
	private JLabel jLabel_ActRecursosInt = null;
	private JScrollPane jScrollPane_ActRecursosInt = null;
	private JTable_Tip jTable_ActRecursosInt = null;
	private JButton jButton_ActRecursosIntCopy = null;
	private JButton jButton_ActRecursosIntUp = null;
	private JButton jButton_ActRecursosIntAdd = null;
	private JButton jButton_ActRecursosIntIns = null;
	private JButton jButton_ActRecursosIntDel = null;

	private JPanel jPanel_ActRecursosExt = null;
	private JLabel jLabel_ActRecursosExt = null;
	private JScrollPane jScrollPane_ActRecursosExt = null;
	private JTable_Tip jTable_ActRecursosExt = null;
	private JButton jButton_ActRecursosExtCopy = null;
	private JButton jButton_ActRecursosExtUp = null;
	private JButton jButton_ActRecursosExtAdd = null;
	private JButton jButton_ActRecursosExtIns = null;
	private JButton jButton_ActRecursosExtDel = null;

	public CBTabela_ActRecursosInt CBData_ActRecursosInt = null;
	public CBTabela_ActRecursosExt CBData_ActRecursosExt = null;
	String tag = "";

	public Frame_ActRecursos() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,631);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_ActRecursosInt, 30);
		up_component(jPanel_ActRecursosExt, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ActRecursosInt(), null);
			jContentPane.add(getJPanel_ActRecursosExt(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_ActRecursosInt() {
		if (jPanel_ActRecursosInt == null) {
			jLabel_ActRecursosInt = new JLabel();
			jLabel_ActRecursosInt.setBounds(new Rectangle(12, 10, 390, 18));
			jLabel_ActRecursosInt.setText("Pessoal tcnico do promotor");
			jLabel_ActRecursosInt.setFont(fmeFrame.letra_bold);

			jButton_ActRecursosIntCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ActRecursosIntCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosIntCopy.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosIntCopy_mouseAdapter(this));
			jButton_ActRecursosIntCopy.setToolTipText("Copiar Linha");
			jButton_ActRecursosIntCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ActRecursosIntUp = new JButton(fmeFrame.subirLinha);
			jButton_ActRecursosIntUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosIntUp.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosIntUp_mouseAdapter(this));
			jButton_ActRecursosIntUp.setToolTipText("Trocar Linhas");
			jButton_ActRecursosIntUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ActRecursosIntAdd = new JButton(fmeFrame.novaLinha);
			jButton_ActRecursosIntAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosIntAdd.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosIntAdd_mouseAdapter(this));
			jButton_ActRecursosIntAdd.setToolTipText("Nova Linha");
			jButton_ActRecursosIntAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ActRecursosIntIns = new JButton(fmeFrame.inserirLinha);
			jButton_ActRecursosIntIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosIntIns.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosIntIns_mouseAdapter(this));
			jButton_ActRecursosIntIns.setToolTipText("Inserir Linha");
			jButton_ActRecursosIntIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ActRecursosIntDel = new JButton(fmeFrame.apagarLinha);
			jButton_ActRecursosIntDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosIntDel.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosIntDel_mouseAdapter(this));
			jButton_ActRecursosIntDel.setToolTipText("Apagar Linha");
			jButton_ActRecursosIntDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ActRecursosInt = new JPanel();
			jPanel_ActRecursosInt.setLayout(null);
			jPanel_ActRecursosInt.setBounds(new Rectangle(15, 50, 640, 278));
			jPanel_ActRecursosInt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActRecursosInt.add(jLabel_ActRecursosInt, null);
			jPanel_ActRecursosInt.add(jButton_ActRecursosIntCopy, null);
			jPanel_ActRecursosInt.add(jButton_ActRecursosIntUp, null);
			jPanel_ActRecursosInt.add(jButton_ActRecursosIntAdd, null);
			jPanel_ActRecursosInt.add(jButton_ActRecursosIntIns, null);
			jPanel_ActRecursosInt.add(jButton_ActRecursosIntDel, null);
			jPanel_ActRecursosInt.add(getJScrollPane_ActRecursosInt(), null);
		}
		return jPanel_ActRecursosInt;
	}
	public JScrollPane getJScrollPane_ActRecursosInt() {
		if (jScrollPane_ActRecursosInt == null) {
			jScrollPane_ActRecursosInt = new JScrollPane();
			jScrollPane_ActRecursosInt.setBounds(new Rectangle(16, 36, 606, 225));
			jScrollPane_ActRecursosInt.setViewportView(getJTable_ActRecursosInt());
			jScrollPane_ActRecursosInt.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActRecursosInt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActRecursosInt.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActRecursosInt;
	}
	public JTable getJTable_ActRecursosInt() {
		if (jTable_ActRecursosInt == null) {
			jTable_ActRecursosInt = new JTable_Tip(40, jScrollPane_ActRecursosInt.getWidth());
			jTable_ActRecursosInt.setFont(fmeFrame.letra);
			jTable_ActRecursosInt.setRowHeight(18);
			jTable_ActRecursosInt.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActRecursosInt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActRecursosInt;
	}
	void jButton_ActRecursosIntCopy_mouseClicked(MouseEvent e) {
		CBData_ActRecursosInt.on_copy_row();
	}
	void jButton_ActRecursosIntUp_mouseClicked(MouseEvent e) {
		CBData_ActRecursosInt.on_up_row();
	}
	void jButton_ActRecursosIntAdd_mouseClicked(MouseEvent e) {
		CBData_ActRecursosInt.on_add_row();
	}
	void jButton_ActRecursosIntDel_mouseClicked(MouseEvent e) {
		CBData_ActRecursosInt.on_del_row();
	}
	void jButton_ActRecursosIntIns_mouseClicked(MouseEvent e) {
		CBData_ActRecursosInt.on_ins_row();
	}

	private JPanel getJPanel_ActRecursosExt() {
		if (jPanel_ActRecursosExt == null) {
			jLabel_ActRecursosExt = new JLabel();
			jLabel_ActRecursosExt.setBounds(new Rectangle(12, 10, 372, 18));
			jLabel_ActRecursosExt.setText("Pessoal tcnico sub-contratado");
			jLabel_ActRecursosExt.setFont(fmeFrame.letra_bold);

			jButton_ActRecursosExtCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ActRecursosExtCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosExtCopy.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosExtCopy_mouseAdapter(this));
			jButton_ActRecursosExtCopy.setToolTipText("Copiar Linha");
			jButton_ActRecursosExtCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ActRecursosExtUp = new JButton(fmeFrame.subirLinha);
			jButton_ActRecursosExtUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosExtUp.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosExtUp_mouseAdapter(this));
			jButton_ActRecursosExtUp.setToolTipText("Trocar Linhas");
			jButton_ActRecursosExtUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ActRecursosExtAdd = new JButton(fmeFrame.novaLinha);
			jButton_ActRecursosExtAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosExtAdd.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosExtAdd_mouseAdapter(this));
			jButton_ActRecursosExtAdd.setToolTipText("Nova Linha");
			jButton_ActRecursosExtAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ActRecursosExtIns = new JButton(fmeFrame.inserirLinha);
			jButton_ActRecursosExtIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosExtIns.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosExtIns_mouseAdapter(this));
			jButton_ActRecursosExtIns.setToolTipText("Inserir Linha");
			jButton_ActRecursosExtIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ActRecursosExtDel = new JButton(fmeFrame.apagarLinha);
			jButton_ActRecursosExtDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActRecursosExtDel.addMouseListener(new Frame_ActRecursos_jButton_ActRecursosExtDel_mouseAdapter(this));
			jButton_ActRecursosExtDel.setToolTipText("Apagar Linha");
			jButton_ActRecursosExtDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ActRecursosExt = new JPanel();
			jPanel_ActRecursosExt.setLayout(null);
			jPanel_ActRecursosExt.setBounds(new Rectangle(15, 338, 640, 278));
			jPanel_ActRecursosExt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActRecursosExt.add(jLabel_ActRecursosExt, null);
			jPanel_ActRecursosExt.add(jButton_ActRecursosExtCopy, null);
			jPanel_ActRecursosExt.add(jButton_ActRecursosExtUp, null);
			jPanel_ActRecursosExt.add(jButton_ActRecursosExtAdd, null);
			jPanel_ActRecursosExt.add(jButton_ActRecursosExtIns, null);
			jPanel_ActRecursosExt.add(jButton_ActRecursosExtDel, null);
			jPanel_ActRecursosExt.add(getJScrollPane_ActRecursosExt(), null);
		}
		return jPanel_ActRecursosExt;
	}
	public JScrollPane getJScrollPane_ActRecursosExt() {
		if (jScrollPane_ActRecursosExt == null) {
			jScrollPane_ActRecursosExt = new JScrollPane();
			jScrollPane_ActRecursosExt.setBounds(new Rectangle(16, 36, 606, 225));
			jScrollPane_ActRecursosExt.setViewportView(getJTable_ActRecursosExt());
			jScrollPane_ActRecursosExt.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActRecursosExt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActRecursosExt.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActRecursosExt;
	}
	public JTable getJTable_ActRecursosExt() {
		if (jTable_ActRecursosExt == null) {
			jTable_ActRecursosExt = new JTable_Tip(40, jScrollPane_ActRecursosExt.getWidth());
			jTable_ActRecursosExt.setFont(fmeFrame.letra);
			jTable_ActRecursosExt.setRowHeight(18);
			jTable_ActRecursosExt.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActRecursosExt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActRecursosExt;
	}
	void jButton_ActRecursosExtCopy_mouseClicked(MouseEvent e) {
		CBData_ActRecursosExt.on_copy_row();
	}
	void jButton_ActRecursosExtUp_mouseClicked(MouseEvent e) {
		CBData_ActRecursosExt.on_up_row();
	}
	void jButton_ActRecursosExtAdd_mouseClicked(MouseEvent e) {
		CBData_ActRecursosExt.on_add_row();
	}
	void jButton_ActRecursosExtDel_mouseClicked(MouseEvent e) {
		CBData_ActRecursosExt.on_del_row();
	}
	void jButton_ActRecursosExtIns_mouseClicked(MouseEvent e) {
		CBData_ActRecursosExt.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_ActRecursosInt.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_ActRecursosInt.Clear();
		CBData_ActRecursosExt.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_ActRecursosInt.validar(null));
		grp.add_grp(CBData_ActRecursosExt.validar(null));
		return grp;
	}
}

class Frame_ActRecursos_jButton_ActRecursosIntCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;
	
	Frame_ActRecursos_jButton_ActRecursosIntCopy_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosIntCopy_mouseClicked(e);
	}	
}

class Frame_ActRecursos_jButton_ActRecursosIntUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;
	
	Frame_ActRecursos_jButton_ActRecursosIntUp_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosIntUp_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosIntAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosIntAdd_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosIntAdd_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosIntDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosIntDel_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosIntDel_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosIntIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosIntIns_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosIntIns_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosExtCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;
	
	Frame_ActRecursos_jButton_ActRecursosExtCopy_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosExtCopy_mouseClicked(e);
	}	
}

class Frame_ActRecursos_jButton_ActRecursosExtUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;
	
	Frame_ActRecursos_jButton_ActRecursosExtUp_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosExtUp_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosExtAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosExtAdd_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosExtAdd_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosExtDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosExtDel_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosExtDel_mouseClicked(e);
	}
}

class Frame_ActRecursos_jButton_ActRecursosExtIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActRecursos adaptee;

	Frame_ActRecursos_jButton_ActRecursosExtIns_mouseAdapter(Frame_ActRecursos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActRecursosExtIns_mouseClicked(e);
	}
}
