package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_ActResultados extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ActResultados = null;
	private JLabel jLabel_ActResultados = null;
	private JScrollPane jScrollPane_ActResultados = null;
	private JTable_Tip jTable_ActResultados = null;
	private JButton jButton_ActResultadosCopy = null;
	private JButton jButton_ActResultadosUp = null;
	private JButton jButton_ActResultadosAdd = null;
	private JButton jButton_ActResultadosIns = null;
	private JButton jButton_ActResultadosDel = null;

	private JPanel jPanel_ActDescResult = null;
	private JLabel jLabel_ActDescResult = null;
	private JScrollPane jScrollPane_ActDescResult = null;
	private JTextArea jTextArea_ActDescResult = null;

	public CBTabela_ActResultados CBData_ActResultados = null;
	public CBRegisto_ActDescResult CBData_ActDescResult = null;
	String tag = "";

	public Frame_ActResultados() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,377);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_ActResultados, 30);
		up_component(jPanel_ActDescResult, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ActResultados(), null);
			jContentPane.add(getJPanel_ActDescResult(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_ActResultados() {
		if (jPanel_ActResultados == null) {
			jLabel_ActResultados = new JLabel();
			jLabel_ActResultados.setBounds(new Rectangle(12, 10, 393, 18));
			jLabel_ActResultados.setText("Calendarizao dos milestones");
			jLabel_ActResultados.setFont(fmeFrame.letra_bold);

			jButton_ActResultadosCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ActResultadosCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActResultadosCopy.addMouseListener(new Frame_ActResultados_jButton_ActResultadosCopy_mouseAdapter(this));
			jButton_ActResultadosCopy.setToolTipText("Copiar Linha");
			jButton_ActResultadosCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ActResultadosUp = new JButton(fmeFrame.subirLinha);
			jButton_ActResultadosUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActResultadosUp.addMouseListener(new Frame_ActResultados_jButton_ActResultadosUp_mouseAdapter(this));
			jButton_ActResultadosUp.setToolTipText("Trocar Linhas");
			jButton_ActResultadosUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ActResultadosAdd = new JButton(fmeFrame.novaLinha);
			jButton_ActResultadosAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActResultadosAdd.addMouseListener(new Frame_ActResultados_jButton_ActResultadosAdd_mouseAdapter(this));
			jButton_ActResultadosAdd.setToolTipText("Nova Linha");
			jButton_ActResultadosAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ActResultadosIns = new JButton(fmeFrame.inserirLinha);
			jButton_ActResultadosIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActResultadosIns.addMouseListener(new Frame_ActResultados_jButton_ActResultadosIns_mouseAdapter(this));
			jButton_ActResultadosIns.setToolTipText("Inserir Linha");
			jButton_ActResultadosIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ActResultadosDel = new JButton(fmeFrame.apagarLinha);
			jButton_ActResultadosDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActResultadosDel.addMouseListener(new Frame_ActResultados_jButton_ActResultadosDel_mouseAdapter(this));
			jButton_ActResultadosDel.setToolTipText("Apagar Linha");
			jButton_ActResultadosDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ActResultados = new JPanel();
			jPanel_ActResultados.setLayout(null);
			jPanel_ActResultados.setBounds(new Rectangle(15, 50, 640, 278));
			jPanel_ActResultados.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActResultados.add(jLabel_ActResultados, null);
			jPanel_ActResultados.add(jButton_ActResultadosCopy, null);
			jPanel_ActResultados.add(jButton_ActResultadosUp, null);
			jPanel_ActResultados.add(jButton_ActResultadosAdd, null);
			jPanel_ActResultados.add(jButton_ActResultadosIns, null);
			jPanel_ActResultados.add(jButton_ActResultadosDel, null);
			jPanel_ActResultados.add(getJScrollPane_ActResultados(), null);
		}
		return jPanel_ActResultados;
	}
	public JScrollPane getJScrollPane_ActResultados() {
		if (jScrollPane_ActResultados == null) {
			jScrollPane_ActResultados = new JScrollPane();
			jScrollPane_ActResultados.setBounds(new Rectangle(16, 36, 606, 225));
			jScrollPane_ActResultados.setViewportView(getJTable_ActResultados());
			jScrollPane_ActResultados.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActResultados.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActResultados.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActResultados;
	}
	public JTable getJTable_ActResultados() {
		if (jTable_ActResultados == null) {
			jTable_ActResultados = new JTable_Tip(40, jScrollPane_ActResultados.getWidth());
			jTable_ActResultados.setFont(fmeFrame.letra);
			jTable_ActResultados.setRowHeight(18);
			jTable_ActResultados.setName("Milestones");
			jTable_ActResultados.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActResultados.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActResultados;
	}
	void jButton_ActResultadosCopy_mouseClicked(MouseEvent e) {
		CBData_ActResultados.on_copy_row();
	}
	void jButton_ActResultadosUp_mouseClicked(MouseEvent e) {
		CBData_ActResultados.on_up_row();
	}
	void jButton_ActResultadosAdd_mouseClicked(MouseEvent e) {
		CBData_ActResultados.on_add_row();
	}
	void jButton_ActResultadosDel_mouseClicked(MouseEvent e) {
		CBData_ActResultados.on_del_row();
	}
	void jButton_ActResultadosIns_mouseClicked(MouseEvent e) {
		CBData_ActResultados.on_ins_row();
	}

	private JPanel getJPanel_ActDescResult() {
		if (jPanel_ActDescResult == null) {
			jLabel_ActDescResult = new JLabel();
			jLabel_ActDescResult.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_ActDescResult.setText("Justificao dos milestones");
			jLabel_ActDescResult.setFont(fmeFrame.letra_bold);

			jPanel_ActDescResult = new JPanel();
			jPanel_ActDescResult.setLayout(null);
			jPanel_ActDescResult.setBounds(new Rectangle(15, 338, 640, 473));
			jPanel_ActDescResult.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActDescResult.setName("act_desc_result_texto");
			jPanel_ActDescResult.add(jLabel_ActDescResult, null);
			jPanel_ActDescResult.add(getJScrollPane_ActDescResult(), null);
		}
		return jPanel_ActDescResult;
	}
	private JScrollPane getJScrollPane_ActDescResult() {
		if (jScrollPane_ActDescResult == null) {
			jScrollPane_ActDescResult = new JScrollPane();
			jScrollPane_ActDescResult.setBounds(new Rectangle(15, 35, 609, 420));
			jScrollPane_ActDescResult.setPreferredSize(new Dimension(250, 250));
			jScrollPane_ActDescResult.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_ActDescResult.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_ActDescResult.setViewportView(getJTextArea_ActDescResult());
		}
		return jScrollPane_ActDescResult;
	}
	public JTextArea getJTextArea_ActDescResult() {
		if (jTextArea_ActDescResult == null) {
			jTextArea_ActDescResult = new JTextArea();
			jTextArea_ActDescResult.setFont(fmeFrame.letra);
			jTextArea_ActDescResult.setLineWrap(true);
			jTextArea_ActDescResult.setWrapStyleWord(true);
			jTextArea_ActDescResult.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_ActDescResult;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_ActResultados.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_ActResultados.Clear();
		CBData_ActDescResult.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_ActResultados.validar(null));
		grp.add_grp(CBData_ActDescResult.validar(null));
		return grp;
	}
}

class Frame_ActResultados_jButton_ActResultadosCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActResultados adaptee;
	
	Frame_ActResultados_jButton_ActResultadosCopy_mouseAdapter(Frame_ActResultados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActResultadosCopy_mouseClicked(e);
	}	
}

class Frame_ActResultados_jButton_ActResultadosUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActResultados adaptee;
	
	Frame_ActResultados_jButton_ActResultadosUp_mouseAdapter(Frame_ActResultados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActResultadosUp_mouseClicked(e);
	}
}

class Frame_ActResultados_jButton_ActResultadosAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActResultados adaptee;

	Frame_ActResultados_jButton_ActResultadosAdd_mouseAdapter(Frame_ActResultados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActResultadosAdd_mouseClicked(e);
	}
}

class Frame_ActResultados_jButton_ActResultadosDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActResultados adaptee;

	Frame_ActResultados_jButton_ActResultadosDel_mouseAdapter(Frame_ActResultados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActResultadosDel_mouseClicked(e);
	}
}

class Frame_ActResultados_jButton_ActResultadosIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActResultados adaptee;

	Frame_ActResultados_jButton_ActResultadosIns_mouseAdapter(Frame_ActResultados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActResultadosIns_mouseClicked(e);
	}
}
