package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;
import javax.swing.JScrollPane;

public class Frame_ActTarefas extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ActDatasEtc = null;
	private JLabel jLabel_ActDatasEtc = null;
	private JLabel jLabel_Actividade = null;
	private JTextField jTextField_Actividade = null;
	private JLabel jLabel_DataIni = null;
	private JTextField jTextField_DataIni = null;
	private JLabel jLabel_DataFim = null;
	private JTextField jTextField_DataFim = null;
	private JLabel jLabel_Duracao = null;
	private JTextField jTextField_Duracao = null;

	private JPanel jPanel_ActTarefas = null;
	private JLabel jLabel_ActTarefas = null;
	private JScrollPane jScrollPane_ActTarefas = null;
	private JTable_Tip jTable_ActTarefas = null;
	private JButton jButton_ActTarefasCopy = null;
	private JButton jButton_ActTarefasUp = null;
	private JButton jButton_ActTarefasAdd = null;
	private JButton jButton_ActTarefasIns = null;
	private JButton jButton_ActTarefasDel = null;

	private JPanel jPanel_ActDescricao = null;
	private JLabel jLabel_ActDescricao = null;
	private JScrollPane jScrollPane_ActDescricao = null;
	private JTextArea jTextArea_ActDescricao = null;

	public CBRegisto_ActDescricao CBData_ActDescricao = null;
	public CBTabela_ActTarefas CBData_ActTarefas = null;
	String tag = "";

	public Frame_ActTarefas() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,642);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_ActDatasEtc, 30);
		up_component(jPanel_ActTarefas, 30);
		up_component(jPanel_ActDescricao, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ActDatasEtc(), null);
			jContentPane.add(getJPanel_ActDescricao(), null);
			jContentPane.add(getJPanel_ActTarefas(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_ActDatasEtc() {
		if (jPanel_ActDatasEtc == null) {
			jLabel_ActDatasEtc = new JLabel();
			jLabel_ActDatasEtc.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_ActDatasEtc.setText("Caracterizao da Actividade:");
			jLabel_ActDatasEtc.setFont(fmeFrame.letra_bold);

			jLabel_Actividade = new JLabel();
			jLabel_Actividade.setBounds(new Rectangle(22, 36, 66, 18));
			jLabel_Actividade.setText("Designao");
			jLabel_Actividade.setFont(fmeFrame.letra);
			jLabel_DataIni = new JLabel();
			jLabel_DataIni.setBounds(new Rectangle(22, 62, 162, 18));
			jLabel_DataIni.setText("Data de Incio da Actividade");
			jLabel_DataIni.setFont(fmeFrame.letra);
			jLabel_DataFim = new JLabel();
			jLabel_DataFim.setBounds(new Rectangle(22, 88, 162, 18));
			jLabel_DataFim.setText("Data de Concluso da Actividade");
			jLabel_DataFim.setFont(fmeFrame.letra);
			jLabel_Duracao = new JLabel();
			jLabel_Duracao.setBounds(new Rectangle(370, 62, 90, 18));
			jLabel_Duracao.setText("Durao (meses)");
			jLabel_Duracao.setFont(fmeFrame.letra);

			jPanel_ActDatasEtc = new JPanel();
			jPanel_ActDatasEtc.setLayout(null);
			jPanel_ActDatasEtc.setBounds(new Rectangle(15, 50, 640, 122));
			jPanel_ActDatasEtc.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActDatasEtc.add(jLabel_ActDatasEtc, null);
			jPanel_ActDatasEtc.add(jLabel_Actividade, null);
			jPanel_ActDatasEtc.add(getJTextField_Actividade(), null);
			jPanel_ActDatasEtc.add(jLabel_DataIni, null);
			jPanel_ActDatasEtc.add(getJTextField_DataIni(), null);
			jPanel_ActDatasEtc.add(jLabel_DataFim, null);
			jPanel_ActDatasEtc.add(getJTextField_DataFim(), null);
			jPanel_ActDatasEtc.add(jLabel_Duracao, null);
			jPanel_ActDatasEtc.add(getJTextField_Duracao(), null);
		}
		return jPanel_ActDatasEtc;
	}
	public JTextField getJTextField_Actividade() {
		if (jTextField_Actividade == null) {
			jTextField_Actividade = new JTextField();
			jTextField_Actividade.setBounds(new Rectangle(88, 36, 536, 18));
			jTextField_Actividade.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Actividade.setFont(fmeFrame.letra);
		}
		return jTextField_Actividade;
	}
	public JTextField getJTextField_DataIni() {
		if (jTextField_DataIni == null) {
			jTextField_DataIni = new JTextField();
			jTextField_DataIni.setBounds(new Rectangle(184, 62, 90, 18));
			jTextField_DataIni.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_DataIni.setFont(fmeFrame.letra);
			jTextField_DataIni.setEditable(false);
		}
		return jTextField_DataIni;
	}
	public JTextField getJTextField_DataFim() {
		if (jTextField_DataFim == null) {
			jTextField_DataFim = new JTextField();
			jTextField_DataFim.setBounds(new Rectangle(184, 88, 90, 18));
			jTextField_DataFim.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_DataFim.setFont(fmeFrame.letra);
			jTextField_DataFim.setEditable(false);
		}
		return jTextField_DataFim;
	}
	public JTextField getJTextField_Duracao() {
		if (jTextField_Duracao == null) {
			jTextField_Duracao = new JTextField();
			jTextField_Duracao.setBounds(new Rectangle(460, 62, 67, 18));
			jTextField_Duracao.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Duracao.setFont(fmeFrame.letra);
			jTextField_Duracao.setEditable(false);
		}
		return jTextField_Duracao;
	}

	private JPanel getJPanel_ActDescricao() {
		if (jPanel_ActDescricao == null) {
			jLabel_ActDescricao = new JLabel();
			jLabel_ActDescricao.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_ActDescricao.setText("Descrio da Actividade:");
			jLabel_ActDescricao.setFont(fmeFrame.letra_bold);

			jPanel_ActDescricao = new JPanel();
			jPanel_ActDescricao.setLayout(null);
			jPanel_ActDescricao.setBounds(new Rectangle(15, 182, 640, 200));
			jPanel_ActDescricao.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActDescricao.setName("act_descricao_texto");
			jPanel_ActDescricao.add(jLabel_ActDescricao, null);
			jPanel_ActDescricao.add(getJScrollPane_ActDescricao(), null);
		}
		return jPanel_ActDescricao;
	}
	private JScrollPane getJScrollPane_ActDescricao() {
		if (jScrollPane_ActDescricao == null) {
			jScrollPane_ActDescricao = new JScrollPane();
			jScrollPane_ActDescricao.setBounds(new Rectangle(15, 35, 609, 150));
			jScrollPane_ActDescricao.setPreferredSize(new Dimension(250, 250));
			jScrollPane_ActDescricao.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_ActDescricao.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_ActDescricao.setViewportView(getJTextArea_ActDescricao());
		}
		return jScrollPane_ActDescricao;
	}
	public JTextArea getJTextArea_ActDescricao() {
		if (jTextArea_ActDescricao == null) {
			jTextArea_ActDescricao = new JTextArea();
			jTextArea_ActDescricao.setFont(fmeFrame.letra);
			jTextArea_ActDescricao.setLineWrap(true);
			jTextArea_ActDescricao.setWrapStyleWord(true);
			jTextArea_ActDescricao.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_ActDescricao;
	}

	private JPanel getJPanel_ActTarefas() {
		if (jPanel_ActTarefas == null) {
			jLabel_ActTarefas = new JLabel();
			jLabel_ActTarefas.setBounds(new Rectangle(12, 10, 377, 18));
			jLabel_ActTarefas.setText("Lista de tarefas");
			jLabel_ActTarefas.setFont(fmeFrame.letra_bold);

			jButton_ActTarefasCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ActTarefasCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActTarefasCopy.addMouseListener(new Frame_ActTarefas_jButton_ActTarefasCopy_mouseAdapter(this));
			jButton_ActTarefasCopy.setToolTipText("Copiar Linha");
			jButton_ActTarefasCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ActTarefasUp = new JButton(fmeFrame.subirLinha);
			jButton_ActTarefasUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActTarefasUp.addMouseListener(new Frame_ActTarefas_jButton_ActTarefasUp_mouseAdapter(this));
			jButton_ActTarefasUp.setToolTipText("Trocar Linhas");
			jButton_ActTarefasUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ActTarefasAdd = new JButton(fmeFrame.novaLinha);
			jButton_ActTarefasAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActTarefasAdd.addMouseListener(new Frame_ActTarefas_jButton_ActTarefasAdd_mouseAdapter(this));
			jButton_ActTarefasAdd.setToolTipText("Nova Linha");
			jButton_ActTarefasAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ActTarefasIns = new JButton(fmeFrame.inserirLinha);
			jButton_ActTarefasIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActTarefasIns.addMouseListener(new Frame_ActTarefas_jButton_ActTarefasIns_mouseAdapter(this));
			jButton_ActTarefasIns.setToolTipText("Inserir Linha");
			jButton_ActTarefasIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ActTarefasDel = new JButton(fmeFrame.apagarLinha);
			jButton_ActTarefasDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ActTarefasDel.addMouseListener(new Frame_ActTarefas_jButton_ActTarefasDel_mouseAdapter(this));
			jButton_ActTarefasDel.setToolTipText("Apagar Linha");
			jButton_ActTarefasDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ActTarefas = new JPanel();
			jPanel_ActTarefas.setLayout(null);
			jPanel_ActTarefas.setBounds(new Rectangle(15, 392, 640, 240));
			jPanel_ActTarefas.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActTarefas.add(jLabel_ActTarefas, null);
			//jPanel_ActTarefas.add(jButton_ActTarefasCopy, null);
			//jPanel_ActTarefas.add(jButton_ActTarefasUp, null);
			jPanel_ActTarefas.add(jButton_ActTarefasAdd, null);
			jPanel_ActTarefas.add(jButton_ActTarefasIns, null);
			jPanel_ActTarefas.add(jButton_ActTarefasDel, null);
			jPanel_ActTarefas.add(getJScrollPane_ActTarefas(), null);
		}
		return jPanel_ActTarefas;
	}
	public JScrollPane getJScrollPane_ActTarefas() {
		if (jScrollPane_ActTarefas == null) {
			jScrollPane_ActTarefas = new JScrollPane();
			jScrollPane_ActTarefas.setBounds(new Rectangle(16, 36, 606, 189));
			jScrollPane_ActTarefas.setViewportView(getJTable_ActTarefas());
			jScrollPane_ActTarefas.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActTarefas.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActTarefas.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActTarefas;
	}
	public JTable getJTable_ActTarefas() {
		if (jTable_ActTarefas == null) {
			jTable_ActTarefas = new JTable_Tip(40, jScrollPane_ActTarefas.getWidth());
			jTable_ActTarefas.setFont(fmeFrame.letra);
			jTable_ActTarefas.setRowHeight(18);
			jTable_ActTarefas.setName("Tarefas");
			jTable_ActTarefas.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActTarefas.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActTarefas;
	}
	void jButton_ActTarefasCopy_mouseClicked(MouseEvent e) {
		CBData_ActTarefas.on_copy_row();
	}
	void jButton_ActTarefasUp_mouseClicked(MouseEvent e) {
		CBData_ActTarefas.on_up_row();
	}
	void jButton_ActTarefasAdd_mouseClicked(MouseEvent e) {
		CBData_ActTarefas.on_add_row();
	}
	void jButton_ActTarefasDel_mouseClicked(MouseEvent e) {
		if (CBData_ActTarefas.del_ins_ok("Apagar")){
			CBData_ActTarefas.on_del_row();
			CBData_ActTarefas.on_update("data_ini", 0, "");
			CBData_ActTarefas.numerar(0);
		}
	}
	void jButton_ActTarefasIns_mouseClicked(MouseEvent e) {
		if (CBData_ActTarefas.del_ins_ok("Inserir")){
			CBData_ActTarefas.on_ins_row();
		}
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_ActDescricao.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_ActDescricao.Clear();
		CBData_ActTarefas.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_ActDescricao.validar(null));
		grp.add_grp(CBData_ActTarefas.validar(null));
		return grp;
	}
}

class Frame_ActTarefas_jButton_ActTarefasCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActTarefas adaptee;
	
	Frame_ActTarefas_jButton_ActTarefasCopy_mouseAdapter(Frame_ActTarefas adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActTarefasCopy_mouseClicked(e);
	}	
}

class Frame_ActTarefas_jButton_ActTarefasUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActTarefas adaptee;
	
	Frame_ActTarefas_jButton_ActTarefasUp_mouseAdapter(Frame_ActTarefas adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActTarefasUp_mouseClicked(e);
	}
}

class Frame_ActTarefas_jButton_ActTarefasAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActTarefas adaptee;

	Frame_ActTarefas_jButton_ActTarefasAdd_mouseAdapter(Frame_ActTarefas adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActTarefasAdd_mouseClicked(e);
	}
}

class Frame_ActTarefas_jButton_ActTarefasDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActTarefas adaptee;

	Frame_ActTarefas_jButton_ActTarefasDel_mouseAdapter(Frame_ActTarefas adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActTarefasDel_mouseClicked(e);
	}
}

class Frame_ActTarefas_jButton_ActTarefasIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActTarefas adaptee;

	Frame_ActTarefas_jButton_ActTarefasIns_mouseAdapter(Frame_ActTarefas adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ActTarefasIns_mouseClicked(e);
	}
}
