package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_ActivIDT extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ActivIDT = null;
	private JLabel jLabel_ActivIDT = null;
	private JScrollPane jScrollPane_ActivIDT = null;
	private JTable_Tip jTable_ActivIDT = null;
	private JButton jButton_ActivIDTAdd = null;
	private JButton jButton_ActivIDTIns = null;
	private JButton jButton_ActivIDTDel = null;

	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	String tag = "";
		
	public Frame_ActivIDT() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,610);
	}

	String coluna_coop = "N";  //  @jve:decl-index=0:
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("coop") != null ) {
			coluna_coop = (String) params.get("coop");
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			
			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_ActivIDT(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_ActivIDT() {
		if (jPanel_ActivIDT == null) {
		    jButton_ActivIDTAdd = new JButton(fmeFrame.novaLinha);
		    jButton_ActivIDTAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ActivIDTAdd.addMouseListener(new Frame_ActivIDT_jButton_ActivIDTAdd_mouseAdapter(this));
		    jButton_ActivIDTAdd.setToolTipText("Nova Linha");
		    jButton_ActivIDTAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_ActivIDTIns = new JButton(fmeFrame.inserirLinha);
		    jButton_ActivIDTIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ActivIDTIns.addMouseListener(new Frame_ActivIDT_jButton_ActivIDTIns_mouseAdapter(this));
		    jButton_ActivIDTIns.setToolTipText("Inserir Linha");
		    jButton_ActivIDTIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_ActivIDTDel = new JButton(fmeFrame.apagarLinha);
		    jButton_ActivIDTDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ActivIDTDel.addMouseListener(new Frame_ActivIDT_jButton_ActivIDTDel_mouseAdapter(this));
		    jButton_ActivIDTDel.setToolTipText("Apagar Linha");
		    jButton_ActivIDTDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_ActivIDT = new JLabel();
			jLabel_ActivIDT.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_ActivIDT.setText("<html>Descrio das Actividades</html>");
			jLabel_ActivIDT.setFont(fmeFrame.letra_bold);			
			jPanel_ActivIDT = new JPanel();
			jPanel_ActivIDT.setLayout(null);
			jPanel_ActivIDT.setBounds(new Rectangle(15, 50, 640, 230));
			jPanel_ActivIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ActivIDT.add(jLabel_ActivIDT, null);
			jPanel_ActivIDT.add(jButton_ActivIDTAdd, null);
			jPanel_ActivIDT.add(jButton_ActivIDTIns, null);
			jPanel_ActivIDT.add(jButton_ActivIDTDel, null);
			jPanel_ActivIDT.add(getJScrollPane_ActivIDT(), null);
		}
		return jPanel_ActivIDT;
	}
	
	public JScrollPane getJScrollPane_ActivIDT() {
		if (jScrollPane_ActivIDT == null) {
			jScrollPane_ActivIDT = new JScrollPane();
			jScrollPane_ActivIDT.setBounds(new Rectangle(10, 40, 620, 170));
			jScrollPane_ActivIDT.setViewportView(getJTable_ActivIDT());
			//jScrollPane_ActivIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ActivIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ActivIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ActivIDT;
	}
	
	public JTable getJTable_ActivIDT() {
		if (jTable_ActivIDT == null) {
			jTable_ActivIDT = new JTable_Tip(40, jScrollPane_ActivIDT.getWidth());
			jTable_ActivIDT.setFont(fmeFrame.letra);
			jTable_ActivIDT.setRowHeight(18);
			jTable_ActivIDT.setName("QuadrosTecn_Tabela");
			jTable_ActivIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ActivIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ActivIDT;
	}
	void jButton_ActivIDTAdd_mouseClicked(MouseEvent e) {
		CBData.ActivIDT.on_add_row();
	}

	void jButton_ActivIDTDel_mouseClicked(MouseEvent e) {
		if(CBData.ActivIDT.del_ins_ok("Apagar")){
			CBData.ActivIDT.on_del_row();
			CTabelas.ActivIDT.refresh();
		}
	}

	void jButton_ActivIDTIns_mouseClicked(MouseEvent e) {
		if(CBData.ActivIDT.del_ins_ok("Inserir")){
			CBData.ActivIDT.on_ins_row();
		}
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_Fundam.setText("Caracterizao e fundamentao das actividades");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 290, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("quadros_tecnicos_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_ActivIDT.getWidth() - jScrollPane_ActivIDT.getWidth();
		int w = jPanel_ActivIDT.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		if (!fmeFrame.contexto.equals("toolbar"))
			CBData.ActivIDT.Clear();
		CBData.ActivIDTTxt.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.ActivIDT.validar(null));
		grp.add_grp(CBData.ActivIDTTxt.validar(null));
		return grp;
	}

}		


class Frame_ActivIDT_jButton_ActivIDTAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActivIDT adaptee;

	Frame_ActivIDT_jButton_ActivIDTAdd_mouseAdapter(Frame_ActivIDT adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ActivIDTAdd_mouseClicked(e);
	}
}

class Frame_ActivIDT_jButton_ActivIDTDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActivIDT adaptee;

	Frame_ActivIDT_jButton_ActivIDTDel_mouseAdapter(Frame_ActivIDT adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ActivIDTDel_mouseClicked(e);
	}
}

class Frame_ActivIDT_jButton_ActivIDTIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ActivIDT adaptee;

	Frame_ActivIDT_jButton_ActivIDTIns_mouseAdapter(Frame_ActivIDT adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ActivIDTIns_mouseClicked(e);
	}
}
