package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_CaractProj2 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Pertinencia = null;
	private JLabel jLabel_Pertinencia = null;
	private JScrollPane jScrollPane_Pertinencia = null;
	private JTextArea jTextArea_Pertinencia = null;

	private JPanel jPanel_CaractInov = null;
	private JLabel jLabel_CaractInov = null;
	private JScrollPane jScrollPane_CaractInov = null;
	private JTextArea jTextArea_CaractInov = null;

	private JPanel jPanel_DesenvolvTec = null;
	private JLabel jLabel_DesenvolvTec = null;
	private JScrollPane jScrollPane_DesenvolvTec = null;
	private JTextArea jTextArea_DesenvolvTec = null;

	String tag = "";

	private final static int area_height = 210;

	public Frame_CaractProj2() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,60+3*(area_height+62));
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_Pertinencia, 30);
		up_component(jPanel_CaractInov, 30);
		up_component(jPanel_DesenvolvTec, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Pertinencia(), null);
			jContentPane.add(getJPanel_CaractInov(), null);
			jContentPane.add(getJPanel_DesenvolvTec(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_Pertinencia() {
		if (jPanel_Pertinencia == null) {
			jLabel_Pertinencia = new JLabel();
			jLabel_Pertinencia.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Pertinencia.setText("Pertinncia da realizao do projecto face aos objectivos");
			jLabel_Pertinencia.setFont(fmeFrame.letra_bold);

			jPanel_Pertinencia = new JPanel();
			jPanel_Pertinencia.setLayout(null);
			jPanel_Pertinencia.setBounds(new Rectangle(15, 50+0*(area_height+62), 640, area_height+52));
			jPanel_Pertinencia.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Pertinencia.setName("_texto");
			jPanel_Pertinencia.add(jLabel_Pertinencia, null);
			jPanel_Pertinencia.add(getJScrollPane_Pertinencia(), null);
		}
		return jPanel_Pertinencia;
	}
	private JScrollPane getJScrollPane_Pertinencia() {
		if (jScrollPane_Pertinencia == null) {
			jScrollPane_Pertinencia = new JScrollPane();
			jScrollPane_Pertinencia.setBounds(new Rectangle(15, 35, 609, area_height));
			jScrollPane_Pertinencia.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Pertinencia.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Pertinencia.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Pertinencia.setViewportView(getJTextArea_Pertinencia());
		}
		return jScrollPane_Pertinencia;
	}
	public JTextArea getJTextArea_Pertinencia() {
		if (jTextArea_Pertinencia == null) {
			jTextArea_Pertinencia = new JTextArea();
			jTextArea_Pertinencia.setFont(fmeFrame.letra);
			jTextArea_Pertinencia.setLineWrap(true);
			jTextArea_Pertinencia.setWrapStyleWord(true);
			jTextArea_Pertinencia.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Pertinencia;
	}

	private JPanel getJPanel_CaractInov() {
		if (jPanel_CaractInov == null) {
			jLabel_CaractInov = new JLabel();
			jLabel_CaractInov.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_CaractInov.setText("Caractersticas inovadoras");
			jLabel_CaractInov.setFont(fmeFrame.letra_bold);

			jPanel_CaractInov = new JPanel();
			jPanel_CaractInov.setLayout(null);
			jPanel_CaractInov.setBounds(new Rectangle(15, 50+1*(area_height+62), 640, area_height+52));
			jPanel_CaractInov.setBorder(BorderFactory.createEtchedBorder());
			jPanel_CaractInov.setName("caract_inov_texto");
			jPanel_CaractInov.add(jLabel_CaractInov, null);
			jPanel_CaractInov.add(getJScrollPane_CaractInov(), null);
		}
		return jPanel_CaractInov;
	}
	private JScrollPane getJScrollPane_CaractInov() {
		if (jScrollPane_CaractInov == null) {
			jScrollPane_CaractInov = new JScrollPane();
			jScrollPane_CaractInov.setBounds(new Rectangle(15, 35, 609, area_height));
			jScrollPane_CaractInov.setPreferredSize(new Dimension(250, 250));
			jScrollPane_CaractInov.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_CaractInov.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_CaractInov.setViewportView(getJTextArea_CaractInov());
		}
		return jScrollPane_CaractInov;
	}
	public JTextArea getJTextArea_CaractInov() {
		if (jTextArea_CaractInov == null) {
			jTextArea_CaractInov = new JTextArea();
			jTextArea_CaractInov.setFont(fmeFrame.letra);
			jTextArea_CaractInov.setLineWrap(true);
			jTextArea_CaractInov.setWrapStyleWord(true);
			jTextArea_CaractInov.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_CaractInov;
	}

	private JPanel getJPanel_DesenvolvTec() {
		if (jPanel_DesenvolvTec == null) {
			jLabel_DesenvolvTec = new JLabel();
			jLabel_DesenvolvTec.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_DesenvolvTec.setText("Desenvolvimentos tcnicos e tecnolgicos que o projecto vai gerar");
			jLabel_DesenvolvTec.setFont(fmeFrame.letra_bold);

			jPanel_DesenvolvTec = new JPanel();
			jPanel_DesenvolvTec.setLayout(null);
			jPanel_DesenvolvTec.setBounds(new Rectangle(15, 50+2*(area_height+62), 640, area_height+52));
			jPanel_DesenvolvTec.setBorder(BorderFactory.createEtchedBorder());
			jPanel_DesenvolvTec.setName("desenvolv_tec_texto");
			jPanel_DesenvolvTec.add(jLabel_DesenvolvTec, null);
			jPanel_DesenvolvTec.add(getJScrollPane_DesenvolvTec(), null);
		}
		return jPanel_DesenvolvTec;
	}
	private JScrollPane getJScrollPane_DesenvolvTec() {
		if (jScrollPane_DesenvolvTec == null) {
			jScrollPane_DesenvolvTec = new JScrollPane();
			jScrollPane_DesenvolvTec.setBounds(new Rectangle(15, 35, 609, area_height));
			jScrollPane_DesenvolvTec.setPreferredSize(new Dimension(250, 250));
			jScrollPane_DesenvolvTec.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_DesenvolvTec.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_DesenvolvTec.setViewportView(getJTextArea_DesenvolvTec());
		}
		return jScrollPane_DesenvolvTec;
	}
	public JTextArea getJTextArea_DesenvolvTec() {
		if (jTextArea_DesenvolvTec == null) {
			jTextArea_DesenvolvTec = new JTextArea();
			jTextArea_DesenvolvTec.setFont(fmeFrame.letra);
			jTextArea_DesenvolvTec.setLineWrap(true);
			jTextArea_DesenvolvTec.setWrapStyleWord(true);
			jTextArea_DesenvolvTec.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_DesenvolvTec;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Pertinencia.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.CaractProj2.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.CaractProj2.validar_1(null));
		grp.add_grp(CBData.CaractProj2.validar_2(null));
		grp.add_grp(CBData.CaractProj2.validar_3(null));
		return grp;
	}
}
