package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Centros_3 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_EmpresasC = null;
	private JLabel jLabel_EmpresasC = null;
	private JLabel jLabel_Empresas = null;
	private JScrollPane jScrollPane_EmpresasC = null;
	private JTable_Tip jTable_EmpresasC = null;
	private JButton jButton_EmpresasCAdd = null;
	private JButton jButton_EmpresasCIns = null;
	private JButton jButton_EmpresasCDel = null;
	
	private JCheckBox jCheckBox_Ambito_1 = null;
	private JCheckBox jCheckBox_Ambito_2 = null;
	private JCheckBox jCheckBox_Ambito_3 = null;
	public JCheckBox jCheckBox_Ambito_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_Ambito = null;  //  @jve:decl-index=0:


	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	String tag = "";
		
	public Frame_Centros_3() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,660);
	}

	String coluna_coop = "N";  //  @jve:decl-index=0:
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("coop") != null ) {
			coluna_coop = (String) params.get("coop");
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			
			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_EmpresasC(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_EmpresasC() {
		if (jPanel_EmpresasC == null) {
		    jButton_EmpresasCAdd = new JButton(fmeFrame.novaLinha);
		    jButton_EmpresasCAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EmpresasCAdd.addMouseListener(new Frame_Centros_3_jButton_EmpresasCAdd_mouseAdapter(this));
		    jButton_EmpresasCAdd.setToolTipText("Nova Linha");
		    jButton_EmpresasCAdd.setBounds(new Rectangle(517, 106, 30, 22));
		    jButton_EmpresasCIns = new JButton(fmeFrame.inserirLinha);
		    jButton_EmpresasCIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EmpresasCIns.addMouseListener(new Frame_Centros_3_jButton_EmpresasCIns_mouseAdapter(this));
		    jButton_EmpresasCIns.setToolTipText("Inserir Linha");
		    jButton_EmpresasCIns.setBounds(new Rectangle(557, 106, 30, 22));
		    jButton_EmpresasCDel = new JButton(fmeFrame.apagarLinha);
		    jButton_EmpresasCDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EmpresasCDel.addMouseListener(new Frame_Centros_3_jButton_EmpresasCDel_mouseAdapter(this));
		    jButton_EmpresasCDel.setToolTipText("Apagar Linha");
		    jButton_EmpresasCDel.setBounds(new Rectangle(597, 106, 30, 22));
			jLabel_EmpresasC = new JLabel();
			jLabel_EmpresasC.setBounds(new Rectangle(12, 10, 362, 18));
			jLabel_EmpresasC.setText("<html>mbito da actividade do Centro de I&DT</html>");
			jLabel_EmpresasC.setFont(fmeFrame.letra_bold);			
			jLabel_Empresas = new JLabel();
			jLabel_Empresas.setBounds(new Rectangle(11, 108, 448, 18));
			jLabel_Empresas.setText("<html>Empresas participadas do grupo para que o Centro de I&DT vai trabalhar</html>");
			jLabel_Empresas.setFont(fmeFrame.letra_bold);			
			jPanel_EmpresasC = new JPanel();
			jPanel_EmpresasC.setLayout(null);
			jPanel_EmpresasC.setBounds(new Rectangle(15, 370, 640, 280));
			jPanel_EmpresasC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_EmpresasC.add(jLabel_EmpresasC, null);
			jPanel_EmpresasC.add(jLabel_Empresas, null);
			jPanel_EmpresasC.add(jButton_EmpresasCAdd, null);
			jPanel_EmpresasC.add(jButton_EmpresasCIns, null);
			jPanel_EmpresasC.add(jButton_EmpresasCDel, null);
			jPanel_EmpresasC.add(getJScrollPane_EmpresasC(), null);
			jPanel_EmpresasC.add(getJCheckBox_Ambito_1(), null);
			jPanel_EmpresasC.add(getJCheckBox_Ambito_2(), null);
			jPanel_EmpresasC.add(getJCheckBox_Ambito_3(), null);
		    this.getJButtonGroup_Ambito();

		}
		return jPanel_EmpresasC;
	}
	
	public JScrollPane getJScrollPane_EmpresasC() {
		if (jScrollPane_EmpresasC == null) {
			jScrollPane_EmpresasC = new JScrollPane();
			jScrollPane_EmpresasC.setBounds(new Rectangle(10, 132, 620, 134));
			jScrollPane_EmpresasC.setViewportView(getJTable_EmpresasC());
			//jScrollPane_EmpresasC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_EmpresasC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_EmpresasC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_EmpresasC;
	}
	
	public JTable getJTable_EmpresasC() {
		if (jTable_EmpresasC == null) {
			jTable_EmpresasC = new JTable_Tip(40, jScrollPane_EmpresasC.getWidth());
			jTable_EmpresasC.setFont(fmeFrame.letra);
			jTable_EmpresasC.setRowHeight(18);
			jTable_EmpresasC.setName("QuadrosTecn_Tabela");
			jTable_EmpresasC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_EmpresasC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_EmpresasC;
	}
	
	public JCheckBox getJCheckBox_Ambito_1() {
		if (jCheckBox_Ambito_1 == null) {
			jCheckBox_Ambito_1 = new JCheckBox();
			jCheckBox_Ambito_1.setBounds(new Rectangle(41, 34, 183, 15));
			jCheckBox_Ambito_1.setText("S para a empresa promotora");
			jCheckBox_Ambito_1.setFont(fmeFrame.letra);
/*			jCheckBox_Ambito_1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Promotor.getByName("emp_nova").vldOnline();}
					catch(Exception ex){}
				}
			});*/

		}
		return jCheckBox_Ambito_1;
	}

	public JCheckBox getJCheckBox_Ambito_2() {
		if (jCheckBox_Ambito_2 == null) {
			jCheckBox_Ambito_2 = new JCheckBox();
			jCheckBox_Ambito_2.setBounds(new Rectangle(41, 54, 190, 15));
			jCheckBox_Ambito_2.setText("Outras empresas");
			jCheckBox_Ambito_2.setFont(fmeFrame.letra);
/*			jCheckBox_Ambito_2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Promotor.getByName("emp_nova").vldOnline();}
					catch(Exception ex){}
				}
			});*/
		}
		return jCheckBox_Ambito_2;
	}
	public JCheckBox getJCheckBox_Ambito_3() {
		if (jCheckBox_Ambito_3 == null) {
			jCheckBox_Ambito_3 = new JCheckBox();
			jCheckBox_Ambito_3.setBounds(new Rectangle(41, 75, 190, 15));
			jCheckBox_Ambito_3.setText("Outras empresas do grupo");
			jCheckBox_Ambito_3.setFont(fmeFrame.letra);
/*			jCheckBox_Ambito_3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Promotor.getByName("emp_nova").vldOnline();}
					catch(Exception ex){}
				}
			});*/
		}
		return jCheckBox_Ambito_3;
	}
	private ButtonGroup getJButtonGroup_Ambito() {
		if (jButtonGroup_Ambito == null) {
			jButtonGroup_Ambito = new ButtonGroup();
			jButtonGroup_Ambito.add(jCheckBox_Ambito_1);
			jButtonGroup_Ambito.add(jCheckBox_Ambito_2);
			jButtonGroup_Ambito.add(jCheckBox_Ambito_3);
			jButtonGroup_Ambito.add(jCheckBox_Ambito_Clear);
		}
		return jButtonGroup_Ambito;
	}


	void jButton_EmpresasCAdd_mouseClicked(MouseEvent e) {
		CBData.EmpresasCentro.on_add_row();
	}

	void jButton_EmpresasCDel_mouseClicked(MouseEvent e) {
		CBData.EmpresasCentro.on_del_row();
	}

	void jButton_EmpresasCIns_mouseClicked(MouseEvent e) {
		CBData.EmpresasCentro.on_ins_row();
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 609, 32));
			jLabel_Fundam.setText("<html>Programa Estratgico<br>Explicitao da estratgia da empresa e do papel da I&D na sua implantao</html>");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 50, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("quadros_tecnicos_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 46, 606, 245));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_EmpresasC.getWidth() - jScrollPane_EmpresasC.getWidth();
		int w = jPanel_EmpresasC.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.AmbitoCentro.Clear();
		CBData.EmpresasCentro.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.AmbitoCentro.validar_2(null));
		grp.add_grp(CBData.AmbitoCentro.validar_1(null));
		grp.add_grp(CBData.EmpresasCentro.validar(null));
		return grp;
	}

}		


class Frame_Centros_3_jButton_EmpresasCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_3 adaptee;

	Frame_Centros_3_jButton_EmpresasCAdd_mouseAdapter(Frame_Centros_3 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EmpresasCAdd_mouseClicked(e);
	}
}

class Frame_Centros_3_jButton_EmpresasCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_3 adaptee;

	Frame_Centros_3_jButton_EmpresasCDel_mouseAdapter(Frame_Centros_3 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EmpresasCDel_mouseClicked(e);
	}
}

class Frame_Centros_3_jButton_EmpresasCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_3 adaptee;

	Frame_Centros_3_jButton_EmpresasCIns_mouseAdapter(Frame_Centros_3 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EmpresasCIns_mouseClicked(e);
	}
}
