package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Centros_4 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_EquipamentoC = null;
	private JLabel jLabel_Equipamento = null;
	private JScrollPane jScrollPane_EquipamentoC = null;
	private JTable_Tip jTable_EquipamentoC = null;
	private JButton jButton_EquipamentoCAdd = null;
	private JButton jButton_EquipamentoCIns = null;
	private JButton jButton_EquipamentoCDel = null;
	
	public JCheckBox jCheckBox_Ambito_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_Ambito = null;  //  @jve:decl-index=0:


	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	String tag = "";
		
	public Frame_Centros_4() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,567);
	}

	String coluna_coop = "N";  //  @jve:decl-index=0:
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("coop") != null ) {
			coluna_coop = (String) params.get("coop");
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			
			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_EquipamentoC(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_EquipamentoC() {
		if (jPanel_EquipamentoC == null) {
		    jButton_EquipamentoCAdd = new JButton(fmeFrame.novaLinha);
		    jButton_EquipamentoCAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipamentoCAdd.addMouseListener(new Frame_Centros_4_jButton_EquipamentoCAdd_mouseAdapter(this));
		    jButton_EquipamentoCAdd.setToolTipText("Nova Linha");
		    jButton_EquipamentoCAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_EquipamentoCIns = new JButton(fmeFrame.inserirLinha);
		    jButton_EquipamentoCIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipamentoCIns.addMouseListener(new Frame_Centros_4_jButton_EquipamentoCIns_mouseAdapter(this));
		    jButton_EquipamentoCIns.setToolTipText("Inserir Linha");
		    jButton_EquipamentoCIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_EquipamentoCDel = new JButton(fmeFrame.apagarLinha);
		    jButton_EquipamentoCDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipamentoCDel.addMouseListener(new Frame_Centros_4_jButton_EquipamentoCDel_mouseAdapter(this));
		    jButton_EquipamentoCDel.setToolTipText("Apagar Linha");
		    jButton_EquipamentoCDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_Equipamento = new JLabel();
			jLabel_Equipamento.setBounds(new Rectangle(11, 13, 448, 18));
			jLabel_Equipamento.setText("<html>Caracterizao do equipamento/software a adquirir</html>");
			jLabel_Equipamento.setFont(fmeFrame.letra_bold);			
			jPanel_EquipamentoC = new JPanel();
			jPanel_EquipamentoC.setLayout(null);
			jPanel_EquipamentoC.setBounds(new Rectangle(15, 370, 640, 187));
			jPanel_EquipamentoC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_EquipamentoC.add(jLabel_Equipamento, null);
			jPanel_EquipamentoC.add(jButton_EquipamentoCAdd, null);
			jPanel_EquipamentoC.add(jButton_EquipamentoCIns, null);
			jPanel_EquipamentoC.add(jButton_EquipamentoCDel, null);
			jPanel_EquipamentoC.add(getJScrollPane_EquipamentoC(), null);

		}
		return jPanel_EquipamentoC;
	}
	
	public JScrollPane getJScrollPane_EquipamentoC() {
		if (jScrollPane_EquipamentoC == null) {
			jScrollPane_EquipamentoC = new JScrollPane();
			jScrollPane_EquipamentoC.setBounds(new Rectangle(10, 37, 620, 134));
			jScrollPane_EquipamentoC.setViewportView(getJTable_EquipamentoC());
			jScrollPane_EquipamentoC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_EquipamentoC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_EquipamentoC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_EquipamentoC;
	}
	
	public JTable getJTable_EquipamentoC() {
		if (jTable_EquipamentoC == null) {
			jTable_EquipamentoC = new JTable_Tip(40, jScrollPane_EquipamentoC.getWidth());
			jTable_EquipamentoC.setFont(fmeFrame.letra);
			jTable_EquipamentoC.setRowHeight(18);
			jTable_EquipamentoC.setName("QuadrosTecn_Tabela");
			jTable_EquipamentoC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_EquipamentoC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_EquipamentoC;
	}
	
	void jButton_EquipamentoCAdd_mouseClicked(MouseEvent e) {
		CBData.EquipCentro.on_add_row();
	}

	void jButton_EquipamentoCDel_mouseClicked(MouseEvent e) {
		CBData.EquipCentro.on_del_row();
	}

	void jButton_EquipamentoCIns_mouseClicked(MouseEvent e) {
		CBData.EquipCentro.on_ins_row();
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 7, 609, 29));
			jLabel_Fundam.setText("<html>Descrio do plano para a implementao do sistema de gesto de investigao, desenvolvimento e inovao</html>");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 50, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("quadros_tecnicos_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_EquipamentoC.getWidth() - jScrollPane_EquipamentoC.getWidth();
		int w = jPanel_EquipamentoC.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.SistGestaoTxt.Clear();
		CBData.EquipCentro.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.SistGestaoTxt.validar(null));
		grp.add_grp(CBData.EquipCentro.validar(null));
		return grp;
	}

}		


class Frame_Centros_4_jButton_EquipamentoCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_4 adaptee;

	Frame_Centros_4_jButton_EquipamentoCAdd_mouseAdapter(Frame_Centros_4 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipamentoCAdd_mouseClicked(e);
	}
}

class Frame_Centros_4_jButton_EquipamentoCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_4 adaptee;

	Frame_Centros_4_jButton_EquipamentoCDel_mouseAdapter(Frame_Centros_4 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipamentoCDel_mouseClicked(e);
	}
}

class Frame_Centros_4_jButton_EquipamentoCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Centros_4 adaptee;

	Frame_Centros_4_jButton_EquipamentoCIns_mouseAdapter(Frame_Centros_4 adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipamentoCIns_mouseClicked(e);
	}
}
