package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.Font;
import javax.swing.JCheckBox;

import java.util.HashMap;
import javax.swing.SwingConstants;
import javax.swing.JLabel;

public class Frame_Decl extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P16 = null;
	private JLabel jLabel_QREN = null;
	private JPanel jPanel_Declaracoes = null;
	private JPanel jPanel_Obs = null;
	private JLabel jLabel_Obs = null;
	private JScrollPane jScrollPane_Pos_Proj = null;
	private JTextArea jTextArea_Obs = null;

	private JLabel jLabel_Geral_1 = null;
	private JLabel jLabel_Geral_2 = null;
	private JLabel jLabel_Eleg_1 = null;
	private JLabel jLabel_Eleg_2 = null;
	private JLabel jLabel_Espec_1 = null;
	private JLabel jLabel_Espec_2 = null;
	private JLabel jLabel_Geral = null;
	private JLabel jLabel_Eleg = null;
	private JLabel jLabel_Espec = null;
	private JLabel jLabel_Obrig = null;
	private JLabel jLabel_Obrig_1 = null;

	private JLabel jLabel_Sim = null;
	private JLabel jLabel_Nao = null;

	private JCheckBox jCheckBox_Geral_1_Sim = null;
	private JCheckBox jCheckBox_Geral_1_Nao = null;
	public JCheckBox jCheckBox_Geral_1_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_Geral_1 = null;  //  @jve:decl-index=0:

	private JCheckBox jCheckBox_Geral_2_Sim = null;
	public JCheckBox jCheckBox_Geral_2_Clear = new JCheckBox();
	
	private JCheckBox jCheckBox_Eleg_1_Sim = null;
	public JCheckBox jCheckBox_Eleg_1_Clear = new JCheckBox();
	
	private JCheckBox jCheckBox_Eleg_2_Sim = null;
	public JCheckBox jCheckBox_Eleg_2_Clear = new JCheckBox();
	
	private JCheckBox jCheckBox_Espec_1_Sim = null;
	public JCheckBox jCheckBox_Espec_1_Clear = new JCheckBox();
	
	private JCheckBox jCheckBox_Espec_2_Sim = null;
	public JCheckBox jCheckBox_Espec_2_Clear = new JCheckBox();
	
	private JCheckBox jCheckBox_Obrig_1_Sim = null;
	public JCheckBox jCheckBox_Obrig_1_Clear = new JCheckBox();

	public JCheckBox jCheckBox_MercPub_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_MercPub = null;  //  @jve:decl-index=0:

	String tag = "";
	
	public Frame_Decl() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,920);
	}
	
	private HashMap _params;  //  @jve:decl-index=0:

	private JLabel jLabel_MercPub = null;

	private JCheckBox jCheckBox_MercPub_Sim = null;

	private JCheckBox jCheckBox_MercPub_Nao = null;

	public void set_params( String _tag, HashMap params  ) {
		tag = _tag;
		if ( params.get("ELEG_ESPEC_1") != null ) {
			//JOptionPane.showMessageDialog(null, "ELEG_ESPEC_1=" + params.get("ELEG_ESPEC_1"));
			String t = this.jLabel_Espec_1.getText();
			t = t.replace("%ELEG_ESPEC_1%", (String) params.get("ELEG_ESPEC_1"));
			this.jLabel_Espec_1.setText(t);
		}
		if ( params.get("ELEG_ESPEC_2") != null ) {
			//JOptionPane.showMessageDialog(null, "ELEG_ESPEC_2=" + params.get("ELEG_ESPEC_2"));
			String t = this.jLabel_Espec_2.getText();
			t = t.replace("%ELEG_ESPEC_2%", (String) params.get("ELEG_ESPEC_2"));
			this.jLabel_Espec_2.setText(t);
		}
		if ( params.get("OBRIG") != null ) {
			//JOptionPane.showMessageDialog(null, "OBRIG=" + params.get("OBRIG"));
			String t = this.jLabel_Obrig_1.getText();
			t = t.replace("%OBRIG%", (String) params.get("OBRIG"));
			this.jLabel_Obrig_1.setText(t);

		}
		this._params = params;
		//JOptionPane.showMessageDialog(null, "params = " + params.size());
	}
	
	public HashMap get_params() {
		return this._params;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {

			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P16 = new JLabel();
			jLabel_P16.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P16.setText("   DECLARAES DE COMPROMISSO");
			jLabel_P16.setFont(fmeFrame.letra_titulo);
			jLabel_P16.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P16, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Declaracoes(), null);
			jContentPane.add(getJPanel_Obs(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Declaracoes() {
		if (jPanel_Declaracoes == null) {
			jLabel_MercPub = new JLabel();
			jLabel_MercPub.setBounds(new Rectangle(30, 432, 533, 23));
			jLabel_MercPub.setText("<html>A entidade promotora encontra-se sujeita  disciplina da contratao pblica ?</html>");
			jLabel_MercPub.setFont(fmeFrame.letra);
			jLabel_Obrig_1 = new JLabel();
			jLabel_Obrig_1.setBounds(new Rectangle(30, 465, 537, 53));
			jLabel_Obrig_1.setText("<html>Tomei conhecimento e declaro estar em condies de cumprir com as obrigaes das entidades beneficirias de acordo com o art. 13 do Enquadramento Nacional, %OBRIG%, salientando de entre as restantes obrigaes, o cumprimento, quando aplicvel, dos normativos legais em matria de contratao pblica relativamente  execuo dos projectos.</html>");
			jLabel_Obrig_1.setFont(fmeFrame.letra);
			jLabel_Obrig = new JLabel();
			jLabel_Obrig.setBounds(new Rectangle(14, 403, 552, 15));
			jLabel_Obrig.setText("4. Obrigaes das Entidades Beneficirias");
			jLabel_Obrig.setFont(fmeFrame.letra_bold);
			jLabel_Espec = new JLabel();
			jLabel_Espec.setBounds(new Rectangle(13, 260, 552, 13));
			jLabel_Espec.setText("3. Condies Especficas de Elegibilidade do Promotor e do Projecto");
			jLabel_Espec.setFont(fmeFrame.letra_bold);
			jLabel_Eleg = new JLabel();
			jLabel_Eleg.setBounds(new Rectangle(14, 131, 552, 13));
			jLabel_Eleg.setText("2. Condies Gerais de Elegibilidade do Promotor e do Projecto");
			jLabel_Eleg.setFont(fmeFrame.letra_bold);
			jLabel_Geral = new JLabel();
			jLabel_Geral.setBounds(new Rectangle(14, 15, 552, 17));
			jLabel_Geral.setText("1. Geral");
			jLabel_Geral.setFont(fmeFrame.letra_bold);
			jLabel_Sim = new JLabel();
			jLabel_Sim.setBounds(new Rectangle(569, 18, 30, 17));
			jLabel_Sim.setText("Sim");
			jLabel_Sim.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Sim.setFont(fmeFrame.letra);
			jLabel_Nao = new JLabel();
			jLabel_Nao.setBounds(new Rectangle(599, 18, 30, 17));
			jLabel_Nao.setText("No");
			jLabel_Nao.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Nao.setFont(fmeFrame.letra);
			jLabel_Espec_2 = new JLabel();
			jLabel_Espec_2.setBounds(new Rectangle(32, 327, 537, 61));
			jLabel_Espec_2.setText("<html>Declaro cumprir ou estar em condies de cumprir nos prazos fixados, as condies especficas de elegibilidade do promotor e do projecto de acordo com %ELEG_ESPEC_2% bem como estar em condies de comprovar o seu cumprimento, sob pena de se poder vir a operar a caducidade da deciso e consequente anulao dos apoios que venham a ser atribudos ao projecto. </html>");
			jLabel_Espec_2.setFont(fmeFrame.letra);
			jLabel_Espec_1 = new JLabel();
			jLabel_Espec_1.setBounds(new Rectangle(32, 285, 537, 30));
			jLabel_Espec_1.setText("<html>Tomei conhecimento das condies especficas de elegibilidade do promotor e do projecto de acordo com %ELEG_ESPEC_1%.</html>");
			jLabel_Espec_1.setFont(fmeFrame.letra);
			jLabel_Eleg_2 = new JLabel();
			jLabel_Eleg_2.setBounds(new Rectangle(33, 197, 537, 45));
			jLabel_Eleg_2.setText("<html>Declaro cumprir ou estar em condies de cumprir as condies gerais de elegibilidade do promotor e do projecto de acordo com o art. 11 e 12 do Enquadramento Nacional nos prazos fixados, sob pena de operar a caducidade e consequente anulao da candidatura.</html>");
			jLabel_Eleg_2.setFont(fmeFrame.letra);
			jLabel_Eleg_1 = new JLabel();
			jLabel_Eleg_1.setBounds(new Rectangle(33, 153, 537, 30));
			jLabel_Eleg_1.setText("<html>Tomei conhecimento das condies gerais de elegibilidade do promotor e do projecto de acordo com o art. 11 e 12 do Enquadramento Nacional. </html>");
			jLabel_Eleg_1.setFont(fmeFrame.letra);
			jLabel_Geral_2 = new JLabel();
			jLabel_Geral_2.setBounds(new Rectangle(32, 85, 537, 30));
			jLabel_Geral_2.setText("<html>Declaro que todas as informaes constantes neste formulrio so verdadeiras, incluindo a veracidade dos<br>pressupostos utilizados na definio do projecto de investimento apresentado.</html>");
			jLabel_Geral_2.setFont(fmeFrame.letra);
			jLabel_Geral_1 = new JLabel();
			jLabel_Geral_1.setBounds(new Rectangle(32, 43, 537, 30));
			jLabel_Geral_1.setText("<html>Declaro que autorizo a utilizao dos dados constantes desta candidatura para outros sistemas no mbito do<br>QREN, salvaguardando o sigilo para o exterior.</html>");
			jLabel_Geral_1.setFont(fmeFrame.letra);
			jPanel_Declaracoes = new JPanel();
			jPanel_Declaracoes.setLayout(null);
			jPanel_Declaracoes.setBounds(new Rectangle(15, 50, 640, 536));
			jPanel_Declaracoes.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Declaracoes.setName("");
			jPanel_Declaracoes.add(jLabel_Sim, null);
			jPanel_Declaracoes.add(jLabel_Nao, null);
			jPanel_Declaracoes.add(jLabel_Geral_1, null);
			jPanel_Declaracoes.add(jLabel_Geral_2, null);
			jPanel_Declaracoes.add(jLabel_Eleg_1, null);
			jPanel_Declaracoes.add(jLabel_Eleg_2, null);
			jPanel_Declaracoes.add(jLabel_Espec_1, null);
			jPanel_Declaracoes.add(jLabel_Espec_2, null);
			jPanel_Declaracoes.add(jLabel_Geral, null);
			jPanel_Declaracoes.add(jLabel_Eleg, null);
			jPanel_Declaracoes.add(jLabel_Espec, null);
			jPanel_Declaracoes.add(jLabel_Obrig, null);
			jPanel_Declaracoes.add(jLabel_Obrig_1, null);
			jPanel_Declaracoes.add(getjCheckBox_Geral_1_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Geral_1_Nao(), null);
		    this.getJButtonGroup_Geral_1();
			jPanel_Declaracoes.add(getjCheckBox_Geral_2_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Eleg_1_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Eleg_2_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Espec_1_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Espec_2_Sim(), null);
			jPanel_Declaracoes.add(getjCheckBox_Obrig_1_Sim(), null);
			jPanel_Declaracoes.add(jLabel_MercPub, null);
			jPanel_Declaracoes.add(getJCheckBox_MercPub_Sim(), null);
			jPanel_Declaracoes.add(getJCheckBox_MercPub_Nao(), null);
		    this.getJButtonGroup_MercPub_1();
			
		}
		return jPanel_Declaracoes;
	}
	
	private JPanel getJPanel_Obs() {
		if (jPanel_Obs == null) {
			jLabel_Obs = new JLabel();
			jLabel_Obs.setBounds(new Rectangle(14, 8, 609, 20));
			jLabel_Obs.setText("Observaes");
			jLabel_Obs.setFont(fmeFrame.letra_titulo);

			jPanel_Obs = new JPanel();
			jPanel_Obs.setLayout(null);
			jPanel_Obs.setBounds(new Rectangle(15, 596, 640, 350));
			jPanel_Obs.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Obs.setName("cond_eleg_texto");
			jPanel_Obs.add(jLabel_Obs, null);
			jPanel_Obs.add(getJScrollPane_Pos_Proj(), null);
			
		}
		return jPanel_Obs;
	}
	
	public JScrollPane getJScrollPane_Pos_Proj() {
		if (jScrollPane_Pos_Proj == null) {
			jScrollPane_Pos_Proj = new JScrollPane();
			jScrollPane_Pos_Proj.setBounds(new Rectangle(15, 35, 609, 301));
			jScrollPane_Pos_Proj.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Pos_Proj.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Pos_Proj.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Pos_Proj.setViewportView(getJTextArea_Obs());
		}
		return jScrollPane_Pos_Proj;
	}
	public JTextArea getJTextArea_Obs() {
		if (jTextArea_Obs == null) {
			jTextArea_Obs = new JTextArea();
			jTextArea_Obs.setFont(fmeFrame.letra);
			jTextArea_Obs.setLineWrap(true);
			jTextArea_Obs.setWrapStyleWord(true);
			jTextArea_Obs.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Obs;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		
		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Declaracoes.getWidth()) );
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Decl.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Decl.validar(null));
		return grp;
	}

	public JCheckBox getjCheckBox_Geral_1_Sim() {
		if (jCheckBox_Geral_1_Sim == null) {
			jCheckBox_Geral_1_Sim = new JCheckBox();
			jCheckBox_Geral_1_Sim.setBounds(new Rectangle(571, 43, 26, 28));
			jCheckBox_Geral_1_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Geral_1_Sim;
	}
	public JCheckBox getjCheckBox_Geral_1_Nao() {
		if (jCheckBox_Geral_1_Nao == null) {
			jCheckBox_Geral_1_Nao = new JCheckBox();
			jCheckBox_Geral_1_Nao.setBounds(new Rectangle(601, 43, 26, 28));
			jCheckBox_Geral_1_Nao.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Geral_1_Nao;
	}
	private ButtonGroup getJButtonGroup_Geral_1() {
		if (jButtonGroup_Geral_1 == null) {
			jButtonGroup_Geral_1 = new ButtonGroup();
			jButtonGroup_Geral_1.add(jCheckBox_Geral_1_Sim);
			jButtonGroup_Geral_1.add(jCheckBox_Geral_1_Nao);
			jButtonGroup_Geral_1.add(jCheckBox_Geral_1_Clear);
		}
		return jButtonGroup_Geral_1;
	}
	private ButtonGroup getJButtonGroup_MercPub_1() {
		if (jButtonGroup_MercPub == null) {
			jButtonGroup_MercPub = new ButtonGroup();
			jButtonGroup_MercPub.add(jCheckBox_MercPub_Sim);
			jButtonGroup_MercPub.add(jCheckBox_MercPub_Nao);
			jButtonGroup_MercPub.add(jCheckBox_MercPub_Clear);
		}
		return jButtonGroup_MercPub;
	}

	public JCheckBox getjCheckBox_Geral_2_Sim() {
		if (jCheckBox_Geral_2_Sim == null) {
			jCheckBox_Geral_2_Sim = new JCheckBox();
			jCheckBox_Geral_2_Sim.setBounds(new Rectangle(571, 85, 26, 29));
			jCheckBox_Geral_2_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Geral_2_Sim;
	}
	public JCheckBox getjCheckBox_Eleg_1_Sim() {
		if (jCheckBox_Eleg_1_Sim == null) {
			jCheckBox_Eleg_1_Sim = new JCheckBox();
			jCheckBox_Eleg_1_Sim.setBounds(new Rectangle(572, 153, 26, 30));
			jCheckBox_Eleg_1_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Eleg_1_Sim;
	}
	public JCheckBox getjCheckBox_Eleg_2_Sim() {
		if (jCheckBox_Eleg_2_Sim == null) {
			jCheckBox_Eleg_2_Sim = new JCheckBox();
			jCheckBox_Eleg_2_Sim.setBounds(new Rectangle(572, 197, 26, 45));
			jCheckBox_Eleg_2_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Eleg_2_Sim;
	}
	public JCheckBox getjCheckBox_Espec_1_Sim() {
		if (jCheckBox_Espec_1_Sim == null) {
			jCheckBox_Espec_1_Sim = new JCheckBox();
			jCheckBox_Espec_1_Sim.setBounds(new Rectangle(571, 294, 26, 21));
			jCheckBox_Espec_1_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Espec_1_Sim;
	}
	public JCheckBox getjCheckBox_Espec_2_Sim() {
		if (jCheckBox_Espec_2_Sim == null) {
			jCheckBox_Espec_2_Sim = new JCheckBox();
			jCheckBox_Espec_2_Sim.setBounds(new Rectangle(571, 346, 26, 21));
			jCheckBox_Espec_2_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Espec_2_Sim;
	}
	public JCheckBox getjCheckBox_Obrig_1_Sim() {
		if (jCheckBox_Obrig_1_Sim == null) {
			jCheckBox_Obrig_1_Sim = new JCheckBox();
			jCheckBox_Obrig_1_Sim.setBounds(new Rectangle(569, 483, 26, 23));
			jCheckBox_Obrig_1_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_Obrig_1_Sim;
	}

	/**
	 * This method initializes jCheckBox_MercPub_Sim	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox_MercPub_Sim() {
		if (jCheckBox_MercPub_Sim == null) {
			jCheckBox_MercPub_Sim = new JCheckBox();
			jCheckBox_MercPub_Sim.setBounds(new Rectangle(571, 433, 21, 21));
			jCheckBox_MercPub_Sim.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_MercPub_Sim;
	}

	/**
	 * This method initializes jCheckBox_MercPub_Nao	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox_MercPub_Nao() {
		if (jCheckBox_MercPub_Nao == null) {
			jCheckBox_MercPub_Nao = new JCheckBox();
			jCheckBox_MercPub_Nao.setBounds(new Rectangle(600, 433, 21, 21));
			jCheckBox_MercPub_Nao.setHorizontalAlignment(SwingConstants.CENTER);
		}
		return jCheckBox_MercPub_Nao;
	}
}
