package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Financ extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Financ = null;
	private JLabel jLabel_Financ = null;
	private JLabel jLabel_nota = null;
	private JScrollPane jScrollPane_Financ = null;
	private JTable_Tip jTable_Financ = null;
	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	String tag = "";
	
	public Frame_Financ() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,930);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {

		jLabel_P01.setVisible(false);
		//up_component ( jPanel_Promotor, 30);		
	}

	String hide_cols = "";
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("hide") != null ) {
			hide_cols = (String) params.get("hide");
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   DADOS DO PROJECTO");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());

		    jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Financ(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Financ() {
		if (jPanel_Financ == null) {
			jLabel_Financ = new JLabel();
			jLabel_Financ.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_Financ.setText("Estrutura de Financiamento (Recursos Financeiros)");
			jLabel_Financ.setFont(fmeFrame.letra_bold);			

			
		    jLabel_nota = new JLabel();
		    jLabel_nota.setBounds(new Rectangle(9, 488, 617, 58));
		    jLabel_nota.setFont(fmeFrame.letra_pequena);
		    jLabel_nota.setText("<html>(1) Novos capitais prprios<br>"+
					"(2) Resultados Lquidos + Amortizaes + Variao de Provises do Exerccio<br>"+
					"(3) Reafectao de valores do activo sem reflexo no autofinanciamento<br>"+
					"(4) Novos suprimentos a incorporar em capital prprio at ao encerramento do projecto</html>");
		    
			jPanel_Financ = new JPanel();
			jPanel_Financ.setLayout(null);
			jPanel_Financ.setBounds(new Rectangle(15, 50, 640, 550));
			jPanel_Financ.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Financ.add(jLabel_nota, null);
			jPanel_Financ.add(jLabel_Financ, null);
			jPanel_Financ.add(getJScrollPane_Financ(), null);
		}
		return jPanel_Financ;
	}
	public JScrollPane getJScrollPane_Financ() {
		if (jScrollPane_Financ == null) {
			jScrollPane_Financ = new JScrollPane();
			jScrollPane_Financ.setBounds(new Rectangle(9, 40, 619, 450));
			jScrollPane_Financ.setViewportView(getJTable_Financ());
			//jScrollPane_Financ.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			//jScrollPane_Financ.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_Financ.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Financ;
	}
	public JTable getJTable_Financ() {
		if (jTable_Financ == null) {
			jTable_Financ = new JTable_Tip(30, jScrollPane_Financ.getWidth());
			jTable_Financ.setRowHeight(18);
			jTable_Financ.setFont(fmeFrame.letra);
			jTable_Financ.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Financ.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Financ;
	}
	
	
	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_Fundam.setText("Descrio das Fontes de Financiamento");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 610, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("cond_eleg_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.dx_expand = jTable_Financ.getWidth() - jScrollPane_Financ.getWidth();
		int w = jPanel_Financ.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;

//		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Financ.getWidth()) );
//		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Finan.Clear();
		CBData.QInv.calc_dados_projecto();
		CBData.FinanTxt.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Finan.validar(null));
		return grp;
	}
}		
	