package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.util.HashMap;

public class Frame_Indic extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P09 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_IndicGerais = null;
	private JLabel jLabel_IndicGerais = null;
	private JScrollPane jScrollPane_IndicGerais = null;
	private JTable_Tip3 jTable_IndicGerais = null;
	private JPanel jPanel_IndicIDT = null;
	private JLabel jLabel_IndicIDT = null;
	private JScrollPane jScrollPane_IndicIDT = null;
	private JTable_Tip jTable_IndicIDT = null;
	
	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	String tag = "";
	
	HashMap hs;
	
	public Frame_Indic() {
		super();
		initialize();
	}
	
	public Dimension getSize () {
		// face  dimenso da pgina base
		return new Dimension(660,695);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		hs = params;
		if ( params.get("IDT")!=null && params.get("IDT").equals("0") ) {
			jPanel_IndicIDT.setVisible(false);
			up_component (jPanel_Fundam, jPanel_IndicIDT.getHeight()+10);
			Dimension d = new Dimension(this.getWidth(), this.getHeight()-jPanel_IndicIDT.getHeight()-10);
			this.setSize(d);
			this.setPreferredSize(d);
			//this.repaint();
//jLabel_Titulo.setText( (String) params.get("TITULO") );
		}
	}
	private void initialize() {
		this.setSize(660, 1400);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			jLabel_P09 = new JLabel();
			jLabel_P09.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P09.setText("   DADOS DO PROJECTO");
			jLabel_P09.setFont(fmeFrame.letra_titulo);
			jLabel_P09.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P09, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_IndicGerais(), null);
			jContentPane.add(getJPanel_IndicIDT(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_IndicGerais() {
		if (jPanel_IndicGerais == null) {
			jLabel_IndicGerais = new JLabel();
		    jLabel_IndicGerais.setBounds(new Rectangle(12, 10, 287, 18));
		    jLabel_IndicGerais.setText("Indicadores Gerais");
		    jLabel_IndicGerais.setFont(fmeFrame.letra_bold);
		    jLabel_IndicIDT = new JLabel();
		    jLabel_IndicIDT.setFont(fmeFrame.letra_bold);
		    jLabel_IndicIDT.setText("Indicadores de I&DT");
		    jLabel_IndicIDT.setBounds(new Rectangle(12, 335, 209, 18));
			
		    jPanel_IndicGerais = new JPanel();
		    jPanel_IndicGerais.setLayout(null);
		    jPanel_IndicGerais.setBounds(new Rectangle(15, 50, 640, 325));
		    jPanel_IndicGerais.setBorder(BorderFactory.createEtchedBorder());
		    jPanel_IndicGerais.add(jLabel_IndicGerais, null);
		    jPanel_IndicGerais.add(getJScrollPane_IndicGerais(), null);
		}
		return jPanel_IndicGerais;
	}
	
	public JScrollPane getJScrollPane_IndicGerais() {
		if (jScrollPane_IndicGerais == null) {
			jScrollPane_IndicGerais = new JScrollPane();
			jScrollPane_IndicGerais.setBounds(new Rectangle(10, 34, 619, 280));
			jScrollPane_IndicGerais.setViewportView(getJTable_IndicGerais());
			jScrollPane_IndicGerais.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_IndicGerais.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_IndicGerais.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_IndicGerais;
	}
	
	public JTable getJTable_IndicGerais() {
		if (jTable_IndicGerais == null) {
			jTable_IndicGerais = new JTable_Tip3(25);
			jTable_IndicGerais.setRowHeight(18);
			jTable_IndicGerais.setName("IndicGerais_Tabela");
			jTable_IndicGerais.setFont(fmeFrame.letra);
			jTable_IndicGerais.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_IndicGerais;
	}
	
	private JPanel getJPanel_IndicIDT() {
		if (jPanel_IndicIDT == null) {
		    jLabel_IndicIDT = new JLabel();
		    jLabel_IndicIDT.setFont(fmeFrame.letra_bold);
		    jLabel_IndicIDT.setText("Indicadores de I&DT");
		    jLabel_IndicIDT.setBounds(new Rectangle(12, 10, 287, 18));
		    
		    jPanel_IndicIDT = new JPanel();
		    jPanel_IndicIDT.setLayout(null);
		    jPanel_IndicIDT.setBounds(new Rectangle(15, 385, 640, 100));
		    jPanel_IndicIDT.setBorder(BorderFactory.createEtchedBorder());
		    jPanel_IndicIDT.add(jLabel_IndicIDT, null);
		    jPanel_IndicIDT.add(getJScrollPane_IndicIDT(), null);
		}
		return jPanel_IndicIDT;
	}


	public JScrollPane getJScrollPane_IndicIDT() {
		if (jScrollPane_IndicIDT == null) {
			jScrollPane_IndicIDT = new JScrollPane();
			jScrollPane_IndicIDT.setBounds(new Rectangle(10, 34, 619, 51));
			jScrollPane_IndicIDT.setViewportView(getJTable_IndicIDT());
			jScrollPane_IndicIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_IndicIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_IndicIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_IndicIDT;
	}
	
	public JTable getJTable_IndicIDT() {
		if (jTable_IndicIDT == null) {
			jTable_IndicIDT = new JTable_Tip(30);
			jTable_IndicIDT.setRowHeight(18);
			jTable_IndicIDT.setFont(fmeFrame.letra);
			jTable_IndicIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_IndicIDT;
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 446, 18));
			jLabel_Fundam.setText("Fundamentao dos Indicadores");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 495, 640, 190));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("cond_eleg_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 140));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.scaleToWidth ( (int) ( 1.15 * jPanel_IndicGerais.getWidth()) );
		print_handler.margem_y = 30;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.IndicGerais.Clear();
		CBData.IndicIDT.Clear();
		CBData.IndicTxt.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.IndicGerais.validar(null));
		if ( !(this.hs.get("IDT")!=null && this.hs.get("IDT").equals("0")) ) {
			grp.add_grp(CBData.IndicIDT.validar(null));
		}
		grp.add_grp(CBData.IndicTxt.validar(null));
		return grp;
	}
}		
	