package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.*;
import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_ListaCoop extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Lista = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ListaCoop = null;
	private JLabel jLabel_ListaCoop = null;
	private JScrollPane jScrollPane_ListaCoop = null;
	private JTableX jTable_ListaCoop = null;  //  @jve:decl-index=0:
	private JButton jButton_ListaCoopUp = null;
	private JButton jButton_ListaCoopAdd = null;
	private JButton jButton_ListaCoopIns = null;
	private JButton jButton_ListaCoopDel = null;

	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;
	

	String tag = "";
	
	public Frame_ListaCoop() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,613);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			jLabel_Lista = new JLabel();
			jLabel_Lista.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Lista.setText("   LISTA DE COOPERAO");
			jLabel_Lista.setFont(fmeFrame.letra_titulo);
			jLabel_Lista.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Lista, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ListaCoop(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_ListaCoop() {
		if (jPanel_ListaCoop == null) {
		    jButton_ListaCoopUp = new JButton(fmeFrame.subirLinha);
		    jButton_ListaCoopUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ListaCoopUp.addMouseListener(new Frame_ListaCoop_jButton_ListaCoopUp_mouseAdapter(this));
		    jButton_ListaCoopUp.setToolTipText("Trocar Linhas");
		    jButton_ListaCoopUp.setBounds(new Rectangle(477, 11, 30, 22));
		    jButton_ListaCoopAdd = new JButton(fmeFrame.novaLinha);
		    jButton_ListaCoopAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ListaCoopAdd.addMouseListener(new Frame_ListaCoop_jButton_ListaCoopAdd_mouseAdapter(this));
		    jButton_ListaCoopAdd.setToolTipText("Nova Linha");
		    jButton_ListaCoopAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_ListaCoopIns = new JButton(fmeFrame.inserirLinha);
		    jButton_ListaCoopIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ListaCoopIns.addMouseListener(new Frame_ListaCoop_jButton_ListaCoopIns_mouseAdapter(this));
		    jButton_ListaCoopIns.setToolTipText("Inserir Linha");
		    jButton_ListaCoopIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_ListaCoopDel = new JButton(fmeFrame.apagarLinha);
		    jButton_ListaCoopDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ListaCoopDel.addMouseListener(new Frame_ListaCoop_jButton_ListaCoopDel_mouseAdapter(this));
		    jButton_ListaCoopDel.setToolTipText("Apagar Linha");
		    jButton_ListaCoopDel.setBounds(new Rectangle(597, 11, 30, 22));

		    jLabel_ListaCoop = new JLabel();
		    jLabel_ListaCoop.setBounds(new Rectangle(12, 10, 381, 18));
		    jLabel_ListaCoop.setText("Lista de Empresas");
		    jLabel_ListaCoop.setFont(fmeFrame.letra_bold);

			jPanel_ListaCoop = new JPanel();
			jPanel_ListaCoop.setLayout(null);
			jPanel_ListaCoop.setBounds(new Rectangle(15, 50, 640, 233));
			jPanel_ListaCoop.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ListaCoop.add(jLabel_ListaCoop, null);
			jPanel_ListaCoop.add(jButton_ListaCoopAdd, null);
			jPanel_ListaCoop.add(jButton_ListaCoopIns, null);
			jPanel_ListaCoop.add(jButton_ListaCoopDel, null);
			jPanel_ListaCoop.add(getJScrollPane_ListaCoop(), null);
		}
		return jPanel_ListaCoop;
	}
	
	public JScrollPane getJScrollPane_ListaCoop() {
		if (jScrollPane_ListaCoop == null) {

		    jScrollPane_ListaCoop = new JScrollPane();
			jScrollPane_ListaCoop.setBounds(new Rectangle(10, 41, 619, 179));
			jScrollPane_ListaCoop.setViewportView(getJTable_ListaCoop());
		    jScrollPane_ListaCoop.setName("ListaCoop_ScrollPane");
			//jScrollPane_ListaCoop.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			jScrollPane_ListaCoop.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ListaCoop.setBorder(BorderFactory.createEtchedBorder());
			//jScrollPane_ListaCoop.getViewport().add(jTable_ListaCoop);
		}
		return jScrollPane_ListaCoop;
	}
	
	public JTableX getJTable_ListaCoop() {
		if (jTable_ListaCoop == null) {
			jTable_ListaCoop = new JTableX();
			//jTable_ListaCoop = new JTable_Tip(40, jScrollPane_ListaCoop.getWidth());
			jTable_ListaCoop.setRowHeight(18);
			jTable_ListaCoop.setFont(fmeFrame.letra);
		    jTable_ListaCoop.setName("ListaCoop_Tabela");
		    jTable_ListaCoop.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_ListaCoop;
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 446, 18));
			jLabel_Fundam.setText("<html>Factores que induziram a opo pela modalidade de cooperao</html>");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 293, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("cond_eleg_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}

	void jButton_ListaCoopCopy_mouseClicked(MouseEvent e) {
		CBData.ListaCoop.on_copy_row();
	}

	void jButton_ListaCoopUp_mouseClicked(MouseEvent e) {
		CBData.ListaCoop.on_up_row();
	}

	void jButton_ListaCoopAdd_mouseClicked(MouseEvent e) {
		CBData.ListaCoop.on_add_row();
	}

	void jButton_ListaCoopDel_mouseClicked(MouseEvent e) {
	    if ( CBData.ListaCoop.del_ins_ok("Apagar") ){
			CBData.ListaCoop.on_del_row();
	        CTabelas.Empresas.refresh();
			CBData.ListaCoop.handler.j.revalidate();
			CBData.ListaCoop.handler.j.repaint();
	    }
	}

	void jButton_ListaCoopIns_mouseClicked(MouseEvent e) {
	    if ( CBData.ListaCoop.del_ins_ok("Inserir") ){
	    	CBData.ListaCoop.on_ins_row();
	    	
	    }
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
//			    print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_ListaCoop.getWidth() - jScrollPane_ListaCoop.getWidth();
		int w = jPanel_ListaCoop.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
		
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.ListaCoop.Clear();
		//System.out.print("clearcoop\n");
	}	
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.ListaCoop.validar(null));
		grp.add_grp(CBData.Coop.validar(null));
		return grp;
	}
		
}			

class Frame_ListaCoop_jButton_ListaCoopCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ListaCoop adaptee;
	
	Frame_ListaCoop_jButton_ListaCoopCopy_mouseAdapter(Frame_ListaCoop adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ListaCoopCopy_mouseClicked(e);
	}	
}

class Frame_ListaCoop_jButton_ListaCoopUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ListaCoop adaptee;
	
	Frame_ListaCoop_jButton_ListaCoopUp_mouseAdapter(Frame_ListaCoop adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ListaCoopUp_mouseClicked(e);
	}
}

class Frame_ListaCoop_jButton_ListaCoopAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ListaCoop adaptee;

	Frame_ListaCoop_jButton_ListaCoopAdd_mouseAdapter(Frame_ListaCoop adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ListaCoopAdd_mouseClicked(e);
	}
}

class Frame_ListaCoop_jButton_ListaCoopDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ListaCoop adaptee;

	Frame_ListaCoop_jButton_ListaCoopDel_mouseAdapter(Frame_ListaCoop adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ListaCoopDel_mouseClicked(e);
	}
}

class Frame_ListaCoop_jButton_ListaCoopIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_ListaCoop adaptee;

	Frame_ListaCoop_jButton_ListaCoopIns_mouseAdapter(Frame_ListaCoop adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ListaCoopIns_mouseClicked(e);
	}
}
class JTableX extends JTable_Tip{
	public JTableX(int altura, int largura) { super(altura, largura); }
	public JTableX(int altura) { super(altura); }
	public JTableX() { super(); }
	public void changeSelection(int rowIndex, int columnIndex, boolean toggle, boolean extend) {
		super.changeSelection( rowIndex, columnIndex, toggle, extend);
		//JOptionPane.showMessageDialog(null, "ok");
		CHTabela handler = (CHTabela) this.getModel();
		if ( !handler.d.getColValue("n_ordem", rowIndex).equals(""))
			handler.d.on_row( rowIndex );
		else
			handler.d.on_row( -1 );
	}
}

