package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.SystemColor;
import java.awt.print.PageFormat;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.border.Border;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.Component;
import java.awt.event.*;
import java.util.*;
import java.awt.event.KeyEvent;
import javax.swing.JButton;


public class Frame_Maj extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;

	private JPanel jContentPane = null;

	private JLabel jLabel_Maj = null;
	private JPanel jPanel_Majoracoes = null;

	private JLabel jLabel_Texto_0 = null;
	private JLabel jLabel_Perc_0 = null;
	private JCheckBox jCheckBox_0 = null;
	private JLabel jLabel_Check_0 = null;
		
	private JPanel jPanel_Obs = null;
	private JLabel jLabel_ObsTitulo = null;
	private JScrollPane jScrollPane_ObsTexto = null;

	public Frame_Maj() {
		super();
		initialize();
	}

	public JLabel JLabel_Texto[];
	public JLabel JLabel_Perc[];
	public JLabel JLabel_Check[];
	public JCheckBox JCheck_List[];

	private JTextArea jTextArea_Fundamento = null;
	
	public void set_params( String s, HashMap params ) {
		
		int n = params.size() / 3;
		//JOptionPane.showMessageDialog(null, n + " majoraes");

		int dh = 50;
		JLabel_Texto = new JLabel [n];
		JLabel_Perc = new JLabel [n];
		JLabel_Check = new JLabel [n];
		JCheck_List = new JCheckBox [n];
		
		int i;
		for ( i=0; i<n; i++ ) {
		
			JLabel_Texto[i] = new JLabel();
			JLabel_Texto[i].setText( (String )params.get( "Design_"+(i+1)) );
			JLabel_Texto[i].setBounds(new Rectangle(10, 13+i*dh, 514, 40));
			JLabel_Texto[i].setBorder(BorderFactory.createLineBorder(Color.black, 1));
			JLabel_Texto[i].setFont(fmeFrame.letra);
			jPanel_Majoracoes.add( JLabel_Texto[i], null);

			JLabel_Perc[i] = new JLabel();
			JLabel_Perc[i].setText( (String )params.get("Perc_"+ (i+1)) );
			JLabel_Perc[i].setBounds(new Rectangle(523, 13+i*dh, 56, 40));
			JLabel_Perc[i].setFont(fmeFrame.letra_bold);
			JLabel_Perc[i].setBorder(BorderFactory.createLineBorder(Color.black, 1));
			JLabel_Perc[i].setHorizontalAlignment(SwingConstants.CENTER);
			jPanel_Majoracoes.add( JLabel_Perc[i], null);

			JLabel_Check[i] = new JLabel();
			JLabel_Check[i].setBounds(new Rectangle(578, 13+i*dh, 52, 40));
			JLabel_Check[i].setHorizontalAlignment(SwingConstants.CENTER);
			JLabel_Check[i].setText("");
			JLabel_Check[i].setBorder(BorderFactory.createLineBorder(Color.black, 1));
			JLabel_Check[i].setFont(fmeFrame.letra_bold);
			jPanel_Majoracoes.add( JLabel_Check[i], null);
			
			JCheck_List[i] = new JCheckBox();
			JCheck_List[i].setFont(fmeFrame.letra);
			JCheck_List[i].setBorder(BorderFactory.createLineBorder(Color.black));
			JCheck_List[i].setDebugGraphicsOptions(0);
			JCheck_List[i].setBorderPainted(false);
			JCheck_List[i].setContentAreaFilled(true);
			JCheck_List[i].setBorderPaintedFlat(true);
			JCheck_List[i].setBounds(new Rectangle(595, 25+i*dh, 18, 18));
			JCheck_List[i].setMargin(new Insets(0, 0, 0, 0));
			JCheck_List[i].setFocusPainted(false);
			jPanel_Majoracoes.add( JCheck_List[i], null);

		}
		
		Dimension d = jPanel_Majoracoes.getSize();
		d.height += i >0 ?  (i-1)*dh : 0;
		jPanel_Majoracoes.setSize(d);
		
		Rectangle r  = jPanel_Obs.getBounds();
		r.y += i >0 ?  (i-1)*dh : 0;
		jPanel_Obs.setBounds(r);
				
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Maj = new JLabel();
			jLabel_Maj.setBounds(new Rectangle(15, 10, 640, 30));
			jLabel_Maj.setText("MAJORAES");
			jLabel_Maj.setFont(fmeFrame.letra_titulo);
			jLabel_Maj.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Maj, null);
			jContentPane.add(getJPanel_Majoracoes(), null);
			jContentPane.add(getJPanel_Obs(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Majoracoes() {
		if (jPanel_Majoracoes == null) {
			
			jLabel_Check_0 = new JLabel();
			jLabel_Check_0.setBounds(new Rectangle(578, 13, 52, 40));
			jLabel_Check_0.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Check_0.setText("");
			jLabel_Check_0.setBorder(BorderFactory.createLineBorder(Color.black, 1));
			jLabel_Check_0.setFont(fmeFrame.letra_bold);
			
			
			jLabel_Texto_0 = new JLabel();
			jLabel_Texto_0.setText("Texto");
			jLabel_Texto_0.setBounds(new Rectangle(10, 13, 514, 40));
			jLabel_Texto_0.setBorder(BorderFactory.createLineBorder(Color.black, 1));
			jLabel_Texto_0.setFont(fmeFrame.letra);
			jLabel_Perc_0 = new JLabel();
			jLabel_Perc_0.setText("x%");
			jLabel_Perc_0.setBounds(new Rectangle(523, 13, 56, 40));
			jLabel_Perc_0.setFont(fmeFrame.letra_bold);
			jLabel_Perc_0.setBorder(BorderFactory.createLineBorder(Color.black, 1));
			jLabel_Perc_0.setHorizontalAlignment(SwingConstants.CENTER);
				
			jPanel_Majoracoes = new JPanel();
			jPanel_Majoracoes.setLayout(null);
			jPanel_Majoracoes.setBounds(new Rectangle(15, 50, 640, 70));
			jPanel_Majoracoes.setBorder(BorderFactory.createEtchedBorder());

//			jPanel_Majoracoes.add(jLabel_Texto_0);
//			jPanel_Majoracoes.add(jLabel_Perc_0);
//			jPanel_Majoracoes.add(getJCheckBox_0());
//			jPanel_Majoracoes.add(jLabel_Check_0, null);
			
		}
		return jPanel_Majoracoes;
	}
	
	public JCheckBox getJCheckBox_0() {
		if (jCheckBox_0 == null) {
			jCheckBox_0 = new JCheckBox();
			jCheckBox_0.setFont(fmeFrame.letra);
			jCheckBox_0.setBorder(BorderFactory.createLineBorder(Color.black));
			jCheckBox_0.setDebugGraphicsOptions(0);
			jCheckBox_0.setBorderPainted(false);
			jCheckBox_0.setContentAreaFilled(true);
			jCheckBox_0.setBorderPaintedFlat(true);
			jCheckBox_0.setBounds(new Rectangle(595, 25, 18, 18));
			jCheckBox_0.setMargin(new Insets(0, 0, 0, 0));
			jCheckBox_0.setFocusPainted(false);
		}
		return jCheckBox_0;
	}

	private JPanel getJPanel_Obs() {
		if (jPanel_Obs == null) {
			
			Border border1 = BorderFactory.createLineBorder(SystemColor.inactiveCaption,1);
			
				
			
			
			jPanel_Obs = new JPanel();
			jPanel_Obs.setLayout(null);
			jPanel_Obs.setBounds(new Rectangle(15, 134, 640, 305));
			jPanel_Obs.setBorder(BorderFactory.createEtchedBorder());

			jPanel_Obs.add(getJLabel_ObsTitulo());
			jPanel_Obs.add(getJScrollPane_ObsTexto());
		}
		return jPanel_Obs;
	}

	JLabel getJLabel_ObsTitulo(){
		if (jLabel_ObsTitulo == null) {
			jLabel_ObsTitulo = new JLabel();
			jLabel_ObsTitulo.setFont(fmeFrame.letra_bold);
			jLabel_ObsTitulo.setBorder(BorderFactory.createLineBorder(SystemColor.inactiveCaption,1));
			jLabel_ObsTitulo.setText("  CRITRIO E - Contributo do projecto para a inovao e diversificao da oferta");
			jLabel_ObsTitulo.setBounds(new Rectangle(9, 11, 600, 25));
		}
		return jLabel_ObsTitulo;
	}
	public JScrollPane getJScrollPane_ObsTexto() {
		if (jScrollPane_ObsTexto == null) {
			jScrollPane_ObsTexto = new JScrollPane();
			jScrollPane_ObsTexto.setBounds(new Rectangle(13, 45, 597, 245));
			jScrollPane_ObsTexto.setPreferredSize(new Dimension(250, 250));
			jScrollPane_ObsTexto.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_ObsTexto.setViewportView(getJTextArea_Fundamento());
			jScrollPane_ObsTexto.setBorder(BorderFactory.createLineBorder(Color.black));
		}
		return jScrollPane_ObsTexto;
	}

	//------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(16+1);

	    print_handler = new CHPrint( this);
	    print_handler.start();

	    print_handler.scaleToWidth ( (int) ( 1.05 * getJPanel_Majoracoes().getWidth()) );
	    print_handler.margem_y = 50;

	    print_handler.header = _lib.get_titulo(caption);
	    print_handler.footer_medida = fme.fmeFrame.title;
	    print_handler.footer_pag = _lib.get_pagina(caption);
	    print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

	    print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
	    return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
	    //CBData.Majoracoes.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fme.fmeFrame.Paginas.getCaption("Pagina_17"));
	    //grp.add_grp(CBData.Majoracoes.validar(null));
	    return grp;
	}

	/**
	 * This method initializes jTextArea_Fundamento	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	public JTextArea getJTextArea_Fundamento() {
		if (jTextArea_Fundamento == null) {
			jTextArea_Fundamento = new JTextArea();
			jTextArea_Fundamento.setFont(fmeFrame.letra);
			jTextArea_Fundamento.setLineWrap(true);
			jTextArea_Fundamento.setWrapStyleWord(true);
			jTextArea_Fundamento.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundamento;
	}

}

