package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_MajorIDT extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_MajorIDT = null;
	private JLabel jLabel_MajorIDT = null;
	private JLabel jLabel_Divulgar = null;
	private JCheckBox jCheckBox_DivulgarSim = null;
	private JCheckBox jCheckBox_DivulgarNao = null;
	public JCheckBox jCheckBox_DivulgarClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Divulgar = null;

	private JPanel jPanel_Fundamenta = null;
	private JLabel jLabel_Fundamenta = null;
	private JScrollPane jScrollPane_Fundamenta = null;
	private JTextArea jTextArea_Fundamenta = null;

	String tag = "";

	public Frame_MajorIDT() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,840);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_MajorIDT, 30);
		up_component(jPanel_Fundamenta, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"DADOS DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_MajorIDT(), null);
			jContentPane.add(getJPanel_Fundamenta(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_MajorIDT() {
		if (jPanel_MajorIDT == null) {
			jLabel_MajorIDT = new JLabel();
			jLabel_MajorIDT.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_MajorIDT.setText("Majoraes");
			jLabel_MajorIDT.setFont(fmeFrame.letra_bold);

			jLabel_Divulgar = new JLabel();
			jLabel_Divulgar.setBounds(new Rectangle(22, 36, 605, 22));
			jLabel_Divulgar.setText("<html>Concorre  majorao Divulgao Ampla dos Resultados do Projecto?</html>");
			jLabel_Divulgar.setFont(fmeFrame.letra);

			jPanel_MajorIDT = new JPanel();
			jPanel_MajorIDT.setLayout(null);
			jPanel_MajorIDT.setBounds(new Rectangle(15, 50, 640, 88));
			jPanel_MajorIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_MajorIDT.add(jLabel_MajorIDT, null);
			jPanel_MajorIDT.add(jLabel_Divulgar);
			jPanel_MajorIDT.add(getJCheckBox_DivulgarSim());
			jPanel_MajorIDT.add(getJCheckBox_DivulgarNao());
			this.getJButtonGroupDivulgar();
		}
		return jPanel_MajorIDT;
	}
	public JCheckBox getJCheckBox_DivulgarSim() {
		if (jCheckBox_DivulgarSim == null) {
			jCheckBox_DivulgarSim = new JCheckBox();
			jCheckBox_DivulgarSim.setBounds(new Rectangle(300, 59, 50, 18));
			jCheckBox_DivulgarSim.setText("Sim");
			jCheckBox_DivulgarSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_DivulgarSim;
	}
	public JCheckBox getJCheckBox_DivulgarNao() {
		if (jCheckBox_DivulgarNao == null) {
			jCheckBox_DivulgarNao = new JCheckBox();
			jCheckBox_DivulgarNao.setBounds(new Rectangle(350, 59, 50, 18));
			jCheckBox_DivulgarNao.setText("No");
			jCheckBox_DivulgarNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_DivulgarNao;
	}
	private ButtonGroup getJButtonGroupDivulgar() {
		if (jButtonGroup_Divulgar == null) {
			jButtonGroup_Divulgar = new ButtonGroup();
			jButtonGroup_Divulgar.add(jCheckBox_DivulgarSim);
			jButtonGroup_Divulgar.add(jCheckBox_DivulgarNao);
			jButtonGroup_Divulgar.add(jCheckBox_DivulgarClear);
		}
		return jButtonGroup_Divulgar;
	}

	private JPanel getJPanel_Fundamenta() {
		if (jPanel_Fundamenta == null) {
			jLabel_Fundamenta = new JLabel();
			jLabel_Fundamenta.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Fundamenta.setText("Fundamentao");
			jLabel_Fundamenta.setFont(fmeFrame.letra_bold);

			jPanel_Fundamenta = new JPanel();
			jPanel_Fundamenta.setLayout(null);
			jPanel_Fundamenta.setBounds(new Rectangle(15, 148, 640, 670));
			jPanel_Fundamenta.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundamenta.setName("fundamenta_texto");
			jPanel_Fundamenta.add(jLabel_Fundamenta, null);
			jPanel_Fundamenta.add(getJScrollPane_Fundamenta(), null);
		}
		return jPanel_Fundamenta;
	}
	private JScrollPane getJScrollPane_Fundamenta() {
		if (jScrollPane_Fundamenta == null) {
			jScrollPane_Fundamenta = new JScrollPane();
			jScrollPane_Fundamenta.setBounds(new Rectangle(15, 35, 609, 620));
			jScrollPane_Fundamenta.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundamenta.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundamenta.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundamenta.setViewportView(getJTextArea_Fundamenta());
		}
		return jScrollPane_Fundamenta;
	}
	public JTextArea getJTextArea_Fundamenta() {
		if (jTextArea_Fundamenta == null) {
			jTextArea_Fundamenta = new JTextArea();
			jTextArea_Fundamenta.setFont(fmeFrame.letra);
			jTextArea_Fundamenta.setLineWrap(true);
			jTextArea_Fundamenta.setWrapStyleWord(true);
			jTextArea_Fundamenta.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundamenta;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_MajorIDT.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.MajorIDT.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.MajorIDT.validar(null));
		return grp;
	}
}
