package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Mercados extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Mercados = null;
	private JLabel jLabel_Mercados = null;
	private JScrollPane jScrollPane_Mercados = null;
	private JTable_Tip jTable_Mercados = null;
	private JButton jButton_MercadosCopy = null;
	private JButton jButton_MercadosUp = null;
	private JButton jButton_MercadosAdd = null;
	private JButton jButton_MercadosIns = null;
	private JButton jButton_MercadosDel = null;

	String tag = "";
	
	public Frame_Mercados() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(1860,410);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_Mercados, 40);		
	}
		
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Mercados(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Mercados() {
		if (jPanel_Mercados == null) {
			jButton_MercadosCopy = new JButton(fmeFrame.copiarLinha);
		    jButton_MercadosCopy.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MercadosCopy.addMouseListener(new Frame_Mercados_jButton_MercadosCopy_mouseAdapter(this));
		    jButton_MercadosCopy.setToolTipText("Copiar Linha");
		    jButton_MercadosCopy.setBounds(new Rectangle(437, 11, 30, 22));
		    jButton_MercadosUp = new JButton(fmeFrame.subirLinha);
		    jButton_MercadosUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MercadosUp.addMouseListener(new Frame_Mercados_jButton_MercadosUp_mouseAdapter(this));
		    jButton_MercadosUp.setToolTipText("Trocar Linhas");
		    jButton_MercadosUp.setBounds(new Rectangle(477, 11, 30, 22));
		    jButton_MercadosAdd = new JButton(fmeFrame.novaLinha);
		    jButton_MercadosAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MercadosAdd.addMouseListener(new Frame_Mercados_jButton_MercadosAdd_mouseAdapter(this));
		    jButton_MercadosAdd.setToolTipText("Nova Linha");
		    jButton_MercadosAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_MercadosIns = new JButton(fmeFrame.inserirLinha);
		    jButton_MercadosIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MercadosIns.addMouseListener(new Frame_Mercados_jButton_MercadosIns_mouseAdapter(this));
		    jButton_MercadosIns.setToolTipText("Inserir Linha");
		    jButton_MercadosIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_MercadosDel = new JButton(fmeFrame.apagarLinha);
		    jButton_MercadosDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MercadosDel.addMouseListener(new Frame_Mercados_jButton_MercadosDel_mouseAdapter(this));
		    jButton_MercadosDel.setToolTipText("Apagar Linha");
		    jButton_MercadosDel.setBounds(new Rectangle(597, 11, 30, 22));

			jLabel_Mercados = new JLabel();
			jLabel_Mercados.setBounds(new Rectangle(12, 10, 294, 18));
			jLabel_Mercados.setText("<html>Actividade econmica por mercado</html>");
			jLabel_Mercados.setFont(fmeFrame.letra_bold);			
			jPanel_Mercados = new JPanel();
			jPanel_Mercados.setLayout(null);
			jPanel_Mercados.setBounds(new Rectangle(15, 50, 1840, 350));
			jPanel_Mercados.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Mercados.add(jLabel_Mercados, null);
			jPanel_Mercados.add(jButton_MercadosCopy, null);
			jPanel_Mercados.add(jButton_MercadosUp, null);
			jPanel_Mercados.add(jButton_MercadosAdd, null);
			jPanel_Mercados.add(jButton_MercadosIns, null);
			jPanel_Mercados.add(jButton_MercadosDel, null);
			jPanel_Mercados.add(getJScrollPane_Mercados(), null);
		}
		return jPanel_Mercados;
	}
	
	public JScrollPane getJScrollPane_Mercados() {
		if (jScrollPane_Mercados == null) {
			jScrollPane_Mercados = new JScrollPane();
			jScrollPane_Mercados.setBounds(new Rectangle(16, 36, 1806, 300));
			jScrollPane_Mercados.setViewportView(getJTable_Mercados());
			jScrollPane_Mercados.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Mercados.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_Mercados.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Mercados;
	}
	
	public JTable getJTable_Mercados() {
		if (jTable_Mercados == null) {
			jTable_Mercados = new JTable_Tip(25);
			jTable_Mercados = new JTable_Tip(40, jScrollPane_Mercados.getWidth());
			jTable_Mercados.setFont(fmeFrame.letra);
			jTable_Mercados.setRowHeight(18);
			jTable_Mercados.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Mercados.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Mercados;
	}
	
	public CBTabela_Mercados cbd_mercados;
	void jButton_MercadosCopy_mouseClicked(MouseEvent e) {
		cbd_mercados.on_copy_row();
	}

	void jButton_MercadosUp_mouseClicked(MouseEvent e) {
		cbd_mercados.on_up_row();
	}

	void jButton_MercadosAdd_mouseClicked(MouseEvent e) {
		cbd_mercados.on_add_row();
	}

	void jButton_MercadosDel_mouseClicked(MouseEvent e) {
		cbd_mercados.on_del_row();
	}

	void jButton_MercadosIns_mouseClicked(MouseEvent e) {
		cbd_mercados.on_ins_row();
	}
	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_Mercados.getWidth() - jScrollPane_Mercados.getWidth();
		int w = jPanel_Mercados.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Mercados.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Mercados.validar(null, ""));
		return grp;
	}

}

class Frame_Mercados_jButton_MercadosCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Mercados adaptee;
	
	Frame_Mercados_jButton_MercadosCopy_mouseAdapter(Frame_Mercados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_MercadosCopy_mouseClicked(e);
	}	
}

class Frame_Mercados_jButton_MercadosUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Mercados adaptee;
	
	Frame_Mercados_jButton_MercadosUp_mouseAdapter(Frame_Mercados adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MercadosUp_mouseClicked(e);
	}
}

class Frame_Mercados_jButton_MercadosAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Mercados adaptee;

	Frame_Mercados_jButton_MercadosAdd_mouseAdapter(Frame_Mercados adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MercadosAdd_mouseClicked(e);
	}
}

class Frame_Mercados_jButton_MercadosDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Mercados adaptee;

	Frame_Mercados_jButton_MercadosDel_mouseAdapter(Frame_Mercados adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MercadosDel_mouseClicked(e);
	}
}

class Frame_Mercados_jButton_MercadosIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Mercados adaptee;

	Frame_Mercados_jButton_MercadosIns_mouseAdapter(Frame_Mercados adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MercadosIns_mouseClicked(e);
	}
}
