package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

import javax.swing.ButtonGroup;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JScrollPane;
import javax.swing.SwingConstants;

import java.awt.Component;
import java.awt.Font;
import javax.swing.JCheckBox;
import javax.swing.JPasswordField;
import javax.swing.JComboBox;

public class Frame_PME extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_PME = null;
	private JLabel jLabel_PME = null;
	private JScrollPane jScrollPane_PME = null;
	private JTable_Tip jTable_PME = null;
	private JButton jButton_PMECopy = null;
	private JButton jButton_PMEUp = null;
	private JButton jButton_PMEAdd = null;
	private JButton jButton_PMEIns = null;
	private JButton jButton_PMEDel = null;
	private JLabel jLabel_notas = null;

	String tag = "";

	private JPanel jPanel_PME0 = null;

	private JLabel jLabel_N_PME = null;

	private JTextField jTextField_n_PME_apres = null;

	private JLabel jLabel_ProjConj = null;

	private JLabel jLabel_Elegivel = null;

	private JTextField jTextField_n_PME_prev = null;

	private JLabel jLabel_N_PME_A = null;

	private JLabel jLabel_N_PME_P = null;

	private JTextField jTextField_Eleg_apres = null;

	private JLabel jLabel_RegiaoUnica = null;
	private JCheckBox jCheckBox_Regiao_Sim = null;
	private JCheckBox jCheckBox_Regiao_Nao = null;
	public JCheckBox jCheckBox_RegiaoClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Regiao = null;

	public JLabel jLabel_RegiaoInv = null;

	private SteppedComboBox jComboBox_Regiao = null;

	public Frame_PME() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,585);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_PME(), null);
			jContentPane.add(getJPanel_PME0(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_PME() {
		if (jPanel_PME == null) {
			jButton_PMECopy = new JButton(fmeFrame.copiarLinha);
		    jButton_PMECopy.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PMECopy.addMouseListener(new Frame_PME_jButton_PMECopy_mouseAdapter(this));
		    jButton_PMECopy.setToolTipText("Copiar Linha");
		    jButton_PMECopy.setBounds(new Rectangle(436, 14, 30, 22));
		    jButton_PMEUp = new JButton(fmeFrame.subirLinha);
		    jButton_PMEUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PMEUp.addMouseListener(new Frame_PME_jButton_PMEUp_mouseAdapter(this));
		    jButton_PMEUp.setToolTipText("Trocar Linhas");
		    jButton_PMEUp.setBounds(new Rectangle(476, 14, 30, 22));
		    jButton_PMEAdd = new JButton(fmeFrame.novaLinha);
		    jButton_PMEAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PMEAdd.addMouseListener(new Frame_PME_jButton_PMEAdd_mouseAdapter(this));
		    jButton_PMEAdd.setToolTipText("Nova Linha");
		    jButton_PMEAdd.setBounds(new Rectangle(516, 14, 30, 22));
		    jButton_PMEIns = new JButton(fmeFrame.inserirLinha);
		    jButton_PMEIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PMEIns.addMouseListener(new Frame_PME_jButton_PMEIns_mouseAdapter(this));
		    jButton_PMEIns.setToolTipText("Inserir Linha");
		    jButton_PMEIns.setBounds(new Rectangle(556, 14, 30, 22));
		    jButton_PMEDel = new JButton(fmeFrame.apagarLinha);
		    jButton_PMEDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PMEDel.addMouseListener(new Frame_PME_jButton_PMEDel_mouseAdapter(this));
		    jButton_PMEDel.setToolTipText("Apagar Linha");
		    jButton_PMEDel.setBounds(new Rectangle(596, 14, 30, 22));
			jLabel_PME = new JLabel();
			jLabel_PME.setBounds(new Rectangle(11, 13, 414, 18));
			jLabel_PME.setText("<html>Identificao das PME envolvidas (50% com um mnimo de 5 PME)</html>");
			jLabel_PME.setFont(fmeFrame.letra_bold);			

			jLabel_notas = new JLabel();
			jLabel_notas.setBounds(new Rectangle(16, 212, 604, 91));
			jLabel_notas.setText("<html><u>Notas</u>:<br>- Pr-Projecto: Valor mdio de vendas nos ltimos trs anos completos anteriores  candidatura;<br>- Ps-Projecto: Valor previsto de vendas um ano aps a data de concluso do projecto;<br>- Marca: Identificar as marcas da empresa (de produtos e servios da empresa ou marca 'nome da Empresa'), no caso de possuir/prever posicionamento nos mercados alvo do plano conjunto com essas marcas;<br>- Marcado alvo prioritrio: Identificao do mercado para a empresa considerado prioritrio dos mercados alvo do plano conjunto;<br>- Objectivo dominante: Identificao do objectivo dominante da empresa no mercado alvo prioritrio identificada na coluna anterior.</html>");
			jLabel_notas.setFont(fmeFrame.letra_pequena);			

			jPanel_PME = new JPanel();
			jPanel_PME.setLayout(null);
			jPanel_PME.setBounds(new Rectangle(15, 240, 640, 305));
			jPanel_PME.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PME.add(jLabel_PME, null);
			jPanel_PME.add(jButton_PMECopy, null);
			jPanel_PME.add(jButton_PMEUp, null);
			jPanel_PME.add(jButton_PMEAdd, null);
			jPanel_PME.add(jButton_PMEIns, null);
			jPanel_PME.add(jButton_PMEDel, null);
			jPanel_PME.add(jLabel_notas, null);
			jPanel_PME.add(getJScrollPane_PME(), null);
					}
		return jPanel_PME;
	}
	
	public JScrollPane getJScrollPane_PME() {
		if (jScrollPane_PME == null) {
			jScrollPane_PME = new JScrollPane();
			jScrollPane_PME.setBounds(new Rectangle(15, 39, 606, 172));
			jScrollPane_PME.setViewportView(getJTable_PME());
			//jScrollPane_PME.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_PME.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_PME.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_PME;
	}
	
	public JTable getJTable_PME() {
		if (jTable_PME == null) {
			jTable_PME = new JTable_Tip(60, jScrollPane_PME.getWidth());
			jTable_PME.setFont(fmeFrame.letra);
			jTable_PME.setRowHeight(18);
			jTable_PME.setName("PME_Tabela");
			jTable_PME.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_PME.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_PME;
	}
	void jButton_PMECopy_mouseClicked(MouseEvent e) {
		CBData.PME.on_copy_row();
		CBData.PME.on_update("", 0, "");
	}

	void jButton_PMEUp_mouseClicked(MouseEvent e) {
		CBData.PME.on_up_row();
	}

	void jButton_PMEAdd_mouseClicked(MouseEvent e) {
		CBData.PME.on_add_row();
	}

	void jButton_PMEDel_mouseClicked(MouseEvent e) {
		CBData.PME.on_del_row();
		CBData.PME.on_update("", 0, "");
	}

	void jButton_PMEIns_mouseClicked(MouseEvent e) {
		CBData.PME.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
	    print_handler.setOrientation (PageFormat.LANDSCAPE);

		print_handler.dx_expand = jTable_PME.getWidth() - jScrollPane_PME.getWidth();
		int w = jPanel_PME.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.CaracConjuntos.Clear();
		CBData.CaracConjuntos.on_update("regiao_unica");
		CBData.PME.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.CaracConjuntos.validar(null));
		grp.add_grp(CBData.PME.validar(null));
		return grp;
	}

	/**
	 * This method initializes jPanel_PME0	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel_PME0() {
		if (jPanel_PME0 == null) {
			jLabel_RegiaoInv = new JLabel();
			jLabel_RegiaoInv.setBounds(new Rectangle(14, 135, 300, 18));
			jLabel_RegiaoInv.setText("<html>Regio onde se situa a maior percentagem de Investimento</html>");
			jLabel_RegiaoInv.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jLabel_RegiaoInv.setForeground(fmeFrame.color_2);
			
			jLabel_RegiaoUnica = new JLabel();
			jLabel_RegiaoUnica.setBounds(new Rectangle(14, 104, 297, 18));
			jLabel_RegiaoUnica.setText("<html>O Investimento situa-se maioritariamente numa s Regio ?</html>");
			jLabel_RegiaoUnica.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jLabel_N_PME_P = new JLabel();
			jLabel_N_PME_P.setBounds(new Rectangle(419, 44, 62, 18));
			jLabel_N_PME_P.setText("Previsto");
			jLabel_N_PME_P.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jLabel_N_PME_A = new JLabel();
			jLabel_N_PME_A.setBounds(new Rectangle(246, 44, 70, 18));
			jLabel_N_PME_A.setText("<html>Apresentado</html>");
			jLabel_N_PME_A.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jLabel_Elegivel = new JLabel();
			jLabel_Elegivel.setBounds(new Rectangle(14, 74, 221, 18));
			jLabel_Elegivel.setText("<html>Investimento Elegvel Total </html>");
			jLabel_Elegivel.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jLabel_ProjConj = new JLabel();
			jLabel_ProjConj.setBounds(new Rectangle(15, 11, 586, 14));
			jLabel_ProjConj.setText("<html>Caractersticas do projecto conjunto</html>");
			jLabel_ProjConj.setFont(fmeFrame.letra_bold);
			jLabel_N_PME = new JLabel();
			jLabel_N_PME.setBounds(new Rectangle(14, 44, 224, 18));
			jLabel_N_PME.setText("<html>N. de PME envolvidas no projecto conjunto</html>");
			jLabel_N_PME.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jPanel_PME0 = new JPanel();
			jPanel_PME0.setLayout(null);
			jPanel_PME0.setBounds(new Rectangle(15, 50, 640, 177));
			jPanel_PME0.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PME0.add(jLabel_N_PME, null);
			jPanel_PME0.add(getjTextField_n_PME_apres(), null);
			jPanel_PME0.add(jLabel_ProjConj, null);
			jPanel_PME0.add(jLabel_Elegivel, null);
			jPanel_PME0.add(getjTextField_n_PME_prev(), null);
			jPanel_PME0.add(jLabel_N_PME_A, null);
			jPanel_PME0.add(jLabel_N_PME_P, null);
			jPanel_PME0.add(getjTextField_Eleg_apres(), null);
			jPanel_PME0.add(jLabel_RegiaoUnica, null);
			jPanel_PME0.add(getJCheckBox_Regiao_Sim(), null);
			jPanel_PME0.add(getjCheckBox_Regiao_Nao(), null);
			this.getJButtonGroup_Regiao();
			jPanel_PME0.add(jLabel_RegiaoInv, null);
			jPanel_PME0.add(getJComboBox_Regiao(), null);
		}
		return jPanel_PME0;
	}

	/**
	 * This method initializes jTextField_n_PME_apres	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getjTextField_n_PME_apres() {
		if (jTextField_n_PME_apres == null) {
			jTextField_n_PME_apres = new JTextField();
			jTextField_n_PME_apres.setBounds(new Rectangle(321, 44, 52, 18));
			jTextField_n_PME_apres.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_n_PME_apres.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField_n_PME_apres.setEditable(false);
			jTextField_n_PME_apres.setFocusable(false);
			jTextField_n_PME_apres.setFont(fmeFrame.letra);
		}
		return jTextField_n_PME_apres;
	}

	/**
	 * This method initializes jTextField_n_PME_prev	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getjTextField_n_PME_prev() {
		if (jTextField_n_PME_prev == null) {
			jTextField_n_PME_prev = new JTextField();
			jTextField_n_PME_prev.setBounds(new Rectangle(494, 43, 52, 18));
			jTextField_n_PME_prev.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_n_PME_prev.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField_n_PME_prev.setFont(fmeFrame.letra);
		}
		return jTextField_n_PME_prev;
	}

	/**
	 * This method initializes jTextField_Eleg_apres	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getjTextField_Eleg_apres() {
		if (jTextField_Eleg_apres == null) {
			jTextField_Eleg_apres = new JTextField();
			jTextField_Eleg_apres.setBounds(new Rectangle(322, 77, 100, 18));
			jTextField_Eleg_apres.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Eleg_apres.setFocusable(false);
			jTextField_Eleg_apres.setEditable(false);
			jTextField_Eleg_apres.setHorizontalAlignment(SwingConstants.RIGHT);
			jTextField_Eleg_apres.setFont(fmeFrame.letra);
		}
		return jTextField_Eleg_apres;
	}

	/**
	 * This method initializes jCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getJCheckBox_Regiao_Sim() {
		if (jCheckBox_Regiao_Sim == null) {
			jCheckBox_Regiao_Sim = new JCheckBox();
			jCheckBox_Regiao_Sim.setBounds(new Rectangle(322, 102, 55, 22));
			jCheckBox_Regiao_Sim.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jCheckBox_Regiao_Sim.setText("Sim");
			jCheckBox_Regiao_Sim.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData.CaracConjuntos.getByName("regiao_unica").vldOnline();}
				    catch (Exception ex) { };
				}
			});

		}
		return jCheckBox_Regiao_Sim;
	}

	/**
	 * This method initializes jCheckBox_Regiao_Nao	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	public JCheckBox getjCheckBox_Regiao_Nao() {
		if (jCheckBox_Regiao_Nao == null) {
			jCheckBox_Regiao_Nao = new JCheckBox();
			jCheckBox_Regiao_Nao.setBounds(new Rectangle(377, 101, 50, 22));
			jCheckBox_Regiao_Nao.setText("No");
			jCheckBox_Regiao_Nao.setFont(new Font("Tahoma", Font.PLAIN, 11));
			jCheckBox_Regiao_Nao.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData.CaracConjuntos.getByName("regiao_unica").vldOnline();}
				    catch (Exception ex) { };
				}
			});
		}
		return jCheckBox_Regiao_Nao;
	}
	private ButtonGroup getJButtonGroup_Regiao() {
		if (jButtonGroup_Regiao == null) {
			jButtonGroup_Regiao = new ButtonGroup();
			jButtonGroup_Regiao.add(jCheckBox_Regiao_Sim);
			jButtonGroup_Regiao.add(jCheckBox_Regiao_Nao);
			jButtonGroup_Regiao.add(jCheckBox_RegiaoClear);
		}
		return jButtonGroup_Regiao;
	}

	public JComboBox getJComboBox_Regiao() {
		if (jComboBox_Regiao == null) {
			jComboBox_Regiao = new SteppedComboBox();
			jComboBox_Regiao.setBounds(new Rectangle(325, 136, 144, 18));
			jComboBox_Regiao.setBorder(BorderFactory.createLineBorder(Color.black, 1));
			jComboBox_Regiao.setFont(fmeFrame.letra);
			jComboBox_Regiao.setBackground(Color.WHITE);
			jComboBox_Regiao.setEnabled(false);
			jComboBox_Regiao.setEditable(false);
			//jComboBox_Regiao.setFocusable(false);
			jComboBox_Regiao.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData.CaracConjuntos.getByName("nuts_II").vldOnline();}
				    catch (Exception ex) { };
				}
			});
		}
		return jComboBox_Regiao;
	}

}		


class Frame_PME_jButton_PMECopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PME adaptee;
	
	Frame_PME_jButton_PMECopy_mouseAdapter(Frame_PME adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PMECopy_mouseClicked(e);
	}	
}

class Frame_PME_jButton_PMEUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PME adaptee;
	
	Frame_PME_jButton_PMEUp_mouseAdapter(Frame_PME adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PMEUp_mouseClicked(e);
	}
}

class Frame_PME_jButton_PMEAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PME adaptee;

	Frame_PME_jButton_PMEAdd_mouseAdapter(Frame_PME adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PMEAdd_mouseClicked(e);
	}
}

class Frame_PME_jButton_PMEDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PME adaptee;

	Frame_PME_jButton_PMEDel_mouseAdapter(Frame_PME adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PMEDel_mouseClicked(e);
	}
}

class Frame_PME_jButton_PMEIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PME adaptee;

	Frame_PME_jButton_PMEIns_mouseAdapter(Frame_PME adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PMEIns_mouseClicked(e);
	}
}
