package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_PTrabalho extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_PTrabalho = null;
	private JLabel jLabel_PTrabalho = null;
	private JScrollPane jScrollPane_PTrabalho = null;
	private JTable_Tip jTable_PTrabalho = null;
	private JButton jButton_PTrabalhoCopy = null;
	private JButton jButton_PTrabalhoUp = null;
	private JButton jButton_PTrabalhoAdd = null;
	private JButton jButton_PTrabalhoIns = null;
	private JButton jButton_PTrabalhoDel = null;

	String tag = "";  //  @jve:decl-index=0:
	
	public Frame_PTrabalho() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,410);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_PTrabalho, 40);		
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_PTrabalho(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_PTrabalho() {
		if (jPanel_PTrabalho == null) {
			jButton_PTrabalhoCopy = new JButton(fmeFrame.copiarLinha);
		    jButton_PTrabalhoCopy.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PTrabalhoCopy.addMouseListener(new Frame_PTrabalho_jButton_PTrabalhoCopy_mouseAdapter(this));
		    jButton_PTrabalhoCopy.setToolTipText("Copiar Linha");
		    jButton_PTrabalhoCopy.setBounds(new Rectangle(437, 11, 30, 22));
		    jButton_PTrabalhoUp = new JButton(fmeFrame.subirLinha);
		    jButton_PTrabalhoUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PTrabalhoUp.addMouseListener(new Frame_PTrabalho_jButton_PTrabalhoUp_mouseAdapter(this));
		    jButton_PTrabalhoUp.setToolTipText("Trocar Linhas");
		    jButton_PTrabalhoUp.setBounds(new Rectangle(477, 11, 30, 22));
		    jButton_PTrabalhoAdd = new JButton(fmeFrame.novaLinha);
		    jButton_PTrabalhoAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PTrabalhoAdd.addMouseListener(new Frame_PTrabalho_jButton_PTrabalhoAdd_mouseAdapter(this));
		    jButton_PTrabalhoAdd.setToolTipText("Nova Linha");
		    jButton_PTrabalhoAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_PTrabalhoIns = new JButton(fmeFrame.inserirLinha);
		    jButton_PTrabalhoIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PTrabalhoIns.addMouseListener(new Frame_PTrabalho_jButton_PTrabalhoIns_mouseAdapter(this));
		    jButton_PTrabalhoIns.setToolTipText("Inserir Linha");
		    jButton_PTrabalhoIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_PTrabalhoDel = new JButton(fmeFrame.apagarLinha);
		    jButton_PTrabalhoDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_PTrabalhoDel.addMouseListener(new Frame_PTrabalho_jButton_PTrabalhoDel_mouseAdapter(this));
		    jButton_PTrabalhoDel.setToolTipText("Apagar Linha");
		    jButton_PTrabalhoDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_PTrabalho = new JLabel();
			jLabel_PTrabalho.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_PTrabalho.setText("<html>Postos de Trabalho do Promotor</html>");
			jLabel_PTrabalho.setFont(fmeFrame.letra_bold);			
			jPanel_PTrabalho = new JPanel();
			jPanel_PTrabalho.setLayout(null);
			jPanel_PTrabalho.setBounds(new Rectangle(15, 50, 640, 350));
			jPanel_PTrabalho.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PTrabalho.add(jLabel_PTrabalho, null);
			jPanel_PTrabalho.add(jButton_PTrabalhoCopy, null);
			jPanel_PTrabalho.add(jButton_PTrabalhoUp, null);
			jPanel_PTrabalho.add(jButton_PTrabalhoAdd, null);
			jPanel_PTrabalho.add(jButton_PTrabalhoIns, null);
			jPanel_PTrabalho.add(jButton_PTrabalhoDel, null);
			jPanel_PTrabalho.add(getJScrollPane_PTrabalho(), null);
		}
		return jPanel_PTrabalho;
	}
	
	public JScrollPane getJScrollPane_PTrabalho() {
		if (jScrollPane_PTrabalho == null) {
			jScrollPane_PTrabalho = new JScrollPane();
			jScrollPane_PTrabalho.setBounds(new Rectangle(16, 36, 606, 300));
			jScrollPane_PTrabalho.setViewportView(getJTable_PTrabalho());
			//jScrollPane_PTrabalho.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			//jScrollPane_PTrabalho.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_PTrabalho.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_PTrabalho;
	}
	
	public JTable getJTable_PTrabalho() {
		if (jTable_PTrabalho == null) {
			//jTable_PTrabalho = new JTable_Tip(25);
			jTable_PTrabalho = new JTable_Tip(40, jScrollPane_PTrabalho.getWidth());
			jTable_PTrabalho.setFont(fmeFrame.letra);
			jTable_PTrabalho.setRowHeight(18);
			jTable_PTrabalho.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_PTrabalho.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_PTrabalho;
	}
	
	public CBTabela_PTrabalho cbd_ptrabalho;
	void jButton_PTrabalhoCopy_mouseClicked(MouseEvent e) {
		cbd_ptrabalho.on_copy_row();
	}

	void jButton_PTrabalhoUp_mouseClicked(MouseEvent e) {
		cbd_ptrabalho.on_up_row();
	}

	void jButton_PTrabalhoAdd_mouseClicked(MouseEvent e) {
		cbd_ptrabalho.on_add_row();
	}

	void jButton_PTrabalhoDel_mouseClicked(MouseEvent e) {
		cbd_ptrabalho.on_del_row();
	}

	void jButton_PTrabalhoIns_mouseClicked(MouseEvent e) {
		cbd_ptrabalho.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		//print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_PTrabalho.getWidth() - jScrollPane_PTrabalho.getWidth();
		int w = jPanel_PTrabalho.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.PTrabalho.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.PTrabalho.validar(null, ""));
		return grp;
	}

}		


class Frame_PTrabalho_jButton_PTrabalhoCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PTrabalho adaptee;
	
	Frame_PTrabalho_jButton_PTrabalhoCopy_mouseAdapter(Frame_PTrabalho adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PTrabalhoCopy_mouseClicked(e);
	}	
}

class Frame_PTrabalho_jButton_PTrabalhoUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PTrabalho adaptee;
	
	Frame_PTrabalho_jButton_PTrabalhoUp_mouseAdapter(Frame_PTrabalho adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PTrabalhoUp_mouseClicked(e);
	}
}

class Frame_PTrabalho_jButton_PTrabalhoAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PTrabalho adaptee;

	Frame_PTrabalho_jButton_PTrabalhoAdd_mouseAdapter(Frame_PTrabalho adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PTrabalhoAdd_mouseClicked(e);
	}
}

class Frame_PTrabalho_jButton_PTrabalhoDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PTrabalho adaptee;

	Frame_PTrabalho_jButton_PTrabalhoDel_mouseAdapter(Frame_PTrabalho adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PTrabalhoDel_mouseClicked(e);
	}
}

class Frame_PTrabalho_jButton_PTrabalhoIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PTrabalho adaptee;

	Frame_PTrabalho_jButton_PTrabalhoIns_mouseAdapter(Frame_PTrabalho adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_PTrabalhoIns_mouseClicked(e);
	}
}
