package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.SwingConstants;

public class Frame_Params extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Params = null;

	private JPanel jPanel_Inicio = null;
	private JLabel jLabel_QREN = null;
	private JLabel jLabel_UE = null;
	private JLabel jLabel_Fase = null;
	private JLabel jLabel_Aviso = null;
	private JLabel jLabel_Sistema = null;
	private JLabel jLabel_Modalidade = null;

	
	private JPanel jPanel_Params = null;
	private JTable_Tip jTable_Financ = null;
	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	private JComboBox jComboBox_Sistema = null;
	private JLabel jLabel_RegEspecial = null;
	private JCheckBox jCheckBox_RegEspecial_Sim = null;
	private JCheckBox jCheckBox_RegEspecial_Nao = null;
	public JCheckBox jCheckBox_RegEspecial_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_RegEspecial = null;

	private JLabel jLabel_EnqEstrategias = null;
	private JCheckBox jCheckBox_EnqEstrategias_Sim = null;
	private JCheckBox jCheckBox_EnqEstrategias_Nao = null;
	public JCheckBox jCheckBox_EnqEstrategias_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_EnqEstrategias = null;  //  @jve:decl-index=0:
	private JLabel jLabel_Qual = null;
	private JComboBox jComboBox_Estrategia = null;
	
	private JTextField jTextField_AnoCand = null;

	private JLabel jLabel_AnoCand = null;

	//private JComboBox jComboBox_Tipologia = null;

	String tag = "";
	
	public Frame_Params() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,710);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Params = new JLabel();
			jLabel_Params.setBounds(new Rectangle(15, 10, 640, 31));
			//jLabel_Params.setText("   PARAMETRIZAO");
			jLabel_Params.setText("   ENQUADRAMENTO NO AVISO DE ABERTURA");
			jLabel_Params.setFont(fmeFrame.letra_titulo);
			jLabel_Params.setBorder(BorderFactory.createEtchedBorder());

		    jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			//jContentPane.add(jLabel_Params, null);
			jContentPane.add(getJPanel_Inicio(), null);
			jContentPane.add(getJPanel_Params(), null);
			jContentPane.add(getJPanel_Fundam(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Inicio() {
		if (jPanel_Inicio == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(15, 5, 78, 46));

			jLabel_UE = new JLabel();
			jLabel_UE.setIcon(fmeFrame.logoUE);
			jLabel_UE.setBounds(new Rectangle(100, 12, 187, 39));

			jLabel_Fase = new JLabel();
			jLabel_Fase.setBounds(new Rectangle(15, 61, 610, 39));
			//jLabel_Fase.setText("- Fase 01/2007 -");
			jLabel_Fase.setHorizontalAlignment(SwingConstants.CENTER);
			String[] aviso = ((String) CParseConfig.hconfig.get("aviso")).split("_");
			jLabel_Fase.setText("= Aviso "+aviso[1]+"/"+aviso[0]+" =");
			jLabel_Fase.setFont(fmeFrame.letra_bold);

			jLabel_Aviso = new JLabel();
			jLabel_Aviso.setBounds(new Rectangle(15, 137, 610, 39));
			//jLabel_Aviso.setText("Candidaturas a Projectos Individuais e de Cooperao");
			jLabel_Aviso.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Aviso.setText("<html><div style='text-align:center'>"+(String) CParseConfig.hconfig.get("aviso_d")+"</div></html>");
			jLabel_Aviso.setFont(fmeFrame.letra_titulo3);

			jLabel_Sistema = new JLabel();
			jLabel_Sistema.setBounds(new Rectangle(15, 99, 610, 39));
			//jLabel_Sistema.setText("SI Qualificao de PME");
			jLabel_Sistema.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Sistema.setText((String) CParseConfig.hconfig.get("sistema"));
			jLabel_Sistema.setFont(fmeFrame.letra_titulo1);

			jLabel_Modalidade = new JLabel();
			jLabel_Modalidade.setBounds(new Rectangle(15, 175, 610, 39));
			//jLabel_Modalidade.setText("Projecto Individual");
			jLabel_Modalidade.setHorizontalAlignment(SwingConstants.CENTER);
			jLabel_Modalidade.setText((String) CParseConfig.hconfig.get("modalidade"));
			jLabel_Modalidade.setFont(fmeFrame.letra_titulo2);

			jPanel_Inicio = new JPanel();
			jPanel_Inicio.setBounds(new Rectangle(15, 10, 640, 245));
			jPanel_Inicio.setLayout(null);
			jPanel_Inicio.setBorder(BorderFactory.createEtchedBorder());

			jPanel_Inicio.add(jLabel_QREN, null);
			jPanel_Inicio.add(jLabel_UE, null);
			jPanel_Inicio.add(jLabel_Fase, null);
			jPanel_Inicio.add(jLabel_Aviso, null);
			jPanel_Inicio.add(jLabel_Sistema, null);
			jPanel_Inicio.add(jLabel_Modalidade, null);
		}
		return jPanel_Inicio;
	}
			
	private JPanel getJPanel_Params() {
		if (jPanel_Params == null) {
			
			jLabel_AnoCand = new JLabel();
			jLabel_AnoCand.setBounds(new Rectangle(20, 20, 105, 18));
			jLabel_AnoCand.setText("Ano de Referncia");
			jLabel_AnoCand.setFont(fmeFrame.letra);
			jLabel_EnqEstrategias = new JLabel();
			jLabel_EnqEstrategias.setBounds(new Rectangle(20, 80, 269, 18));
			jLabel_EnqEstrategias.setText("Enquadramento em Estratgias de Eficincia Colectiva");
			jLabel_EnqEstrategias.setFont(fmeFrame.letra);
			jLabel_Qual = new JLabel();
			jLabel_Qual.setBounds(new Rectangle(410, 80, 48, 18));
			jLabel_Qual.setText("Qual?");
			jLabel_Qual.setFont(fmeFrame.letra);
			jLabel_Qual.setHorizontalAlignment(SwingConstants.RIGHT);
			if (((String) CParseConfig.hconfig.get("ef_colectiva")).equals("0")){
				jLabel_EnqEstrategias.setForeground(fmeFrame.color_2);
				jLabel_Qual.setForeground(fmeFrame.color_2);
			}
			jLabel_RegEspecial = new JLabel();
			jLabel_RegEspecial.setBounds(new Rectangle(20, 50, 143, 18));
			jLabel_RegEspecial.setText("Projecto de Regime Especial");
			jLabel_RegEspecial.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("reg_especial")).equals("0"))
				jLabel_RegEspecial.setForeground(fmeFrame.color_2);
			jPanel_Params = new JPanel();
			jPanel_Params.setLayout(null);
			jPanel_Params.setBounds(new Rectangle(15, 265, 640, 115));
			jPanel_Params.setBorder(BorderFactory.createEtchedBorder());
			//jPanel_Params.add(getJComboBox_Sistema(), null);
			jPanel_Params.add(jLabel_RegEspecial);
			jPanel_Params.add(getJCheckBox_RegEspecial_Sim(), null);
			jPanel_Params.add(getJCheckBox_RegEspecial_Nao(), null);
		    this.getJButtonGroup_RegEspecial();
			jPanel_Params.add(jLabel_EnqEstrategias);
			jPanel_Params.add(getJCheckBox_EnqEstrategias_Sim(), null);
			jPanel_Params.add(getJCheckBox_EnqEstrategias_Nao(), null);
		    this.getJButtonGroup_EnqEstrategias();
			jPanel_Params.add(jLabel_Qual);
			jPanel_Params.add(getJComboBox_Estrategia(), null);
			jPanel_Params.add(getJTextField_AnoCand(), null);
			jPanel_Params.add(jLabel_AnoCand, null);
			//jPanel_Params.add(getJComboBox_Concurso(), null);
			//jPanel_Params.add(getJComboBox_Tipologia(), null);
		}
		return jPanel_Params;
	}
	
	public JCheckBox getJCheckBox_RegEspecial_Sim() {
		if (jCheckBox_RegEspecial_Sim == null) {
			jCheckBox_RegEspecial_Sim = new JCheckBox();
			jCheckBox_RegEspecial_Sim.setBounds(new Rectangle(170, 50, 48, 19));
			jCheckBox_RegEspecial_Sim.setText("Sim");
			jCheckBox_RegEspecial_Sim.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("reg_especial")).equals("0"))
				jCheckBox_RegEspecial_Sim.setEnabled(false);
		}
		return jCheckBox_RegEspecial_Sim;
	}

	public JCheckBox getJCheckBox_RegEspecial_Nao() {
		if (jCheckBox_RegEspecial_Nao == null) {
			jCheckBox_RegEspecial_Nao = new JCheckBox();
			jCheckBox_RegEspecial_Nao.setBounds(new Rectangle(219, 50, 48, 19));
			jCheckBox_RegEspecial_Nao.setText("No");
			jCheckBox_RegEspecial_Nao.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("reg_especial")).equals("0"))
				jCheckBox_RegEspecial_Nao.setEnabled(false);
		}
		return jCheckBox_RegEspecial_Nao;
	}
	private ButtonGroup getJButtonGroup_RegEspecial() {
		if (jButtonGroup_RegEspecial == null) {
			jButtonGroup_RegEspecial = new ButtonGroup();
			jButtonGroup_RegEspecial.add(jCheckBox_RegEspecial_Sim);
			jButtonGroup_RegEspecial.add(jCheckBox_RegEspecial_Nao);
			jButtonGroup_RegEspecial.add(jCheckBox_RegEspecial_Clear);
		}
		return jButtonGroup_RegEspecial;
	}

	public JCheckBox getJCheckBox_EnqEstrategias_Sim() {
		if (jCheckBox_EnqEstrategias_Sim == null) {
			jCheckBox_EnqEstrategias_Sim = new JCheckBox();
			jCheckBox_EnqEstrategias_Sim.setBounds(new Rectangle(304, 80, 48, 19));
			jCheckBox_EnqEstrategias_Sim.setText("Sim");
			jCheckBox_EnqEstrategias_Sim.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("ef_colectiva")).equals("0")){
				jCheckBox_EnqEstrategias_Sim.setEnabled(false);
			}
		}
		return jCheckBox_EnqEstrategias_Sim;
	}

	public JCheckBox getJCheckBox_EnqEstrategias_Nao() {
		if (jCheckBox_EnqEstrategias_Nao == null) {
			jCheckBox_EnqEstrategias_Nao = new JCheckBox();
			jCheckBox_EnqEstrategias_Nao.setBounds(new Rectangle(354, 80, 48, 19));
			jCheckBox_EnqEstrategias_Nao.setText("No");
			jCheckBox_EnqEstrategias_Nao.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("ef_colectiva")).equals("0")){
				jCheckBox_EnqEstrategias_Nao.setEnabled(false);
			}
		}
		return jCheckBox_EnqEstrategias_Nao;
	}
	private ButtonGroup getJButtonGroup_EnqEstrategias() {
		if (jButtonGroup_EnqEstrategias == null) {
			jButtonGroup_EnqEstrategias = new ButtonGroup();
			jButtonGroup_EnqEstrategias.add(jCheckBox_EnqEstrategias_Sim);
			jButtonGroup_EnqEstrategias.add(jCheckBox_EnqEstrategias_Nao);
			jButtonGroup_EnqEstrategias.add(jCheckBox_EnqEstrategias_Clear);
		}
		return jButtonGroup_EnqEstrategias;
	}

	public JComboBox getJComboBox_Estrategia() {
		if (jComboBox_Estrategia == null) {
			jComboBox_Estrategia = new SteppedComboBox();
			jComboBox_Estrategia.setBounds(new Rectangle(460, 80, 160, 18));
			jComboBox_Estrategia.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_Estrategia.setBackground(Color.WHITE);
			jComboBox_Estrategia.setFont(fmeFrame.letra);
			if (((String) CParseConfig.hconfig.get("ef_colectiva")).equals("0")){
				jComboBox_Estrategia.setEnabled(false);
			}
		
		}
		return jComboBox_Estrategia;
	}

	
	public JTable getJTable_Financ() {
		if (jTable_Financ == null) {
			jTable_Financ = new JTable_Tip(30);
			jTable_Financ.setRowHeight(18);
			jTable_Financ.setFont(fmeFrame.letra);
			jTable_Financ.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Financ.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Financ;
	}
	
	
	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(14, 8, 609, 27));
			jLabel_Fundam.setText("<html>Fundamentao do enquadramento no Aviso de Abertura e, quando aplicvel, na Estratgia de Eficincia Colectiva Seleccionada</html>");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 390, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("cond_eleg_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}
/*
	public JComboBox getJComboBox_Sistema() {
		if (jComboBox_Sistema == null) {
			jComboBox_Sistema = new SteppedComboBox();
			jComboBox_Sistema.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_Sistema.setBackground(Color.WHITE);
			jComboBox_Sistema.setBounds(new Rectangle(215, 60, 200, 18));
			jComboBox_Sistema.setFont(fmeFrame.letra);
			jComboBox_Sistema.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData_Noconfig.Params.getByName("sistema").vldOnline();}
				    catch (Exception ex) { };
				}
			});
		}
		return jComboBox_Sistema;
	}
*/
	public  JTextField getJTextField_AnoCand() {
		if (jTextField_AnoCand == null) {
			jTextField_AnoCand = new JTextField();
			jTextField_AnoCand.setBounds(new Rectangle(174, 20, 42, 18));
			jTextField_AnoCand.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_AnoCand.setFont(fmeFrame.letra);
		}
		return jTextField_AnoCand;
	}
	/*
	public JComboBox getJComboBox_Concurso() {
		if (jComboBox_Concurso == null) {
			jComboBox_Concurso = new SteppedComboBox();
			jComboBox_Concurso.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_Concurso.setBackground(Color.WHITE);
			jComboBox_Concurso.setBounds(new Rectangle(215, 90, 200, 18));
			jComboBox_Concurso.setFont(fmeFrame.letra);
		}
		return jComboBox_Concurso;
	}*/

//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Inicio.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Params.Clear();
		CBData.Params.init();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Params.validar_1(null));
		grp.add_grp(CBData.Params.validar_2(null));
		return grp;
	}

}		
