package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;
import javax.swing.JLabel;

public class Frame_Pareceres extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Professores = null;
	private JLabel jLabel_Professores = null;
	private JScrollPane jScrollPane_Professores = null;
	private JTable_Tip jTable_Professores = null;
	private JButton jButton_ProfessoresCopy = null;
	private JButton jButton_ProfessoresUp = null;
	private JButton jButton_ProfessoresAdd = null;
	private JButton jButton_ProfessoresIns = null;
	private JButton jButton_ProfessoresDel = null;

	private JPanel jPanel_Fundamenta = null;
	private JLabel jLabel_Fundamenta = null;
	private JScrollPane jScrollPane_Fundamenta = null;
	private JTextArea jTextArea_Fundamenta = null;

	String tag = "";

	public Frame_Pareceres() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,740);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_Professores, 30);
		up_component(jPanel_Fundamenta, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Professores(), null);
			jContentPane.add(getJPanel_Fundamenta(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_Professores() {
		if (jPanel_Professores == null) {
			jLabel_Professores = new JLabel();
			jLabel_Professores.setBounds(new Rectangle(12, 10, 409, 32));
			jLabel_Professores.setText("<html>Pareceres prvios dos professores universitrios que o promotor<br>&nbsp;&nbsp;tenha obtido e queira referir na candidatura</html>");
			jLabel_Professores.setFont(fmeFrame.letra_bold);

			jButton_ProfessoresCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ProfessoresCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProfessoresCopy.addMouseListener(new Frame_Pareceres_jButton_ProfessoresCopy_mouseAdapter(this));
			jButton_ProfessoresCopy.setToolTipText("Copiar Linha");
			jButton_ProfessoresCopy.setBounds(new Rectangle(437, 25, 30, 22));
			jButton_ProfessoresUp = new JButton(fmeFrame.subirLinha);
			jButton_ProfessoresUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProfessoresUp.addMouseListener(new Frame_Pareceres_jButton_ProfessoresUp_mouseAdapter(this));
			jButton_ProfessoresUp.setToolTipText("Trocar Linhas");
			jButton_ProfessoresUp.setBounds(new Rectangle(477, 25, 30, 22));
			jButton_ProfessoresAdd = new JButton(fmeFrame.novaLinha);
			jButton_ProfessoresAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProfessoresAdd.addMouseListener(new Frame_Pareceres_jButton_ProfessoresAdd_mouseAdapter(this));
			jButton_ProfessoresAdd.setToolTipText("Nova Linha");
			jButton_ProfessoresAdd.setBounds(new Rectangle(517, 25, 30, 22));
			jButton_ProfessoresIns = new JButton(fmeFrame.inserirLinha);
			jButton_ProfessoresIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProfessoresIns.addMouseListener(new Frame_Pareceres_jButton_ProfessoresIns_mouseAdapter(this));
			jButton_ProfessoresIns.setToolTipText("Inserir Linha");
			jButton_ProfessoresIns.setBounds(new Rectangle(557, 25, 30, 22));
			jButton_ProfessoresDel = new JButton(fmeFrame.apagarLinha);
			jButton_ProfessoresDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProfessoresDel.addMouseListener(new Frame_Pareceres_jButton_ProfessoresDel_mouseAdapter(this));
			jButton_ProfessoresDel.setToolTipText("Apagar Linha");
			jButton_ProfessoresDel.setBounds(new Rectangle(597, 25, 30, 22));

			jPanel_Professores = new JPanel();
			jPanel_Professores.setLayout(null);
			jPanel_Professores.setBounds(new Rectangle(15, 50, 640, 182));
			jPanel_Professores.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Professores.add(jLabel_Professores, null);
			jPanel_Professores.add(jButton_ProfessoresCopy, null);
			jPanel_Professores.add(jButton_ProfessoresUp, null);
			jPanel_Professores.add(jButton_ProfessoresAdd, null);
			jPanel_Professores.add(jButton_ProfessoresIns, null);
			jPanel_Professores.add(jButton_ProfessoresDel, null);
			jPanel_Professores.add(getJScrollPane_Professores(), null);
		}
		return jPanel_Professores;
	}
	public JScrollPane getJScrollPane_Professores() {
		if (jScrollPane_Professores == null) {
			jScrollPane_Professores = new JScrollPane();
			jScrollPane_Professores.setBounds(new Rectangle(16, 50, 606, 117));
			jScrollPane_Professores.setViewportView(getJTable_Professores());
			jScrollPane_Professores.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Professores.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_Professores.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Professores;
	}
	public JTable getJTable_Professores() {
		if (jTable_Professores == null) {
			jTable_Professores = new JTable_Tip(40, jScrollPane_Professores.getWidth());
			jTable_Professores.setFont(fmeFrame.letra);
			jTable_Professores.setRowHeight(18);
			jTable_Professores.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Professores.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Professores;
	}
	void jButton_ProfessoresCopy_mouseClicked(MouseEvent e) {
		CBData.Professores.on_copy_row();
	}
	void jButton_ProfessoresUp_mouseClicked(MouseEvent e) {
		CBData.Professores.on_up_row();
	}
	void jButton_ProfessoresAdd_mouseClicked(MouseEvent e) {
		CBData.Professores.on_add_row();
	}
	void jButton_ProfessoresDel_mouseClicked(MouseEvent e) {
		CBData.Professores.on_del_row();
	}
	void jButton_ProfessoresIns_mouseClicked(MouseEvent e) {
		CBData.Professores.on_ins_row();
	}

	private JPanel getJPanel_Fundamenta() {
		if (jPanel_Fundamenta == null) {
			jLabel_Fundamenta = new JLabel();
			jLabel_Fundamenta.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Fundamenta.setText("Fundamentao");
			jLabel_Fundamenta.setFont(fmeFrame.letra_bold);

			jPanel_Fundamenta = new JPanel();
			jPanel_Fundamenta.setLayout(null);
			jPanel_Fundamenta.setBounds(new Rectangle(15, 242, 640, 474));
			jPanel_Fundamenta.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundamenta.setName("fundamenta_texto");
			jPanel_Fundamenta.add(jLabel_Fundamenta, null);
			jPanel_Fundamenta.add(getJScrollPane_Fundamenta(), null);
		}
		return jPanel_Fundamenta;
	}
	private JScrollPane getJScrollPane_Fundamenta() {
		if (jScrollPane_Fundamenta == null) {
			jScrollPane_Fundamenta = new JScrollPane();
			jScrollPane_Fundamenta.setBounds(new Rectangle(15, 35, 609, 420));
			jScrollPane_Fundamenta.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundamenta.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundamenta.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundamenta.setViewportView(getJTextArea_Fundamenta());
		}
		return jScrollPane_Fundamenta;
	}
	public JTextArea getJTextArea_Fundamenta() {
		if (jTextArea_Fundamenta == null) {
			jTextArea_Fundamenta = new JTextArea();
			jTextArea_Fundamenta.setFont(fmeFrame.letra);
			jTextArea_Fundamenta.setLineWrap(true);
			jTextArea_Fundamenta.setWrapStyleWord(true);
			jTextArea_Fundamenta.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundamenta;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Professores.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.Professores.Clear();
		CBData.Fundamenta.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Professores.validar(null));
		grp.add_grp(CBData.Fundamenta.validar(null));
		return grp;
	}
}

class Frame_Pareceres_jButton_ProfessoresCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Pareceres adaptee;
	
	Frame_Pareceres_jButton_ProfessoresCopy_mouseAdapter(Frame_Pareceres adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProfessoresCopy_mouseClicked(e);
	}	
}

class Frame_Pareceres_jButton_ProfessoresUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Pareceres adaptee;
	
	Frame_Pareceres_jButton_ProfessoresUp_mouseAdapter(Frame_Pareceres adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProfessoresUp_mouseClicked(e);
	}
}

class Frame_Pareceres_jButton_ProfessoresAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Pareceres adaptee;

	Frame_Pareceres_jButton_ProfessoresAdd_mouseAdapter(Frame_Pareceres adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProfessoresAdd_mouseClicked(e);
	}
}

class Frame_Pareceres_jButton_ProfessoresDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Pareceres adaptee;

	Frame_Pareceres_jButton_ProfessoresDel_mouseAdapter(Frame_Pareceres adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProfessoresDel_mouseClicked(e);
	}
}

class Frame_Pareceres_jButton_ProfessoresIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Pareceres adaptee;

	Frame_Pareceres_jButton_ProfessoresIns_mouseAdapter(Frame_Pareceres adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProfessoresIns_mouseClicked(e);
	}
}
