package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.*;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_QInv extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P12 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_QInv = null;
	private JLabel jLabel_QInv = null;
	private JScrollPane jScrollPane_QInv = null;
	private JTable_Tip jTable_QInv = null;
	private JButton jButton_QInvCopy = null;
	private JButton jButton_QInvUp = null;
	private JButton jButton_QInvAdd = null;
	private JButton jButton_QInvIns = null;
	private JButton jButton_QInvDel = null;

	String tag = "";
	
	public Frame_QInv() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,450);
	}
	
	String coluna_coop = "N";  //  @jve:decl-index=0:
	String coluna_conj = "N";  //  @jve:decl-index=0:
	String coluna_activ = "N";  //  @jve:decl-index=0:
	String coluna_activ_idt = "N";  //  @jve:decl-index=0:
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("coop") != null ) {
			coluna_coop = (String) params.get("coop");
		}
		if ( params.get("conj") != null ) {
			coluna_conj = (String) params.get("conj");
		}		
		if ( params.get("activ") != null ) {
			coluna_activ = (String) params.get("activ");
		}		
		if ( params.get("activ_idt") != null ) {
			coluna_activ_idt = (String) params.get("activ_idt");
		}		
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P12 = new JLabel();
			jLabel_P12.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P12.setText("   DADOS DO PROJECTO");
			jLabel_P12.setFont(fmeFrame.letra_titulo);
			jLabel_P12.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P12, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_QInv(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_QInv() {
		if (jPanel_QInv == null) {
			jButton_QInvCopy = new JButton(fmeFrame.copiarLinha);
		    jButton_QInvCopy.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QInvCopy.addMouseListener(new Frame_QInv_jButton_QInvCopy_mouseAdapter(this));
		    jButton_QInvCopy.setToolTipText("Copiar Linha");
		    jButton_QInvCopy.setBounds(new Rectangle(437, 11, 30, 22));
		    jButton_QInvUp = new JButton(fmeFrame.subirLinha);
		    jButton_QInvUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QInvUp.addMouseListener(new Frame_QInv_jButton_QInvUp_mouseAdapter(this));
		    jButton_QInvUp.setToolTipText("Trocar Linhas");
		    jButton_QInvUp.setBounds(new Rectangle(477, 11, 30, 22));
		    jButton_QInvAdd = new JButton(fmeFrame.novaLinha);
		    jButton_QInvAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QInvAdd.addMouseListener(new Frame_QInv_jButton_QInvAdd_mouseAdapter(this));
		    jButton_QInvAdd.setToolTipText("Nova Linha");
		    jButton_QInvAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_QInvIns = new JButton(fmeFrame.inserirLinha);
		    jButton_QInvIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QInvIns.addMouseListener(new Frame_QInv_jButton_QInvIns_mouseAdapter(this));
		    jButton_QInvIns.setToolTipText("Inserir Linha");
		    jButton_QInvIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_QInvDel = new JButton(fmeFrame.apagarLinha);
		    jButton_QInvDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QInvDel.addMouseListener(new Frame_QInv_jButton_QInvDel_mouseAdapter(this));
		    jButton_QInvDel.setToolTipText("Apagar Linha");
		    jButton_QInvDel.setBounds(new Rectangle(597, 11, 30, 22));

		    jLabel_QInv = new JLabel();
		    jLabel_QInv.setBounds(new Rectangle(12, 10, 262, 18));
		    jLabel_QInv.setText("Quadro de Investimentos");
		    jLabel_QInv.setFont(fmeFrame.letra_bold);

			jPanel_QInv = new JPanel();
			jPanel_QInv.setLayout(null);
			jPanel_QInv.setBounds(new Rectangle(15, 50, 640, 380));
			jPanel_QInv.setBorder(BorderFactory.createEtchedBorder());
			jPanel_QInv.add(jLabel_QInv, null);
			jPanel_QInv.add(jButton_QInvCopy, null);
			jPanel_QInv.add(jButton_QInvUp, null);
			jPanel_QInv.add(jButton_QInvAdd, null);
			jPanel_QInv.add(jButton_QInvIns, null);
			jPanel_QInv.add(jButton_QInvDel, null);
			jPanel_QInv.add(getJScrollPane_QInv(), null);
		}
		return jPanel_QInv;
	}
	
	public JScrollPane getJScrollPane_QInv() {
		if (jScrollPane_QInv == null) {

		    jScrollPane_QInv = new JScrollPane();
			jScrollPane_QInv.setBounds(new Rectangle(10, 40, 620, 328));
			jScrollPane_QInv.setViewportView(getJTable_QInv());
		    jScrollPane_QInv.setName("QInv_ScrollPane");
			//jScrollPane_QInv.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			jScrollPane_QInv.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_QInv.setBorder(BorderFactory.createEtchedBorder());
			//jScrollPane_QInv.getViewport().add(jTable_QInv);
		}
		return jScrollPane_QInv;
	}
	
	public JTable getJTable_QInv() {
		if (jTable_QInv == null) {
			jTable_QInv = new JTable_Tip(40, jScrollPane_QInv.getWidth());
			jTable_QInv.setRowHeight(18);
			jTable_QInv.setFont(fmeFrame.letra);
		    jTable_QInv.setName("QInv_Tabela");
		    jTable_QInv.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_QInv;
	}
	void jButton_QInvCopy_mouseClicked(MouseEvent e) {
		CBData.QInv.on_copy_row();
		CBData.QInv.calc_dados_projecto();
	}

	void jButton_QInvUp_mouseClicked(MouseEvent e) {
		CBData.QInv.on_up_row();
	}

	void jButton_QInvAdd_mouseClicked(MouseEvent e) {
		CBData.QInv.on_add_row();
	}

	void jButton_QInvDel_mouseClicked(MouseEvent e) {
		CBData.QInv.on_del_row();
		CBData.QInv.calc_dados_projecto();
		CBData.QInv.handler.j.revalidate();
		CBData.QInv.handler.j.repaint();
	}

	void jButton_QInvIns_mouseClicked(MouseEvent e) {
		CBData.QInv.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
	    print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_QInv.getWidth() - jScrollPane_QInv.getWidth();
		int w = jPanel_QInv.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
		
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.QInv.Clear();
		for (int i=0; i<CBData.QInv.dados.size(); i++){
			((String [])CBData.QInv.dados.elementAt(i))[9] = "";
		}
	}	
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.QInv.validar(null));
		return grp;
	}
		
}			

class Frame_QInv_jButton_QInvCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QInv adaptee;
	
	Frame_QInv_jButton_QInvCopy_mouseAdapter(Frame_QInv adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QInvCopy_mouseClicked(e);
	}	
}

class Frame_QInv_jButton_QInvUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QInv adaptee;
	
	Frame_QInv_jButton_QInvUp_mouseAdapter(Frame_QInv adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QInvUp_mouseClicked(e);
	}
}

class Frame_QInv_jButton_QInvAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QInv adaptee;

	Frame_QInv_jButton_QInvAdd_mouseAdapter(Frame_QInv adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QInvAdd_mouseClicked(e);
	}
}

class Frame_QInv_jButton_QInvDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QInv adaptee;

	Frame_QInv_jButton_QInvDel_mouseAdapter(Frame_QInv adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QInvDel_mouseClicked(e);
	}
}

class Frame_QInv_jButton_QInvIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QInv adaptee;

	Frame_QInv_jButton_QInvIns_mouseAdapter(Frame_QInv adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QInvIns_mouseClicked(e);
	}
}
