package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_QuadrosSC extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_QuadrosSC = null;
	private JLabel jLabel_QuadrosSC = null;
	private JScrollPane jScrollPane_QuadrosSC = null;
	private JTable_Tip jTable_QuadrosSC = null;
	private JButton jButton_QuadrosSCCopy = null;
	private JButton jButton_QuadrosSCUp = null;
	private JButton jButton_QuadrosSCAdd = null;
	private JButton jButton_QuadrosSCIns = null;
	private JButton jButton_QuadrosSCDel = null;

	String tag = "";
	
	public Frame_QuadrosSC() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(1260,410);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_QuadrosSC, 40);		
	}
		
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   DADOS DO PROJECTO");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_QuadrosSC(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_QuadrosSC() {
		if (jPanel_QuadrosSC == null) {
			jButton_QuadrosSCCopy = new JButton(fmeFrame.copiarLinha);
		    jButton_QuadrosSCCopy.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QuadrosSCCopy.addMouseListener(new Frame_QuadrosSC_jButton_QuadrosSCCopy_mouseAdapter(this));
		    jButton_QuadrosSCCopy.setToolTipText("Copiar Linha");
		    jButton_QuadrosSCCopy.setBounds(new Rectangle(437, 11, 30, 22));
		    jButton_QuadrosSCUp = new JButton(fmeFrame.subirLinha);
		    jButton_QuadrosSCUp.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QuadrosSCUp.addMouseListener(new Frame_QuadrosSC_jButton_QuadrosSCUp_mouseAdapter(this));
		    jButton_QuadrosSCUp.setToolTipText("Trocar Linhas");
		    jButton_QuadrosSCUp.setBounds(new Rectangle(477, 11, 30, 22));
		    jButton_QuadrosSCAdd = new JButton(fmeFrame.novaLinha);
		    jButton_QuadrosSCAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QuadrosSCAdd.addMouseListener(new Frame_QuadrosSC_jButton_QuadrosSCAdd_mouseAdapter(this));
		    jButton_QuadrosSCAdd.setToolTipText("Nova Linha");
		    jButton_QuadrosSCAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_QuadrosSCIns = new JButton(fmeFrame.inserirLinha);
		    jButton_QuadrosSCIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QuadrosSCIns.addMouseListener(new Frame_QuadrosSC_jButton_QuadrosSCIns_mouseAdapter(this));
		    jButton_QuadrosSCIns.setToolTipText("Inserir Linha");
		    jButton_QuadrosSCIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_QuadrosSCDel = new JButton(fmeFrame.apagarLinha);
		    jButton_QuadrosSCDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_QuadrosSCDel.addMouseListener(new Frame_QuadrosSC_jButton_QuadrosSCDel_mouseAdapter(this));
		    jButton_QuadrosSCDel.setToolTipText("Apagar Linha");
		    jButton_QuadrosSCDel.setBounds(new Rectangle(597, 11, 30, 22));

			jLabel_QuadrosSC = new JLabel();
			jLabel_QuadrosSC.setBounds(new Rectangle(12, 10, 417, 18));
			jLabel_QuadrosSC.setText("<html>Tcnicos de entidades de investigao por contrato</html>");
			jLabel_QuadrosSC.setFont(fmeFrame.letra_bold);			
			jPanel_QuadrosSC = new JPanel();
			jPanel_QuadrosSC.setLayout(null);
			jPanel_QuadrosSC.setBounds(new Rectangle(15, 50, 1240, 350));
			jPanel_QuadrosSC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_QuadrosSC.add(jLabel_QuadrosSC, null);
			jPanel_QuadrosSC.add(jButton_QuadrosSCCopy, null);
			jPanel_QuadrosSC.add(jButton_QuadrosSCUp, null);
			jPanel_QuadrosSC.add(jButton_QuadrosSCAdd, null);
			jPanel_QuadrosSC.add(jButton_QuadrosSCIns, null);
			jPanel_QuadrosSC.add(jButton_QuadrosSCDel, null);
			jPanel_QuadrosSC.add(getJScrollPane_QuadrosSC(), null);
		}
		return jPanel_QuadrosSC;
	}
	
	public JScrollPane getJScrollPane_QuadrosSC() {
		if (jScrollPane_QuadrosSC == null) {
			jScrollPane_QuadrosSC = new JScrollPane();
			jScrollPane_QuadrosSC.setBounds(new Rectangle(16, 36, 1206, 300));
			jScrollPane_QuadrosSC.setViewportView(getJTable_QuadrosSC());
			jScrollPane_QuadrosSC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_QuadrosSC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_QuadrosSC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_QuadrosSC;
	}
	
	public JTable getJTable_QuadrosSC() {
		if (jTable_QuadrosSC == null) {
			//jTable_QuadrosSC = new JTable_Tip(25);
			jTable_QuadrosSC = new JTable_Tip(60, jScrollPane_QuadrosSC.getWidth());
			jTable_QuadrosSC.setFont(fmeFrame.letra);
			jTable_QuadrosSC.setRowHeight(18);
			jTable_QuadrosSC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_QuadrosSC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_QuadrosSC;
	}
	
	//public CBTabela_QuadrosSC cbd_QuadrosSC;
	void jButton_QuadrosSCCopy_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_copy_row();
		CBData.QuadroSC.numerar(0);
	}

	void jButton_QuadrosSCUp_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_up_row();
	}

	void jButton_QuadrosSCAdd_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_add_row();
	}

	void jButton_QuadrosSCDel_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_del_row();
	}

	void jButton_QuadrosSCIns_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_ins_row();
	}
	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_QuadrosSC.getWidth() - jScrollPane_QuadrosSC.getWidth();
		int w = jPanel_QuadrosSC.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.QuadroSC.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.QuadroSC.validar(null, ""));
		return grp;
	}

}

class Frame_QuadrosSC_jButton_QuadrosSCCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadrosSC adaptee;
	
	Frame_QuadrosSC_jButton_QuadrosSCCopy_mouseAdapter(Frame_QuadrosSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadrosSCCopy_mouseClicked(e);
	}	
}

class Frame_QuadrosSC_jButton_QuadrosSCUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadrosSC adaptee;
	
	Frame_QuadrosSC_jButton_QuadrosSCUp_mouseAdapter(Frame_QuadrosSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QuadrosSCUp_mouseClicked(e);
	}
}

class Frame_QuadrosSC_jButton_QuadrosSCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadrosSC adaptee;

	Frame_QuadrosSC_jButton_QuadrosSCAdd_mouseAdapter(Frame_QuadrosSC adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QuadrosSCAdd_mouseClicked(e);
	}
}

class Frame_QuadrosSC_jButton_QuadrosSCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadrosSC adaptee;

	Frame_QuadrosSC_jButton_QuadrosSCDel_mouseAdapter(Frame_QuadrosSC adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QuadrosSCDel_mouseClicked(e);
	}
}

class Frame_QuadrosSC_jButton_QuadrosSCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadrosSC adaptee;

	Frame_QuadrosSC_jButton_QuadrosSCIns_mouseAdapter(Frame_QuadrosSC adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_QuadrosSCIns_mouseClicked(e);
	}
}
