package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_SubContrat extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_SubContrat = null;
	private JLabel jLabel_SubContrat = null;
	private JScrollPane jScrollPane_SubContrat = null;
	private JTable_Tip jTable_SubContrat = null;
	private JButton jButton_SubContratCopy = null;
	private JButton jButton_SubContratUp = null;
	private JButton jButton_SubContratAdd = null;
	private JButton jButton_SubContratIns = null;
	private JButton jButton_SubContratDel = null;

	String tag = "";

	public Frame_SubContrat() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,470);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_SubContrat, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_SubContrat(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_SubContrat() {
		if (jPanel_SubContrat == null) {
			jButton_SubContratCopy = new JButton(fmeFrame.copiarLinha);
			jButton_SubContratCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_SubContratCopy.addMouseListener(new Frame_SubContrat_jButton_SubContratCopy_mouseAdapter(this));
			jButton_SubContratCopy.setToolTipText("Copiar Linha");
			jButton_SubContratCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_SubContratUp = new JButton(fmeFrame.subirLinha);
			jButton_SubContratUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_SubContratUp.addMouseListener(new Frame_SubContrat_jButton_SubContratUp_mouseAdapter(this));
			jButton_SubContratUp.setToolTipText("Trocar Linhas");
			jButton_SubContratUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_SubContratAdd = new JButton(fmeFrame.novaLinha);
			jButton_SubContratAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_SubContratAdd.addMouseListener(new Frame_SubContrat_jButton_SubContratAdd_mouseAdapter(this));
			jButton_SubContratAdd.setToolTipText("Nova Linha");
			jButton_SubContratAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_SubContratIns = new JButton(fmeFrame.inserirLinha);
			jButton_SubContratIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_SubContratIns.addMouseListener(new Frame_SubContrat_jButton_SubContratIns_mouseAdapter(this));
			jButton_SubContratIns.setToolTipText("Inserir Linha");
			jButton_SubContratIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_SubContratDel = new JButton(fmeFrame.apagarLinha);
			jButton_SubContratDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_SubContratDel.addMouseListener(new Frame_SubContrat_jButton_SubContratDel_mouseAdapter(this));
			jButton_SubContratDel.setToolTipText("Apagar Linha");
			jButton_SubContratDel.setBounds(new Rectangle(597, 11, 30, 22));

			jLabel_SubContrat = new JLabel();
			jLabel_SubContrat.setBounds(new Rectangle(12, 10, 498, 18));
			jLabel_SubContrat.setText("Entidades de investigao por contrato e assistncia tcnica, cientfica e consultoria");
			jLabel_SubContrat.setFont(fmeFrame.letra_bold);

			jPanel_SubContrat = new JPanel();
			jPanel_SubContrat.setLayout(null);
			jPanel_SubContrat.setBounds(new Rectangle(15, 50, 640, 384));
			jPanel_SubContrat.setBorder(BorderFactory.createEtchedBorder());
			jPanel_SubContrat.add(jLabel_SubContrat, null);
//			jPanel_SubContrat.add(jButton_SubContratCopy, null);
//			jPanel_SubContrat.add(jButton_SubContratUp, null);
			jPanel_SubContrat.add(jButton_SubContratAdd, null);
			jPanel_SubContrat.add(jButton_SubContratIns, null);
			jPanel_SubContrat.add(jButton_SubContratDel, null);
			jPanel_SubContrat.add(getJScrollPane_SubContrat(), null);
		}
		return jPanel_SubContrat;
	}
	public JScrollPane getJScrollPane_SubContrat() {
		if (jScrollPane_SubContrat == null) {
			jScrollPane_SubContrat = new JScrollPane();
			jScrollPane_SubContrat.setBounds(new Rectangle(16, 36, 606, 332));
			jScrollPane_SubContrat.setViewportView(getJTable_SubContrat());
			jScrollPane_SubContrat.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_SubContrat.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_SubContrat.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_SubContrat;
	}
	public JTable getJTable_SubContrat() {
		if (jTable_SubContrat == null) {
			jTable_SubContrat = new JTable_Tip(40, jScrollPane_SubContrat.getWidth());
			jTable_SubContrat.setFont(fmeFrame.letra);
			jTable_SubContrat.setRowHeight(18);
			jTable_SubContrat.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_SubContrat.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_SubContrat;
	}
	void jButton_SubContratCopy_mouseClicked(MouseEvent e) {
		CBData.SubContrat.on_copy_row();
	}
	void jButton_SubContratUp_mouseClicked(MouseEvent e) {
		CBData.SubContrat.on_up_row();
	}
	void jButton_SubContratAdd_mouseClicked(MouseEvent e) {
		CBData.SubContrat.on_add_row();
	}
	void jButton_SubContratDel_mouseClicked(MouseEvent e) {
		if (CBData.SubContrat.del_ins_ok("Apagar")){
			CBData.SubContrat.on_del_row();
		}
	}
	void jButton_SubContratIns_mouseClicked(MouseEvent e) {
		if (CBData.SubContrat.del_ins_ok("Inserir")){
			CBData.SubContrat.on_ins_row();
		}
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_SubContrat.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.SubContrat.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.SubContrat.validar(null));
		return grp;
	}
}

class Frame_SubContrat_jButton_SubContratCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_SubContrat adaptee;
	
	Frame_SubContrat_jButton_SubContratCopy_mouseAdapter(Frame_SubContrat adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_SubContratCopy_mouseClicked(e);
	}	
}

class Frame_SubContrat_jButton_SubContratUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_SubContrat adaptee;
	
	Frame_SubContrat_jButton_SubContratUp_mouseAdapter(Frame_SubContrat adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_SubContratUp_mouseClicked(e);
	}
}

class Frame_SubContrat_jButton_SubContratAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_SubContrat adaptee;

	Frame_SubContrat_jButton_SubContratAdd_mouseAdapter(Frame_SubContrat adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_SubContratAdd_mouseClicked(e);
	}
}

class Frame_SubContrat_jButton_SubContratDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_SubContrat adaptee;

	Frame_SubContrat_jButton_SubContratDel_mouseAdapter(Frame_SubContrat adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_SubContratDel_mouseClicked(e);
	}
}

class Frame_SubContrat_jButton_SubContratIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_SubContrat adaptee;

	Frame_SubContrat_jButton_SubContratIns_mouseAdapter(Frame_SubContrat adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_SubContratIns_mouseClicked(e);
	}
}
