package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_Tecnicos extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Tecnicos = null;
	private JLabel jLabel_Tecnicos = null;
	private JScrollPane jScrollPane_Tecnicos = null;
	private JTableX jTable_Tecnicos = null;
	private JButton jButton_TecnicosCopy = null;
	private JButton jButton_TecnicosUp = null;
	private JButton jButton_TecnicosAdd = null;
	private JButton jButton_TecnicosIns = null;
	private JButton jButton_TecnicosDel = null;

	public CBTabela_Tecnicos CBData_Tecnicos = null;
	String tag = "";

	public Frame_Tecnicos() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(1260,460);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		up_component(jPanel_Tecnicos, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(1260, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Tecnicos(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_Tecnicos() {
		if (jPanel_Tecnicos == null) {
			jLabel_Tecnicos = new JLabel();
			jLabel_Tecnicos.setBounds(new Rectangle(12, 10, 478, 18));
			jLabel_Tecnicos.setText("Pessoal tcnico do promotor a afectar ao projecto");
			jLabel_Tecnicos.setFont(fmeFrame.letra_bold);

			jButton_TecnicosCopy = new JButton(fmeFrame.copiarLinha);
			jButton_TecnicosCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_TecnicosCopy.addMouseListener(new Frame_Tecnicos_jButton_TecnicosCopy_mouseAdapter(this));
			jButton_TecnicosCopy.setToolTipText("Copiar Linha");
			jButton_TecnicosCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_TecnicosUp = new JButton(fmeFrame.subirLinha);
			jButton_TecnicosUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_TecnicosUp.addMouseListener(new Frame_Tecnicos_jButton_TecnicosUp_mouseAdapter(this));
			jButton_TecnicosUp.setToolTipText("Trocar Linhas");
			jButton_TecnicosUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_TecnicosAdd = new JButton(fmeFrame.novaLinha);
			jButton_TecnicosAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_TecnicosAdd.addMouseListener(new Frame_Tecnicos_jButton_TecnicosAdd_mouseAdapter(this));
			jButton_TecnicosAdd.setToolTipText("Nova Linha");
			jButton_TecnicosAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_TecnicosIns = new JButton(fmeFrame.inserirLinha);
			jButton_TecnicosIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_TecnicosIns.addMouseListener(new Frame_Tecnicos_jButton_TecnicosIns_mouseAdapter(this));
			jButton_TecnicosIns.setToolTipText("Inserir Linha");
			jButton_TecnicosIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_TecnicosDel = new JButton(fmeFrame.apagarLinha);
			jButton_TecnicosDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_TecnicosDel.addMouseListener(new Frame_Tecnicos_jButton_TecnicosDel_mouseAdapter(this));
			jButton_TecnicosDel.setToolTipText("Apagar Linha");
			jButton_TecnicosDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_Tecnicos = new JPanel();
			jPanel_Tecnicos.setLayout(null);
			jPanel_Tecnicos.setBounds(new Rectangle(15, 50, 1240, 400));
			jPanel_Tecnicos.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Tecnicos.add(jLabel_Tecnicos, null);
//			jPanel_Tecnicos.add(jButton_TecnicosCopy, null);
//			jPanel_Tecnicos.add(jButton_TecnicosUp, null);
			jPanel_Tecnicos.add(jButton_TecnicosAdd, null);
			jPanel_Tecnicos.add(jButton_TecnicosIns, null);
			jPanel_Tecnicos.add(jButton_TecnicosDel, null);
			jPanel_Tecnicos.add(getJScrollPane_Tecnicos(), null);
		}
		return jPanel_Tecnicos;
	}
	public JScrollPane getJScrollPane_Tecnicos() {
		if (jScrollPane_Tecnicos == null) {
			jScrollPane_Tecnicos = new JScrollPane();
			jScrollPane_Tecnicos.setBounds(new Rectangle(16, 36, 1206, 350));
			jScrollPane_Tecnicos.setViewportView(getJTable_Tecnicos());
			jScrollPane_Tecnicos.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Tecnicos.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_Tecnicos.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Tecnicos;
	}
	public JTable getJTable_Tecnicos() {
		if (jTable_Tecnicos == null) {
			jTable_Tecnicos = new JTableX(50, jScrollPane_Tecnicos.getWidth());
			jTable_Tecnicos.setFont(fmeFrame.letra);
			jTable_Tecnicos.setRowHeight(18);
			jTable_Tecnicos.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Tecnicos.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Tecnicos;
	}
	void jButton_TecnicosCopy_mouseClicked(MouseEvent e) {
		CBData_Tecnicos.on_copy_row();
	}
	void jButton_TecnicosUp_mouseClicked(MouseEvent e) {
		CBData_Tecnicos.on_up_row();
	}
	void jButton_TecnicosAdd_mouseClicked(MouseEvent e) {
		CBData_Tecnicos.on_add_row();
	}
	void jButton_TecnicosDel_mouseClicked(MouseEvent e) {
		if (CBData_Tecnicos.del_ins_ok("Apagar"))
			CBData_Tecnicos.on_del_row();
	}
	void jButton_TecnicosIns_mouseClicked(MouseEvent e) {
		if (CBData_Tecnicos.del_ins_ok("Inserir"))
			CBData_Tecnicos.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Tecnicos.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_Tecnicos.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_Tecnicos.validar(null));
		return grp;
	}
}

class Frame_Tecnicos_jButton_TecnicosCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Tecnicos adaptee;
	
	Frame_Tecnicos_jButton_TecnicosCopy_mouseAdapter(Frame_Tecnicos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosCopy_mouseClicked(e);
	}	
}

class Frame_Tecnicos_jButton_TecnicosUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Tecnicos adaptee;
	
	Frame_Tecnicos_jButton_TecnicosUp_mouseAdapter(Frame_Tecnicos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosUp_mouseClicked(e);
	}
}

class Frame_Tecnicos_jButton_TecnicosAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Tecnicos adaptee;

	Frame_Tecnicos_jButton_TecnicosAdd_mouseAdapter(Frame_Tecnicos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosAdd_mouseClicked(e);
	}
}

class Frame_Tecnicos_jButton_TecnicosDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Tecnicos adaptee;

	Frame_Tecnicos_jButton_TecnicosDel_mouseAdapter(Frame_Tecnicos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosDel_mouseClicked(e);
	}
}

class Frame_Tecnicos_jButton_TecnicosIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Tecnicos adaptee;

	Frame_Tecnicos_jButton_TecnicosIns_mouseAdapter(Frame_Tecnicos adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosIns_mouseClicked(e);
	}
}
