package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.util.HashMap;

public class Frame_Texto1B_1 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;
	private JPanel jPanel_Txt = null;
	private JLabel jLabel_Design = null;
	private JLabel jLabel_SubDesign = null;
	private int n_linhas = 0;
	private JScrollPane jScrollPane_Txt = null;
	private JTextArea jTextArea_Txt = null;

	String tag = "";  //  @jve:decl-index=0:
	//public CBRegisto_Texto1B_1 cbd_texto;
	public Frame_Texto1B_1() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,730+(n_linhas*18));
	}
	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_Txt, 40);		
	}
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("TITULO") != null ) {
			jLabel_Titulo.setText( (String) params.get("TITULO") );
		}
		if ( params.get("DESIGN") != null ) {
			jLabel_Design.setText( "<html>"+(String) params.get("DESIGN")+"</html>" );
		}
		if ( params.get("SUBDESIGN") != null ) {
			String s = (String) params.get("SUBDESIGN");
			s = s.replace("\\n", "<br>");
			s = "<html>"+s+"</html>";
			//System.out.print(s);
			jLabel_SubDesign.setText( s );
		}
		if ( params.get("L_SUBDESIGN") != null ) {
			n_linhas = Integer.parseInt((String) params.get("L_SUBDESIGN"));
			jLabel_SubDesign.setBounds(new Rectangle(15, 30, 615, 1+(n_linhas*18)));
			jScrollPane_Txt.setBounds(new Rectangle(15, 35+(n_linhas*18), 610, 620));
			jPanel_Txt.setBounds(new Rectangle(15, 50, 640, 670+(n_linhas*18)));
			this.setSize(this.getSize());
			this.setPreferredSize(this.getSize());
			//JOptionPane.showMessageDialog(null, "linhas = "+n_linhas);
		}
		
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			//jLabel_P03.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_Txt(), null);
		}
		return jContentPane;
	}
	
	public JPanel getjPanel_Txt() {
		if (jPanel_Txt == null) {
			//JOptionPane.showMessageDialog(null, "panel = "+(n_linhas*18));
			jLabel_Design = new JLabel();
			//jLabel_Design.setBounds(new Rectangle(12, 10, 620, 18));
			jLabel_Design.setBounds(new Rectangle(12, 7, 609, 29));
			jLabel_Design.setFont(fmeFrame.letra_bold);

			jLabel_SubDesign = new JLabel();
			jLabel_SubDesign.setBounds(new Rectangle(15, 35, 615, 1+(n_linhas*18)));
			jLabel_SubDesign.setFont(fmeFrame.letra);

			jPanel_Txt = new JPanel();
			jPanel_Txt.setLayout(null);
			jPanel_Txt.setBounds(new Rectangle(15, 50, 640, 670+(n_linhas*18)));
			jPanel_Txt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Txt.setName("evolucao_texto");
			jPanel_Txt.add(jLabel_Design, null);
			jPanel_Txt.add(jLabel_SubDesign, null);
			jPanel_Txt.add(getjScrollPane_Txt(), null);
			
		}
		return jPanel_Txt;
	}
	
	public JScrollPane getjScrollPane_Txt() {
		if (jScrollPane_Txt == null) {
			jScrollPane_Txt = new JScrollPane();
			jScrollPane_Txt.setBounds(new Rectangle(15, 35+(n_linhas*18), 610, 620));
			jScrollPane_Txt.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Txt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Txt.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Txt.setViewportView(getJTextArea_Txt());
		}
		return jScrollPane_Txt;
	}
	public JTextArea getJTextArea_Txt() {
		if (jTextArea_Txt == null) {
			jTextArea_Txt = new JTextArea();
			jTextArea_Txt.setFont(fmeFrame.letra);
			jTextArea_Txt.setLineWrap(true);
			jTextArea_Txt.setWrapStyleWord(true);
			jTextArea_Txt.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Txt;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		

		print_handler.scaleToWidth ( (int) ( 1.05 * getjPanel_Txt().getWidth()) );
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		if (tag.equals("TxtEvolucao")) 
			CBData.TxtEvolucao.getByName("texto").clear();
		if (tag.equals("TxtProdutos")) 
			CBData.TxtProdutos.getByName("texto").clear();
		if (tag.equals("TxtAccoes")) 
			CBData.TxtAccoes.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj1")) 
			CBData.TxtAccoesConj1.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj6")) 
			CBData.TxtAccoesConj6.getByName("texto").clear();
		if (tag.equals("TxtQInv")) 
			CBData.TxtQInv.getByName("texto").clear();
		if (tag.equals("CaractProj3")) 
			CBData.CaractProj3.getByName("texto").clear();
		if (tag.equals("PlanoImpl")) 
			CBData.PlanoImpl.getByName("texto").clear();
		if (tag.equals("Incentivo75")) 
			CBData.Incentivo75.getByName("texto").clear();
		if (tag.equals("Estrutur75")) 
			CBData.Estrutur75.getByName("texto").clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		if (tag.equals("TxtEvolucao")) grp.add_grp(CBData.TxtEvolucao.validar(null, ""));
		if (tag.equals("TxtProdutos")) grp.add_grp(CBData.TxtProdutos.validar(null, ""));
		if (tag.equals("TxtAccoes")) grp.add_grp(CBData.TxtAccoes.validar(null, ""));
		if (tag.equals("TxtJustifIncentivo")) grp.add_grp(CBData.TxtJustifIncentivo.validar(null, ""));
		if (tag.equals("TxtAccoesConj1")) grp.add_grp(CBData.TxtAccoesConj1.validar(null, ""));
		if (tag.equals("TxtAccoesConj6")) grp.add_grp(CBData.TxtAccoesConj6.validar(null, ""));
		if (tag.equals("TxtQInv")) grp.add_grp(CBData.TxtQInv.validar_qinv(null, ""));
		if (tag.equals("CaractProj3")) grp.add_grp(CBData.CaractProj3.validar(null, ""));
		if (tag.equals("PlanoImpl")) grp.add_grp(CBData.PlanoImpl.validar(null, ""));
		return grp;
	}
}
