package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.io.*;
import java.util.HashMap;
import javax.swing.JLabel;
import javax.swing.SwingConstants;
import java.awt.Font;
import javax.swing.JTextArea;

public class Frame_TextoCriterios extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;
	private JPanel jPanel_Crit = null;
	private JPanel jPanel_Txt = null;
	private JScrollPane jScrollPane_Txt = null;
	public JLabel jLabel_Lista = null;

	private JLabel jLabel_Factores = null;

	private JLabel jLabel_Design = null;

	private JLabel jLabel_Fundamento = null;

	private JTextArea jTextArea_Txt = null;

	String tag = "";
	
	public Frame_TextoCriterios() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,991);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("TITULO") != null ) {
			jLabel_Titulo.setText( (String) params.get("TITULO") );
		}
		if ( params.get("DESIGN") != null ) {
			jLabel_Design.setText( (String) params.get("DESIGN") );
		}
		if ( params.get("CRITERIOS") != null ) {
			//JOptionPane.showMessageDialog(null, (String) params.get("CRITERIOS"));
			
	        String s = "";
	        String filename = (String) params.get("CRITERIOS");
	        try {
		        BufferedReader in = new BufferedReader(
		                new InputStreamReader ( this.getClass().getResourceAsStream(filename))
		        );
			    String s1 = in.readLine();
		        while( s1 != null ) {
		          s += s1; 
		          s1 = in.readLine();
		        }
		     }
		     catch(IOException e1)	     
		     { 
		    	 JOptionPane.showMessageDialog(null, e1.getMessage());
		     }
		     //JOptionPane.showMessageDialog(null, "s=" + s);
		     this.jLabel_Lista.setText(s);
		   
		}	
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			//jLabel_P03.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setText("%TITULO%");
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Crit(), null);
			jContentPane.add(getJPanel_Txt(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_Crit() {
		if (jPanel_Crit == null) {
			jLabel_Design = new JLabel();
			jLabel_Design.setBounds(new Rectangle(12, 10, 603, 18));
			jLabel_Design.setText("%DESIGN%");
			jLabel_Design.setFont(fmeFrame.letra_bold);
			jLabel_Factores = new JLabel();
			jLabel_Factores.setBounds(new Rectangle(12, 35, 214, 18));
			jLabel_Factores.setText("Factores a abordar");
			jLabel_Factores.setFont(fmeFrame.letra_bold);
			jLabel_Lista = new JLabel();
			jLabel_Lista.setBounds(new Rectangle(13, 52, 612, 195));
			jLabel_Lista.setText("%INDICE%");
			jLabel_Lista.setVerticalAlignment(SwingConstants.TOP);
			jLabel_Lista.setVerticalTextPosition(SwingConstants.TOP);
			//jLabel_Lista.setFont(new Font("Arial", Font.PLAIN, 10));
			jLabel_Lista.setFont(fmeFrame.letra);
			jPanel_Crit = new JPanel();
			jPanel_Crit.setLayout(null);
			jPanel_Crit.setBounds(new Rectangle(15, 50, 640, 251));
			jPanel_Crit.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Crit.add(jLabel_Lista, null);
			jPanel_Crit.add(jLabel_Factores, null);
			jPanel_Crit.add(jLabel_Design, null);
			
		}
		return jPanel_Crit;
	}
	
	private JPanel getJPanel_Txt() {
		if (jPanel_Txt == null) {
			jLabel_Fundamento = new JLabel();
			jLabel_Fundamento.setBounds(new Rectangle(14, 8, 243, 21));
			jLabel_Fundamento.setText("Fundamentao");
			jLabel_Fundamento.setFont(fmeFrame.letra_bold);
			jPanel_Txt = new JPanel();
			jPanel_Txt.setLayout(null);
			jPanel_Txt.setBounds(new Rectangle(15, 311, 640, 670));
			jPanel_Txt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Txt.setName("evolucao_texto");
			jPanel_Txt.add(getJScrollPane_Txt(), null);
			jPanel_Txt.add(jLabel_Fundamento, null);
			
		}
		return jPanel_Txt;
	}
	
	public JScrollPane getJScrollPane_Txt() {
		if (jScrollPane_Txt == null) {
			jScrollPane_Txt = new JScrollPane();
			jScrollPane_Txt.setBounds(new Rectangle(15, 35, 609, 620));
			jScrollPane_Txt.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Txt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Txt.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Txt.setViewportView(getJTextArea_Txt());
		}
		return jScrollPane_Txt;
	}
	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		

		print_handler.scaleToWidth ( (int) ( 1.05 * getJPanel_Txt().getWidth()) );
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		if (tag.equals("TxtCritQual"))
			CBData.TxtCritQual.getByName("texto").clear();
		if (tag.equals("TxtCritConjunto"))
			CBData.TxtCritConjunto.getByName("texto").clear();
		if (tag.equals("TxtCritInov"))
			CBData.TxtCritInov.getByName("texto").clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		if (tag.equals("TxtCritQual")) grp.add_grp(CBData.TxtCritQual.validar(null));
		if (tag.equals("TxtCritConjunto")) grp.add_grp(CBData.TxtCritConjunto.validar(null));
		if (tag.equals("TxtCritInov")) grp.add_grp(CBData.TxtCritInov.validar(null));
		if (tag.equals("TxtCritInov_A")) grp.add_grp(CBData.TxtCritInov_A.validar(null));
		if (tag.equals("TxtCritInov_B")) grp.add_grp(CBData.TxtCritInov_B.validar(null));
		if (tag.equals("TxtCritInov_C")) grp.add_grp(CBData.TxtCritInov_C.validar(null));
		if (tag.equals("TxtCritInov_D")) grp.add_grp(CBData.TxtCritInov_D.validar(null));
		return grp;
	}

	/**
	 * This method initializes jTextArea_Txt	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	public JTextArea getJTextArea_Txt() {
		if (jTextArea_Txt == null) {
			jTextArea_Txt = new JTextArea();
			jTextArea_Txt.setFont(fmeFrame.letra);
			jTextArea_Txt.setLineWrap(true);
			jTextArea_Txt.setWrapStyleWord(true);
			jTextArea_Txt.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Txt;
	}

}

