package fme;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Properties;
import java.io.File;
import java.net.URL;
import java.net.URLConnection;
import java.io.*;
import java.net.*;

class CHEnvio {

  static CEnvio dlg;
  static String proxyHost = null, proxyPort=null;
  static boolean proxySet = false;
  static fmeFrame f;

  static void envio (fmeFrame _f) {
    f = _f;
    dlg = new CEnvio (f, "Exportar Candidatura", true);

    dlg.setSize(new Dimension(565, 245));
    dlg.setLocation(Toolkit.getDefaultToolkit().getScreenSize().width / 2 - dlg.getSize().width / 2,
                    Toolkit.getDefaultToolkit().getScreenSize().height / 2 - dlg.getSize().height / 2);

    Properties systemSettings = System.getProperties();
    proxyHost = (String) systemSettings.get("proxyHost");
    proxyPort = (String) systemSettings.get("proxyPort");
    proxySet = proxyHost != null;
    if ( proxySet && proxyPort == null ) proxyPort = "80";

    dlg.jCheckBox_Proxy.setSelected(proxySet);
    dlg.jTextField_proxy.setText(proxyHost);
    dlg.jTextField_porta.setText(proxyPort);

    _show_envio();

    dlg.show();
    dlg = null;
  }

  static void internet() {

    URL url;

    try {
      String proxy, port;
      boolean proxy_set;
      proxy = dlg.jTextField_proxy.getText();
      port = dlg.jTextField_porta.getText();
      proxy_set = dlg.jCheckBox_Proxy.isSelected();

      if ( proxy_set != proxySet || ! proxy.equals(proxyHost) || ! port.equals(proxyPort)) {
        proxyHost = proxy;
        proxyPort = port;
        proxy_set = proxy_set;

        Properties systemSettings = System.getProperties();
        if ( proxy_set ) {
          systemSettings.put("proxySet", "true");
          systemSettings.put("proxyHost", proxy);
          systemSettings.put("proxyPort", port);
        }
        else {
          systemSettings.put("proxySet", "false");
          systemSettings.put("proxyHost", "");
          systemSettings.put("proxyPort", "");
        }
        System.setProperties(systemSettings);
      }

      File f_zip = new File(fmeFrame.LastFile.getCanonicalPath());
      //83.240.154.166
      String name = "http://atend2.gabprime.org/atend-cand/atend.php?";
      name += "AVISO=" + CParseConfig.hconfig.get("aviso");
      name += "&CLASSE=" + CParseConfig.hconfig.get("extensao"); 
      name += "&VS=" + URLEncoder.encode(CBData.vs);
      name += "&FILE=" + URLEncoder.encode(f_zip.getName());
      //name += "&TESTE=S";
      //JOptionPane.showMessageDialog(null, name);
      //String name = "http://atend.gabprime.org/recepcao/atend-cand.php?TESTE=S&";
     /* name += "FICHEIRO=" + URLEncoder.encode(f_zip.getName());
      name += "&TAMANHO=" + f_zip.length();
      name += "&VERSAO=" + URLEncoder.encode(CBData.vs);*/

      url = new URL(name);
      URLConnection conn = url.openConnection();
      conn.setDoOutput(true);

      byte data[] = new byte[2048];
      BufferedInputStream in = new BufferedInputStream(new DataInputStream(new FileInputStream(f_zip)));
      BufferedOutputStream out = new BufferedOutputStream(new DataOutputStream( conn.getOutputStream()));
      while (in.read(data) != -1)
        out.write(data);
      in.close();
      out.close();

      String s, msg = "";
      BufferedReader r = new BufferedReader(new InputStreamReader(conn.getInputStream()));
      while ( (s = r.readLine()) != null )
        msg = msg + s + "\n";
      r.close();

      //JOptionPane.showMessageDialog(null, msg);
      //return;
      String ggp_stat = "", ggp_msg = "", ggp_t = "";
      String tok[] = msg.split("###");
      for ( int i = 0; i < tok.length; i ++ ) {
        if ( tok[i].startsWith("STAT=") ) ggp_stat = tok[i].substring(5);
        if ( tok[i].startsWith("REF=") ) ggp_t = tok[i].substring(4);
        if ( tok[i].startsWith("MSG=") ) ggp_msg = tok[i].substring(4);
      }
      ggp_stat = ggp_stat.replaceAll("\n", "");
      ggp_t = ggp_t.replaceAll("\n", "");

      msg = _make_msg ( ggp_stat, ggp_t, ggp_msg );

      CMsg m = new CMsg( dlg,  msg );
      m.setSize(new Dimension(445, 340));
      m.setLocation(Toolkit.getDefaultToolkit().getScreenSize().width / 2 - m.getSize().width / 2,
                  Toolkit.getDefaultToolkit().getScreenSize().height / 2 - m.getSize().height / 2);
      m.show();

      if ( ggp_stat.equals("OK!")) {
        CBData.exportado = "2";
        CBData.T = ggp_t;
        _show_envio();
        f.jMenuFile_Save_actionPerformed(null, false, true, false);
      }
    } catch ( MalformedURLException e ) {
      JOptionPane.showMessageDialog(null, "Erro na ligao: " + e.getMessage());
    } catch ( IOException e ) {
      JOptionPane.showMessageDialog(null, "Erro na ligao: " + e.getMessage());
    } catch ( Exception e ) {
      JOptionPane.showMessageDialog(null, "Erro na ligao: " + e.getMessage());
    }
  }

  static String _make_msg ( String ggp_stat, String ggp_T, String  ggp_msg) {
    String msg;
    msg = "<html>";
    msg += "<table width='400' border='0' cellspacing='0' cellpadding='0'>";
    //ggp_T = "T010101001P2332";
    if (  ! ggp_stat.equals("OK!") ){
      msg += "<tr><td align='center'><font color=red size=3><strong>O ficheiro no foi exportado!</strong></font><br><br></td></tr>";
    }
    else {
      msg += "<tr><td align='center'><font color=blue size=3><strong>O ficheiro foi exportado com sucesso!</strong></font><br><br></td></tr>";
      msg += "<tr><td>O seu ficheiro de candidatura foi aceite e recebeu a referncia provisria:<br><br></td></tr>";
      msg += "<tr><td align='center'><font size=3><strong>" + ggp_T + "</strong></font><br><br></td></tr>";
    }
    msg += "<tr><td><br><strong>Observaes:</strong> <br><br>";
    ggp_msg = ggp_msg.replaceAll("\n", "<br>");
    msg += ggp_msg + "</td></tr>";

    msg+= "</table>";
    msg+= "</html>";
    return msg;
  }

  static void validar() {
    _show_envio();
    f.jMenuFile_Save_actionPerformed(null, false, true, false);
  }

  static void _show_envio() {
    dlg.jLabel_Exportada.setVisible(false);
    dlg.jLabel_T.setVisible(false);

    if ( CBData.exportado.equals("2") ) {
        dlg.jTextField_porta.setEditable(false);
        dlg.jTextField_proxy.setEditable(false);
        dlg.jCheckBox_Proxy.setEnabled(false);
        dlg.jLabel_Exportada.setVisible(true);
        dlg.jLabel_T.setVisible(true);
        dlg.jLabel_T.setText(CBData.T);
        dlg.jButton_Post.setEnabled(false);
    }
  }
}

class CEnvio extends JDialog {

  JPanel panel1 = new JPanel();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();

  JCheckBox jCheckBox_Proxy = new JCheckBox();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel();

  JTextField jTextField_proxy = new JTextField();
  JTextField jTextField_porta = new JTextField();

  JButton jButton_Post = new JButton();

  JButton jButton_Cancel = new JButton();
  JLabel jLabel_T = new JLabel();
  JLabel jLabel_Exportada = new JLabel();

  ImageIcon apagarLinha = new ImageIcon(fme.fmeFrame.class.getResource("apagarlinha.gif"));

  public CEnvio(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public CEnvio() {
    this(null, "", false);
  }

  private void jbInit() throws Exception {

    panel1.setLayout(null);
    this.getContentPane().setLayout(null);
    panel1.setBounds(new Rectangle(0, 299, 1, 1));
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setBounds(new Rectangle(16, 19, 528, 150));
    jPanel1.setLayout(null);
    //jLabel1.setFont(new java.awt.Font("Lucida Sans", 1, 12));
    jLabel1.setText("Envio da Candidatura pela Internet");
    jLabel1.setBounds(new Rectangle(18, 18, 276, 15));
    jLabel1.setFont(fmeFrame.letra_titulo);

    jCheckBox_Proxy.setBorder(BorderFactory.createLineBorder(Color.black));
    jCheckBox_Proxy.setText("<html>Usar um servidor proxy para a LAN (no aplicvel a ligaes " +
    "por modem/ADSL ou VPN)<html>");
    jCheckBox_Proxy.setBounds(new Rectangle(16, 40, 268, 49));
    jCheckBox_Proxy.setFont(fmeFrame.letra);
    
    jLabel2.setBounds(new Rectangle(34, 111, 58, 15));
    jLabel2.setText("Endereo");
    jLabel2.setFont(fmeFrame.letra);
    jLabel3.setFont(fmeFrame.letra);
    jLabel3.setText("Porta");
    jLabel3.setBounds(new Rectangle(206, 111, 34, 15));
    jTextField_proxy.setBorder(BorderFactory.createLineBorder(Color.black));
    jTextField_proxy.setText("255.255.255.255");
    jTextField_proxy.setBounds(new Rectangle(90, 109, 90, 19));
    jTextField_porta.setBounds(new Rectangle(243, 109, 37, 19));
    jTextField_porta.setBorder(BorderFactory.createLineBorder(Color.black));
    jTextField_porta.setText("");
    jButton_Post.setFont(fmeFrame.letra);
    jButton_Post.setBounds(new Rectangle(330, 100, 175, 28));
    jButton_Post.setText("Enviar Candidatura");
    jButton_Post.addActionListener(new CEnvio_jButton_Post_actionAdapter(this));

    jButton_Cancel.setFont(fmeFrame.letra);
    jButton_Cancel.setBounds(new Rectangle(464, 180, 80, 26));
    jButton_Cancel.setText("Fechar");
    jButton_Cancel.addActionListener(new CEnvio_jButton_Cancel_actionAdapter(this));
    jLabel_T.setBounds(new Rectangle(330, 60, 175, 20));
    jLabel_T.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel_T.setOpaque(true);
    jLabel_T.setBorder(null);
    jLabel_T.setForeground(Color.white);
    jLabel_T.setFont(fmeFrame.letra_bold);
    jLabel_T.setBackground(Color.red);
    jLabel_Exportada.setFont(fmeFrame.letra_bold);
    jLabel_Exportada.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel_Exportada.setText("Candidatura Exportada");
    jLabel_Exportada.setBounds(new Rectangle(330, 40, 175, 15));
    this.getContentPane().add(panel1, null);

    jPanel1.add(jButton_Post, null);
    jPanel1.add(jCheckBox_Proxy, null);
    jPanel1.add(jLabel2, null);
    jPanel1.add(jLabel_T, null);
    jPanel1.add(jLabel_Exportada, null);
    jPanel1.add(jTextField_porta, null);
    jPanel1.add(jLabel3, null);
    jPanel1.add(jTextField_proxy, null);
    jPanel1.add(jLabel1, null);
    this.getContentPane().add(jButton_Cancel, null);
    this.getContentPane().add(jPanel1, null);

    setModal(true);
    setResizable(false);
    //setSize(new Dimension(575, 370));
    //setLocation(Toolkit.getDefaultToolkit().getScreenSize().width / 2 - getSize().width / 2,
    //Toolkit.getDefaultToolkit().getScreenSize().height / 2 - getSize().height / 2);
    //setVisible(true);
  }

  void jButton_Post_actionPerformed(ActionEvent e) {
    CHEnvio.internet();
  }

  void jButton_Cancel_actionPerformed(ActionEvent e) {
    hide();
  }

  void jButton_Ficheiro_actionPerformed(ActionEvent e) {
    CHEnvio.validar();
  }
}

class CEnvio_jButton_Post_actionAdapter implements java.awt.event.ActionListener {
  CEnvio adaptee;

  CEnvio_jButton_Post_actionAdapter(CEnvio adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Post_actionPerformed(e);
  }
}

class CEnvio_jButton_Cancel_actionAdapter implements java.awt.event.ActionListener {
  CEnvio adaptee;

  CEnvio_jButton_Cancel_actionAdapter(CEnvio adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Cancel_actionPerformed(e);
  }
}

class CEnvio_jButton_Ficheiro_actionAdapter implements java.awt.event.ActionListener {
  CEnvio adaptee;

  CEnvio_jButton_Ficheiro_actionAdapter(CEnvio adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton_Ficheiro_actionPerformed(e);
  }
}
