package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.util.Vector;
import javax.swing.text.*;
import javax.swing.table.*;

import java.io.IOException;
import java.lang.*;
import java.awt.event.*;
import java.util.*;


class CHPrintPage {
  static PrinterJob pj = PrinterJob.getPrinterJob();

  CHPrintPage () {
    pj = PrinterJob.getPrinterJob();
  }

  static boolean setup () {
    return pj.printDialog();
  }
}

class CHPrint {

  PrinterJob pj;
  String header = new String();
  String footer_medida = new String();
  String footer_pag = new String();
  String footer_promotor = new String();
  boolean multipage = false;

  JInternalFrame frame;
  Vector pComps = new Vector();

  public double scale = 1;

  int y_offset = 0;      // offset (para colocao)
  int n_page = 0;        // n de pgina (para colocao)
  int margem_y = 0;      // margem de cima em cada pgina

  int PY;                // altura da pgina (para impresso)
  int margem_x = 0;
  int n_page_c = 0;

  int dx_expand = 0;    //alargar em solidariedade (paineis, caixas de texto);

  boolean landscape = false;

  Paper p; //new Paper();
  static PageFormat pf; //= new PageFormat();
  boolean started = false;
  boolean primeira_caixa = true;  //apoio para painel_texto
  boolean primeiro_quadro = true; // apoio pata painel_quadro

  public CHPrint( JInternalFrame f ) {
    frame = f;
    started = false;
  }

  void start () {

    started = true;

    /* o que funciona...
    //PrinterJob pj = CHPrintPage.pj; o que funciona !
    pf  = pj.defaultPage();
     p = pf.getPaper();
    */

    //PrinterJob pj = PrinterJob.getPrinterJob();
    pj = PrinterJob.getPrinterJob();

    pf  = CHPrintPage.pj.defaultPage();
    p = pf.getPaper();

    double margin = 25;
    double x = margin ;
    double y = margin;
    double dx = 2 * p.getImageableX() + p.getImageableWidth() -  2 * x;
    double dy = 2 * p.getImageableY() + p.getImageableHeight() - 2 * y;

    p.setImageableArea( x, y, dx, dy );
    pf.setPaper(p);

    pf.setOrientation( PageFormat.PORTRAIT );
  }

  public void margem_x ( int n) {
    p.setImageableArea( p.getImageableX() + n, p.getImageableY(), p.getImageableWidth(), p.getImageableHeight()  );
    pf.setPaper(p);
  }

  public void setOrientation ( int orientation ) {
    pf.setOrientation( orientation );
    //$01
    landscape = orientation == PageFormat.LANDSCAPE;
  }

  public void scaleToWidth ( int w ) {

    //JOptionPane.showMessageDialog(null, "1: " + Integer.toString( (int) pf.getImageableWidth()));
    //JOptionPane.showMessageDialog(null, "2: " + Integer.toString(w) );

    //scale = 0.95 * (double) pf.getImageableWidth() / (double) w;
    scale = (double) pf.getImageableWidth() / (double) w;
    scale = Math.round(scale*100) / 100.0;
    //JOptionPane.showMessageDialog(null, "scale: " + Double.toString( scale ));
  }

  public void print_page() {

	    Component[] comps = frame.getContentPane().getComponents();

	    // papel
	    /*
	      Paper p = new Paper();
	      PageFormat pf = new PageFormat();
	      p.setImageableArea(0, 0, p.getWidth(), p.getHeight());
	      pf.setPaper(p);
	    */

	    //margem_y = 100;
	    PY = (int) pf.getImageableY() + (int) ((pf.getImageableHeight()- 2 * margem_y)/scale);
	    PY = (int) (pf.getImageableHeight()/scale);
	    //JOptionPane.showMessageDialog(null, "1: " + Integer.toString( (int) pf.getImageableY()));
	    //JOptionPane.showMessageDialog(null, "2: " + Integer.toString( (int) pf.getImageableHeight()));

	    n_page_c = 0;

	    //y_offset = 0;
	    y_offset = margem_y;
	    n_page = 0;

	    // previo - ordem
	    for ( int i = 0; i < comps.length; i++ ) {
	      for ( int j = i+1; j < comps.length; j ++) {
	          if ( comps[i].getY() > comps[j].getY() ) {
	            Component c = comps[i];
	            comps[i] = comps[j];
	            comps[j] = c;
	          }
	      }
	    }

	    // clones para imprimir
	    for ( int i = 0; i < comps.length; i++)
	    {
	      Component c = comps[i];
	      String s = c.getClass().getName();

	      // PAINIS
	      if ( s.endsWith("JPanel") && c.isVisible() ){

	    	  if ( c.getName() != null && c.getName().endsWith("_noprint") ) {
	    		  continue;
	    	  }
   	
	        //JOptionPane.showMessageDialog(null,  "PAINEL: " + c.getName() );

	        if ( c.getName() != null && c.getName().endsWith("_texto") ) {
	          //JOptionPane.showMessageDialog(null,  "PAINEL texto: " + c.getName() );
	          painel_texto( (JPanel) c);
	        }
	        else if ( c.getName() != null && c.getName().endsWith("_Quadro") ) {
	          //JOptionPane.showMessageDialog(null,  "PAINEL quadro: " + c.getName() );
	          painel_quadro( (JPanel) c);
	        }
	        else {   //  funo painel_geral

	          //JOptionPane.showMessageDialog(null, "painel " + c.getY() + " com y_offset = " + y_offset );

	          //acrescentar o painel
	          Component cpanel = Clone(c);
	          if (cpanel != null) {
	            pComps.addElement(cpanel);
	            cpanel.setLocation( c.getX(), c.getY() + y_offset );
	            //JOptionPane.showMessageDialog(null, "PAINEL EM " + cpanel.getY());
	          }

	          int cpanel_idx = pComps.size();

	          // e os componentes interiores
	          Component[] icomps = ((JPanel)c).getComponents();
	          int dif_dy=0;
	          for (int j = 0; j < icomps.length; j++) {
	            Component ic = icomps[j];

	            Component pc = Clone(icomps[j]);
	            if (pc != null) {
	              pComps.addElement(pc);
	              pc.setLocation(pc.getX() + cpanel.getX(), pc.getY() + cpanel.getY());

	              //JOptionPane.showMessageDialog(null, "elemento em " + pc.getY());

	              if ( (pc.getHeight() - icomps[j].getHeight()) > dif_dy ) {
	                dif_dy = pc.getHeight() - icomps[j].getHeight();
	                //JOptionPane.showMessageDialog(null, pc.getName() + " aumentou " + Integer.toString(dif_dy));
	              }
	            }
	          }

	          // aumento do painel por extenso dos elementos interiores...
	          if ( dif_dy > 0 )  {
	            cpanel.setSize( cpanel.getWidth(), cpanel.getHeight() + dif_dy  );
	            y_offset+= dif_dy;
	            //JOptionPane.showMessageDialog(null, " clone de " + c.getName() + " aumentou de " + Integer.toString( c.getHeight() ) +" para " + Integer.toString( cpanel.getHeight() ));
	          }

	          // ele prprio mudar de pgina ?

	          //mal ? int Y = cpanel.getY() + y_offset ;
	          int Y = cpanel.getY() ;
	          int n_pagei = Y / PY;
	          //int n_pagef = ( Y + cpanel.getHeight())/ PY;
	          int n_pagef = ( Y + cpanel.getHeight() + margem_y )/ PY; // EXCESSIVO ?
	          //JOptionPane.showMessageDialog(null, c.getName() + ": " + " Y = " + Integer.toString (Y ) + " dY = " + Integer.toString ( cpanel.getHeight() ) +" PY= " + Integer.toString (PY ) );

	         // JOptionPane.showMessageDialog(null, "i: " + n_pagei + " f: " + n_pagef + " c: " + n_page_c);

	          if ( n_pagef > n_pagei || n_pagef > n_page_c ) {
	            dif_dy = n_pagef * PY - Y + margem_y;
	         //   JOptionPane.showMessageDialog(null, cpanel.getY() + " muda de pgina");
	            cpanel.setLocation( cpanel.getX(), cpanel.getY() + dif_dy  );
	            y_offset += dif_dy;

	            //mudar os interiores (excepto ScrollPane ? )
	            for ( int j = cpanel_idx; j < pComps.size(); j++) {
	              Component cx = (Component) pComps.elementAt(j);
	              cx.setLocation( cx.getX(), cx.getY() + dif_dy);
	              //JOptionPane.showMessageDialog(null, cx.getName() + " desloca-se para  " + cx.getY());
	              cx.repaint();
	            }
	          }
	          n_page_c = n_pagef;
	        }
	      }

	      // componentes isolados
	      else {

		     if ( c.isVisible() ) {
		    	  if ( c.getName() != null && c.getName().endsWith("_noprint") ) {
		    		  continue;
		    	  }

		    	  boolean b = c.isVisible();
		    	  c.setVisible(true);
		          Component cx = Clone(c);
		          c.setVisible(b);
		          //JOptionPane.showMessageDialog(null, c.getName());
		          //System.out.print(c.getClass().getName());
		          cx.setLocation(cx.getX(), cx.getY() + y_offset);
	
		          if ( c.getName() != null && c.getName().equals("logo") )
		            cx.setLocation( cx.getX() + dx_expand, cx.getY() );
	
		          pComps.addElement(cx);
		     }
	      }

	    }

	    // end clones para imprimir

	   // JOptionPane.showMessageDialog(null, "cancelar impresso...");

	    // imprimir...
	    //py_offset=0;

	   //CHPrintPage.pj.setPrintable( (Printable) frame, pf);
	   pj.setPrintable( (Printable) frame, pf);
	   try {
	     //CHPrintPage.pj.print();
	     pj.print();
	   }
	   catch (PrinterException pe) {
	     JOptionPane.showMessageDialog(null, "ERRO print...");
	   }
	 }

  //-----------------------------------------------
  //----------------  Clone -----------------------
  //-----------------------------------------------
  Component Clone( Component orig ) {

    if ( !orig.isVisible() ) return null;
    //JOptionPane.showMessageDialog(null, "nome -> " + orig.getClass().getName() );

    Component c = null;

    if ( orig.getClass().getName().endsWith("TextField") ||
         orig.getClass().getName().endsWith("JComboBox") ||
         orig.getClass().getName().endsWith("SteppedComboBox") ) {
      JTextField ct = new JTextField();
      ct.setLocation( orig.getX(), orig.getY());
      ct.setBorder(BorderFactory.createLineBorder(Color.black));
      ct.setBounds( orig.getBounds());
      ct.setFont(fmeFrame.letra);
      if ( orig.getClass().getName().endsWith("TextField") ) {
        ct.setHorizontalAlignment( ((JTextField) orig).getHorizontalAlignment() );
        ct.setFont( ((JTextField) orig).getFont() );
      }

      if ( orig.getClass().getName().endsWith("JComboBox") ||
           orig.getClass().getName().endsWith("SteppedComboBox") ) {
        if ( ( (JComboBox) orig).getSelectedIndex() >= 0)
          ct.setText( ( (JComboBox) orig).getSelectedItem().toString());
      }
      else
        ct.setText( ((JTextField)orig).getText()  );
      c = ct;
      c.setName( orig.getName() + "-clone" );
    }

    if ( orig.getClass().getName().endsWith("JLabel") ) {
      JLabel cl= new JLabel();
      cl.setBounds( orig.getBounds());
      cl.setText( ((JLabel) orig).getText() );
      cl.setHorizontalTextPosition( ((JLabel) orig).getHorizontalTextPosition() );
      cl.setHorizontalAlignment( ((JLabel) orig).getHorizontalAlignment() );
      cl.setFont( orig.getFont());
      c = cl;
      //024
      cl.setIcon( ((JLabel) orig).getIcon() );
      cl.setBorder( ((JLabel) orig).getBorder()  );
      c.setName( orig.getName() + "-clone" );
    }

    if ( orig.getClass().getName().endsWith("Panel") ) {
      JPanel cp = new JPanel();
      cp.setBorder( ((JPanel)orig).getBorder() );
      cp.setBounds( orig.getBounds());

      if ( dx_expand > 0 ) {
        cp.setSize( cp.getWidth() + dx_expand, cp.getHeight()  );
      }

      c=cp;
      c.setName( orig.getName() + "-clone" );
    }

    if ( orig.getClass().getName().endsWith("CheckBox") ) {
      JCheckBox chk = new JCheckBox();
      //chk.setBackground( ((JCheckBox)orig).getBackground());
      chk.setBorder( ((JCheckBox)orig).getBorder() );
      chk.setBorderPainted( false );
      //chk.setContentAreaFilled(true);
      chk.setText( ((JCheckBox)orig).getText());
      chk.setFont(((JCheckBox)orig).getFont());
      chk.setBorderPaintedFlat(true);
      chk.setBounds( orig.getBounds());
      chk.setHorizontalTextPosition( ((JCheckBox)orig).getHorizontalTextPosition());
      chk.setBackground( Color.white  );
      c = chk;
      c.setName( orig.getName() + "-clone" );
      chk.setSelected(  ((JCheckBox)orig).isSelected() );
      chk.setHorizontalAlignment(((JCheckBox)orig).getHorizontalAlignment());

    }

    //TAB CAE - PARA GENERALIZAR
    // scroll pane com tabela
    if ( orig.getClass().getName().endsWith("ScrollPane") ) {

      //JOptionPane.showMessageDialog(null, "painel: " + orig.getName());

      JScrollPane sp_org = (JScrollPane) orig;
      Component[] t = sp_org.getViewport().getComponents();
      for ( int i = 0; i < t.length; i ++ ) {

        //JOptionPane.showMessageDialog(null, "dentro temos: " + t[i].getClass().getName());

        if ( t[i].getClass().getName().endsWith("JTable")  ||
                t[i].getClass().getName().endsWith("JTableX") ||
                t[i].getClass().getName().endsWith("JTable_Tip") ||
             ( t[i].getName() != null && t[i].getName().endsWith("_Tabela"))  ) {

          //JOptionPane.showMessageDialog(null, "tabela: " + t[i].getName() );

          //container panel
          JPanel np = new JPanel();
          //JScrollPane np = new JScrollPane();

          np.setLocation(sp_org.getLocation());
          np.setBorder( sp_org.getBorder() );

          JTable jt_org = (JTable) t[i];
          JTable jt = new JTable(jt_org.getModel());

          //jt.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
          //jt.setSize(orig.getSize());
          jt.setRowHeight(jt_org.getRowHeight());

          CHTabela dt = (CHTabela) jt_org.getModel();
          int nrows = dt.getRowCount();
          //JOptionPane.showMessageDialog(null, "So " + Integer.toString(nrows) + " linhas.");

          //jt.setSize(jt_org.getWidth(), 4 * jt_org.getRowHeight());
          jt.setSize(jt_org.getWidth(), nrows * jt_org.getRowHeight());
          jt.setFont( t[i].getFont());
          jt.setBorder( null );
          jt.setColumnModel(jt_org.getColumnModel());

          JTableHeader tbh = new JTableHeader ( jt_org.getColumnModel());
          //jt.setTableHeader(jt_org.getTableHeader());

          int w = tbh.getPreferredSize().width;
          int h = jt_org.getTableHeader().getHeight();
          jt.setTableHeader(tbh);
          tbh.setSize(new Dimension(w, h));
          tbh.setTable(jt);

          np.setSize(jt.getWidth() -1 , jt.getHeight() + jt.getTableHeader().getHeight() );

          np.add(jt, null);
          jt.getTableHeader().setLocation( 0, 0);
          jt.setLocation( 0, jt.getTableHeader().getHeight() + 1  );
          if (dt.d.ui != null) jt.getTableHeader().setUI(dt.d.ui);
          np.add(jt.getTableHeader(), null);

          c = np;
          c.setName( orig.getName() + "-clone" );
        }
        else if ( t[i].getClass().getName().endsWith("EditorPane") ) {

        //	JOptionPane.showMessageDialog(null, " aqui ?");


        	JEditorPane jp = new JEditorPane();

        	jp.setBounds(new Rectangle(10, 10, 620, 660));

        	jp.setFont( t[i].getFont() );

//        	java.net.URL URL = ((JEditorPane) t[i]).getPage();

        	java.net.URL URL = fme.fmeFrame.class.getResource("parecer_tecnico.html");

        	try {

        	jp.setPage( URL );

        	}

        	catch ( IOException e ) {

        	System.err.println("Attempted to read a bad URL: " + URL);

        	}


        	jp.revalidate();

        	jp.repaint();


        	JScrollPane jsp = new JScrollPane();

        	jsp.setBounds(new Rectangle(10, 10, 620, 660));

        	jsp.setViewportView( jp );


        	jsp.repaint();


        	return jp;

        }

      }
    }

    return c;
  }

  //****************************************************************************
  //print
  //****************************************************************************
  int print ( Graphics g, PageFormat pf, int pageIndex ) {

    //JOptionPane.showMessageDialog(null, "Pgina: " + Integer.toString(pageIndex));

    int f_x = (int) pf.getImageableX();
    int f_dx = (int) pf.getImageableWidth();

    g.translate ( margem_x, 0);

    int n_page = pageIndex;
    boolean has_page = false;
    //double scale = 0.73;
    //int margem_y = 100;
    //int PY = (int) pf.getImageableY() + (int) ((pf.getImageableHeight()-2 * margem_y)/scale);

    ((Graphics2D) g).scale( scale, scale);

    //g.translate( (int) pf.getImageableX() + 50, (int) pf.getImageableY() + margem_y  );
    /*
    if ( pf.getOrientation() == PageFormat.PORTRAIT )
      g.translate( (int) pf.getImageableX() + 50, (int) pf.getImageableY() );
    else
      g.translate( (int) pf.getImageableX() + 5 , (int) pf.getImageableY() );     // ???
    */

    g.translate( (int) pf.getImageableX() , (int) pf.getImageableY() );     // ???

    for ( int i = 0; i < pComps.size(); i++)
    {
      Component c = (Component) (pComps.elementAt(i));
      int Y = c.getY();

      //JOptionPane.showMessageDialog(null, "print "
      //+ "X= " + Integer.toString(c.getX())
      //+ "Y = " + Integer.toString(Y));

//if ( pageIndex > 0  && Y > PY ) {
//  JOptionPane.showMessageDialog(null, "PRINT EM Y= " + Integer.toString(Y )  );
//}

      if ( Y > n_page*PY && Y < (n_page+1)*PY ) {

        //if ( pageIndex > 0  && Y > PY ) {
        //  JOptionPane.showMessageDialog(null, "DENTRO !!! PRINT EM Y= " + Integer.toString(Y )  );
        //}

        if ( c.getClass().getName().endsWith ("Panel") )  {

          if ( ((JPanel) c).getBorder() != null )
            g.drawRect( (int) c.getX(), c.getY() - n_page * PY, (int) c.getWidth(), (int) c.getHeight());

            if ( f_x == 0 ) f_x = c.getX();
            else if ( c.getX() < f_x ) f_x = c.getX();
            if ( c.getWidth() > f_dx ) f_dx = c.getWidth();

            //**************************************************************************************
          JPanel p = (JPanel) c;
          Component[] icomps = p.getComponents();
          for ( int j = 0; j < icomps.length; j++ ) {
            Component pc = icomps[j];
            //g.translate( c.getX()+ pc.getX(), c.getY()+ pc.getY() );
            g.translate( c.getX()+ pc.getX(), c.getY()+ pc.getY() - n_page * PY );

            //JOptionPane.showMessageDialog(null, "print inside panel - classe " + pc.getClass().getName()  );

            pc.paint(g);
            //g.translate(  -(c.getX() + pc.getX()), -(c.getY()+ pc.getY()));
            g.translate(  -(c.getX() + pc.getX()), -(c.getY()+ pc.getY() - n_page * PY));
            has_page = true;

            //**************************************************************************************
          }

        }
        else {
          g.translate(c.getX(), Y - n_page* PY );
          c.paint(g);
          g.translate( -c.getX(), -( Y - n_page* PY) );
          has_page = true;

          if ( f_x == 0 ) f_x = c.getX();
          else if ( c.getX() < f_x ) f_x = c.getX();
          if ( c.getWidth() > f_dx ) f_dx = c.getWidth();

        }
      }

      if ( Y  > (n_page+1)*PY ) {
        multipage = true;
      }
    }

    // cabealho e rodap
    if (has_page) {

      JLabel h = new JLabel();

      h.setBackground(Color.darkGray);
      h.setFont(fmeFrame.letra_titulo);
      h.setForeground(Color.white);
      h.setBorder(null);
      h.setText( header  );
      h.setSize  ( f_dx , 20  );
//$02
//    h.setLocation( f_x ,  margem_y / 2  );
      h.setLocation( f_x ,  17 );
      h.setOpaque(true);
      //g.translate(h.getX(), h.getY() + n_page* PY );
      g.translate(h.getX(), h.getY() );
      h.paint(g);
      //g.translate( -h.getX(), - ( h.getY() + n_page* PY) );
      g.translate( -h.getX(), -  h.getY()  );

      h.setText( footer_medida);
      //h.setLocation( f_x ,  PY - ( (int) (1.5 * margem_y) )/ 2  );
//$02
      h.setLocation( f_x ,  PY - ( 16 + 8 ));
      h.setSize( h.getWidth() - 80, h.getHeight() -4 );
      //g.translate(h.getX(), h.getY() + n_page* PY );
      g.translate(h.getX(), h.getY() );
      h.paint(g);
      g.translate( -h.getX(), -  h.getY()  );

      h.setText( footer_pag );
      if ( multipage ) h.setText( footer_pag + "/" + ( pageIndex + 1) );
//      h.setLocation( h.getX() + h.getWidth()  ,  PY - (int) (1.5 * margem_y) / 2  );
      h.setLocation( h.getX() + h.getWidth() - 20 ,  PY - ( 16 + 8 ));
      h.setSize( 80 + 1 +20, h.getHeight() );
      h.setHorizontalTextPosition(JLabel.RIGHT);
      g.translate(h.getX(), h.getY()  );
      h.paint(g);
      g.translate( -h.getX(), -  h.getY()  );


      h.setBackground(Color.white);
      h.setFont(fmeFrame.letra_pequena);
      h.setForeground(Color.black);
      h.setText( "Promotor: " + footer_promotor );
      h.setSize( f_dx  , 15  );
      //h.setLocation( f_x ,  PY - (int) (1.5 * margem_y) / 2 + 22  );
      h.setLocation( f_x ,  PY - ( 8 ) );
      g.translate(h.getX(), h.getY() );
      h.paint(g);
      g.translate( -h.getX(), - h.getY()  );

    }

    if ( has_page) return Printable.PAGE_EXISTS;
    else return Printable.NO_SUCH_PAGE;
    //return Printable.NO_SUCH_PAGE;

  }

  //*********************** TEXTO **********************************************

  public static String getWrappedText(JTextArea c) {
    int len = c.getDocument().getLength();
    int offset = 0;

    // Increase 10% for extra newlines
    StringBuffer buf = new StringBuffer((int)(len*1.10));

    try {
      while (offset < len) {
          int end = Utilities.getRowEnd(c, offset);
          if (end < 0) {
              break;
          }

          // Include the last character on the line
          end = Math.min(end+1, len);

          String s = c.getDocument().getText(offset, end-offset);
          buf.append(s);

          // Add a newline if s does not have one
          if (!s.endsWith("\n")) {
              buf.append('\n');
          }
          offset = end;
      }
    } catch (Exception e) { }
    return buf.toString();
  }

  public static int getWrappedText_nlines (JTextArea c) {
    int len = c.getDocument().getLength();
    int offset = 0;
    int nlines = 0;

    // Increase 10% for extra newlines
    StringBuffer buf = new StringBuffer((int)(len*1.10));

    try {
      while (offset < len) {
          int end = Utilities.getRowEnd(c, offset);
          if (end < 0) {
              break;
          }

          // Include the last character on the line
          end = Math.min(end+1, len);

          String s = c.getDocument().getText(offset, end-offset);
          buf.append(s);

          // Add a newline if s does not have one
          if (!s.endsWith("\n")) {
              buf.append('\n');
          }
          offset = end;
          nlines++;
      }
    } catch (Exception e) {}
    return nlines;
  }


  public static String getWrappedText_getnlines (JTextArea c, int n) {
    int len = c.getDocument().getLength();
    int offset = 0;
    int nlines = 0;

    // Increase 10% for extra newlines
    StringBuffer buf = new StringBuffer((int)(len*1.10));

    try {
      while (offset < len) {
          int end = Utilities.getRowEnd(c, offset);
          if (end < 0) {
              break;
          }
          // Include the last character on the line
          end = Math.min(end+1, len);

          String s = c.getDocument().getText(offset, end-offset);
          buf.append(s);

          // Add a newline if s does not have one
          if (!s.endsWith("\n")) {
              buf.append('\n');
          }
          offset = end;
          nlines++;
          if ( nlines >= n ) break;
      }
    } catch (Exception e) { }
    return buf.toString();
  }

  public static String getWrappedText_getnlines (JTextArea c, int start, int n) {
    int len = c.getDocument().getLength();
    int offset = 0;
    int nlines = 0;

    // Increase 10% for extra newlines
    StringBuffer buf = new StringBuffer((int)(len*1.10));

    try {
        while (offset < len) {
            int end = Utilities.getRowEnd(c, offset);
            if (end < 0) {
                break;
            }
            // Include the last character on the line
            end = Math.min(end+1, len);

            String s = c.getDocument().getText(offset, end-offset);

            if ( nlines >= start )
            buf.append(s);

            // Add a newline if s does not have one
            if (!s.endsWith("\n")) {
                if ( nlines >= start )
                buf.append('\n');
            }
            offset = end;
            nlines++;
            if ( nlines >= start + n ) break;
        }
    } catch (Exception e) {
    }
    return buf.toString();
  }

  //----------------------------------------------------------------------------
  //--------------------- painel texto -----------------------------------------
  //----------------------------------------------------------------------------

  void painel_texto ( JPanel painel ) {

    boolean skip_page = false;

    // localizar: scroll_pane_texto, caixa_texto
    JScrollPane sp_texto = null;
    JTextArea txt_area = null;

    Component[] t = painel.getComponents();
    for ( int i = 0; i < t.length; i ++ ) {
      if ( t[i].getClass().getName().endsWith("ScrollPane") ) {
          sp_texto = (JScrollPane) t[i];
      }
    }

    t = sp_texto.getViewport().getComponents();
    for ( int ix = 0; ix < t.length; ix ++ ) {
      if ( t[ix].getClass().getName().endsWith("TextArea") ) {
          txt_area = (JTextArea) t[ix];
      }
      else continue;

//BLOCO

      //
      int i_top_margin = sp_texto.getY();
      int i_bottom_margin = painel.getHeight() - i_top_margin - sp_texto.getHeight();

      int txt_nlines = getWrappedText_nlines(txt_area);

      int txt_nlines_printed = 0;
      do {

        //JOptionPane.showMessageDialog(null, "CAIXA " + ix + ", " + txt_nlines
        //    + "\nPY = " + PY
        //    + "\npainel = " + painel.getY()
        //    + "\ni_top_margin = " + i_top_margin
        //    + "\ni_bottom_margin = " + i_bottom_margin
        //    + "\nmargem_y = " + margem_y
        //    + "\nlinhas. y_offset = " + y_offset);

        // disponvel: at ao fim da pgina ou pgina toda;
        int dmax;
        if (txt_nlines_printed == 0 ) {
          dmax = PY - ( (painel.getY() + y_offset)) % PY - i_top_margin - i_bottom_margin - margem_y;
          // no cabendo na pgina
          //if (dmax < sp_texto.getHeight()) {
          //JOptionPane.showMessageDialog(null, "Avaliao existe" + dmax + " vs preciso" + txt_area.getHeight());
          if (dmax < sp_texto.getHeight()) {
            //JOptionPane.showMessageDialog(null, "(Primeira) J no cabe..." + dmax + " vs " + txt_area.getHeight()
            //               + " y_offset = " + y_offset  );
            //primeira_caixa = false;
            //dmax = PY;
            if ( primeira_caixa )
              dmax = PY - painel.getY() - i_top_margin - i_bottom_margin - 2 * margem_y;
            else {
              dmax = PY - i_top_margin - i_bottom_margin - 2 * margem_y;
              skip_page = true;
            }
          }
        }
        else {
          //dmax = PY - painel.getY() - i_top_margin - i_bottom_margin - margem_y;
          dmax = PY - i_top_margin - i_bottom_margin - 2 * margem_y;
          skip_page = true;
        }
          // preciso
        int need;
        if (txt_nlines == 0) need = txt_area.getHeight();
        else need = (int) (txt_area.getHeight() *
                           (1 - (double) txt_nlines_printed / (double) txt_nlines)) + 1;
        int jt_height = need < dmax ? need : dmax;
        //JOptionPane.showMessageDialog(null, "heigth: " + jt_height );

        // clone
        JTextArea jt = new JTextArea();
        jt.setFont(txt_area.getFont());
        //jt.setSize( txt_area.getWidth(), jt_height );
        jt.setSize(sp_texto.getWidth(), jt_height + 5);
        if (dx_expand > 0)
          jt.setSize(jt.getWidth() + dx_expand, jt.getHeight());
        jt.setLocation(sp_texto.getLocation());
        jt.setBorder(painel.getBorder());

        int nprintlines = (int) ( (double) jt_height / txt_area.getHeight() *
                                 txt_nlines);
        jt.setText(txt_area.getText());
        //JOptionPane.showMessageDialog(null, "Imprime: " + Integer.toString( nprintlines ) + " linhas.");
        String txt = getWrappedText_getnlines(txt_area, txt_nlines_printed,
                                              nprintlines);
        //JOptionPane.showMessageDialog(null, "Texto:\n" + txt );
        jt.setText(txt);

        // lista de componentes
        JPanel np = new JPanel();
        np.setBorder(painel.getBorder());
        np.setSize(painel.getSize());
        np.setSize(np.getWidth() + dx_expand,
                   np.getHeight() + jt.getHeight() - sp_texto.getHeight());

        np.add(jt, null);

        // outros componentes
        t = painel.getComponents();
        for (int i = 0; i < t.length; i++) {
          if (!t[i].getClass().getName().endsWith("ScrollPane")) {
            Component c = Clone(t[i]);
            //if ( dx_expand > 0 ) c.setSize( c.getWidth() + dx_expand, c.getHeight());
            np.add(c, null);
          }
        }

        pComps.addElement(np);

        // localizao
        //if ( txt_nlines_printed == 0 ) {
        if ( !skip_page ) {

          np.setLocation(painel.getLocation());
          np.setLocation(np.getX(), np.getY() + y_offset);

          //JOptionPane.showMessageDialog(null, "Y_OFFSET era: " + Integer.toString( y_offset) );
          //JOptionPane.showMessageDialog(null, "jt: " + Integer.toString( jt.getHeight()) );
          //JOptionPane.showMessageDialog(null, "sp: " + Integer.toString( sp_texto.getHeight() ) );

          y_offset = y_offset + jt.getHeight() - sp_texto.getHeight();
          //JOptionPane.showMessageDialog(null, "Y_OFFSET fica: " + Integer.toString( y_offset) );

        }
        else {

          // avanar para a pgina seguinte : caixas de continuao
          int dif_y = PY - (painel.getY() + y_offset) + margem_y;
          //JOptionPane.showMessageDialog(null, "avanar: " + Integer.toString(dif_y) );

          dif_y = PY - (painel.getY() + y_offset) % PY + margem_y;
          //JOptionPane.showMessageDialog(null, "avanar (antes): " + Integer.toString(dif_y) );

          np.setLocation(painel.getX(), painel.getY() + y_offset + dif_y);
          //JOptionPane.showMessageDialog(null, "fica em: " + Integer.toString( painel.getY() + y_offset + dif_y  ) );

          //JOptionPane.showMessageDialog(null, "PAINEL.y " + Integer.toString(painel.getY()) );
          //JOptionPane.showMessageDialog(null, "Y_OFFSET " + Integer.toString( y_offset) );

          //JOptionPane.showMessageDialog(null, "Y_OFFSET era: " + Integer.toString( y_offset) );
          //y_offset += dif_y + np.getHeight() ;
          y_offset += 2 * margem_y + np.getHeight();

          //JOptionPane.showMessageDialog(null, "Y_OFFSET fica:" + Integer.toString( y_offset) );

        }

        //JOptionPane.showMessageDialog(null, "PAINEL em: " + Integer.toString( np.getY()  ) );

        txt_nlines_printed += nprintlines;
        primeira_caixa = false;
      }

      while (txt_nlines_printed < txt_nlines);

    } //END BLOCO

  }




  //----------------------------------------------------------------------------
  // painel QUADRO (dividir por vrias pginas)
  //----------------------------------------------------------------------------

  void painel_quadro ( JPanel painel ) {

   // JOptionPane.showMessageDialog(null, "Quadro");

    // localizar: scroll_pane, tabela
    JScrollPane sp_tabela = null;
    JTable jt_org = null;

    Component[] t = painel.getComponents();
    for (int i = 0; i < t.length; i++) {
      //JOptionPane.showMessageDialog(null, "_ScrollPane ? " + t[i].getName() );
      if (t[i].getName() != null && t[i].getName().endsWith("_ScrollPane")) {
        sp_tabela = (JScrollPane) t[i];
      }
    }

    t = sp_tabela.getViewport().getComponents();
    for (int i = 0; i < t.length; i++) {
      //JOptionPane.showMessageDialog(null, "_Tabela ? " + t[i].getName() );
      if (t[i].getName() != null && t[i].getName().endsWith("_Tabela")) {
        jt_org = (JTable) t[i];
      }
    }

    int nrows = jt_org.getModel().getRowCount();
    //JOptionPane.showMessageDialog(null, "so " + Integer.toString(nrows) + " linhas para imprimir");

    int px, py;
    px = jt_org.getWidth() + 2 * sp_tabela.getX();
//    py = PY - ( painel.getY()  + 2* margem_y ) - sp_tabela.getY();

    // teste
    px = painel.getWidth();

    px += this.dx_expand;

/*
    int nprows = (int) ( (double) ( py - jt_org.getTableHeader().getHeight() ) /
                                  ( jt_org.getRowHeight() ) - 1);

    int npprows = nprows;
*/
    //JOptionPane.showMessageDialog(null, "D para " + Integer.toString(nprows) + " linhas por pgina.");

    int nprinted_rows = 0;
    int npage = 0;

    //int y_desconto_final = 0;

    do {

      if ( primeiro_quadro ) {
        if ( nprinted_rows == 0 )
          py = PY - ( painel.getY()  + 2* margem_y ) - sp_tabela.getY();
        else
          py = PY -  2* margem_y - sp_tabela.getY();
      }
      else { // 2+ quadro
        if ( nprinted_rows == 0 ) {
          int disponivel = PY - (painel.getY() + y_offset)%PY - margem_y;
          if ( disponivel < painel.getHeight()) {
            //JOptionPane.showMessageDialog(null, "2 j no cabe..: " + disponivel + " vs " + painel.getHeight());
            //JOptionPane.showMessageDialog(null, "2 j no cabe... leva mais " + (disponivel + 2*margem_y));
            y_offset += disponivel + 2*margem_y;
            py = PY -  2* margem_y - sp_tabela.getY();
          }
          else {
            //JOptionPane.showMessageDialog(null, "2 ainda cabe...offset= " + y_offset);
            py = PY -  2* margem_y - painel.getY() - sp_tabela.getY();
            //mas tem que descer ?
            int inicio_disponivel = (painel.getY() + y_offset)%PY;
            //JOptionPane.showMessageDialog(null, "org: " + painel.getY() + " disp " + inicio_disponivel);
            if ( inicio_disponivel < painel.getY() ) {
              y_offset += painel.getY() - inicio_disponivel;
              //JOptionPane.showMessageDialog(null, "descer: " + (inicio_disponivel - painel.getY()) );
            }
          }
        }
        else
          py = PY -  2* margem_y - sp_tabela.getY();
      }

      int nprows = (int) ( (double) ( py - jt_org.getTableHeader().getHeight() ) /
                                        ( jt_org.getRowHeight() ) - 1);
      int npprows = nprows;

      if ( ! primeiro_quadro ) {
        //JOptionPane.showMessageDialog(null, "d para " + nprows + " linhas");
      }

      CHTabela dt = (CHTabela) jt_org.getModel();
      CHTabelaPrint dtp = new CHTabelaPrint(dt);

      if ( nrows - nprinted_rows < nprows ) {
        nprows = nrows - nprinted_rows;
//        JOptionPane.showMessageDialog(null, "faltam  s " + nprows);
      }
      dtp.print_rows = nprows;
      dtp.row_offset = nprinted_rows;

      //

      // lista de componentes
      JPanel np = new JPanel();
      np.setBorder(painel.getBorder());

      np.setLocation(painel.getX() , painel.getY() + y_offset );
      np.setSize(px, py );

      /*
      if ( nprinted_rows > 0 ) {
        npage = nprinted_rows / npprows;
        JOptionPane.showMessageDialog(null, "pgina: " + npage );
        y_offset = (PY - painel.getY() + margem_y )  + ( npage-1) * PY;
      }
      */

      /*
      if ( npage == 0 )
        np.setLocation(painel.getX() , painel.getY() + y_offset );
      else
        np.setLocation(painel.getX() , painel.getY() + y_offset + margem_y );
      np.setSize(px, py );
      */

      // clone da tabela

      JTable jt = new JTable(dtp);
      jt.setRowHeight(jt_org.getRowHeight());
      jt.setSize(jt_org.getWidth(), nprows * jt_org.getRowHeight());
      //jt.setSize( px, nprows * jt_org.getRowHeight());

      //JTableHeader tbh = jt_org.getTableHeader();
      JTableHeader tbh = new JTableHeader ( jt_org.getColumnModel());
      
      int w = jt_org.getPreferredSize().width;
      int h = jt_org.getTableHeader().getHeight();
   //   jt.setTableHeader(tbh);
      tbh.setSize(new Dimension(w, h));
 //     tbh.setTable(jt);
      
      //JTableHeader tbh = dtp.getTableHeader();
      jt.setTableHeader( tbh);

      if (dt.d.ui != null) tbh.setUI(dt.d.ui);

      tbh.setSize(  jt_org.getTableHeader().getSize());
      tbh.setTable(jt);

      jt.setBorder(null);
      jt.setColumnModel(jt_org.getColumnModel());
      //jt.setTableHeader(jt_org.getTableHeader());
      jt.setTableHeader( tbh );
      jt.setBorder( BorderFactory.createLineBorder( Color.gray) );
      jt.getTableHeader().setBorder(  BorderFactory.createLineBorder( Color.gray) );


      // PRINT-NEW
      // ????px = jt.getHeight() + tbh.getHeight();

      // outros componentes interiores
      int y_interiores = 0;
      t = painel.getComponents();
      for (int i = 0; i < t.length; i++) {
        if (t[i].getClass().getName().endsWith("Label") ||  t[i].getClass().getName().endsWith("TextField")) {
          Component c = Clone(t[i]);
          np.add(c, null);
        }
      }

      //jt.getTableHeader().setLocation(1, 1);
      int j_dx = ( np.getWidth() - jt.getWidth()) / 2;
      //int j_dy = ( np.getHeight() - jt.getHeight() - jt.getTableHeader().getHeight()) / 2;
      //j_dy +=  sp_tabela.getY() - jt.getTableHeader().getHeight();
      jt.setLocation( j_dx , sp_tabela.getY() + jt.getTableHeader().getHeight() );
      jt.getTableHeader().setLocation(j_dx, sp_tabela.getY() );
      np.add(jt, null);

      //
      py = painel.getHeight();   // ????
      py += (jt.getHeight() + jt.getTableHeader().getHeight()) - sp_tabela.getHeight();
      np.setSize(px, py );

      //JOptionPane.showMessageDialog(null, "Quadro j_dx: " + j_dx );

      //np.add(jt.getTableHeader(), null);

      np.add( tbh , null);

      //
      np.repaint();
      pComps.addElement(np);

      nprinted_rows += nprows;

      if ( nprinted_rows  < nrows  ) {
        if ( npage == 0 && primeiro_quadro )
          y_offset += PY - painel.getY();
        else
          y_offset += PY;
      }
      else {
        if ( npage == 0 ) {
          y_offset += np.getHeight() - painel.getHeight();
        }
        else {
          y_offset += np.getHeight() - painel.getHeight(); //tambm ???
        }
      }
      npage++;
      n_page_c++;
    } while ( nprinted_rows < nrows);

    //JOptionPane.showMessageDialog(null, "y_offset " + y_offset );

    //JOptionPane.showMessageDialog(null, "y_offset final " + y_offset + " (PY= " + PY + ")");

    primeiro_quadro = false;

  }

  static void show () {
    Dialog_Print d = new Dialog_Print();
    //fmeFrame.Paginas.GoTo("Pagina_02");
    //fmeFrame.P02.print_page();
  }
}


