package fme;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;

public class CMsgInfo extends JDialog {
	String file;
	JPanel panel1;
	JButton jButton_Fechar;
    JEditorPane jEditorPane_Guia = null;
	private JScrollPane jScrollPane_Guia = null;
	 
  public CMsgInfo(String _file) {
    super(new JDialog(), "Guia de Preenchimento", false);
    file = _file;
    try {
      jbInit();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    panel1 = new JPanel();
    panel1.setLayout(null);
    panel1.add(getJScrollPane_Guia(), null);
    panel1.add(getJButton_Fechar(), null);
    getContentPane().add(panel1);
    setModal(true);
    this.setResizable(false);
    pack();
  }
  
	public JScrollPane getJScrollPane_Guia() {
		if (jScrollPane_Guia == null) {
			jScrollPane_Guia = new JScrollPane();
			jScrollPane_Guia.setBounds(new Rectangle(9, 10, 475, 275));
			jScrollPane_Guia.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Guia.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Guia.setViewportView(getJEditorPane_Guia());
		}
		return jScrollPane_Guia;
	}
	
	public JEditorPane getJEditorPane_Guia() {
		if (jEditorPane_Guia == null) {
			jEditorPane_Guia = new JEditorPane();
			jEditorPane_Guia.setEditable(false);
			java.net.URL helpURL = fme.fmeFrame.class.getResource(file+".html");
		    if (helpURL != null) {
		        try {
		        	jEditorPane_Guia.setPage(helpURL);
		        } catch (IOException e) {
		            System.err.println("Attempted to read a bad URL: " + helpURL);
		        }
		    } else {
		    	helpURL = fme.fmeFrame.class.getResource("erro.html");
		        try {
		        	jEditorPane_Guia.setPage(helpURL);
		        } catch (IOException e) {
		            System.err.println("Attempted to read a bad URL: " + helpURL);
		        }
		        System.err.println("Couldn't find file: "+file+".html");
		    }
		}
		return jEditorPane_Guia;
	}
  
	public JButton getJButton_Fechar() {
		if (jButton_Fechar == null) {
			jButton_Fechar = new JButton();
		    jButton_Fechar = new JButton();
		    jButton_Fechar.setBounds(new Rectangle(404, 292, 80, 25));
		    jButton_Fechar.setText("Fechar");
		    jButton_Fechar.addActionListener(new CMsgInfo_jButton1_actionAdapter(this));
		}
		return jButton_Fechar;
	}

  void jButton1_actionPerformed(ActionEvent e) {
    hide();
  }
}

class CMsgInfo_jButton1_actionAdapter implements java.awt.event.ActionListener {
	CMsgInfo adaptee;

	CMsgInfo_jButton1_actionAdapter(CMsgInfo adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
