package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

import javax.swing.JInternalFrame;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import java.awt.Font;

public class Frame_ActRecursos_N extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	public JTabbedPane jTabbedPane = null;

	String tag = "";

	public Frame_ActRecursos_N() {
		super();
		initialize();
	}

	public Dimension getSize () {
	//	face  dimenso da pgina base
		return new Dimension(630,685);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout( null );
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder());
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
		}
		return jContentPane;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		if ( fmeFrame.contexto.equals("toolbar")){
			int i = this.getJTabbedPane().getSelectedIndex();
			Component p = this.getJTabbedPane().getComponentAt(i);
			p = p.getComponentAt( 100, 100);
			Frame_ActRecursos frame = (Frame_ActRecursos) p;
			frame.tag = this.tag;
			frame.print_page();
		}else{
			for (int i=0;i<CBData.ActLista.dados.size();i++){
				Component p = this.getJTabbedPane().getComponentAt(i);
				p = p.getComponentAt( 100, 100);
				Frame_ActRecursos frame = (Frame_ActRecursos) p;
				frame.tag = this.tag;
				frame.print_page();
			}
		}
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		if (fmeFrame.contexto.equals("toolbar")){
			int i = this.getJTabbedPane().getSelectedIndex();
			((CBTabela_ActRecursosInt) CBData.ActLista.Lista_RecursosInt.elementAt(i)).Clear();
			((CBTabela_ActRecursosExt) CBData.ActLista.Lista_RecursosExt.elementAt(i)).Clear();
		}else{
			for (int i=0; i<CBData.ActLista.dados.size(); i++){
				((CBTabela_ActRecursosInt) CBData.ActLista.Lista_RecursosInt.elementAt(i)).Clear();
				((CBTabela_ActRecursosExt) CBData.ActLista.Lista_RecursosExt.elementAt(i)).Clear();
			}
		}
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp (fmeFrame.Paginas.getCaption(tag));
		if ( fmeFrame.contexto.equals("toolbar")){
			int i = this.getJTabbedPane().getSelectedIndex();
			if (!CBData.ActLista.isRowEmpty(i)){
				String na = " n. "+(i+1);
				grp.add_grp ( ((CBTabela_ActRecursosInt) CBData.ActLista.Lista_RecursosInt.elementAt(i)).validar(null, na) );
				grp.add_grp ( ((CBTabela_ActRecursosExt) CBData.ActLista.Lista_RecursosExt.elementAt(i)).validar(null, na) );
			}
		}else{
			for (int i=0; i<CBData.ActLista.Lista_Descricao.size(); i++) {
				if (!CBData.ActLista.isRowEmpty(i)){
					String na = " n. " + (i+1);
					grp.add_grp ( ((CBTabela_ActRecursosInt) CBData.ActLista.Lista_RecursosInt.elementAt(i)).validar(null, na) );
					grp.add_grp ( ((CBTabela_ActRecursosExt) CBData.ActLista.Lista_RecursosExt.elementAt(i)).validar(null, na) );
				}
			}
		}
		return grp;
	}

	public JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(0, 50, getSize().width+40, getSize().height-50));
			jTabbedPane.setBorder(BorderFactory.createEmptyBorder());
			jTabbedPane.setFont(fmeFrame.letra);
			jTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
			jTabbedPane.addChangeListener(new ChangeListener() {
		        // This method is called whenever the selected tab changes
		        public void stateChanged(ChangeEvent evt) {
		            int sel = ((JTabbedPane)evt.getSource()).getSelectedIndex();
					try{CBData.ActLista.on_row(sel);}
					catch(Exception ex){}
		        }
		    });

		}
		return jTabbedPane;
	}

	public Frame_ActRecursos nova_pagina ( String s, int n ) {

		Frame_ActRecursos pg = new Frame_ActRecursos();
		Dimension d = ((Pagina_Base)pg).getSize();
		((JInternalFrame)pg).setPreferredSize( d );
		((JInternalFrame)pg).setBounds( new Rectangle(0,0,680,1400) );
		((javax.swing.plaf.basic.BasicInternalFrameUI) pg.getUI()).setNorthPane(null);
		pg.setVisible(true);
		pg.tirar_titulo();

		JPanel jp = new JPanel();
		jp.setLayout(null);
		jp.setBounds( new Rectangle(0,0,680,1400));
		jp.add(pg, null);
		jp.setBorder(BorderFactory.createEmptyBorder());
		jTabbedPane.insertTab(s, null, jp, null, n);

		jTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);

		return pg;
	}

}
