package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.*;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Balanco extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Balanco = null;
	private JLabel jLabel_Balanco = null;
	private JScrollPane jScrollPane_Balanco_Fixed = null;
	private JScrollPane jScrollPane_Balanco = null;
	private JTable_Tip jTable_Balanco_Fixed = null;
	private JTable_Tip jTable_Balanco = null;

	String tag = "";  //  @jve:decl-index=0:
	
	public Frame_Balanco() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,1167);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_Balanco, 40);		
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1500);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Balanco(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Balanco() {
		if (jPanel_Balanco == null) {

			jLabel_Balanco = new JLabel();
			jLabel_Balanco.setBounds(new Rectangle(12, 10, 541, 18));
			jLabel_Balanco.setText("<html>Balanos Histricos e Previsionais</html>");
			jLabel_Balanco.setFont(fmeFrame.letra_bold);			

			jPanel_Balanco = new JPanel();
			jPanel_Balanco.setLayout(null);
			jPanel_Balanco.setBounds(new Rectangle(15, 50, 640, 1107));
			jPanel_Balanco.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Balanco.add(jLabel_Balanco, null);
			jPanel_Balanco.add(getJScrollPane_Balanco_Fixed(), null);
			jPanel_Balanco.add(getJScrollPane_Balanco(), null);
		}
		return jPanel_Balanco;
	}
	
	public JScrollPane getJScrollPane_Balanco_Fixed() {
		if (jScrollPane_Balanco_Fixed == null) {
			jScrollPane_Balanco_Fixed = new JScrollPane();
			jScrollPane_Balanco_Fixed.setBounds(new Rectangle(16, 36, 206, 1055));
			jScrollPane_Balanco_Fixed.setViewportView(getJTable_Balanco_Fixed());
			jScrollPane_Balanco_Fixed.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			//jScrollPane_Balanco_Fixed.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_Balanco_Fixed.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Balanco_Fixed;
	}
	public JScrollPane getJScrollPane_Balanco() {
		if (jScrollPane_Balanco == null) {
			jScrollPane_Balanco = new JScrollPane();
			jScrollPane_Balanco.setBounds(new Rectangle(216+4, 36, 400, 1055));
			jScrollPane_Balanco.setViewportView(getJTable_Balanco());
			//jScrollPane_Balanco.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			//jScrollPane_Balanco.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_Balanco.setBorder(BorderFactory.createEtchedBorder());
			AdjustmentListener listener = new MyAdjustmentListener();
			jScrollPane_Balanco.getHorizontalScrollBar().addAdjustmentListener(listener);
//jScrollPane_Balanco
		}
		return jScrollPane_Balanco;
	}
	
	public JTable getJTable_Balanco_Fixed() {
		if (jTable_Balanco_Fixed == null) {
			jTable_Balanco_Fixed = new JTable_Tip(25, jScrollPane_Balanco_Fixed.getWidth());
			jTable_Balanco_Fixed.setRowHeight(18);
			jTable_Balanco_Fixed.setFont(fmeFrame.letra);
			jTable_Balanco_Fixed.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Balanco_Fixed.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Balanco_Fixed;
	}
	public JTable getJTable_Balanco() {
		if (jTable_Balanco == null) {
			jTable_Balanco = new JTable_Tip(25, jScrollPane_Balanco.getWidth());
			jTable_Balanco.setRowHeight(18);
			jTable_Balanco.setFont(fmeFrame.letra);
			jTable_Balanco.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Balanco.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Balanco;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_Balanco.getWidth() - jScrollPane_Balanco.getWidth();
		int w = jPanel_Balanco.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Balanco.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Balanco.validar(null, ""));
		return grp;
	}

}
class MyAdjustmentListener implements AdjustmentListener {
    // This method is called whenever the value of a scrollbar is changed,
    // either by the user or programmatically.
    public void adjustmentValueChanged(AdjustmentEvent evt) {
        Adjustable source = evt.getAdjustable();

        // getValueIsAdjusting() returns true if the user is currently
        // dragging the scrollbar's knob and has not picked a final value
        if (evt.getValueIsAdjusting()) {
            // The user is dragging the knob
            return;
        }

        // Determine which scrollbar fired the event
        int orient = source.getOrientation();
        if (orient == Adjustable.HORIZONTAL) {
            // Event from horizontal scrollbar
        } else {
            // Event from vertical scrollbar
        }

        // Determine the type of event
        int type = evt.getAdjustmentType();
        switch (type) {
          case AdjustmentEvent.UNIT_INCREMENT:
              // Scrollbar was increased by one unit
              break;
          case AdjustmentEvent.UNIT_DECREMENT:
              // Scrollbar was decreased by one unit
              break;
          case AdjustmentEvent.BLOCK_INCREMENT:
              // Scrollbar was increased by one block
              break;
          case AdjustmentEvent.BLOCK_DECREMENT:
              // Scrollbar was decreased by one block
              break;
          case AdjustmentEvent.TRACK:
              // The knob on the scrollbar was dragged
              break;
        }

        // Get current value
        int value = evt.getValue();
    }
}

	