package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_CaractProj1 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Descricao = null;
	private JLabel jLabel_Descricao = null;
	private JScrollPane jScrollPane_Descricao = null;
	private JTextArea jTextArea_Descricao = null;

	private JPanel jPanel_Identificacao = null;
	private JLabel jLabel_Identificacao = null;
	private JScrollPane jScrollPane_Identificacao = null;
	private JTextArea jTextArea_Identificacao = null;

	String tag = "";

	private final static int area_height = 362;

	public Frame_CaractProj1() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,60+2*(area_height+62));
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_Descricao, 30);
		up_component(jPanel_Identificacao, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"DADOS DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Descricao(), null);
			jContentPane.add(getJPanel_Identificacao(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_Descricao() {
		if (jPanel_Descricao == null) {
			jLabel_Descricao = new JLabel();
			jLabel_Descricao.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Descricao.setText("Descrio do projecto");
			jLabel_Descricao.setFont(fmeFrame.letra_bold);

			jPanel_Descricao = new JPanel();
			jPanel_Descricao.setLayout(null);
			jPanel_Descricao.setBounds(new Rectangle(15, 50+0*(area_height+62), 640, area_height+52));
			jPanel_Descricao.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Descricao.setName("descricao_texto");
			jPanel_Descricao.add(jLabel_Descricao, null);
			jPanel_Descricao.add(getJScrollPane_Descricao(), null);
		}
		return jPanel_Descricao;
	}
	private JScrollPane getJScrollPane_Descricao() {
		if (jScrollPane_Descricao == null) {
			jScrollPane_Descricao = new JScrollPane();
			jScrollPane_Descricao.setBounds(new Rectangle(15, 35, 609, area_height));
			jScrollPane_Descricao.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Descricao.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Descricao.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Descricao.setViewportView(getJTextArea_Descricao());
		}
		return jScrollPane_Descricao;
	}
	public JTextArea getJTextArea_Descricao() {
		if (jTextArea_Descricao == null) {
			jTextArea_Descricao = new JTextArea();
			jTextArea_Descricao.setFont(fmeFrame.letra);
			jTextArea_Descricao.setLineWrap(true);
			jTextArea_Descricao.setWrapStyleWord(true);
			jTextArea_Descricao.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Descricao;
	}

	private JPanel getJPanel_Identificacao() {
		if (jPanel_Identificacao == null) {
			jLabel_Identificacao = new JLabel();
			jLabel_Identificacao.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Identificacao.setText("Identificao dos objectivos e metas do projecto");
			jLabel_Identificacao.setFont(fmeFrame.letra_bold);

			jPanel_Identificacao = new JPanel();
			jPanel_Identificacao.setLayout(null);
			jPanel_Identificacao.setBounds(new Rectangle(15, 50+1*(area_height+62), 640, area_height+52));
			jPanel_Identificacao.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Identificacao.setName("identificacao_texto");
			jPanel_Identificacao.add(jLabel_Identificacao, null);
			jPanel_Identificacao.add(getJScrollPane_Identificacao(), null);
		}
		return jPanel_Identificacao;
	}
	private JScrollPane getJScrollPane_Identificacao() {
		if (jScrollPane_Identificacao == null) {
			jScrollPane_Identificacao = new JScrollPane();
			jScrollPane_Identificacao.setBounds(new Rectangle(15, 35, 609, area_height));
			jScrollPane_Identificacao.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Identificacao.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Identificacao.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Identificacao.setViewportView(getJTextArea_Identificacao());
		}
		return jScrollPane_Identificacao;
	}
	public JTextArea getJTextArea_Identificacao() {
		if (jTextArea_Identificacao == null) {
			jTextArea_Identificacao = new JTextArea();
			jTextArea_Identificacao.setFont(fmeFrame.letra);
			jTextArea_Identificacao.setLineWrap(true);
			jTextArea_Identificacao.setWrapStyleWord(true);
			jTextArea_Identificacao.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Identificacao;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_Descricao.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.CaractProj1.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.CaractProj1.validar_1(null));
		grp.add_grp(CBData.CaractProj1.validar_2(null));
		return grp;
	}
}
