package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Centros extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_RHumIDT = null;
	private JLabel jLabel_RHumIDT = null;
	private JScrollPane jScrollPane_RHumIDT = null;
	private JTable_Tip jTable_RHumIDT = null;

	private JPanel jPanel_DespesasIDT = null;
	private JLabel jLabel_DespesasIDT = null;
	private JScrollPane jScrollPane_DespesasIDT = null;
	private JTable_Tip jTable_DespesasIDT = null;

	private JPanel jPanel_ServicosIDT = null;
	private JLabel jLabel_ServicosIDT = null;
	private JScrollPane jScrollPane_ServicosIDT = null;
	private JTable_Tip jTable_ServicosIDT = null;

	private JPanel jPanel_ProjQuadroIDT = null;
	private JLabel jLabel_ProjQuadroIDT = null;
	private JScrollPane jScrollPane_ProjQuadroIDT = null;
	private JTable_Tip jTable_ProjQuadroIDT = null;

	String tag = "";  //  @jve:decl-index=0:
	
	public Frame_Centros() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,710);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_RHumIDT, 40);		
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   DADOS DO PROJECTO");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_RHumIDT(), null);
			jContentPane.add(getJPanel_DespesasIDT(), null);
			jContentPane.add(getJPanel_ServicosIDT(), null);
			jContentPane.add(getJPanel_ProjQuadroIDT(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_RHumIDT() {
		if (jPanel_RHumIDT == null) {
			jLabel_RHumIDT = new JLabel();
			jLabel_RHumIDT.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_RHumIDT.setText("<html>Recursos Humanos de I&D (n.)</html>");
			jLabel_RHumIDT.setFont(fmeFrame.letra_bold);			
			jPanel_RHumIDT = new JPanel();
			jPanel_RHumIDT.setLayout(null);
			jPanel_RHumIDT.setBounds(new Rectangle(15, 50, 640, 150));
			jPanel_RHumIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_RHumIDT.add(jLabel_RHumIDT, null);
			jPanel_RHumIDT.add(getJScrollPane_RHumIDT(), null);
		}
		return jPanel_RHumIDT;
	}
	
	public JScrollPane getJScrollPane_RHumIDT() {
		if (jScrollPane_RHumIDT == null) {
			jScrollPane_RHumIDT = new JScrollPane();
			jScrollPane_RHumIDT.setBounds(new Rectangle(16, 36, 606, 100));
			jScrollPane_RHumIDT.setViewportView(getJTable_RHumIDT());
			jScrollPane_RHumIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_RHumIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_RHumIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_RHumIDT;
	}
	
	public JTable getJTable_RHumIDT() {
		if (jTable_RHumIDT == null) {
			//jTable_RHumIDT = new JTable_Tip(25);
			jTable_RHumIDT = new JTable_Tip(25, jScrollPane_RHumIDT.getWidth());
			jTable_RHumIDT.setFont(fmeFrame.letra);
			jTable_RHumIDT.setRowHeight(18);
			jTable_RHumIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_RHumIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_RHumIDT;
	}
	
	private JPanel getJPanel_DespesasIDT() {
		if (jPanel_DespesasIDT == null) {
			jLabel_DespesasIDT = new JLabel();
			jLabel_DespesasIDT.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_DespesasIDT.setText("<html>Despesas de I&D intramuros</html>");
			jLabel_DespesasIDT.setFont(fmeFrame.letra_bold);			
			jPanel_DespesasIDT = new JPanel();
			jPanel_DespesasIDT.setLayout(null);
			jPanel_DespesasIDT.setBounds(new Rectangle(15, 210, 640, 190));
			jPanel_DespesasIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_DespesasIDT.add(jLabel_DespesasIDT, null);
			jPanel_DespesasIDT.add(getJScrollPane_DespesasIDT(), null);
		}
		return jPanel_DespesasIDT;
	}
	
	public JScrollPane getJScrollPane_DespesasIDT() {
		if (jScrollPane_DespesasIDT == null) {
			jScrollPane_DespesasIDT = new JScrollPane();
			jScrollPane_DespesasIDT.setBounds(new Rectangle(16, 36, 606, 137));
			jScrollPane_DespesasIDT.setViewportView(getJTable_DespesasIDT());
			//jScrollPane_DespesasIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_DespesasIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_DespesasIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_DespesasIDT;
	}
	
	public JTable getJTable_DespesasIDT() {
		if (jTable_DespesasIDT == null) {
			//jTable_DespesasIDT = new JTable_Tip(25);
			jTable_DespesasIDT = new JTable_Tip(25, jScrollPane_DespesasIDT.getWidth());
			jTable_DespesasIDT.setFont(fmeFrame.letra);
			jTable_DespesasIDT.setRowHeight(18);
			jTable_DespesasIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_DespesasIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_DespesasIDT;
	}

	private JPanel getJPanel_ServicosIDT() {
		if (jPanel_ServicosIDT == null) {
			jLabel_ServicosIDT = new JLabel();
			jLabel_ServicosIDT.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_ServicosIDT.setText("<html>Aquisio de servios de I&D a Instituies SCT</html>");
			jLabel_ServicosIDT.setFont(fmeFrame.letra_bold);			
			jPanel_ServicosIDT = new JPanel();
			jPanel_ServicosIDT.setLayout(null);
			jPanel_ServicosIDT.setBounds(new Rectangle(15, 410, 640, 130));
			jPanel_ServicosIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ServicosIDT.add(jLabel_ServicosIDT, null);
			jPanel_ServicosIDT.add(getJScrollPane_ServicosIDT(), null);
		}
		return jPanel_ServicosIDT;
	}
	
	public JScrollPane getJScrollPane_ServicosIDT() {
		if (jScrollPane_ServicosIDT == null) {
			jScrollPane_ServicosIDT = new JScrollPane();
			jScrollPane_ServicosIDT.setBounds(new Rectangle(16, 36, 606, 82));
			jScrollPane_ServicosIDT.setViewportView(getJTable_ServicosIDT());
			//jScrollPane_ServicosIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ServicosIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_ServicosIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ServicosIDT;
	}
	
	public JTable getJTable_ServicosIDT() {
		if (jTable_ServicosIDT == null) {
			//jTable_ServicosIDT = new JTable_Tip(25);
			jTable_ServicosIDT = new JTable_Tip(25, jScrollPane_ServicosIDT.getWidth());
			jTable_ServicosIDT.setFont(fmeFrame.letra);
			jTable_ServicosIDT.setRowHeight(18);
			jTable_ServicosIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ServicosIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ServicosIDT;
	}
	
	private JPanel getJPanel_ProjQuadroIDT() {
		if (jPanel_ProjQuadroIDT == null) {
			jLabel_ProjQuadroIDT = new JLabel();
			jLabel_ProjQuadroIDT.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_ProjQuadroIDT.setText("<html>Projectos do Programa Quadro da UE</html>");
			jLabel_ProjQuadroIDT.setFont(fmeFrame.letra_bold);			
			jPanel_ProjQuadroIDT = new JPanel();
			jPanel_ProjQuadroIDT.setLayout(null);
			jPanel_ProjQuadroIDT.setBounds(new Rectangle(15, 550, 640, 150));
			jPanel_ProjQuadroIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ProjQuadroIDT.add(jLabel_ProjQuadroIDT, null);
			jPanel_ProjQuadroIDT.add(getJScrollPane_ProjQuadroIDT(), null);
		}
		return jPanel_ProjQuadroIDT;
	}
	
	public JScrollPane getJScrollPane_ProjQuadroIDT() {
		if (jScrollPane_ProjQuadroIDT == null) {
			jScrollPane_ProjQuadroIDT = new JScrollPane();
			jScrollPane_ProjQuadroIDT.setBounds(new Rectangle(16, 36, 606, 101));
			jScrollPane_ProjQuadroIDT.setViewportView(getJTable_ProjQuadroIDT());
			//jScrollPane_ProjQuadroIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ProjQuadroIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_ProjQuadroIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ProjQuadroIDT;
	}
	
	public JTable getJTable_ProjQuadroIDT() {
		if (jTable_ProjQuadroIDT == null) {
			//jTable_ProjQuadroIDT = new JTable_Tip(25);
			jTable_ProjQuadroIDT = new JTable_Tip(25, jScrollPane_ProjQuadroIDT.getWidth());
			jTable_ProjQuadroIDT.setFont(fmeFrame.letra);
			jTable_ProjQuadroIDT.setRowHeight(18);
			jTable_ProjQuadroIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ProjQuadroIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ProjQuadroIDT;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		//print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_ProjQuadroIDT.getWidth() - jScrollPane_ProjQuadroIDT.getWidth();
		int w = jPanel_ProjQuadroIDT.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.RHumIDT.Clear();
		CBData.DespesasIDT.Clear();
		CBData.ServicosIDT.Clear();
		CBData.ProjQuadroIDT.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		//grp.add_grp(CBData.RHumIDT.validar(null, ""));
		//grp.add_grp(CBData.DespesasIDT.validar(null, ""));
		//grp.add_grp(CBData.ServicosIDT.validar(null, ""));
		//grp.add_grp(CBData.ProjQuadroIDT.validar(null, ""));
		return grp;
	}

}		
