package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Centros_2 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_PropIntelectual = null;
	private JLabel jLabel_PropIntelectual = null;
	private JScrollPane jScrollPane_PropIntelectual = null;
	private JTable_Tip jTable_PropIntelectual = null;

	private JPanel jPanel_BalTecnol = null;
	private JLabel jLabel_BalTecnol = null;
	private JScrollPane jScrollPane_BalTecnol = null;
	private JTable_Tip jTable_BalTecnol = null;

	private JPanel jPanel_OutrosIndic = null;
	private JLabel jLabel_aviso = null;
	private JLabel jLabel_OutrosIndic = null;
	private JScrollPane jScrollPane_OutrosIndic = null;
	private JTable_Tip jTable_OutrosIndic = null;

	private JTable_Tip jTable_ProjQuadroIDT = null;

	String tag = "";  //  @jve:decl-index=0:
	
	public Frame_Centros_2() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(1316,675);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_PropIntelectual, 40);		
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	private void initialize() {
		this.setSize(1370, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   DADOS DO PROJECTO");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_PropIntelectual(), null);
			jContentPane.add(getJPanel_BalTecnol(), null);
			jContentPane.add(getJPanel_OutrosIndic(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_PropIntelectual() {
		if (jPanel_PropIntelectual == null) {
			jLabel_PropIntelectual = new JLabel();
			jLabel_PropIntelectual.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_PropIntelectual.setText("<html>Propriedade Intelectual</html>");
			jLabel_PropIntelectual.setFont(fmeFrame.letra_bold);			
			jPanel_PropIntelectual = new JPanel();
			jPanel_PropIntelectual.setLayout(null);
			jPanel_PropIntelectual.setBounds(new Rectangle(15, 50, 640, 209));
			jPanel_PropIntelectual.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PropIntelectual.add(jLabel_PropIntelectual, null);
			jPanel_PropIntelectual.add(getJScrollPane_PropIntelectual(), null);
		}
		return jPanel_PropIntelectual;
	}
	
	public JScrollPane getJScrollPane_PropIntelectual() {
		if (jScrollPane_PropIntelectual == null) {
			jScrollPane_PropIntelectual = new JScrollPane();
			jScrollPane_PropIntelectual.setBounds(new Rectangle(16, 36, 606, 158));
			jScrollPane_PropIntelectual.setViewportView(getJTable_PropIntelectual());
			//jScrollPane_PropIntelectual.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_PropIntelectual.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_PropIntelectual.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_PropIntelectual;
	}
	
	public JTable getJTable_PropIntelectual() {
		if (jTable_PropIntelectual == null) {
			//jTable_PropIntelectual = new JTable_Tip(25);
			jTable_PropIntelectual = new JTable_Tip(25, jScrollPane_PropIntelectual.getWidth());
			jTable_PropIntelectual.setFont(fmeFrame.letra);
			jTable_PropIntelectual.setRowHeight(18);
			jTable_PropIntelectual.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_PropIntelectual.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_PropIntelectual;
	}
	
	private JPanel getJPanel_BalTecnol() {
		if (jPanel_BalTecnol == null) {
			jLabel_BalTecnol = new JLabel();
			jLabel_BalTecnol.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_BalTecnol.setText("<html>Balana Tecnolgica com o estrangeiro</html>");
			jLabel_BalTecnol.setFont(fmeFrame.letra_bold);			
			jPanel_BalTecnol = new JPanel();
			jPanel_BalTecnol.setLayout(null);
			jPanel_BalTecnol.setBounds(new Rectangle(15, 269, 1296, 235));
			jPanel_BalTecnol.setBorder(BorderFactory.createEtchedBorder());
			jPanel_BalTecnol.add(jLabel_BalTecnol, null);
			jPanel_BalTecnol.add(getJScrollPane_BalTecnol(), null);
		}
		return jPanel_BalTecnol;
	}
	
	public JScrollPane getJScrollPane_BalTecnol() {
		if (jScrollPane_BalTecnol == null) {
			jScrollPane_BalTecnol = new JScrollPane();
			jScrollPane_BalTecnol.setBounds(new Rectangle(16, 36, 1266, 187));
			jScrollPane_BalTecnol.setViewportView(getJTable_BalTecnol());
			jScrollPane_BalTecnol.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_BalTecnol.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_BalTecnol.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_BalTecnol;
	}
	
	public JTable getJTable_BalTecnol() {
		if (jTable_BalTecnol == null) {
			//jTable_BalTecnol = new JTable_Tip(25);
			jTable_BalTecnol = new JTable_Tip(40, jScrollPane_BalTecnol.getWidth());
			jTable_BalTecnol.setFont(fmeFrame.letra);
			jTable_BalTecnol.setRowHeight(18);
			jTable_BalTecnol.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_BalTecnol.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_BalTecnol;
	}

	private JPanel getJPanel_OutrosIndic() {
		if (jPanel_OutrosIndic == null) {
			jLabel_aviso= new JLabel();
			jLabel_aviso.setBounds(new Rectangle(17, 119, 604, 27));
			jLabel_aviso.setText("<html>(1) Peso das vendas e prestao de servios de produtos/processos/servios desenvolvidos nos 3 anos anteriores no volume de facturao total da empresa</html>");
			jLabel_aviso.setFont(fmeFrame.letra_pequena);
			jLabel_aviso.setHorizontalAlignment(SwingConstants.RIGHT);

			jLabel_OutrosIndic = new JLabel();
			jLabel_OutrosIndic.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_OutrosIndic.setText("<html>Outros indicadores de resultados</html>");
			jLabel_OutrosIndic.setFont(fmeFrame.letra_bold);			
			jPanel_OutrosIndic = new JPanel();
			jPanel_OutrosIndic.setLayout(null);
			jPanel_OutrosIndic.setBounds(new Rectangle(15, 514, 640, 149));
			jPanel_OutrosIndic.setBorder(BorderFactory.createEtchedBorder());
			jPanel_OutrosIndic.add(jLabel_OutrosIndic, null);
			jPanel_OutrosIndic.add(jLabel_aviso, null);
			jPanel_OutrosIndic.add(getJScrollPane_OutrosIndic(), null);
		}
		return jPanel_OutrosIndic;
	}
	
	public JScrollPane getJScrollPane_OutrosIndic() {
		if (jScrollPane_OutrosIndic == null) {
			jScrollPane_OutrosIndic = new JScrollPane();
			jScrollPane_OutrosIndic.setBounds(new Rectangle(16, 36, 606, 82));
			jScrollPane_OutrosIndic.setViewportView(getJTable_OutrosIndic());
			//jScrollPane_OutrosIndic.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_OutrosIndic.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_OutrosIndic.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_OutrosIndic;
	}
	
	public JTable getJTable_OutrosIndic() {
		if (jTable_OutrosIndic == null) {
			//jTable_OutrosIndic = new JTable_Tip(25);
			jTable_OutrosIndic = new JTable_Tip(25, jScrollPane_OutrosIndic.getWidth());
			jTable_OutrosIndic.setFont(fmeFrame.letra);
			jTable_OutrosIndic.setRowHeight(18);
			jTable_OutrosIndic.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_OutrosIndic.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_OutrosIndic;
	}
	



	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_BalTecnol.getWidth() - jScrollPane_BalTecnol.getWidth();
		int w = jPanel_BalTecnol.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.PropIntelectual.Clear();
		CBData.BalTecnol.Clear();
		CBData.OutrosIndic.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		//grp.add_grp(CBData.PropIntelectual.validar(null, ""));
		//grp.add_grp(CBData.BalTecnol.validar(null, ""));
		//grp.add_grp(CBData.OutrosIndic.validar(null, ""));
		return grp;
	}

}		
