package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_CurricIDT extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_ProdIDT = null;
	private JLabel jLabel_ProdIDT = null;
	private JScrollPane jScrollPane_ProdIDT = null;
	private JTable_Tip jTable_ProdIDT = null;
	private JButton jButton_ProdIDTCopy = null;
	private JButton jButton_ProdIDTUp = null;
	private JButton jButton_ProdIDTAdd = null;
	private JButton jButton_ProdIDTIns = null;
	private JButton jButton_ProdIDTDel = null;

	private JPanel jPanel_InovaIDT = null;
	private JLabel jLabel_InovaIDT = null;
	private JScrollPane jScrollPane_InovaIDT = null;
	private JTable_Tip jTable_InovaIDT = null;
	private JButton jButton_InovaIDTCopy = null;
	private JButton jButton_InovaIDTUp = null;
	private JButton jButton_InovaIDTAdd = null;
	private JButton jButton_InovaIDTIns = null;
	private JButton jButton_InovaIDTDel = null;

	private JPanel jPanel_RegPropIDT = null;
	private JLabel jLabel_RegPropIDT = null;
	private JScrollPane jScrollPane_RegPropIDT = null;
	private JTable_Tip jTable_RegPropIDT = null;
	private JButton jButton_RegPropIDTCopy = null;
	private JButton jButton_RegPropIDTUp = null;
	private JButton jButton_RegPropIDTAdd = null;
	private JButton jButton_RegPropIDTIns = null;
	private JButton jButton_RegPropIDTDel = null;

	private JPanel jPanel_OutrasIDT = null;
	private JLabel jLabel_OutrasIDT = null;
	private JScrollPane jScrollPane_OutrasIDT = null;
	private JTextArea jTextArea_OutrasIDT = null;

	String tag = "";

	public Frame_CurricIDT() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,1065);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_ProdIDT, 30);
		up_component(jPanel_InovaIDT, 30);
		up_component(jPanel_RegPropIDT, 30);
		up_component(jPanel_OutrasIDT, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1200);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROMOTOR");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_ProdIDT(), null);
			jContentPane.add(getJPanel_InovaIDT(), null);
			jContentPane.add(getJPanel_RegPropIDT(), null);
			jContentPane.add(getJPanel_OutrasIDT(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_ProdIDT() {
		if (jPanel_ProdIDT == null) {
			jLabel_ProdIDT = new JLabel();
			jLabel_ProdIDT.setBounds(new Rectangle(12, 10, 418, 18));
			jLabel_ProdIDT.setText("Novos produtos lanados pela empresa nos ltimos trs anos");
			jLabel_ProdIDT.setFont(fmeFrame.letra_bold);

			jButton_ProdIDTCopy = new JButton(fmeFrame.copiarLinha);
			jButton_ProdIDTCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProdIDTCopy.addMouseListener(new Frame_CurricIDT_jButton_ProdIDTCopy_mouseAdapter(this));
			jButton_ProdIDTCopy.setToolTipText("Copiar Linha");
			jButton_ProdIDTCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_ProdIDTUp = new JButton(fmeFrame.subirLinha);
			jButton_ProdIDTUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProdIDTUp.addMouseListener(new Frame_CurricIDT_jButton_ProdIDTUp_mouseAdapter(this));
			jButton_ProdIDTUp.setToolTipText("Trocar Linhas");
			jButton_ProdIDTUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_ProdIDTAdd = new JButton(fmeFrame.novaLinha);
			jButton_ProdIDTAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProdIDTAdd.addMouseListener(new Frame_CurricIDT_jButton_ProdIDTAdd_mouseAdapter(this));
			jButton_ProdIDTAdd.setToolTipText("Nova Linha");
			jButton_ProdIDTAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_ProdIDTIns = new JButton(fmeFrame.inserirLinha);
			jButton_ProdIDTIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProdIDTIns.addMouseListener(new Frame_CurricIDT_jButton_ProdIDTIns_mouseAdapter(this));
			jButton_ProdIDTIns.setToolTipText("Inserir Linha");
			jButton_ProdIDTIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_ProdIDTDel = new JButton(fmeFrame.apagarLinha);
			jButton_ProdIDTDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_ProdIDTDel.addMouseListener(new Frame_CurricIDT_jButton_ProdIDTDel_mouseAdapter(this));
			jButton_ProdIDTDel.setToolTipText("Apagar Linha");
			jButton_ProdIDTDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_ProdIDT = new JPanel();
			jPanel_ProdIDT.setLayout(null);
			jPanel_ProdIDT.setBounds(new Rectangle(15, 50, 640, 170));
			jPanel_ProdIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_ProdIDT.add(jLabel_ProdIDT, null);
			jPanel_ProdIDT.add(jButton_ProdIDTCopy, null);
			jPanel_ProdIDT.add(jButton_ProdIDTUp, null);
			jPanel_ProdIDT.add(jButton_ProdIDTAdd, null);
			jPanel_ProdIDT.add(jButton_ProdIDTIns, null);
			jPanel_ProdIDT.add(jButton_ProdIDTDel, null);
			jPanel_ProdIDT.add(getJScrollPane_ProdIDT(), null);
		}
		return jPanel_ProdIDT;
	}
	public JScrollPane getJScrollPane_ProdIDT() {
		if (jScrollPane_ProdIDT == null) {
			jScrollPane_ProdIDT = new JScrollPane();
			jScrollPane_ProdIDT.setBounds(new Rectangle(16, 36, 606, 121));
			jScrollPane_ProdIDT.setViewportView(getJTable_ProdIDT());
			jScrollPane_ProdIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_ProdIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_ProdIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_ProdIDT;
	}
	public JTable getJTable_ProdIDT() {
		if (jTable_ProdIDT == null) {
			jTable_ProdIDT = new JTable_Tip(45, jScrollPane_ProdIDT.getWidth());
			jTable_ProdIDT.setFont(fmeFrame.letra);
			jTable_ProdIDT.setRowHeight(18);
			jTable_ProdIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_ProdIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_ProdIDT;
	}
	void jButton_ProdIDTCopy_mouseClicked(MouseEvent e) {
		CBData.ProdIDT.on_copy_row();
	}
	void jButton_ProdIDTUp_mouseClicked(MouseEvent e) {
		CBData.ProdIDT.on_up_row();
	}
	void jButton_ProdIDTAdd_mouseClicked(MouseEvent e) {
		CBData.ProdIDT.on_add_row();
	}
	void jButton_ProdIDTDel_mouseClicked(MouseEvent e) {
		CBData.ProdIDT.on_del_row();
	}
	void jButton_ProdIDTIns_mouseClicked(MouseEvent e) {
		CBData.ProdIDT.on_ins_row();
	}

	private JPanel getJPanel_InovaIDT() {
		if (jPanel_InovaIDT == null) {
			jLabel_InovaIDT = new JLabel();
			jLabel_InovaIDT.setBounds(new Rectangle(12, 10, 418, 18));
			jLabel_InovaIDT.setText("Outras inovaes introduzidas pela empresa nos ltimos trs anos");
			jLabel_InovaIDT.setFont(fmeFrame.letra_bold);

			jButton_InovaIDTCopy = new JButton(fmeFrame.copiarLinha);
			jButton_InovaIDTCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_InovaIDTCopy.addMouseListener(new Frame_CurricIDT_jButton_InovaIDTCopy_mouseAdapter(this));
			jButton_InovaIDTCopy.setToolTipText("Copiar Linha");
			jButton_InovaIDTCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_InovaIDTUp = new JButton(fmeFrame.subirLinha);
			jButton_InovaIDTUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_InovaIDTUp.addMouseListener(new Frame_CurricIDT_jButton_InovaIDTUp_mouseAdapter(this));
			jButton_InovaIDTUp.setToolTipText("Trocar Linhas");
			jButton_InovaIDTUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_InovaIDTAdd = new JButton(fmeFrame.novaLinha);
			jButton_InovaIDTAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_InovaIDTAdd.addMouseListener(new Frame_CurricIDT_jButton_InovaIDTAdd_mouseAdapter(this));
			jButton_InovaIDTAdd.setToolTipText("Nova Linha");
			jButton_InovaIDTAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_InovaIDTIns = new JButton(fmeFrame.inserirLinha);
			jButton_InovaIDTIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_InovaIDTIns.addMouseListener(new Frame_CurricIDT_jButton_InovaIDTIns_mouseAdapter(this));
			jButton_InovaIDTIns.setToolTipText("Inserir Linha");
			jButton_InovaIDTIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_InovaIDTDel = new JButton(fmeFrame.apagarLinha);
			jButton_InovaIDTDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_InovaIDTDel.addMouseListener(new Frame_CurricIDT_jButton_InovaIDTDel_mouseAdapter(this));
			jButton_InovaIDTDel.setToolTipText("Apagar Linha");
			jButton_InovaIDTDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_InovaIDT = new JPanel();
			jPanel_InovaIDT.setLayout(null);
			jPanel_InovaIDT.setBounds(new Rectangle(15, 230, 640, 170));
			jPanel_InovaIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_InovaIDT.add(jLabel_InovaIDT, null);
			jPanel_InovaIDT.add(jButton_InovaIDTCopy, null);
			jPanel_InovaIDT.add(jButton_InovaIDTUp, null);
			jPanel_InovaIDT.add(jButton_InovaIDTAdd, null);
			jPanel_InovaIDT.add(jButton_InovaIDTIns, null);
			jPanel_InovaIDT.add(jButton_InovaIDTDel, null);
			jPanel_InovaIDT.add(getJScrollPane_InovaIDT(), null);
		}
		return jPanel_InovaIDT;
	}
	public JScrollPane getJScrollPane_InovaIDT() {
		if (jScrollPane_InovaIDT == null) {
			jScrollPane_InovaIDT = new JScrollPane();
			jScrollPane_InovaIDT.setBounds(new Rectangle(16, 36, 606, 121));
			jScrollPane_InovaIDT.setViewportView(getJTable_InovaIDT());
			jScrollPane_InovaIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_InovaIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_InovaIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_InovaIDT;
	}
	public JTable getJTable_InovaIDT() {
		if (jTable_InovaIDT == null) {
			jTable_InovaIDT = new JTable_Tip(45, jScrollPane_InovaIDT.getWidth());
			jTable_InovaIDT.setFont(fmeFrame.letra);
			jTable_InovaIDT.setRowHeight(18);
			jTable_InovaIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_InovaIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_InovaIDT;
	}
	void jButton_InovaIDTCopy_mouseClicked(MouseEvent e) {
		CBData.InovaIDT.on_copy_row();
	}
	void jButton_InovaIDTUp_mouseClicked(MouseEvent e) {
		CBData.InovaIDT.on_up_row();
	}
	void jButton_InovaIDTAdd_mouseClicked(MouseEvent e) {
		CBData.InovaIDT.on_add_row();
	}
	void jButton_InovaIDTDel_mouseClicked(MouseEvent e) {
		CBData.InovaIDT.on_del_row();
	}
	void jButton_InovaIDTIns_mouseClicked(MouseEvent e) {
		CBData.InovaIDT.on_ins_row();
	}

	private JPanel getJPanel_RegPropIDT() {
		if (jPanel_RegPropIDT == null) {
			jLabel_RegPropIDT = new JLabel();
			jLabel_RegPropIDT.setBounds(new Rectangle(12, 10, 418, 18));
			jLabel_RegPropIDT.setText("Registo de Propriedade Intelectual");
			jLabel_RegPropIDT.setFont(fmeFrame.letra_bold);

			jButton_RegPropIDTCopy = new JButton(fmeFrame.copiarLinha);
			jButton_RegPropIDTCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_RegPropIDTCopy.addMouseListener(new Frame_CurricIDT_jButton_RegPropIDTCopy_mouseAdapter(this));
			jButton_RegPropIDTCopy.setToolTipText("Copiar Linha");
			jButton_RegPropIDTCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_RegPropIDTUp = new JButton(fmeFrame.subirLinha);
			jButton_RegPropIDTUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_RegPropIDTUp.addMouseListener(new Frame_CurricIDT_jButton_RegPropIDTUp_mouseAdapter(this));
			jButton_RegPropIDTUp.setToolTipText("Trocar Linhas");
			jButton_RegPropIDTUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_RegPropIDTAdd = new JButton(fmeFrame.novaLinha);
			jButton_RegPropIDTAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_RegPropIDTAdd.addMouseListener(new Frame_CurricIDT_jButton_RegPropIDTAdd_mouseAdapter(this));
			jButton_RegPropIDTAdd.setToolTipText("Nova Linha");
			jButton_RegPropIDTAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_RegPropIDTIns = new JButton(fmeFrame.inserirLinha);
			jButton_RegPropIDTIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_RegPropIDTIns.addMouseListener(new Frame_CurricIDT_jButton_RegPropIDTIns_mouseAdapter(this));
			jButton_RegPropIDTIns.setToolTipText("Inserir Linha");
			jButton_RegPropIDTIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_RegPropIDTDel = new JButton(fmeFrame.apagarLinha);
			jButton_RegPropIDTDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_RegPropIDTDel.addMouseListener(new Frame_CurricIDT_jButton_RegPropIDTDel_mouseAdapter(this));
			jButton_RegPropIDTDel.setToolTipText("Apagar Linha");
			jButton_RegPropIDTDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_RegPropIDT = new JPanel();
			jPanel_RegPropIDT.setLayout(null);
			jPanel_RegPropIDT.setBounds(new Rectangle(15, 410, 640, 165));
			jPanel_RegPropIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_RegPropIDT.add(jLabel_RegPropIDT, null);
			jPanel_RegPropIDT.add(jButton_RegPropIDTCopy, null);
			jPanel_RegPropIDT.add(jButton_RegPropIDTUp, null);
			jPanel_RegPropIDT.add(jButton_RegPropIDTAdd, null);
			jPanel_RegPropIDT.add(jButton_RegPropIDTIns, null);
			jPanel_RegPropIDT.add(jButton_RegPropIDTDel, null);
			jPanel_RegPropIDT.add(getJScrollPane_RegPropIDT(), null);
		}
		return jPanel_RegPropIDT;
	}
	public JScrollPane getJScrollPane_RegPropIDT() {
		if (jScrollPane_RegPropIDT == null) {
			jScrollPane_RegPropIDT = new JScrollPane();
			jScrollPane_RegPropIDT.setBounds(new Rectangle(16, 36, 606, 116));
			jScrollPane_RegPropIDT.setViewportView(getJTable_RegPropIDT());
			jScrollPane_RegPropIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_RegPropIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_RegPropIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_RegPropIDT;
	}
	public JTable getJTable_RegPropIDT() {
		if (jTable_RegPropIDT == null) {
			jTable_RegPropIDT = new JTable_Tip(40, jScrollPane_RegPropIDT.getWidth());
			jTable_RegPropIDT.setFont(fmeFrame.letra);
			jTable_RegPropIDT.setRowHeight(18);
			jTable_RegPropIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_RegPropIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_RegPropIDT;
	}
	void jButton_RegPropIDTCopy_mouseClicked(MouseEvent e) {
		CBData.RegPropIDT.on_copy_row();
	}
	void jButton_RegPropIDTUp_mouseClicked(MouseEvent e) {
		CBData.RegPropIDT.on_up_row();
	}
	void jButton_RegPropIDTAdd_mouseClicked(MouseEvent e) {
		CBData.RegPropIDT.on_add_row();
	}
	void jButton_RegPropIDTDel_mouseClicked(MouseEvent e) {
		CBData.RegPropIDT.on_del_row();
	}
	void jButton_RegPropIDTIns_mouseClicked(MouseEvent e) {
		CBData.RegPropIDT.on_ins_row();
	}

	private JPanel getJPanel_OutrasIDT() {
		if (jPanel_OutrasIDT == null) {
			jLabel_OutrasIDT = new JLabel();
			jLabel_OutrasIDT.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_OutrasIDT.setText("Outras actividades de I&DT ou aspectos relevantes para o curriculum de inovao da empresa");
			jLabel_OutrasIDT.setFont(fmeFrame.letra_bold);

			jPanel_OutrasIDT = new JPanel();
			jPanel_OutrasIDT.setLayout(null);
			jPanel_OutrasIDT.setBounds(new Rectangle(15, 585, 640, 470));
			jPanel_OutrasIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_OutrasIDT.setName("outras_idt_texto");
			jPanel_OutrasIDT.add(jLabel_OutrasIDT, null);
			jPanel_OutrasIDT.add(getJScrollPane_OutrasIDT(), null);
		}
		return jPanel_OutrasIDT;
	}
	private JScrollPane getJScrollPane_OutrasIDT() {
		if (jScrollPane_OutrasIDT == null) {
			jScrollPane_OutrasIDT = new JScrollPane();
			jScrollPane_OutrasIDT.setBounds(new Rectangle(15, 35, 609, 420));
			jScrollPane_OutrasIDT.setPreferredSize(new Dimension(250, 250));
			jScrollPane_OutrasIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_OutrasIDT.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_OutrasIDT.setViewportView(getJTextArea_OutrasIDT());
		}
		return jScrollPane_OutrasIDT;
	}
	public JTextArea getJTextArea_OutrasIDT() {
		if (jTextArea_OutrasIDT == null) {
			jTextArea_OutrasIDT = new JTextArea();
			jTextArea_OutrasIDT.setFont(fmeFrame.letra);
			jTextArea_OutrasIDT.setLineWrap(true);
			jTextArea_OutrasIDT.setWrapStyleWord(true);
			jTextArea_OutrasIDT.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_OutrasIDT;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.30 * jPanel_ProdIDT.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.ProdIDT.Clear();
		CBData.InovaIDT.Clear();
		CBData.RegPropIDT.Clear();
		CBData.OutrasIDT.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.ProdIDT.validar(null));
		grp.add_grp(CBData.InovaIDT.validar(null));
		grp.add_grp(CBData.RegPropIDT.validar(null));
		grp.add_grp(CBData.OutrasIDT.validar(null));
		return grp;
	}
}

class Frame_CurricIDT_jButton_ProdIDTCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_ProdIDTCopy_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProdIDTCopy_mouseClicked(e);
	}	
}

class Frame_CurricIDT_jButton_ProdIDTUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_ProdIDTUp_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProdIDTUp_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_ProdIDTAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_ProdIDTAdd_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProdIDTAdd_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_ProdIDTDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_ProdIDTDel_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProdIDTDel_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_ProdIDTIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_ProdIDTIns_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_ProdIDTIns_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_InovaIDTCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_InovaIDTCopy_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_InovaIDTCopy_mouseClicked(e);
	}	
}

class Frame_CurricIDT_jButton_InovaIDTUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_InovaIDTUp_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_InovaIDTUp_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_InovaIDTAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_InovaIDTAdd_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_InovaIDTAdd_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_InovaIDTDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_InovaIDTDel_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_InovaIDTDel_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_InovaIDTIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_InovaIDTIns_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_InovaIDTIns_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_RegPropIDTCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_RegPropIDTCopy_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_RegPropIDTCopy_mouseClicked(e);
	}	
}

class Frame_CurricIDT_jButton_RegPropIDTUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;
	
	Frame_CurricIDT_jButton_RegPropIDTUp_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_RegPropIDTUp_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_RegPropIDTAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_RegPropIDTAdd_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_RegPropIDTAdd_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_RegPropIDTDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_RegPropIDTDel_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_RegPropIDTDel_mouseClicked(e);
	}
}

class Frame_CurricIDT_jButton_RegPropIDTIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_CurricIDT adaptee;

	Frame_CurricIDT_jButton_RegPropIDTIns_mouseAdapter(Frame_CurricIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_RegPropIDTIns_mouseClicked(e);
	}
}
