package fme;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.BorderFactory;
import java.awt.Color;

public class Frame_CurricTec extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_CurricTec = null;
	private JLabel jLabel_CurricTec = null;
	private JLabel jLabel_NIF = null;
	private JTextField jTextField_NIF = null;
	private JLabel jLabel_Nome = null;
	private JTextField jTextField_Nome = null;
	private JLabel jLabel_Bolseiro = null;
	private JCheckBox jCheckBox_BolseiroSim = null;
	private JCheckBox jCheckBox_BolseiroNao = null;
	public JCheckBox jCheckBox_BolseiroClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Bolseiro = null;
	private JLabel jLabel_VincFP = null;
	private JCheckBox jCheckBox_VincFPSim = null;
	private JCheckBox jCheckBox_VincFPNao = null;
	public JCheckBox jCheckBox_VincFPClear = new JCheckBox();
	private ButtonGroup jButtonGroup_VincFP = null;
	private JLabel jLabel_TipoVFP = null;
	private JTextField jTextField_TipoVFP = null;
	private JLabel jLabel_FormAcad = null;
	private JScrollPane jScrollPane_FormAcad = null;
	private JTextArea jTextArea_FormAcad = null;
	private JLabel jLabel_FormProf = null;
	private JScrollPane jScrollPane_FormProf = null;
	private JTextArea jTextArea_FormProf = null;
	private JLabel jLabel_Funcao = null;
	private JScrollPane jScrollPane_Funcao = null;
	private JTextArea jTextArea_Funcao = null;
	private JLabel jLabel_Chefia = null;
	private JCheckBox jCheckBox_ChefiaSim = null;
	private JCheckBox jCheckBox_ChefiaNao = null;
	public JCheckBox jCheckBox_ChefiaClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Chefia = null;
	private JLabel jLabel_Tarefa = null;
	private JScrollPane jScrollPane_Tarefa = null;
	private JTextArea jTextArea_Tarefa = null;

	private JPanel jPanel_Passado = null;
	private JLabel jLabel_Passado = null;
	private JScrollPane jScrollPane_Passado = null;
	private JTextArea jTextArea_Passado = null;

	CBRegisto_CurricTec CBData_CurricTec = null;
	String tag = "";

	public Frame_CurricTec() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,755);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_CurricTec, 30);
		up_component(jPanel_Passado, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_CurricTec(), null);
			jContentPane.add(getJPanel_Passado(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_CurricTec() {
		if (jPanel_CurricTec == null) {
			jLabel_CurricTec = new JLabel();
			jLabel_CurricTec.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_CurricTec.setText("Curricula dos tcnicos afectos ao projecto");
			jLabel_CurricTec.setFont(fmeFrame.letra_bold);

			jLabel_NIF = new JLabel();
			jLabel_NIF.setBounds(new Rectangle(22, 36, 52, 18));
			jLabel_NIF.setText("NIF");
			jLabel_NIF.setFont(fmeFrame.letra);
			jLabel_Nome = new JLabel();
			jLabel_Nome.setBounds(new Rectangle(22, 62, 52, 18));
			jLabel_Nome.setText("Nome");
			jLabel_Nome.setFont(fmeFrame.letra);
			jLabel_Bolseiro = new JLabel();
			jLabel_Bolseiro.setBounds(new Rectangle(22, 88, 52, 18));
			jLabel_Bolseiro.setText("Bolseiro");
			jLabel_Bolseiro.setFont(fmeFrame.letra);
			jLabel_VincFP = new JLabel();
			jLabel_VincFP.setBounds(new Rectangle(22, 114, 154, 18));
			jLabel_VincFP.setText("Vnculo  Funo Pblica");
			jLabel_VincFP.setFont(fmeFrame.letra);
			jLabel_TipoVFP = new JLabel();
			jLabel_TipoVFP.setBounds(new Rectangle(313, 114, 185, 18));
			jLabel_TipoVFP.setText("Caso afirmativo, que tipo de vnculo?");
			jLabel_TipoVFP.setFont(fmeFrame.letra);
			jLabel_FormAcad = new JLabel();
			jLabel_FormAcad.setBounds(new Rectangle(22, 140, 154, 18));
			jLabel_FormAcad.setText("Formao Acadmica");
			jLabel_FormAcad.setFont(fmeFrame.letra);
			jLabel_FormProf = new JLabel();
			jLabel_FormProf.setBounds(new Rectangle(22, 202, 154, 18));
			jLabel_FormProf.setText("Formao Profissional");
			jLabel_FormProf.setFont(fmeFrame.letra);
			jLabel_Funcao = new JLabel();
			jLabel_Funcao.setBounds(new Rectangle(22, 264, 154, 32));
			jLabel_Funcao.setText("<html>Funo exercida no promotor ou entidade contratada</html>");
			jLabel_Funcao.setFont(fmeFrame.letra);
			jLabel_Chefia = new JLabel();
			jLabel_Chefia.setBounds(new Rectangle(22, 326, 154, 18));
			jLabel_Chefia.setText("Exerccio de cargo de chefia");
			jLabel_Chefia.setFont(fmeFrame.letra);
			jLabel_Tarefa = new JLabel();
			jLabel_Tarefa.setBounds(new Rectangle(22, 352, 154, 32));
			jLabel_Tarefa.setText("<html>Tarefas desempenhadas antes do incio deste projecto</html>");
			jLabel_Tarefa.setFont(fmeFrame.letra);

			jPanel_CurricTec = new JPanel();
			jPanel_CurricTec.setLayout(null);
			jPanel_CurricTec.setBounds(new Rectangle(15, 50, 640, 422));
			jPanel_CurricTec.setBorder(BorderFactory.createEtchedBorder());
			jPanel_CurricTec.setName("curric_tec_texto");
			jPanel_CurricTec.add(jLabel_CurricTec, null);
			jPanel_CurricTec.add(jLabel_NIF, null);
			jPanel_CurricTec.add(getJTextField_NIF(), null);
			jPanel_CurricTec.add(jLabel_Nome, null);
			jPanel_CurricTec.add(getJTextField_Nome(), null);
			jPanel_CurricTec.add(jLabel_Bolseiro, null);
			jPanel_CurricTec.add(getJCheckBox_BolseiroSim());
			jPanel_CurricTec.add(getJCheckBox_BolseiroNao());
			this.getJButtonGroupBolseiro();
			jPanel_CurricTec.add(jLabel_VincFP, null);
			jPanel_CurricTec.add(getJCheckBox_VincFPSim());
			jPanel_CurricTec.add(getJCheckBox_VincFPNao());
			this.getJButtonGroupVincFP();
			jPanel_CurricTec.add(jLabel_TipoVFP, null);
			jPanel_CurricTec.add(getJTextField_TipoVFP(), null);
			jPanel_CurricTec.add(jLabel_FormAcad, null);
			jPanel_CurricTec.add(getJScrollPane_FormAcad(), null);
			jPanel_CurricTec.add(jLabel_FormProf, null);
			jPanel_CurricTec.add(getJScrollPane_FormProf(), null);
			jPanel_CurricTec.add(jLabel_Funcao, null);
			jPanel_CurricTec.add(getJScrollPane_Funcao(), null);
			jPanel_CurricTec.add(jLabel_Chefia, null);
			jPanel_CurricTec.add(getJCheckBox_ChefiaSim());
			jPanel_CurricTec.add(getJCheckBox_ChefiaNao());
			this.getJButtonGroupChefia();
			jPanel_CurricTec.add(jLabel_Tarefa, null);
			jPanel_CurricTec.add(getJScrollPane_Tarefa(), null);
		}
		return jPanel_CurricTec;
	}
	public JTextField getJTextField_NIF() {
		if (jTextField_NIF == null) {
			jTextField_NIF = new JTextField();
			jTextField_NIF.setBounds(new Rectangle(76, 36, 90, 18));
			jTextField_NIF.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_NIF.setFont(fmeFrame.letra);
		}
		return jTextField_NIF;
	}
	public JTextField getJTextField_Nome() {
		if (jTextField_Nome == null) {
			jTextField_Nome = new JTextField();
			jTextField_Nome.setBounds(new Rectangle(76, 62, 548, 18));
			jTextField_Nome.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Nome.setFont(fmeFrame.letra);
		}
		return jTextField_Nome;
	}
	public JCheckBox getJCheckBox_BolseiroSim() {
		if (jCheckBox_BolseiroSim == null) {
			jCheckBox_BolseiroSim = new JCheckBox();
			jCheckBox_BolseiroSim.setBounds(new Rectangle(76, 88, 50, 18));
			jCheckBox_BolseiroSim.setText("Sim");
			jCheckBox_BolseiroSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_BolseiroSim;
	}
	public JCheckBox getJCheckBox_BolseiroNao() {
		if (jCheckBox_BolseiroNao == null) {
			jCheckBox_BolseiroNao = new JCheckBox();
			jCheckBox_BolseiroNao.setBounds(new Rectangle(126, 88, 68, 18));
			jCheckBox_BolseiroNao.setText("No");
			jCheckBox_BolseiroNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_BolseiroNao;
	}
	private ButtonGroup getJButtonGroupBolseiro() {
		if (jButtonGroup_Bolseiro == null) {
			jButtonGroup_Bolseiro = new ButtonGroup();
			jButtonGroup_Bolseiro.add(jCheckBox_BolseiroSim);
			jButtonGroup_Bolseiro.add(jCheckBox_BolseiroNao);
			jButtonGroup_Bolseiro.add(jCheckBox_BolseiroClear);
		}
		return jButtonGroup_Bolseiro;
	}
	public JCheckBox getJCheckBox_VincFPSim() {
		if (jCheckBox_VincFPSim == null) {
			jCheckBox_VincFPSim = new JCheckBox();
			jCheckBox_VincFPSim.setBounds(new Rectangle(176, 114, 50, 18));
			jCheckBox_VincFPSim.setText("Sim");
			jCheckBox_VincFPSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_VincFPSim;
	}
	public JCheckBox getJCheckBox_VincFPNao() {
		if (jCheckBox_VincFPNao == null) {
			jCheckBox_VincFPNao = new JCheckBox();
			jCheckBox_VincFPNao.setBounds(new Rectangle(226, 114, 68, 18));
			jCheckBox_VincFPNao.setText("No");
			jCheckBox_VincFPNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_VincFPNao;
	}
	private ButtonGroup getJButtonGroupVincFP() {
		if (jButtonGroup_VincFP == null) {
			jButtonGroup_VincFP = new ButtonGroup();
			jButtonGroup_VincFP.add(jCheckBox_VincFPSim);
			jButtonGroup_VincFP.add(jCheckBox_VincFPNao);
			jButtonGroup_VincFP.add(jCheckBox_VincFPClear);
		}
		return jButtonGroup_VincFP;
	}
	public JTextField getJTextField_TipoVFP() {
		if (jTextField_TipoVFP == null) {
			jTextField_TipoVFP = new JTextField();
			jTextField_TipoVFP.setBounds(new Rectangle(498, 114, 126, 18));
			jTextField_TipoVFP.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_TipoVFP.setFont(fmeFrame.letra);
		}
		return jTextField_TipoVFP;
	}
	private JScrollPane getJScrollPane_FormAcad() {
		if (jScrollPane_FormAcad == null) {
			jScrollPane_FormAcad = new JScrollPane();
			jScrollPane_FormAcad.setBounds(new Rectangle(176, 140, 448, 54));
			jScrollPane_FormAcad.setPreferredSize(new Dimension(250, 250));
			jScrollPane_FormAcad.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_FormAcad.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_FormAcad.setViewportView(getJTextArea_FormAcad());
		}
		return jScrollPane_FormAcad;
	}
	public JTextArea getJTextArea_FormAcad() {
		if (jTextArea_FormAcad == null) {
			jTextArea_FormAcad = new JTextArea();
			jTextArea_FormAcad.setFont(fmeFrame.letra);
			jTextArea_FormAcad.setLineWrap(true);
			jTextArea_FormAcad.setWrapStyleWord(true);
			jTextArea_FormAcad.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_FormAcad;
	}
	private JScrollPane getJScrollPane_FormProf() {
		if (jScrollPane_FormProf == null) {
			jScrollPane_FormProf = new JScrollPane();
			jScrollPane_FormProf.setBounds(new Rectangle(176, 202, 448, 54));
			jScrollPane_FormProf.setPreferredSize(new Dimension(250, 250));
			jScrollPane_FormProf.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_FormProf.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_FormProf.setViewportView(getJTextArea_FormProf());
		}
		return jScrollPane_FormProf;
	}
	public JTextArea getJTextArea_FormProf() {
		if (jTextArea_FormProf == null) {
			jTextArea_FormProf = new JTextArea();
			jTextArea_FormProf.setFont(fmeFrame.letra);
			jTextArea_FormProf.setLineWrap(true);
			jTextArea_FormProf.setWrapStyleWord(true);
			jTextArea_FormProf.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_FormProf;
	}
	private JScrollPane getJScrollPane_Funcao() {
		if (jScrollPane_Funcao == null) {
			jScrollPane_Funcao = new JScrollPane();
			jScrollPane_Funcao.setBounds(new Rectangle(176, 264, 448, 54));
			jScrollPane_Funcao.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Funcao.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Funcao.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Funcao.setViewportView(getJTextArea_Funcao());
		}
		return jScrollPane_Funcao;
	}
	public JTextArea getJTextArea_Funcao() {
		if (jTextArea_Funcao == null) {
			jTextArea_Funcao = new JTextArea();
			jTextArea_Funcao.setFont(fmeFrame.letra);
			jTextArea_Funcao.setLineWrap(true);
			jTextArea_Funcao.setWrapStyleWord(true);
			jTextArea_Funcao.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Funcao;
	}
	public JCheckBox getJCheckBox_ChefiaSim() {
		if (jCheckBox_ChefiaSim == null) {
			jCheckBox_ChefiaSim = new JCheckBox();
			jCheckBox_ChefiaSim.setBounds(new Rectangle(176, 326, 50, 18));
			jCheckBox_ChefiaSim.setText("Sim");
			jCheckBox_ChefiaSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_ChefiaSim;
	}
	public JCheckBox getJCheckBox_ChefiaNao() {
		if (jCheckBox_ChefiaNao == null) {
			jCheckBox_ChefiaNao = new JCheckBox();
			jCheckBox_ChefiaNao.setBounds(new Rectangle(226, 326, 68, 18));
			jCheckBox_ChefiaNao.setText("No");
			jCheckBox_ChefiaNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_ChefiaNao;
	}
	private ButtonGroup getJButtonGroupChefia() {
		if (jButtonGroup_Chefia == null) {
			jButtonGroup_Chefia = new ButtonGroup();
			jButtonGroup_Chefia.add(jCheckBox_ChefiaSim);
			jButtonGroup_Chefia.add(jCheckBox_ChefiaNao);
			jButtonGroup_Chefia.add(jCheckBox_ChefiaClear);
		}
		return jButtonGroup_Chefia;
	}
	private JScrollPane getJScrollPane_Tarefa() {
		if (jScrollPane_Tarefa == null) {
			jScrollPane_Tarefa = new JScrollPane();
			jScrollPane_Tarefa.setBounds(new Rectangle(176, 352, 448, 54));
			jScrollPane_Tarefa.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Tarefa.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Tarefa.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Tarefa.setViewportView(getJTextArea_Tarefa());
		}
		return jScrollPane_Tarefa;
	}
	public JTextArea getJTextArea_Tarefa() {
		if (jTextArea_Tarefa == null) {
			jTextArea_Tarefa = new JTextArea();
			jTextArea_Tarefa.setFont(fmeFrame.letra);
			jTextArea_Tarefa.setLineWrap(true);
			jTextArea_Tarefa.setWrapStyleWord(true);
			jTextArea_Tarefa.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Tarefa;
	}

	private JPanel getJPanel_Passado() {
		if (jPanel_Passado == null) {
			jLabel_Passado = new JLabel();
			jLabel_Passado.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_Passado.setText("Descreva sucintamente os conhecimentos e experincia passada teis para o projecto:");
			jLabel_Passado.setFont(fmeFrame.letra_bold);

			jPanel_Passado = new JPanel();
			jPanel_Passado.setLayout(null);
			jPanel_Passado.setBounds(new Rectangle(15, 482, 640, 260));
			jPanel_Passado.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Passado.setName("Passado_texto");
			jPanel_Passado.add(jLabel_Passado, null);
			jPanel_Passado.add(getJScrollPane_Passado(), null);
		}
		return jPanel_Passado;
	}
	private JScrollPane getJScrollPane_Passado() {
		if (jScrollPane_Passado == null) {
			jScrollPane_Passado = new JScrollPane();
			jScrollPane_Passado.setBounds(new Rectangle(15, 35, 609, 210));
			jScrollPane_Passado.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Passado.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Passado.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Passado.setViewportView(getJTextArea_Passado());
		}
		return jScrollPane_Passado;
	}
	public JTextArea getJTextArea_Passado() {
		if (jTextArea_Passado == null) {
			jTextArea_Passado = new JTextArea();
			jTextArea_Passado.setFont(fmeFrame.letra);
			jTextArea_Passado.setLineWrap(true);
			jTextArea_Passado.setWrapStyleWord(true);
			jTextArea_Passado.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Passado;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_CurricTec.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_CurricTec.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_CurricTec.validar(null));
		return grp;
	}
}
