package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.table.AbstractTableModel;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_DR extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_DR = null;
	private JLabel jLabel_DR = null;
	private JScrollPane jScrollPane_DR = null;
	private JTable_Tip jTable_DR = null;

	String tag = "";
	
	public Frame_DR() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(660,1330);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}
	
	public void tirar_titulo () {
		jLabel_P01.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component ( jPanel_DR, 40);		
	}

	private void initialize() {
		this.setSize(670, 1500);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_DR(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_DR() {
		if (jPanel_DR == null) {
			
			jLabel_DR = new JLabel();
			jLabel_DR.setBounds(new Rectangle(12, 10, 541, 18));
			jLabel_DR.setText("<html>Demonstraes de Resultados Histricos e Previsionais</html>");
			jLabel_DR.setFont(fmeFrame.letra_bold);			

			jPanel_DR = new JPanel();
			jPanel_DR.setLayout(null);
			jPanel_DR.setBounds(new Rectangle(15, 50, 640, 1270));
			jPanel_DR.setBorder(BorderFactory.createEtchedBorder());
			jPanel_DR.add(jLabel_DR, null);
			jPanel_DR.add(getJScrollPane_DR(), null);
		}
		return jPanel_DR;
	}
	
	public JScrollPane getJScrollPane_DR() {
		if (jScrollPane_DR == null) {
			jScrollPane_DR = new JScrollPane();
			jScrollPane_DR.setBounds(new Rectangle(16, 36, 606, 1217));
			jScrollPane_DR.setViewportView(getJTable_DR());
			//jScrollPane_DR.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			//jScrollPane_DR.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_DR.setBorder(BorderFactory.createEtchedBorder());

		     // JScrollPane scroll = new JScrollPane(table);
		     // jScrollPane_DR.setCorner(JScrollPane.UPPER_LEFT_CORNER, getJTableFixed_DR().getTableHeader());

		
		}
		return jScrollPane_DR;
	}
	
	public JTable getJTable_DR() {
		if (jTable_DR == null) {
//			jTable_DR = new JTable_Tip(30);
			jTable_DR = new JTable_Tip(25, jScrollPane_DR.getWidth());
			jTable_DR.setRowHeight(18);
			jTable_DR.setFont(fmeFrame.letra);
		    jTable_DR.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		    jTable_DR.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
	    

//jTable_DR.setVisible(true);
		}
		return jTable_DR;
	}
	/*
	public JTable getJTableFixed_DR() {
		if (jTableFixed_DR == null) {
			jTableFixed_DR = new JTable() {
		        public void valueChanged(ListSelectionEvent e) {
		          super.valueChanged(e);
		          checkSelection(false);
		        }
		      };
		      jTableFixed_DR.setRowHeight(18);
		      jTableFixed_DR.setFont(fmeFrame.letra);
		      jTableFixed_DR.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		      jTableFixed_DR.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTableFixed_DR;
	}

	
	private void checkSelection(boolean isFixedTable) {
		int fixedSelectedIndex = jTableFixed_DR.getSelectedRow();
		int selectedIndex = jTable_DR.getSelectedRow();
		if (fixedSelectedIndex != selectedIndex) {
			if (isFixedTable) {
				jTable_DR.setRowSelectionInterval(fixedSelectedIndex, fixedSelectedIndex);
			} else {
				jTableFixed_DR.setRowSelectionInterval(selectedIndex, selectedIndex);
			}
		}
	}
*/
	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		//print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_DR.getWidth() - jScrollPane_DR.getWidth();
		int w = jPanel_DR.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.DR.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.DR.validar(null, ""));
		return grp;
	}
}			
	