package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.util.HashMap;

public class Frame_DescFisica extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P09 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_DescFisica = null;
	private JLabel jLabel_DescFisica = null;
	private JLabel jLabel_Areas = null;
	private JScrollPane jScrollPane_Areas = null;
	private JTable_Tip jTable_Areas = null;
	private JLabel jLabel_GrupoEmp = null;
	private SteppedComboBox jComboBox_GrupoEmp = null;
	private JLabel jLabel_Empreendimento = null;
	private SteppedComboBox jComboBox_Empreendimento = null;
	private JLabel jLabel_Regime = null;
	private SteppedComboBox jComboBox_Regime = null;
	private JLabel jLabel_Capacidade = null;
	private JScrollPane jScrollPane_Capacidade = null;
	private JTable_Tip jTable_Capacidade = null;

	String tag = "";
	
	public Frame_DescFisica() {
		super();
		initialize();
	}
	
	public Dimension getSize () {
		// face  dimenso da pgina base
		return new Dimension(660,1045);
	}

	private void initialize() {
		this.setSize(670, 1400);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			jLabel_P09 = new JLabel();
			jLabel_P09.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P09.setText("   DADOS DO PROJECTO");
			jLabel_P09.setFont(fmeFrame.letra_titulo);
			jLabel_P09.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P09, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_DescFisica(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_DescFisica() {
		if (jPanel_DescFisica == null) {
			jLabel_Areas = new JLabel();
		    jLabel_Areas.setBounds(new Rectangle(12, 35, 209, 18));
		    jLabel_Areas.setText("reas");
		    jLabel_Areas.setFont(fmeFrame.letra_bold);
			jLabel_DescFisica = new JLabel();
		    jLabel_DescFisica.setBounds(new Rectangle(12, 10, 301, 18));
		    jLabel_DescFisica.setText("Descrio Fsica do Empreendimento");
		    jLabel_DescFisica.setFont(fmeFrame.letra_bold);
		    jLabel_GrupoEmp = new JLabel();
		    jLabel_GrupoEmp.setText("Grupo de Empreendimento");
		    jLabel_GrupoEmp.setFont(fmeFrame.letra);
		    jLabel_GrupoEmp.setBounds(new Rectangle(25, 211, 146, 18));
		    jLabel_Empreendimento = new JLabel();
		    jLabel_Empreendimento.setText("Empreendimento");
		    jLabel_Empreendimento.setFont(fmeFrame.letra);
		    jLabel_Empreendimento.setBounds(new Rectangle(25, 243, 146, 18));
		    jLabel_Regime = new JLabel();
		    jLabel_Regime.setBounds(new Rectangle(25, 275, 146, 18));
		    jLabel_Regime.setFont(fmeFrame.letra);
		    jLabel_Regime.setText("Regime de Construo");
		    jLabel_Capacidade = new JLabel();
		    jLabel_Capacidade.setFont(fmeFrame.letra_bold);
		    jLabel_Capacidade.setText("Capacidade");
		    jLabel_Capacidade.setBounds(new Rectangle(12, 315, 209, 18));
			
			jPanel_DescFisica = new JPanel();
			jPanel_DescFisica.setLayout(null);
			jPanel_DescFisica.setBounds(new Rectangle(15, 50, 640, 985));
			jPanel_DescFisica.setBorder(BorderFactory.createEtchedBorder());
			jPanel_DescFisica.add(jLabel_DescFisica, null);
			jPanel_DescFisica.add(jLabel_Areas, null);
			jPanel_DescFisica.add(getJScrollPane_Areas(), null);
			jPanel_DescFisica.add(jLabel_GrupoEmp, null);
			jPanel_DescFisica.add(getJComboBox_GrupoEmp(), null);
			jPanel_DescFisica.add(jLabel_Empreendimento, null);
			jPanel_DescFisica.add(getJComboBox_Empreendimento(), null);
			jPanel_DescFisica.add(jLabel_Regime, null);
			jPanel_DescFisica.add(getJComboBox_Regime(), null);
			jPanel_DescFisica.add(jLabel_Capacidade, null);
			jPanel_DescFisica.add(getJScrollPane_Capacidade(), null);
		}
		return jPanel_DescFisica;
	}
	
	public JScrollPane getJScrollPane_Areas() {
		if (jScrollPane_Areas == null) {
			jScrollPane_Areas = new JScrollPane();
			jScrollPane_Areas.setBounds(new Rectangle(10, 55, 619, 136));
			jScrollPane_Areas.setViewportView(getJTable_Areas());
			jScrollPane_Areas.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Areas.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_Areas.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Areas;
	}
	
	public JTable getJTable_Areas() {
		if (jTable_Areas == null) {
			jTable_Areas = new JTable_Tip(25);
			jTable_Areas.setRowHeight(18);
			jTable_Areas.setFont(fmeFrame.letra);
			jTable_Areas.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_Areas;
	}

	public JComboBox getJComboBox_GrupoEmp() {
		if (jComboBox_GrupoEmp == null) {
			jComboBox_GrupoEmp = new SteppedComboBox();
			//jComboBox_GrupoEmp.setPopupWidth(210);
			jComboBox_GrupoEmp.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_GrupoEmp.setBounds(new Rectangle(166, 211, 455, 18));
			jComboBox_GrupoEmp.setFont(fmeFrame.letra);
			jComboBox_GrupoEmp.setBackground(Color.WHITE);
			jComboBox_GrupoEmp.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData.Emp.getByName("grupo_empreend").vldOnline();}
				    catch (Exception ex) { };
				}
			});
		}
		return jComboBox_GrupoEmp;
	}
	public JComboBox getJComboBox_Empreendimento() {
		if (jComboBox_Empreendimento == null) {
			jComboBox_Empreendimento = new SteppedComboBox();
			//jComboBox_GrupoEmp.setPopupWidth(210);
			jComboBox_Empreendimento.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_Empreendimento.setBounds(new Rectangle(166, 243, 455, 18));
			jComboBox_Empreendimento.setFont(fmeFrame.letra);
			jComboBox_Empreendimento.setBackground(Color.WHITE);
			jComboBox_Empreendimento.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
				    try {CBData.Emp.getByName("empreendimento").vldOnline();}
				    catch (Exception ex) { };
				}
			});
		}
		return jComboBox_Empreendimento;
	}
	public JComboBox getJComboBox_Regime() {
		if (jComboBox_Regime == null) {
			jComboBox_Regime = new SteppedComboBox();
			//jComboBox_Regime.setPopupWidth(210);
			jComboBox_Regime.setBorder(BorderFactory.createLineBorder(Color.black));
			jComboBox_Regime.setBounds(new Rectangle(166, 275, 455, 18));
			jComboBox_Regime.setFont(fmeFrame.letra);
			jComboBox_Regime.setBackground(Color.WHITE);
		}
		return jComboBox_Regime;
	}

	public JScrollPane getJScrollPane_Capacidade() {
		if (jScrollPane_Capacidade == null) {
			jScrollPane_Capacidade = new JScrollPane();
			jScrollPane_Capacidade.setBounds(new Rectangle(10, 335, 619, 640));
			jScrollPane_Capacidade.setViewportView(getJTable_Capacidade());
			jScrollPane_Capacidade.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Capacidade.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_Capacidade.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Capacidade;
	}
	
	public JTable getJTable_Capacidade() {
		if (jTable_Capacidade == null) {
			jTable_Capacidade = new JTable_Tip(25);
			jTable_Capacidade.setRowHeight(18);
			jTable_Capacidade.setFont(fmeFrame.letra);
			jTable_Capacidade.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_Capacidade;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.scaleToWidth ( (int) ( 1.15 * jPanel_DescFisica.getWidth()) );
		print_handler.margem_y = 30;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Areas.Clear();
		CBData.Emp.Clear();
		CBData.Capacidade.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Areas.validar(null));
		//grp.add_grp(CBData.Emp.validar(null));
		grp.add_grp(CBData.Capacidade.validar(null));
		return grp;
	}
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
}		
	