package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_EntExt extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_EntExt = null;
	private JLabel jLabel_EntExt = null;
	private JScrollPane jScrollPane_EntExt = null;
	private JTable_Tip jTable_EntExt = null;
	private JButton jButton_EntExtAdd = null;
	private JButton jButton_EntExtIns = null;
	private JButton jButton_EntExtDel = null;

	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	private JPanel jPanel_EquipaCoord = null;
	private JLabel jLabel_EquipaCoord = null;
	private JScrollPane jScrollPane_EquipaCoord = null;
	private JTable_Tip2 jTable_EquipaCoord = null;
	private JButton jButton_EquipaCoordAdd = null;
	private JButton jButton_EquipaCoordIns = null;
	private JButton jButton_EquipaCoordDel = null;

	private JPanel jPanel_Fundam2 = null;
	private JLabel jLabel_Fundam2 = null;
	private JScrollPane jScrollPane_Fundam2 = null;
	private JTextArea jTextArea_Fundam2 = null;

	String tag = "";
		
	public Frame_EntExt() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,980);
	}

	String coluna_coop = "N";  //  @jve:decl-index=0:
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("coop") != null ) {
			coluna_coop = (String) params.get("coop");
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			
			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_EntExt(), null);
			jContentPane.add(getJPanel_Fundam(), null);
			jContentPane.add(getjPanel_EquipaCoord(), null);
			jContentPane.add(getJPanel_Fundam2(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_EntExt() {
		if (jPanel_EntExt == null) {
		    jButton_EntExtAdd = new JButton(fmeFrame.novaLinha);
		    jButton_EntExtAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EntExtAdd.addMouseListener(new Frame_EntExt_jButton_EntExtAdd_mouseAdapter(this));
		    jButton_EntExtAdd.setToolTipText("Nova Linha");
		    jButton_EntExtAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_EntExtIns = new JButton(fmeFrame.inserirLinha);
		    jButton_EntExtIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EntExtIns.addMouseListener(new Frame_EntExt_jButton_EntExtIns_mouseAdapter(this));
		    jButton_EntExtIns.setToolTipText("Inserir Linha");
		    jButton_EntExtIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_EntExtDel = new JButton(fmeFrame.apagarLinha);
		    jButton_EntExtDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EntExtDel.addMouseListener(new Frame_EntExt_jButton_EntExtDel_mouseAdapter(this));
		    jButton_EntExtDel.setToolTipText("Apagar Linha");
		    jButton_EntExtDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_EntExt = new JLabel();
			jLabel_EntExt.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_EntExt.setText("<html>Entidades externas a envolver</html>");
			jLabel_EntExt.setFont(fmeFrame.letra_bold);			
			jPanel_EntExt = new JPanel();
			jPanel_EntExt.setLayout(null);
			jPanel_EntExt.setBounds(new Rectangle(15, 50, 640, 190));
			jPanel_EntExt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_EntExt.add(jLabel_EntExt, null);
			jPanel_EntExt.add(jButton_EntExtAdd, null);
			jPanel_EntExt.add(jButton_EntExtIns, null);
			jPanel_EntExt.add(jButton_EntExtDel, null);
			jPanel_EntExt.add(getJScrollPane_EntExt(), null);
		}
		return jPanel_EntExt;
	}
	
	public JScrollPane getJScrollPane_EntExt() {
		if (jScrollPane_EntExt == null) {
			jScrollPane_EntExt = new JScrollPane();
			jScrollPane_EntExt.setBounds(new Rectangle(10, 40, 620, 134));
			jScrollPane_EntExt.setViewportView(getJTable_EntExt());
			//jScrollPane_EntExt.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_EntExt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_EntExt.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_EntExt;
	}
	
	public JTable getJTable_EntExt() {
		if (jTable_EntExt == null) {
			jTable_EntExt = new JTable_Tip(40, jScrollPane_EntExt.getWidth());
			jTable_EntExt.setFont(fmeFrame.letra);
			jTable_EntExt.setRowHeight(18);
			jTable_EntExt.setName("EntExt_Tabela");
			jTable_EntExt.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_EntExt.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_EntExt;
	}
	void jButton_EntExtAdd_mouseClicked(MouseEvent e) {
		CBData.EntExt.on_add_row();
	}

	void jButton_EntExtDel_mouseClicked(MouseEvent e) {
		if (CBData.EntExt.del_ins_ok("Apagar")){
			CBData.EntExt.on_del_row();
			CTabelas.EntExt.refresh();
		}
	}

	void jButton_EntExtIns_mouseClicked(MouseEvent e) {
		CBData.EntExt.on_ins_row();
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_Fundam.setText("Competncias especficas das entidades");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 250, 640, 255));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("ent_ext_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 200));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}

//-----------------------------
	private JPanel getjPanel_EquipaCoord() {
		if (jPanel_EquipaCoord == null) {
		    jButton_EquipaCoordAdd = new JButton(fmeFrame.novaLinha);
		    jButton_EquipaCoordAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipaCoordAdd.addMouseListener(new Frame_EntExt_jButton_EquipaCoordAdd_mouseAdapter(this));
		    jButton_EquipaCoordAdd.setToolTipText("Nova Linha");
		    jButton_EquipaCoordAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_EquipaCoordIns = new JButton(fmeFrame.inserirLinha);
		    jButton_EquipaCoordIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipaCoordIns.addMouseListener(new Frame_EntExt_jButton_EquipaCoordIns_mouseAdapter(this));
		    jButton_EquipaCoordIns.setToolTipText("Inserir Linha");
		    jButton_EquipaCoordIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_EquipaCoordDel = new JButton(fmeFrame.apagarLinha);
		    jButton_EquipaCoordDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_EquipaCoordDel.addMouseListener(new Frame_EntExt_jButton_EquipaCoordDel_mouseAdapter(this));
		    jButton_EquipaCoordDel.setToolTipText("Apagar Linha");
		    jButton_EquipaCoordDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_EquipaCoord = new JLabel();
			jLabel_EquipaCoord.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_EquipaCoord.setText("<html>Equipa Coordenadora</html>");
			jLabel_EquipaCoord.setFont(fmeFrame.letra_bold);			
			jPanel_EquipaCoord = new JPanel();
			jPanel_EquipaCoord.setLayout(null);
			jPanel_EquipaCoord.setBounds(new Rectangle(15, 515, 640, 190));
			jPanel_EquipaCoord.setBorder(BorderFactory.createEtchedBorder());
			jPanel_EquipaCoord.add(jLabel_EquipaCoord, null);
			jPanel_EquipaCoord.add(jButton_EquipaCoordAdd, null);
			jPanel_EquipaCoord.add(jButton_EquipaCoordIns, null);
			jPanel_EquipaCoord.add(jButton_EquipaCoordDel, null);
			jPanel_EquipaCoord.add(getJScrollPane_EquipaCoord(), null);
		}
		return jPanel_EquipaCoord;
	}
	
	public JScrollPane getJScrollPane_EquipaCoord() {
		if (jScrollPane_EquipaCoord == null) {
			jScrollPane_EquipaCoord = new JScrollPane();
			jScrollPane_EquipaCoord.setBounds(new Rectangle(10, 40, 620, 134));
			jScrollPane_EquipaCoord.setViewportView(getJTable_EquipaCoord());
			//jScrollPane_EquipaCoord.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_EquipaCoord.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_EquipaCoord.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_EquipaCoord;
	}
	
	public JTable getJTable_EquipaCoord() {
		if (jTable_EquipaCoord == null) {
			jTable_EquipaCoord = new JTable_Tip2(40, jScrollPane_EquipaCoord.getWidth());
			//jTable_EquipaCoord = new JTable_Tip2();
			jTable_EquipaCoord.setFont(fmeFrame.letra);
			jTable_EquipaCoord.setRowHeight(18);
			jTable_EquipaCoord.setName("EquipaCoord_Tabela");
			jTable_EquipaCoord.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_EquipaCoord.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_EquipaCoord;
	}
	void jButton_EquipaCoordAdd_mouseClicked(MouseEvent e) {
		CBData.EquipaCoord.on_add_row();
	}

	void jButton_EquipaCoordDel_mouseClicked(MouseEvent e) {
		CBData.EquipaCoord.on_del_row();
	}

	void jButton_EquipaCoordIns_mouseClicked(MouseEvent e) {
		CBData.EquipaCoord.on_ins_row();
	}

	private JPanel getJPanel_Fundam2() {
		if (jPanel_Fundam2 == null) {
			jLabel_Fundam2 = new JLabel();
			jLabel_Fundam2.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_Fundam2.setText("Experincia da equipa em projectos de natureza semelhante");
			jLabel_Fundam2.setFont(fmeFrame.letra_bold);

			jPanel_Fundam2 = new JPanel();
			jPanel_Fundam2.setLayout(null);
			jPanel_Fundam2.setBounds(new Rectangle(15, 715, 640, 255));
			jPanel_Fundam2.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam2.setName("equipa_coord_texto");
			jPanel_Fundam2.add(jLabel_Fundam2, null);
			jPanel_Fundam2.add(getJScrollPane_Fundam2(), null);
			
		}
		return jPanel_Fundam2;
	}
	
	public JScrollPane getJScrollPane_Fundam2() {
		if (jScrollPane_Fundam2 == null) {
			jScrollPane_Fundam2 = new JScrollPane();
			jScrollPane_Fundam2.setBounds(new Rectangle(15, 36, 606, 200));
			jScrollPane_Fundam2.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam2.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam2.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam2.setViewportView(getJTextArea_Fundam2());
		}
		return jScrollPane_Fundam2;
	}
	public JTextArea getJTextArea_Fundam2() {
		if (jTextArea_Fundam2 == null) {
			jTextArea_Fundam2 = new JTextArea();
			jTextArea_Fundam2.setFont(fmeFrame.letra);
			jTextArea_Fundam2.setLineWrap(true);
			jTextArea_Fundam2.setWrapStyleWord(true);
			jTextArea_Fundam2.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam2;
	}


	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_EntExt.getWidth() - jScrollPane_EntExt.getWidth();
		int w = jPanel_EntExt.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.25 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.EntExt.Clear();
		CBData.EntExtTxt.Clear();
		CBData.EquipaCoord.Clear();
		CBData.EquipaCoordTxt.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.EntExt.validar(null));
		grp.add_grp(CBData.EntExtTxt.validar(null));
		grp.add_grp(CBData.EquipaCoord.validar(null));
		grp.add_grp(CBData.EquipaCoordTxt.validar(null));
		return grp;
	}

}		


class Frame_EntExt_jButton_EntExtAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EntExtAdd_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EntExtAdd_mouseClicked(e);
	}
}

class Frame_EntExt_jButton_EntExtDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EntExtDel_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EntExtDel_mouseClicked(e);
	}
}

class Frame_EntExt_jButton_EntExtIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EntExtIns_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EntExtIns_mouseClicked(e);
	}
}

class Frame_EntExt_jButton_EquipaCoordAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EquipaCoordAdd_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipaCoordAdd_mouseClicked(e);
	}
}

class Frame_EntExt_jButton_EquipaCoordDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EquipaCoordDel_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipaCoordDel_mouseClicked(e);
	}
}

class Frame_EntExt_jButton_EquipaCoordIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EntExt adaptee;

	Frame_EntExt_jButton_EquipaCoordIns_mouseAdapter(Frame_EntExt adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_EquipaCoordIns_mouseClicked(e);
	}
}
