package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import javax.swing.JLabel;
import java.awt.Rectangle;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import java.awt.Insets;

public class Frame_EstrutIDT extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;
	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_EstrutIDT = null;
	private JLabel jLabel_EstrutIDT = null;
	private JLabel jLabel_DepartIDT = null;
	private JCheckBox jCheckBox_DepartSim = null;
	private JCheckBox jCheckBox_DepartNao = null;
	public JCheckBox jCheckBox_DepartClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Depart = null;
	private JLabel jLabel_LabIDT = null;
	private JCheckBox jCheckBox_LabSim = null;
	private JCheckBox jCheckBox_LabNao = null;
	public JCheckBox jCheckBox_LabClear = new JCheckBox();
	private ButtonGroup jButtonGroup_Lab = null;

	private JPanel jPanel_PessoalIDT = null;
	private JLabel jLabel_PessoalIDT = null;
	private JScrollPane jScrollPane_PessoalIDT = null;
	private JTable_Tip jTable_PessoalIDT = null;
	private JButton jButton_PessoalIDTCopy = null;
	private JButton jButton_PessoalIDTUp = null;
	private JButton jButton_PessoalIDTAdd = null;
	private JButton jButton_PessoalIDTIns = null;
	private JButton jButton_PessoalIDTDel = null;

	private JPanel jPanel_AreaTecIDT = null;
	private JLabel jLabel_AreaTecIDT = null;
	private JScrollPane jScrollPane_AreaTecIDT = null;
	private JTextArea jTextArea_AreaTecIDT = null;

	String tag = "";

	public Frame_EstrutIDT() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,820);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		jLabel_QREN.setVisible(false);
		up_component(jPanel_EstrutIDT, 30);
		up_component(jPanel_PessoalIDT, 30);
		up_component(jPanel_AreaTecIDT, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROMOTOR");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_EstrutIDT(), null);
			jContentPane.add(getJPanel_PessoalIDT(), null);
			jContentPane.add(getJPanel_AreaTecIDT(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_EstrutIDT() {
		if (jPanel_EstrutIDT == null) {
			jLabel_EstrutIDT = new JLabel();
			jLabel_EstrutIDT.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_EstrutIDT.setText("Estruturas e Actividades de I&DT");
			jLabel_EstrutIDT.setFont(fmeFrame.letra_bold);
			jLabel_DepartIDT = new JLabel();
			jLabel_DepartIDT.setBounds(new Rectangle(22, 36, 266, 18));
			jLabel_DepartIDT.setText("A empresa tem Departamento/Ncleo de I&DT?");
			jLabel_DepartIDT.setFont(fmeFrame.letra);
			jLabel_LabIDT = new JLabel();
			jLabel_LabIDT.setBounds(new Rectangle(22, 62, 266, 18));
			jLabel_LabIDT.setText("A empresa tem Laboratrio de I&DT prprio?");
			jLabel_LabIDT.setFont(fmeFrame.letra);

			jPanel_EstrutIDT = new JPanel();
			jPanel_EstrutIDT.setLayout(null);
			jPanel_EstrutIDT.setBounds(new Rectangle(15, 50, 640, 90));
			jPanel_EstrutIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_EstrutIDT.add(jLabel_EstrutIDT, null);
			jPanel_EstrutIDT.add(jLabel_DepartIDT, null);
			jPanel_EstrutIDT.add(getJCheckBox_DepartSim(), null);
			jPanel_EstrutIDT.add(getJCheckBox_DepartNao(), null);
			this.getJButtonGroupDepart();
			jPanel_EstrutIDT.add(jLabel_LabIDT, null);
			jPanel_EstrutIDT.add(getJCheckBox_LabSim(), null);
			jPanel_EstrutIDT.add(getJCheckBox_LabNao(), null);
			this.getJButtonGroupLab();
		}
		return jPanel_EstrutIDT;
	}
	public JCheckBox getJCheckBox_DepartSim() {
		if (jCheckBox_DepartSim == null) {
			jCheckBox_DepartSim = new JCheckBox();
			jCheckBox_DepartSim.setBounds(new Rectangle(287, 36, 50, 18));
			jCheckBox_DepartSim.setText("Sim");
			jCheckBox_DepartSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_DepartSim;
	}
	public JCheckBox getJCheckBox_DepartNao() {
		if (jCheckBox_DepartNao == null) {
			jCheckBox_DepartNao = new JCheckBox();
			jCheckBox_DepartNao.setBounds(new Rectangle(338, 36, 68, 18));
			jCheckBox_DepartNao.setText("No");
			jCheckBox_DepartNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_DepartNao;
	}
	private ButtonGroup getJButtonGroupDepart() {
		if (jButtonGroup_Depart == null) {
			jButtonGroup_Depart = new ButtonGroup();
			jButtonGroup_Depart.add(jCheckBox_DepartSim);
			jButtonGroup_Depart.add(jCheckBox_DepartNao);
			jButtonGroup_Depart.add(jCheckBox_DepartClear);
		}
		return jButtonGroup_Depart;
	}
	public JCheckBox getJCheckBox_LabSim() {
		if (jCheckBox_LabSim == null) {
			jCheckBox_LabSim = new JCheckBox();
			jCheckBox_LabSim.setBounds(new Rectangle(287, 62, 41, 18));
			jCheckBox_LabSim.setText("Sim");
			jCheckBox_LabSim.setFont(fmeFrame.letra);
		}
		return jCheckBox_LabSim;
	}
	public JCheckBox getJCheckBox_LabNao() {
		if (jCheckBox_LabNao == null) {
			jCheckBox_LabNao = new JCheckBox();
			jCheckBox_LabNao.setBounds(new Rectangle(338, 62, 44, 18));
			jCheckBox_LabNao.setText("No");
			jCheckBox_LabNao.setFont(fmeFrame.letra);
		}
		return jCheckBox_LabNao;
	}
	private ButtonGroup getJButtonGroupLab() {
		if (jButtonGroup_Lab == null) {
			jButtonGroup_Lab = new ButtonGroup();
			jButtonGroup_Lab.add(jCheckBox_LabSim);
			jButtonGroup_Lab.add(jCheckBox_LabNao);
			jButtonGroup_Lab.add(jCheckBox_LabClear);
		}
		return jButtonGroup_Lab;
	}

	private JPanel getJPanel_PessoalIDT() {
		if (jPanel_PessoalIDT == null) {
			jLabel_PessoalIDT = new JLabel();
			jLabel_PessoalIDT.setBounds(new Rectangle(12, 10, 412, 18));
			jLabel_PessoalIDT.setText("Pessoal em actividades de I&DT  data da candidatura");
			jLabel_PessoalIDT.setFont(fmeFrame.letra_bold);

			jButton_PessoalIDTCopy = new JButton(fmeFrame.copiarLinha);
			jButton_PessoalIDTCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalIDTCopy.addMouseListener(new Frame_EstrutIDT_jButton_PessoalIDTCopy_mouseAdapter(this));
			jButton_PessoalIDTCopy.setToolTipText("Copiar Linha");
			jButton_PessoalIDTCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_PessoalIDTUp = new JButton(fmeFrame.subirLinha);
			jButton_PessoalIDTUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalIDTUp.addMouseListener(new Frame_EstrutIDT_jButton_PessoalIDTUp_mouseAdapter(this));
			jButton_PessoalIDTUp.setToolTipText("Trocar Linhas");
			jButton_PessoalIDTUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_PessoalIDTAdd = new JButton(fmeFrame.novaLinha);
			jButton_PessoalIDTAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalIDTAdd.addMouseListener(new Frame_EstrutIDT_jButton_PessoalIDTAdd_mouseAdapter(this));
			jButton_PessoalIDTAdd.setToolTipText("Nova Linha");
			jButton_PessoalIDTAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_PessoalIDTIns = new JButton(fmeFrame.inserirLinha);
			jButton_PessoalIDTIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalIDTIns.addMouseListener(new Frame_EstrutIDT_jButton_PessoalIDTIns_mouseAdapter(this));
			jButton_PessoalIDTIns.setToolTipText("Inserir Linha");
			jButton_PessoalIDTIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_PessoalIDTDel = new JButton(fmeFrame.apagarLinha);
			jButton_PessoalIDTDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalIDTDel.addMouseListener(new Frame_EstrutIDT_jButton_PessoalIDTDel_mouseAdapter(this));
			jButton_PessoalIDTDel.setToolTipText("Apagar Linha");
			jButton_PessoalIDTDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_PessoalIDT = new JPanel();
			jPanel_PessoalIDT.setLayout(null);
			jPanel_PessoalIDT.setBounds(new Rectangle(15, 150, 640, 168));
			jPanel_PessoalIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PessoalIDT.add(jLabel_PessoalIDT, null);
			jPanel_PessoalIDT.add(jButton_PessoalIDTCopy, null);
			jPanel_PessoalIDT.add(jButton_PessoalIDTUp, null);
			jPanel_PessoalIDT.add(jButton_PessoalIDTAdd, null);
			jPanel_PessoalIDT.add(jButton_PessoalIDTIns, null);
			jPanel_PessoalIDT.add(jButton_PessoalIDTDel, null);
			jPanel_PessoalIDT.add(getJScrollPane_PessoalIDT(), null);
		}
		return jPanel_PessoalIDT;
	}
	public JScrollPane getJScrollPane_PessoalIDT() {
		if (jScrollPane_PessoalIDT == null) {
			jScrollPane_PessoalIDT = new JScrollPane();
			jScrollPane_PessoalIDT.setBounds(new Rectangle(16, 36, 606, 117));
			jScrollPane_PessoalIDT.setViewportView(getJTable_PessoalIDT());
			jScrollPane_PessoalIDT.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_PessoalIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_PessoalIDT.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_PessoalIDT;
	}
	public JTable getJTable_PessoalIDT() {
		if (jTable_PessoalIDT == null) {
			jTable_PessoalIDT = new JTable_Tip(40, jScrollPane_PessoalIDT.getWidth());
			jTable_PessoalIDT.setFont(fmeFrame.letra);
			jTable_PessoalIDT.setRowHeight(18);
			jTable_PessoalIDT.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_PessoalIDT.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_PessoalIDT;
	}
	void jButton_PessoalIDTCopy_mouseClicked(MouseEvent e) {
		CBData.PessoalIDT.on_copy_row();
	}
	void jButton_PessoalIDTUp_mouseClicked(MouseEvent e) {
		CBData.PessoalIDT.on_up_row();
	}
	void jButton_PessoalIDTAdd_mouseClicked(MouseEvent e) {
		CBData.PessoalIDT.on_add_row();
	}
	void jButton_PessoalIDTDel_mouseClicked(MouseEvent e) {
		CBData.PessoalIDT.on_del_row();
	}
	void jButton_PessoalIDTIns_mouseClicked(MouseEvent e) {
		CBData.PessoalIDT.on_ins_row();
	}

	private JPanel getJPanel_AreaTecIDT() {
		if (jPanel_AreaTecIDT == null) {
			jLabel_AreaTecIDT = new JLabel();
			jLabel_AreaTecIDT.setBounds(new Rectangle(12, 10, 412, 18));
			jLabel_AreaTecIDT.setText("Descrio das reas Tecnolgicas existentes na empresa");
			jLabel_AreaTecIDT.setFont(fmeFrame.letra_bold);

			jPanel_AreaTecIDT = new JPanel();
			jPanel_AreaTecIDT.setLayout(null);
			jPanel_AreaTecIDT.setBounds(new Rectangle(15, 328, 640, 474));
			jPanel_AreaTecIDT.setBorder(BorderFactory.createEtchedBorder());
			jPanel_AreaTecIDT.setName("area_tec_idt_texto");
			jPanel_AreaTecIDT.add(jLabel_AreaTecIDT, null);
			jPanel_AreaTecIDT.add(getJScrollPane_AreaTecIDT(), null);
		}
		return jPanel_AreaTecIDT;
	}
	private JScrollPane getJScrollPane_AreaTecIDT() {
		if (jScrollPane_AreaTecIDT == null) {
			jScrollPane_AreaTecIDT = new JScrollPane();
			jScrollPane_AreaTecIDT.setBounds(new Rectangle(15, 35, 609, 420));
			jScrollPane_AreaTecIDT.setPreferredSize(new Dimension(250, 250));
			jScrollPane_AreaTecIDT.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_AreaTecIDT.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_AreaTecIDT.setViewportView(getJTextArea_AreaTecIDT());
		}
		return jScrollPane_AreaTecIDT;
	}
	public JTextArea getJTextArea_AreaTecIDT() {
		if (jTextArea_AreaTecIDT == null) {
			jTextArea_AreaTecIDT = new JTextArea();
			jTextArea_AreaTecIDT.setFont(fmeFrame.letra);
			jTextArea_AreaTecIDT.setLineWrap(true);
			jTextArea_AreaTecIDT.setWrapStyleWord(true);
			jTextArea_AreaTecIDT.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_AreaTecIDT;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_EstrutIDT.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.EstrutIDT.Clear();
		CBData.PessoalIDT.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.EstrutIDT.validar_1(null));
		grp.add_grp(CBData.PessoalIDT.validar(null));
		grp.add_grp(CBData.EstrutIDT.validar_2(null));
		return grp;
	}
}

class Frame_EstrutIDT_jButton_PessoalIDTCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EstrutIDT adaptee;
	
	Frame_EstrutIDT_jButton_PessoalIDTCopy_mouseAdapter(Frame_EstrutIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalIDTCopy_mouseClicked(e);
	}	
}

class Frame_EstrutIDT_jButton_PessoalIDTUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EstrutIDT adaptee;
	
	Frame_EstrutIDT_jButton_PessoalIDTUp_mouseAdapter(Frame_EstrutIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalIDTUp_mouseClicked(e);
	}
}

class Frame_EstrutIDT_jButton_PessoalIDTAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EstrutIDT adaptee;

	Frame_EstrutIDT_jButton_PessoalIDTAdd_mouseAdapter(Frame_EstrutIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalIDTAdd_mouseClicked(e);
	}
}

class Frame_EstrutIDT_jButton_PessoalIDTDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EstrutIDT adaptee;

	Frame_EstrutIDT_jButton_PessoalIDTDel_mouseAdapter(Frame_EstrutIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalIDTDel_mouseClicked(e);
	}
}

class Frame_EstrutIDT_jButton_PessoalIDTIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_EstrutIDT adaptee;

	Frame_EstrutIDT_jButton_PessoalIDTIns_mouseAdapter(Frame_EstrutIDT adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalIDTIns_mouseClicked(e);
	}
}
