package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.event.*;
import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

import javax.swing.BorderFactory;
import javax.swing.JComboBox;
import javax.swing.SwingConstants;
import javax.swing.JLabel;

public class Frame_Major extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Major_ = null;

	private JPanel jPanel_MajorCoop = null;
	private JLabel jLabel_MajorCoop = null;
	private JCheckBox jCheckBox_MajorCoop = null;
	public JCheckBox jCheckBox_MajorCoopClear = new JCheckBox();
	private JLabel jLabel_MajorCoop_L = null;
	private JScrollPane jScrollPane_MajorCoop = null;
	private JTable_Tip jTable_MajorCoop = null;
	private JButton jButton_MajorCoopUp = null;
	private JButton jButton_MajorCoopAdd = null;
	private JButton jButton_MajorCoopIns = null;
	private JButton jButton_MajorCoopDel = null;

	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	private JPanel jPanel_MajorEmpreend = null;
	private JLabel jLabel_MajorEmpreendJovem = null;
	private JLabel jLabel_MajorDetem = null;
	//private JLabel jLabel_MajorEmpreendJovem = null;
	//private JLabel jLabel_MajorEmpreendJovem = null;
	private JLabel jLabel_MajorEmpreendFem = null;
	private JCheckBox jCheckBox_MajorEmpreendJovem = null;
	public JCheckBox jCheckBox_MajorEmpreendJovemClear = new JCheckBox();
	private JCheckBox jCheckBox_MajorEmpreendFem = null;
	public JCheckBox jCheckBox_MajorEmpreendFemClear = new JCheckBox();
	private JTable_Tip jTable_MajorEmpreend = null;
	private JCheckBox jCheckBox_Directa = null;
	private JCheckBox jCheckBox_Indirecta = null;
	public JCheckBox jCheckBox_Detem_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_Detem = null;  //  @jve:decl-index=0:
	public JLabel jLabel_NIF = null;
	private JTextField jTextField_NIF = null;
	public JLabel jLabel_Nome = null;
	private JTextField jTextField_Nome = null;
	public JLabel jLabel_Part = null;
	private JFormattedTextField jTextField_Part = null;
	public JLabel jLabel_Genero = null;
	private SteppedComboBox jComboBox_Genero = null;
	public JLabel jLabel_Idade = null;
	private JFormattedTextField jTextField_Idade = null;
	public JLabel jLabel_Cargo = null;
	private JTextField jTextField_Cargo = null;
	private JLabel jLabel_Texto = null;
	private JScrollPane jScrollPane_Texto = null;
	private JTextArea jTextArea_Texto = null;
	public JCheckBox jCheckBox_Declaracao = null;
	public JCheckBox jCheckBox_Declaracao_Clear = new JCheckBox();


	String tag = "";

	public JLabel jLabel_FormaInd = null;
	
	public Frame_Major() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,830);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("empreeendedorismo")!=null && params.get("empreeendedorismo").equals("0") ) {
			jPanel_MajorEmpreend.setVisible(false);
		}

	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Major_ = new JLabel();
			jLabel_Major_.setBounds(new Rectangle(15, 10, 640, 30));
			jLabel_Major_.setText("   DADOS DO PROJECTO");
			jLabel_Major_.setFont(fmeFrame.letra_titulo);
			jLabel_Major_.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Major_, null);
			jContentPane.add(getJPanel_MajorCoop(), null);
			jContentPane.add(getJPanel_Fundam(), null);
			jContentPane.add(getJPanel_MajorEmpreend(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_MajorCoop() {
		if (jPanel_MajorCoop == null) {
		    jButton_MajorCoopAdd = new JButton(fmeFrame.novaLinha);
		    jButton_MajorCoopAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MajorCoopAdd.addMouseListener(new Frame_Major_jButton_MajorCoopAdd_mouseAdapter(this));
		    jButton_MajorCoopAdd.setToolTipText("Nova Linha");
		    jButton_MajorCoopAdd.setBounds(new Rectangle(517, 36, 30, 22));
		    jButton_MajorCoopIns = new JButton(fmeFrame.inserirLinha);
		    jButton_MajorCoopIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MajorCoopIns.addMouseListener(new Frame_Major_jButton_MajorCoopIns_mouseAdapter(this));
		    jButton_MajorCoopIns.setToolTipText("Inserir Linha");
		    jButton_MajorCoopIns.setBounds(new Rectangle(557, 36, 30, 22));
		    jButton_MajorCoopDel = new JButton(fmeFrame.apagarLinha);
		    jButton_MajorCoopDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_MajorCoopDel.addMouseListener(new Frame_Major_jButton_MajorCoopDel_mouseAdapter(this));
		    jButton_MajorCoopDel.setToolTipText("Apagar Linha");
		    jButton_MajorCoopDel.setBounds(new Rectangle(597, 36, 30, 22));

		    jLabel_MajorCoop = new JLabel();
		    jLabel_MajorCoop.setBounds(new Rectangle(12, 10, 175, 18));
		    jLabel_MajorCoop.setText("O projecto inclui cooperao");
		    jLabel_MajorCoop.setFont(fmeFrame.letra_bold);

		    jLabel_MajorCoop_L = new JLabel();
		    jLabel_MajorCoop_L.setBounds(new Rectangle(12, 40, 381, 18));
		    jLabel_MajorCoop_L.setText("Lista de empresas com quem coopera");
		    jLabel_MajorCoop_L.setFont(fmeFrame.letra_bold);

			jPanel_MajorCoop = new JPanel();
			jPanel_MajorCoop.setLayout(null);
			jPanel_MajorCoop.setBounds(new Rectangle(15, 50, 640, 220));
			jPanel_MajorCoop.setBorder(BorderFactory.createEtchedBorder());
			jPanel_MajorCoop.add(jLabel_MajorCoop, null);
			jPanel_MajorCoop.add(getJCheckBox_MajorCoop(), null);
			jPanel_MajorCoop.add(jLabel_MajorCoop_L, null);
			jPanel_MajorCoop.add(jButton_MajorCoopAdd, null);
			jPanel_MajorCoop.add(jButton_MajorCoopIns, null);
			jPanel_MajorCoop.add(jButton_MajorCoopDel, null);
			jPanel_MajorCoop.add(getJScrollPane_MajorCoop(), null);
		}
		return jPanel_MajorCoop;
	}
	
	public JCheckBox getJCheckBox_MajorCoop() {
		if (jCheckBox_MajorCoop == null) {
			jCheckBox_MajorCoop = new JCheckBox();
			jCheckBox_MajorCoop.setBounds(new Rectangle(189, 10, 29, 18));
			jCheckBox_MajorCoop.setBorder(BorderFactory.createLineBorder(Color.black));
			jCheckBox_MajorCoop.setDebugGraphicsOptions(0);
			jCheckBox_MajorCoop.setBorderPainted(false);
			jCheckBox_MajorCoop.setContentAreaFilled(true);
			jCheckBox_MajorCoop.setFocusPainted(false);
			jCheckBox_MajorCoop.setMargin(new Insets(0, 0, 0, 0));
			jCheckBox_MajorCoop.setBorderPaintedFlat(true);
			jCheckBox_MajorCoop.setFont(fmeFrame.letra);
		}
		return jCheckBox_MajorCoop;
	}


	public JScrollPane getJScrollPane_MajorCoop() {
		if (jScrollPane_MajorCoop == null) {
		    jScrollPane_MajorCoop = new JScrollPane();
			jScrollPane_MajorCoop.setBounds(new Rectangle(10, 67, 619, 138));
			jScrollPane_MajorCoop.setViewportView(getJTable_MajorCoop());
		    jScrollPane_MajorCoop.setName("MajorCoop_ScrollPane");
			//jScrollPane_MajorCoop.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			jScrollPane_MajorCoop.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_MajorCoop.setBorder(BorderFactory.createEtchedBorder());
			//jScrollPane_MajorCoop.getViewport().add(jTable_MajorCoop);
		}
		return jScrollPane_MajorCoop;
	}
	
	public JTable getJTable_MajorCoop() {
		if (jTable_MajorCoop == null) {
			jTable_MajorCoop = new JTable_Tip(40, jScrollPane_MajorCoop.getWidth());
			jTable_MajorCoop.setRowHeight(18);
			jTable_MajorCoop.setFont(fmeFrame.letra);
		    jTable_MajorCoop.setName("MajorCoop_Tabela");
		    jTable_MajorCoop.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_MajorCoop;
	}


	void jButton_MajorCoopAdd_mouseClicked(MouseEvent e) {
		CBData.MajorCoop.on_add_row();
	}

	void jButton_MajorCoopDel_mouseClicked(MouseEvent e) {
		CBData.MajorCoop.on_del_row();
		CBData.MajorCoop.handler.j.revalidate();
		CBData.MajorCoop.handler.j.repaint();
	}

	void jButton_MajorCoopIns_mouseClicked(MouseEvent e) {
		CBData.MajorCoop.on_ins_row();
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 446, 18));
			jLabel_Fundam.setText("Fundamentao da cooperao");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 280, 640, 190));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("cond_eleg_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 140));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}

	private JPanel getJPanel_MajorEmpreend() {
		if (jPanel_MajorEmpreend == null) {
		    jLabel_FormaInd = new JLabel();
		    jLabel_FormaInd.setBounds(new Rectangle(140, 92, 193, 17));
		    jLabel_FormaInd.setText("Forma de Participao Indirecta");
		    jLabel_FormaInd.setFont(fmeFrame.letra);
		    jLabel_FormaInd.setForeground(fmeFrame.color_2);
		    jLabel_MajorEmpreendJovem = new JLabel();
		    jLabel_MajorEmpreendJovem.setBounds(new Rectangle(12, 10, 258, 18));
		    jLabel_MajorEmpreendJovem.setText("Majorao de Empreendedorismo Jovem");
		    jLabel_MajorEmpreendJovem.setFont(fmeFrame.letra_bold);

		    jLabel_MajorDetem = new JLabel();
		    jLabel_MajorDetem.setBounds(new Rectangle(12, 40, 258, 18));
		    jLabel_MajorDetem.setText("Detm participao igual ou superior a 50%:");
		    jLabel_MajorDetem.setFont(fmeFrame.letra);

		    jLabel_MajorEmpreendFem = new JLabel();
		    jLabel_MajorEmpreendFem.setBounds(new Rectangle(328, 10, 258, 18));
		    jLabel_MajorEmpreendFem.setText("Majorao de Empreendedorismo Feminino");
		    jLabel_MajorEmpreendFem.setFont(fmeFrame.letra_bold);

			jLabel_Nome = new JLabel();
			jLabel_Nome.setBounds(new Rectangle(38, 212, 40, 18));
			jLabel_Nome.setText("Nome");
			jLabel_Nome.setFont(fmeFrame.letra);
			jLabel_NIF = new JLabel();
			jLabel_NIF.setBounds(new Rectangle(38, 187, 40, 18));
			jLabel_NIF.setText("NIF");
			jLabel_NIF.setFont(fmeFrame.letra);
			jLabel_Part = new JLabel();
			jLabel_Part.setBounds(new Rectangle(38, 237, 53, 18));
			jLabel_Part.setText("Part. (%)");
			jLabel_Part.setFont(fmeFrame.letra);
			jLabel_Genero = new JLabel();
			jLabel_Genero.setBounds(new Rectangle(194, 237, 40, 18));
			jLabel_Genero.setText("Gnero");
			jLabel_Genero.setFont(fmeFrame.letra);
			jLabel_Idade = new JLabel();
			jLabel_Idade.setBounds(new Rectangle(359, 237, 40, 18));
			jLabel_Idade.setText("Idade");
			jLabel_Idade.setFont(fmeFrame.letra);
			jLabel_Cargo = new JLabel();
			jLabel_Cargo.setBounds(new Rectangle(38, 263, 40, 18));
			jLabel_Cargo.setText("Cargo");
			jLabel_Cargo.setFont(fmeFrame.letra);

			jPanel_MajorEmpreend = new JPanel();
			jPanel_MajorEmpreend.setLayout(null);
			jPanel_MajorEmpreend.setBounds(new Rectangle(15, 480, 640, 340));
			jPanel_MajorEmpreend.setBorder(BorderFactory.createEtchedBorder());
			jPanel_MajorEmpreend.add(jLabel_MajorEmpreendJovem, null);
			jPanel_MajorEmpreend.add(jLabel_MajorEmpreendFem, null);
			jPanel_MajorEmpreend.add(jLabel_MajorDetem, null);
			jPanel_MajorEmpreend.add(getJCheckBox_MajorEmpreendJovem(), null);
			jPanel_MajorEmpreend.add(getJCheckBox_MajorEmpreendFem(), null);
			jPanel_MajorEmpreend.add(getJCheckBox_Directa(), null);
			jPanel_MajorEmpreend.add(getJCheckBox_Indirecta(), null);
		    this.getJButtonGroup_Detem();
		    jPanel_MajorEmpreend.add(jLabel_NIF, null);
		    jPanel_MajorEmpreend.add(getJTextField_NIF(), null);
		    jPanel_MajorEmpreend.add(jLabel_Nome, null);
		    jPanel_MajorEmpreend.add(getJTextField_Nome(), null);
		    jPanel_MajorEmpreend.add(jLabel_Part, null);
		    jPanel_MajorEmpreend.add(getJTextField_Part(), null);
		    jPanel_MajorEmpreend.add(jLabel_Genero, null);
		    jPanel_MajorEmpreend.add(getJComboBox_Genero(), null);
		    jPanel_MajorEmpreend.add(jLabel_Idade, null);
		    jPanel_MajorEmpreend.add(getJTextField_Idade(), null);
		    jPanel_MajorEmpreend.add(jLabel_Cargo, null);
		    jPanel_MajorEmpreend.add(getJTextField_Cargo(), null);
		    jPanel_MajorEmpreend.add(getJScrollPane_Texto(), null);
		    jPanel_MajorEmpreend.add(getJCheckBox_Declaracao(), null);

		    jPanel_MajorEmpreend.add(jLabel_FormaInd, null);
		}
		return jPanel_MajorEmpreend;
	}
	public JCheckBox getJCheckBox_Directa() {
		if (jCheckBox_Directa == null) {
			jCheckBox_Directa = new JCheckBox();
			jCheckBox_Directa.setBounds(new Rectangle(32, 69, 70, 19));
			jCheckBox_Directa.setText("Directa");
			jCheckBox_Directa.setFont(fmeFrame.letra);
			jCheckBox_Directa.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Major.getByName("detem").vldOnline();}
					catch(Exception ex){}
				}
			});

		}
		return jCheckBox_Directa;
	}
	public JCheckBox getJCheckBox_Indirecta() {
		if (jCheckBox_Indirecta == null) {
			jCheckBox_Indirecta = new JCheckBox();
			jCheckBox_Indirecta.setBounds(new Rectangle(32, 89, 83, 23));
			jCheckBox_Indirecta.setText("Indirecta");
			jCheckBox_Indirecta.setFont(fmeFrame.letra);
			jCheckBox_Indirecta.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Major.getByName("detem").vldOnline();}
					catch(Exception ex){}
				}
			});

		}
		return jCheckBox_Indirecta;
	}
	
	private ButtonGroup getJButtonGroup_Detem() {
		if (jButtonGroup_Detem == null) {
			jButtonGroup_Detem = new ButtonGroup();
			jButtonGroup_Detem.add(jCheckBox_Directa);
			jButtonGroup_Detem.add(jCheckBox_Indirecta);
			jButtonGroup_Detem.add(jCheckBox_Detem_Clear);
		}
		return jButtonGroup_Detem;
	}
	public JTextField getJTextField_NIF() {
		if (jTextField_NIF == null) {
			jTextField_NIF = new JTextField();
			jTextField_NIF.setBounds(new Rectangle(87, 187, 80, 18));
			jTextField_NIF.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_NIF.setFont(fmeFrame.letra);
		}
		return jTextField_NIF;
	}

	public JTextField getJTextField_Nome() {
		if (jTextField_Nome == null) {
			jTextField_Nome = new JTextField();
			jTextField_Nome.setBounds(new Rectangle(87, 212, 450, 18));
			jTextField_Nome.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Nome.setFont(fmeFrame.letra);
		}
		return jTextField_Nome;
	}

	public JFormattedTextField getJTextField_Part() {
		if (jTextField_Part == null) {
			jTextField_Part = new JFormattedTextField();
			jTextField_Part.setBounds(new Rectangle(87, 237, 79, 18));
			jTextField_Part.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Part.setFont(fmeFrame.letra);
		}
		return jTextField_Part;
	}

	public SteppedComboBox getJComboBox_Genero() {
		if (jComboBox_Genero == null) {
			jComboBox_Genero = new SteppedComboBox();
			//jComboBox_Genero.setPopupWidth(210);
			jComboBox_Genero.setBorder(BorderFactory.createLineBorder(Color.black));
			//jComboBox_Genero.setBounds(new Rectangle(412, 136, 211, 18));
			jComboBox_Genero.setBounds(new Rectangle(236, 237, 79, 18));
			jComboBox_Genero.setFont(fmeFrame.letra);
			jComboBox_Genero.setBackground(Color.WHITE);
			jComboBox_Genero.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.Major.getByName("socio_genero").vldOnline();}
					catch(Exception ex){}
				}
			});
		}
		return jComboBox_Genero;
	}

	public JFormattedTextField getJTextField_Idade() {
		if (jTextField_Idade == null) {
			jTextField_Idade = new JFormattedTextField();
			jTextField_Idade.setBounds(new Rectangle(401, 237, 40, 18));
			jTextField_Idade.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Idade.setFont(fmeFrame.letra);
		}
		return jTextField_Idade;
	}

	public JTextField getJTextField_Cargo() {
		if (jTextField_Cargo == null) {
			jTextField_Cargo = new JTextField();
			jTextField_Cargo.setBounds(new Rectangle(87, 263, 450, 18));
			jTextField_Cargo.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Cargo.setFont(fmeFrame.letra);
		}
		return jTextField_Cargo;
	}

	public JCheckBox getJCheckBox_MajorEmpreendJovem() {
		if (jCheckBox_MajorEmpreendJovem == null) {
			jCheckBox_MajorEmpreendJovem = new JCheckBox();
			jCheckBox_MajorEmpreendJovem.setBounds(new Rectangle(271, 10, 28, 18));
			jCheckBox_MajorEmpreendJovem.setBorder(BorderFactory.createLineBorder(Color.black));
			jCheckBox_MajorEmpreendJovem.setDebugGraphicsOptions(0);
			jCheckBox_MajorEmpreendJovem.setBorderPainted(false);
			jCheckBox_MajorEmpreendJovem.setContentAreaFilled(true);
			jCheckBox_MajorEmpreendJovem.setFocusPainted(false);
			jCheckBox_MajorEmpreendJovem.setMargin(new Insets(0, 0, 0, 0));
			jCheckBox_MajorEmpreendJovem.setBorderPaintedFlat(true);
			jCheckBox_MajorEmpreendJovem.setFont(fmeFrame.letra);
		}
		return jCheckBox_MajorEmpreendJovem;
	}
	public JCheckBox getJCheckBox_MajorEmpreendFem() {
		if (jCheckBox_MajorEmpreendFem == null) {
			jCheckBox_MajorEmpreendFem = new JCheckBox();
			jCheckBox_MajorEmpreendFem.setBounds(new Rectangle(587, 10, 28, 18));
			jCheckBox_MajorEmpreendFem.setBorder(BorderFactory.createLineBorder(Color.black));
			jCheckBox_MajorEmpreendFem.setDebugGraphicsOptions(0);
			jCheckBox_MajorEmpreendFem.setBorderPainted(false);
			jCheckBox_MajorEmpreendFem.setContentAreaFilled(true);
			jCheckBox_MajorEmpreendFem.setFocusPainted(false);
			jCheckBox_MajorEmpreendFem.setMargin(new Insets(0, 0, 0, 0));
			jCheckBox_MajorEmpreendFem.setBorderPaintedFlat(true);
			jCheckBox_MajorEmpreendFem.setFont(fmeFrame.letra);
		}
		return jCheckBox_MajorEmpreendFem;
	}

	public JScrollPane getJScrollPane_Texto() {
		if (jScrollPane_Texto == null) {
			jScrollPane_Texto = new JScrollPane();
			jScrollPane_Texto.setBounds(new Rectangle(140, 110, 406, 50));
			jScrollPane_Texto.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Texto.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Texto.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Texto.setViewportView(getJTextArea_Texto());
		}
		return jScrollPane_Texto;
	}
	public JTextArea getJTextArea_Texto() {
		if (jTextArea_Texto == null) {
			jTextArea_Texto = new JTextArea();
			jTextArea_Texto.setFont(fmeFrame.letra);
			jTextArea_Texto.setLineWrap(true);
			jTextArea_Texto.setWrapStyleWord(true);
			jTextArea_Texto.setMargin(new Insets(5, 5, 5, 5));
			jTextArea_Texto.setEnabled(false);
			jTextArea_Texto.setEditable(false);
			jTextArea_Texto.setFocusable(false);
			jTextArea_Texto.setBackground(new Color(238,238,238));
		}
		return jTextArea_Texto;
	}
	public JCheckBox getJCheckBox_Declaracao() {
		if (jCheckBox_Declaracao == null) {
			jCheckBox_Declaracao = new JCheckBox();
			jCheckBox_Declaracao.setBounds(new Rectangle(37, 294, 502, 34));
			jCheckBox_Declaracao.setBorder(BorderFactory.createLineBorder(Color.black));
			jCheckBox_Declaracao.setDebugGraphicsOptions(0);
			jCheckBox_Declaracao.setBorderPainted(false);
			jCheckBox_Declaracao.setContentAreaFilled(true);
			jCheckBox_Declaracao.setFocusPainted(false);
			jCheckBox_Declaracao.setMargin(new Insets(0, 0, 0, 0));
			jCheckBox_Declaracao.setBorderPaintedFlat(true);
			jCheckBox_Declaracao.setFont(fmeFrame.letra);
			jCheckBox_Declaracao.setHorizontalTextPosition(SwingConstants.LEFT);
			jCheckBox_Declaracao.setText("<html>Compromete-se a manter as funes executivas e a participao igual ou superior a 50% durante, pelo menos, dois anos aps a concluso do projecto</html>");
		}
		return jCheckBox_Declaracao;
	}

	public JTable getJTable_MajorEmpreend() {
		if (jTable_MajorEmpreend == null) {
			jTable_MajorEmpreend = new JTable_Tip(40, jScrollPane_MajorCoop.getWidth());
			jTable_MajorEmpreend.setRowHeight(18);
			jTable_MajorEmpreend.setFont(fmeFrame.letra);
		    jTable_MajorEmpreend.setName("MajorCoop_Tabela");
		    jTable_MajorEmpreend.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		}
		return jTable_MajorEmpreend;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
//			    print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.dx_expand = jTable_MajorCoop.getWidth() - jScrollPane_MajorCoop.getWidth();
		int w = jPanel_MajorCoop.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
		
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.Major.Clear();
		CBData.MajorCoop.Clear();
	}	
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.Major.validar_1(null));
		grp.add_grp(CBData.Major.validar_2(null));
		return grp;
	}
}			

class Frame_Major_jButton_MajorCoopAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Major adaptee;

	Frame_Major_jButton_MajorCoopAdd_mouseAdapter(Frame_Major adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MajorCoopAdd_mouseClicked(e);
	}
}

class Frame_Major_jButton_MajorCoopDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Major adaptee;

	Frame_Major_jButton_MajorCoopDel_mouseAdapter(Frame_Major adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MajorCoopDel_mouseClicked(e);
	}
}

class Frame_Major_jButton_MajorCoopIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Major adaptee;

	Frame_Major_jButton_MajorCoopIns_mouseAdapter(Frame_Major adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_MajorCoopIns_mouseClicked(e);
	}
}
