package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_PessoalSC extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_PessoalSC = null;
	private JLabel jLabel_PessoalSC = null;
	private JScrollPane jScrollPane_PessoalSC = null;
	private JTableX jTable_PessoalSC = null;
	private JButton jButton_PessoalSCCopy = null;
	private JButton jButton_PessoalSCUp = null;
	private JButton jButton_PessoalSCAdd = null;
	private JButton jButton_PessoalSCIns = null;
	private JButton jButton_PessoalSCDel = null;

	public CBTabela_PessoalSC CBData_PessoalSC = null;
	String tag = "";

	public Frame_PessoalSC() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(970,470);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		up_component(jPanel_PessoalSC, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(970, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_PessoalSC(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_PessoalSC() {
		if (jPanel_PessoalSC == null) {
			jLabel_PessoalSC = new JLabel();
			jLabel_PessoalSC.setBounds(new Rectangle(12, 10, 399, 18));
			jLabel_PessoalSC.setText("Tcnicos de entidades de investigao por contrato");
			jLabel_PessoalSC.setFont(fmeFrame.letra_bold);

			jButton_PessoalSCCopy = new JButton(fmeFrame.copiarLinha);
			jButton_PessoalSCCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalSCCopy.addMouseListener(new Frame_PessoalSC_jButton_PessoalSCCopy_mouseAdapter(this));
			jButton_PessoalSCCopy.setToolTipText("Copiar Linha");
			jButton_PessoalSCCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_PessoalSCUp = new JButton(fmeFrame.subirLinha);
			jButton_PessoalSCUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalSCUp.addMouseListener(new Frame_PessoalSC_jButton_PessoalSCUp_mouseAdapter(this));
			jButton_PessoalSCUp.setToolTipText("Trocar Linhas");
			jButton_PessoalSCUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_PessoalSCAdd = new JButton(fmeFrame.novaLinha);
			jButton_PessoalSCAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalSCAdd.addMouseListener(new Frame_PessoalSC_jButton_PessoalSCAdd_mouseAdapter(this));
			jButton_PessoalSCAdd.setToolTipText("Nova Linha");
			jButton_PessoalSCAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_PessoalSCIns = new JButton(fmeFrame.inserirLinha);
			jButton_PessoalSCIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalSCIns.addMouseListener(new Frame_PessoalSC_jButton_PessoalSCIns_mouseAdapter(this));
			jButton_PessoalSCIns.setToolTipText("Inserir Linha");
			jButton_PessoalSCIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_PessoalSCDel = new JButton(fmeFrame.apagarLinha);
			jButton_PessoalSCDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_PessoalSCDel.addMouseListener(new Frame_PessoalSC_jButton_PessoalSCDel_mouseAdapter(this));
			jButton_PessoalSCDel.setToolTipText("Apagar Linha");
			jButton_PessoalSCDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_PessoalSC = new JPanel();
			jPanel_PessoalSC.setLayout(null);
			jPanel_PessoalSC.setBounds(new Rectangle(15, 50, 940, 402));
			jPanel_PessoalSC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_PessoalSC.add(jLabel_PessoalSC, null);
//			jPanel_PessoalSC.add(jButton_PessoalSCCopy, null);
//			jPanel_PessoalSC.add(jButton_PessoalSCUp, null);
			jPanel_PessoalSC.add(jButton_PessoalSCAdd, null);
			jPanel_PessoalSC.add(jButton_PessoalSCIns, null);
			jPanel_PessoalSC.add(jButton_PessoalSCDel, null);
			jPanel_PessoalSC.add(getJScrollPane_PessoalSC(), null);
		}
		return jPanel_PessoalSC;
	}
	public JScrollPane getJScrollPane_PessoalSC() {
		if (jScrollPane_PessoalSC == null) {
			jScrollPane_PessoalSC = new JScrollPane();
			jScrollPane_PessoalSC.setBounds(new Rectangle(16, 36, 906, 350));
			jScrollPane_PessoalSC.setViewportView(getJTable_PessoalSC());
			jScrollPane_PessoalSC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_PessoalSC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_PessoalSC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_PessoalSC;
	}
	public JTable getJTable_PessoalSC() {
		if (jTable_PessoalSC == null) {
			jTable_PessoalSC = new JTableX(40, jScrollPane_PessoalSC.getWidth());
			jTable_PessoalSC.setFont(fmeFrame.letra);
			jTable_PessoalSC.setRowHeight(18);
			jTable_PessoalSC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_PessoalSC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_PessoalSC;
	}
	void jButton_PessoalSCCopy_mouseClicked(MouseEvent e) {
		CBData_PessoalSC.on_copy_row();
	}
	void jButton_PessoalSCUp_mouseClicked(MouseEvent e) {
		CBData_PessoalSC.on_up_row();
	}
	void jButton_PessoalSCAdd_mouseClicked(MouseEvent e) {
		CBData_PessoalSC.on_add_row();
	}
	void jButton_PessoalSCDel_mouseClicked(MouseEvent e) {
		CBData_PessoalSC.on_del_row();
	}
	void jButton_PessoalSCIns_mouseClicked(MouseEvent e) {
		CBData_PessoalSC.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		//print_handler.setOrientation (PageFormat.LANDSCAPE);
		
		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_PessoalSC.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData_PessoalSC.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData_PessoalSC.validar(null));
		return grp;
	}
}

class Frame_PessoalSC_jButton_PessoalSCCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PessoalSC adaptee;
	
	Frame_PessoalSC_jButton_PessoalSCCopy_mouseAdapter(Frame_PessoalSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalSCCopy_mouseClicked(e);
	}	
}

class Frame_PessoalSC_jButton_PessoalSCUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PessoalSC adaptee;
	
	Frame_PessoalSC_jButton_PessoalSCUp_mouseAdapter(Frame_PessoalSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalSCUp_mouseClicked(e);
	}
}

class Frame_PessoalSC_jButton_PessoalSCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PessoalSC adaptee;

	Frame_PessoalSC_jButton_PessoalSCAdd_mouseAdapter(Frame_PessoalSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalSCAdd_mouseClicked(e);
	}
}

class Frame_PessoalSC_jButton_PessoalSCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PessoalSC adaptee;

	Frame_PessoalSC_jButton_PessoalSCDel_mouseAdapter(Frame_PessoalSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalSCDel_mouseClicked(e);
	}
}

class Frame_PessoalSC_jButton_PessoalSCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_PessoalSC adaptee;

	Frame_PessoalSC_jButton_PessoalSCIns_mouseAdapter(Frame_PessoalSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_PessoalSCIns_mouseClicked(e);
	}
}
