package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.SystemColor;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.print.PageFormat;

import javax.swing.*;
import javax.swing.border.Border;

import java.util.HashMap;

import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JFormattedTextField;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.JTextField;

public class Frame_Proj_1 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;

	private JPanel jContentPane = null;

	private JLabel jLabel_P07 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Responsavel = null;
	private JLabel jLabel_Responsavel = null;
	private JLabel jLabel_Nome = null;
	private JTextField jTextField_Nome = null;
	private JLabel jLabel_Funcao = null;
	private JTextField jTextField_Funcao = null;
	
	private JLabel jLabel_Telemovel = null;
	private JTextField jTextField_Telemovel = null;
	private JLabel jLabel_Email = null;
	private JTextField jTextField_Email = null;

	private JPanel jPanel_Projecto = null;
	private JLabel jLabel_Projecto = null;
	private JLabel jLabel_Designacao = null;
	private JTextField jTextField_Designacao = null;
	private JTable_Tip jTable_Tipologia = null;

	private JPanel jPanel_Calendar = null;
	private JLabel jLabel_Calendar = null;
	private JLabel jLabel_Inicio = null;
	private JFormattedTextField jTextField_Inicio = null;
	private JLabel jLabel_Fim = null;
	private JFormattedTextField jTextField_Fim = null;

	private JPanel jPanel_CAE = null;
	private JLabel jLabel_CAE = null;
	private JScrollPane jScrollPane_CAE = null;
	private JTable_Tip jTable_CAE = null;

	private JLabel jLabel_Acronimo = null;
	private JLabel jLabel_Estrategia = null;
	private JLabel jLabel_AreasTecno = null;
	private JTextField jTextField_Acronimo = null;
	private JTextField jTextField_Estrategia = null;
	private JScrollPane jScrollPane_RedesIntID = null;
	private JTable_Tip jTable_RedesIntID = null;

	private JFormattedTextField jTextField_Meses = null;
	private JLabel jLabel_Meses = null;

	private JPanel jPanel_RedesIntID = null;
	private JLabel jLabel_RedesIntID = null;
	private JScrollPane jScrollPane_AreasTecno = null;
	private JTable_Tip jTable_AreasTecno = null;
	private JLabel jLabel_RPIID = null;
	private JCheckBox jCheckBox_RPIID_Sim = null;
	private JCheckBox jCheckBox_RPIID_Nao = null;
	public JCheckBox jCheckBox_RPIID_Clear = new JCheckBox();
	private ButtonGroup jButtonGroup_RPIID = null;  //  @jve:decl-index=0:

	public CBTabela_RedesIntID CBData_RedesIntID = null;
	public CBTabela_AreasTecno CBData_AreasTecno = null;
	String tag = "";
		
	public Frame_Proj_1() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,850);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}
	
	public void x (Dimension d){
		this.setPreferredSize(d);
		this.revalidate();
		this.repaint();
	}
	
	private void initialize() {
		this.setSize(690, 1950 );
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_P07 = new JLabel();
			jLabel_P07.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P07.setText("   DADOS DO PROJECTO");
			jLabel_P07.setFont(fmeFrame.letra_titulo);
			jLabel_P07.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P07, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_Responsavel(), null);
			jContentPane.add(getJPanel_Projecto(), null);
			jContentPane.add(getJPanel_RedesIntID(), null);
			jContentPane.add(getJPanel_Calendar(), null);
			jContentPane.add(getJPanel_CAE(), null);
		}
		return jContentPane;
	}
	
	private JPanel getJPanel_Responsavel() {
		if (jPanel_Responsavel == null) {
			jLabel_Nome = new JLabel();
			jLabel_Nome.setBounds(new Rectangle(29, 38, 98, 18));
			jLabel_Nome.setText("Nome");
			jLabel_Nome.setFont(fmeFrame.letra);

			jLabel_Funcao = new JLabel();
			jLabel_Funcao.setBounds(new Rectangle(28, 65, 98, 18));
			jLabel_Funcao.setText("Funo no promotor");
			jLabel_Funcao.setHorizontalAlignment(SwingConstants.LEFT);
			jLabel_Funcao.setFont(fmeFrame.letra);

			jLabel_Telemovel = new JLabel();
			jLabel_Telemovel.setBounds(new Rectangle(438, 38, 54, 18));
			jLabel_Telemovel.setText("Telemvel");
			jLabel_Telemovel.setHorizontalAlignment(SwingConstants.RIGHT);
			jLabel_Telemovel.setFont(fmeFrame.letra);

			jLabel_Email = new JLabel();
			jLabel_Email.setBounds(new Rectangle(438, 65, 54, 18));
			jLabel_Email.setText("E-Mail");
			jLabel_Email.setHorizontalAlignment(SwingConstants.RIGHT);
			jLabel_Email.setFont(fmeFrame.letra);

			jLabel_Responsavel = new JLabel();
			jLabel_Responsavel.setText("Responsvel pelo Projecto");
			jLabel_Responsavel.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_Responsavel.setFont(fmeFrame.letra_bold);
			
			jPanel_Responsavel = new JPanel();
			jPanel_Responsavel.setLayout(null);
			jPanel_Responsavel.setBounds(new Rectangle(15, 248, 640, 98));
			jPanel_Responsavel.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Responsavel.add(jLabel_Responsavel);
			jPanel_Responsavel.add(jLabel_Nome);
			jPanel_Responsavel.add(getJTextField_Nome());
			jPanel_Responsavel.add(jLabel_Funcao);
			jPanel_Responsavel.add(getJTextField_Funcao());
			jPanel_Responsavel.add(jLabel_Telemovel);
			jPanel_Responsavel.add(getJTextField_Telemovel());
			jPanel_Responsavel.add(jLabel_Email);
			jPanel_Responsavel.add(getJTextField_Email());
		}
		return jPanel_Responsavel;
	}

	public JTextField getJTextField_Nome() {
		if (jTextField_Nome == null) {
			jTextField_Nome = new JTextField();
			jTextField_Nome.setBounds(new Rectangle(128, 38, 296, 18));
			jTextField_Nome.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Nome.setFont(fmeFrame.letra);
		}
		return jTextField_Nome;
	}
	
	private ButtonGroup getJButtonGroup_RPIID() {
		if (jButtonGroup_RPIID == null) {
			jButtonGroup_RPIID = new ButtonGroup();
			jButtonGroup_RPIID.add(jCheckBox_RPIID_Sim);
			jButtonGroup_RPIID.add(jCheckBox_RPIID_Nao);
			jButtonGroup_RPIID.add(jCheckBox_RPIID_Clear);
		}
		return jButtonGroup_RPIID;
	}

	public JTextField getJTextField_Funcao() {
		if (jTextField_Funcao == null) {
			jTextField_Funcao = new JTextField();
			jTextField_Funcao.setBounds(new Rectangle(128, 65, 296, 18));
			jTextField_Funcao.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Funcao.setFont(fmeFrame.letra);
		}
		return jTextField_Funcao;
	}


	public JTextField getJTextField_Telemovel() {
		if (jTextField_Telemovel == null) {
			jTextField_Telemovel = new JTextField();
			jTextField_Telemovel.setBounds(new Rectangle(497, 38, 128, 18));
			jTextField_Telemovel.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Telemovel.setFont(fmeFrame.letra);
		}
		return jTextField_Telemovel;
	}
	
	public JTextField getJTextField_Email() {
		if (jTextField_Email == null) {
			jTextField_Email = new JTextField();
			jTextField_Email.setBounds(new Rectangle(497, 65, 128, 18));
			jTextField_Email.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Email.setFont(fmeFrame.letra);
		}
		return jTextField_Email;
	}

	public JPanel getJPanel_Projecto() {
		if (jPanel_Projecto == null) {
			jLabel_AreasTecno = new JLabel();
			jLabel_AreasTecno.setBounds(new Rectangle(29, 119, 110, 18));
			jLabel_AreasTecno.setText("reas Tecnolgicas");
			jLabel_AreasTecno.setFont(fmeFrame.letra);
			jLabel_Estrategia = new JLabel();
			jLabel_Estrategia.setBounds(new Rectangle(29, 92, 110, 18));
			jLabel_Estrategia.setText("Estratgia Dominante");
			jLabel_Estrategia.setFont(fmeFrame.letra);
			jLabel_Acronimo = new JLabel();
			jLabel_Acronimo.setBounds(new Rectangle(29, 38, 63, 18));
			jLabel_Acronimo.setText("Acrnimo");
			jLabel_Acronimo.setFont(fmeFrame.letra);
			jLabel_Designacao = new JLabel();
			jLabel_Designacao.setBounds(new Rectangle(29, 65, 110, 19));
			jLabel_Designacao.setText("Designao");
			jLabel_Designacao.setFont(fmeFrame.letra);

			jLabel_Projecto = new JLabel();
			jLabel_Projecto.setText("Descrio e Tipologia do Projecto");
			jLabel_Projecto.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_Projecto.setFont(fmeFrame.letra_bold);
			
			jPanel_Projecto = new JPanel();
			jPanel_Projecto.setLayout(null);
			jPanel_Projecto.setBounds(new Rectangle(15, 50, 640, 188));
			jPanel_Projecto.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Projecto.add(jLabel_Projecto);
			jPanel_Projecto.add(jLabel_Designacao);
			jPanel_Projecto.add(getJTextField_Designacao());
			jPanel_Projecto.add(jLabel_Acronimo, null);
			jPanel_Projecto.add(jLabel_Estrategia, null);
			jPanel_Projecto.add(jLabel_AreasTecno, null);
			jPanel_Projecto.add(getJTextField_Acronimo(), null);
			jPanel_Projecto.add(getJTextField_Estrategia(), null);
//			jPanel_Projecto.add(getJScrollPane_AreasTecno(), null);
			jPanel_Projecto.add(getJScrollPane_AreasTecno(), null);
		}
		return jPanel_Projecto;
	}

	public JTable_Tip getJTable_Tipologia() {
		if (jTable_Tipologia == null) {
			jTable_Tipologia = new JTable_Tip(0);
			jTable_Tipologia.setRowHeight(18);
			jTable_Tipologia.setFont(fmeFrame.letra);
			jTable_Tipologia.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Tipologia.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			//jTable_Tipologia.setTableHeader( null );
		}
		return jTable_Tipologia;
	}

	private JPanel getJPanel_RedesIntID() {
		if (jPanel_RedesIntID == null) {
			jLabel_RPIID = new JLabel();
			jLabel_RPIID.setBounds(new Rectangle(29, 38, 371, 18));
			jLabel_RPIID.setText("O Projecto est inserido em redes e Programas Internacionais de I&D?");
			jLabel_RPIID.setFont(fmeFrame.letra);
			jLabel_RedesIntID = new JLabel();
			jLabel_RedesIntID.setBounds(new Rectangle(12, 10, 616, 18));
			jLabel_RedesIntID.setText("Insero em Redes e Programas Internacionais de I&D");
			jLabel_RedesIntID.setFont(fmeFrame.letra_bold);

			jPanel_RedesIntID = new JPanel();
			jPanel_RedesIntID.setLayout(null);
			jPanel_RedesIntID.setBounds(new Rectangle(15, 356, 640, 212));
			jPanel_RedesIntID.setBorder(BorderFactory.createEtchedBorder());
			jPanel_RedesIntID.add(jLabel_RedesIntID, null);
			jPanel_RedesIntID.add(getJScrollPane_RedesIntID(), null);
			jPanel_RedesIntID.add(jLabel_RPIID, null);
			jPanel_RedesIntID.add(getJCheckBox_RPIID_Sim(), null);
			jPanel_RedesIntID.add(getJCheckBox_RPIID_Nao(), null);
			this.getJButtonGroup_RPIID();
		}
		return jPanel_RedesIntID;
	}
	public JScrollPane getJScrollPane_RedesIntID() {
		if (jScrollPane_RedesIntID == null) {
			jScrollPane_RedesIntID = new JScrollPane();
			jScrollPane_RedesIntID.setBounds(new Rectangle(16, 74, 606, 120));
			jScrollPane_RedesIntID.setViewportView(getJTable_RedesIntID());
			jScrollPane_RedesIntID.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_RedesIntID.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_RedesIntID.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_RedesIntID;
	}
	public JTable getJTable_RedesIntID() {
		if (jTable_RedesIntID == null) {
			jTable_RedesIntID = new JTable_Tip();
			jTable_RedesIntID.setFont(fmeFrame.letra);
			jTable_RedesIntID.setRowHeight(18);
			jTable_RedesIntID.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_RedesIntID.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_RedesIntID;
	}
	public JScrollPane getJScrollPane_AreasTecno() {
		if (jScrollPane_AreasTecno == null) {
			jScrollPane_AreasTecno = new JScrollPane();
			jScrollPane_AreasTecno.setBounds(new Rectangle(141, 119, 484, 58));
			jScrollPane_AreasTecno.setViewportView(getJTable_AreasTecno());
			jScrollPane_AreasTecno.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_AreasTecno.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_AreasTecno.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_AreasTecno;
	}
	public JTable getJTable_AreasTecno() {
		if (jTable_AreasTecno == null) {
			jTable_AreasTecno = new JTable_Tip(-1);
			jTable_AreasTecno.setFont(fmeFrame.letra);
			jTable_AreasTecno.setRowHeight(18);
			jTable_AreasTecno.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_AreasTecno.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_AreasTecno;
	}

	public JTextField getJTextField_Designacao() {
		if (jTextField_Designacao == null) {
			jTextField_Designacao = new JTextField();
			jTextField_Designacao.setBounds(new Rectangle(141, 65, 484, 18));
			jTextField_Designacao.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Designacao.setFont(fmeFrame.letra);
		}
		return jTextField_Designacao;
	}
	
	public JPanel getJPanel_Calendar() {
		if (jPanel_Calendar == null) {
			jLabel_Meses = new JLabel();
			jLabel_Meses.setBounds(new Rectangle(252, 38, 66, 18));
			jLabel_Meses.setText("N meses");
			jLabel_Meses.setFont(fmeFrame.letra);
			//jLabel_Meses.setVisible(false);
			jLabel_Inicio = new JLabel();
			jLabel_Inicio.setBounds(new Rectangle(29, 38, 74, 18));
			jLabel_Inicio.setText("Data de Incio");
			jLabel_Inicio.setFont(fmeFrame.letra);

			jLabel_Fim = new JLabel();
			jLabel_Fim.setBounds(new Rectangle(421, 38, 65, 18));
			jLabel_Fim.setText("Data de Fim");
			jLabel_Fim.setFont(fmeFrame.letra);

			jLabel_Calendar = new JLabel();
			jLabel_Calendar.setText("Calendarizao");
			jLabel_Calendar.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_Calendar.setFont(fmeFrame.letra_bold);
			
			jPanel_Calendar = new JPanel();
			jPanel_Calendar.setLayout(null);
			jPanel_Calendar.setBounds(new Rectangle(15, 578, 640, 75));
			jPanel_Calendar.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Calendar.add(jLabel_Calendar);
			jPanel_Calendar.add(jLabel_Inicio);
			jPanel_Calendar.add(getJTextField_Inicio());
			jPanel_Calendar.add(jLabel_Fim);
			jPanel_Calendar.add(getJTextField_Fim());
			jPanel_Calendar.add(getJTextField_Meses(), null);
			jPanel_Calendar.add(jLabel_Meses, null);
		}
		return jPanel_Calendar;
	}
	
	public JFormattedTextField getJTextField_Inicio() {
		if (jTextField_Inicio == null) {
			jTextField_Inicio = new JFormattedTextField();
			jTextField_Inicio.setBounds(new Rectangle(101, 38, 81, 18));
			jTextField_Inicio.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Inicio.setFont(fmeFrame.letra);
			jTextField_Inicio.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try{CBData.DadosProjecto.getByName("dt_inicio").vldOnline();}
					catch(Exception ex){}
				}
			});
		}
		return jTextField_Inicio;
	}
	public JFormattedTextField getJTextField_Fim() {
		if (jTextField_Fim == null) {
			jTextField_Fim = new JFormattedTextField();
			jTextField_Fim.setBounds(new Rectangle(486, 38, 81, 18));
			jTextField_Fim.setBorder(BorderFactory.createLineBorder(Color.black));
			//jTextField_Fim.setEditable(false);
			jTextField_Fim.setFont(fmeFrame.letra);
		}
		return jTextField_Fim;
	}
	public JPanel getJPanel_CAE() {
		if (jPanel_CAE == null) {
			jLabel_CAE = new JLabel();
			jLabel_CAE.setBounds(new Rectangle(12, 10, 301, 18));
			jLabel_CAE.setText("Actividade(s) Econmica(s) do Projecto");
			jLabel_CAE.setFont(fmeFrame.letra_bold);			
			jPanel_CAE = new JPanel();
			jPanel_CAE.setLayout(null);
			jPanel_CAE.setBounds(new Rectangle(15, 663, 640, 160));
			jPanel_CAE.setBorder(BorderFactory.createEtchedBorder());
			jPanel_CAE.add(jLabel_CAE, null);
			jPanel_CAE.add(getJScrollPane_CAE(), null);
			//jPanel_CAE.add(getJTable_CAE(), null);
		}
		return jPanel_CAE;
	}

	public JScrollPane getJScrollPane_CAE() {
		if (jScrollPane_CAE == null) {
			jScrollPane_CAE = new JScrollPane();
			jScrollPane_CAE.setBounds(new Rectangle(18, 36, 610, 101));
			jScrollPane_CAE.setViewportView(getJTable_CAE());
			jScrollPane_CAE.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_CAE.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_NEVER);
			jScrollPane_CAE.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_CAE;
	}

	public JTable_Tip getJTable_CAE() {
		if (jTable_CAE == null) {
			jTable_CAE = new JTable_Tip();
			jTable_CAE.setRowHeight(18);
			jTable_CAE.setBounds(new Rectangle(18, 26, 610, 101));
			jTable_CAE.setFont(fmeFrame.letra);
		}
		return jTable_CAE;
	}


	//------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_CAE.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.Responsavel.Clear();
		CBData.DadosProjecto.Clear();
		//CBData.Tipologia.Clear();
		CBData.ProjCae.Clear();
		CBData_RedesIntID.Clear();
		CBData_AreasTecno.Clear();
		//CBData.BalIntercalar.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.DadosProjecto.validar_1(null));
		grp.add_grp(CBData.Responsavel.validar_1(null));
//		grp.add_grp(CBData.Tipologia.validar(null));
		grp.add_grp(CBData.Responsavel.validar_2(null));
		grp.add_grp(CBData_RedesIntID.validar(null));
		grp.add_grp(CBData.DadosProjecto.validar_2(null));
		grp.add_grp(CBData.ProjCae.validar(null));
		//grp.add_grp(CBData_AreasTecno.validar(null));
		//grp.add_grp(CBData.BalIntercalar.validar(null));
		return grp;
	}

	public JFormattedTextField getJTextField_Meses() {
		if (jTextField_Meses == null) {
			jTextField_Meses = new JFormattedTextField();
			jTextField_Meses.setBounds(new Rectangle(324, 38, 48, 18));
			jTextField_Meses.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Meses.setFont(fmeFrame.letra);
			jTextField_Meses.setEditable(false);
			
			//jTextField_Meses.setVisible(false);
		}
		return jTextField_Meses;
	}

	public JTextField getJTextField_Acronimo() {
		if (jTextField_Acronimo == null) {
			jTextField_Acronimo = new JTextField();
			jTextField_Acronimo.setBounds(new Rectangle(141, 38, 117, 18));
			jTextField_Acronimo.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Acronimo.setFont(fmeFrame.letra);
		}
		return jTextField_Acronimo;
	}

	public JTextField getJTextField_Estrategia() {
		if (jTextField_Estrategia == null) {
			jTextField_Estrategia = new JTextField();
			jTextField_Estrategia.setBounds(new Rectangle(141, 92, 484, 18));
			jTextField_Estrategia.setBorder(BorderFactory.createLineBorder(Color.black));
			jTextField_Estrategia.setFont(fmeFrame.letra);
		}
		return jTextField_Estrategia;
	}

	public JCheckBox getJCheckBox_RPIID_Sim() {
		if (jCheckBox_RPIID_Sim == null) {
			jCheckBox_RPIID_Sim = new JCheckBox();
			jCheckBox_RPIID_Sim.setBounds(new Rectangle(450, 36, 50, 22));
			jCheckBox_RPIID_Sim.setText("Sim");
			jCheckBox_RPIID_Sim.setFont(fmeFrame.letra);
		}
		return jCheckBox_RPIID_Sim;
	}
	public JCheckBox getJCheckBox_RPIID_Nao() {
		if (jCheckBox_RPIID_Nao == null) {
			jCheckBox_RPIID_Nao = new JCheckBox();
			jCheckBox_RPIID_Nao.setBounds(new Rectangle(500, 36, 50, 22));
			jCheckBox_RPIID_Nao.setText("No");
			jCheckBox_RPIID_Nao.setFont(fmeFrame.letra);
		}
		return jCheckBox_RPIID_Nao;
	}
}
