package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.print.*;

import java.util.HashMap;

public class Frame_Projectos extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_P15 = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_Projectos = null;
	private JLabel jLabel_Projectos = null;
	private JScrollPane jScrollPane_Projectos = null;
	private JTable_Tip jTable_Projectos = null;
	private JButton jButton_ProjectosAdd = null;
	private JButton jButton_ProjectosIns = null;
	private JButton jButton_ProjectosDel = null;

	private JPanel jPanel_Fundam = null;
	private JLabel jLabel_Fundam = null;
	private JScrollPane jScrollPane_Fundam = null;
	private JTextArea jTextArea_Fundam = null;

	private JPanel jPanel_FundamC = null;
	private JLabel jLabel_FundamC = null;
	private JLabel jLabel_FundamC_ = null;
	private JScrollPane jScrollPane_FundamC = null;
	private JTextArea jTextArea_FundamC = null;

	private JPanel jPanel_TecnicosC = null;
	private JLabel jLabel_TecnicosC = null;
	private JScrollPane jScrollPane_TecnicosC = null;
	private JTable_Tip jTable_TecnicosC = null;
	private JButton jButton_TecnicosCAdd = null;
	private JButton jButton_TecnicosCIns = null;
	private JButton jButton_TecnicosCDel = null;

	HashMap hs;  //  @jve:decl-index=0:

	String tag = "";
		
	public Frame_Projectos() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,1125);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		this.hs = params;
		if ( params.get("centros")!=null && params.get("centros").equals("0") ) {
			jPanel_FundamC.setVisible(false);
			jPanel_TecnicosC.setVisible(false);
		}
		if ( params.get("centros")!=null && params.get("centros").equals("1") ) {
			jPanel_Fundam.setVisible(false);
			up_component (jPanel_FundamC, jPanel_Fundam.getHeight()+10);
			up_component (jPanel_TecnicosC, jPanel_Fundam.getHeight()+10);
		}
	}
	
	private void initialize() {
		this.setSize(670, 1500);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			
			jLabel_P15 = new JLabel();
			jLabel_P15.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P15.setText("   DADOS DO PROJECTO");
			jLabel_P15.setFont(fmeFrame.letra_titulo);
			jLabel_P15.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_P15, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_Projectos(), null);
			jContentPane.add(getJPanel_Fundam(), null);
			jContentPane.add(getJPanel_FundamC(), null);
			jContentPane.add(getJPanel_TecnicosC(), null);
			
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_Projectos() {
		if (jPanel_Projectos == null) {
		    jButton_ProjectosAdd = new JButton(fmeFrame.novaLinha);
		    jButton_ProjectosAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ProjectosAdd.addMouseListener(new Frame_Projectos_jButton_ProjectosAdd_mouseAdapter(this));
		    jButton_ProjectosAdd.setToolTipText("Nova Linha");
		    jButton_ProjectosAdd.setBounds(new Rectangle(517, 11, 30, 22));
		    jButton_ProjectosIns = new JButton(fmeFrame.inserirLinha);
		    jButton_ProjectosIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ProjectosIns.addMouseListener(new Frame_Projectos_jButton_ProjectosIns_mouseAdapter(this));
		    jButton_ProjectosIns.setToolTipText("Inserir Linha");
		    jButton_ProjectosIns.setBounds(new Rectangle(557, 11, 30, 22));
		    jButton_ProjectosDel = new JButton(fmeFrame.apagarLinha);
		    jButton_ProjectosDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_ProjectosDel.addMouseListener(new Frame_Projectos_jButton_ProjectosDel_mouseAdapter(this));
		    jButton_ProjectosDel.setToolTipText("Apagar Linha");
		    jButton_ProjectosDel.setBounds(new Rectangle(597, 11, 30, 22));
			jLabel_Projectos = new JLabel();
			jLabel_Projectos.setBounds(new Rectangle(12, 10, 362, 18));
			jLabel_Projectos.setText("<html>Identificao dos projectos de I&DT a desenvolver</html>");
			jLabel_Projectos.setFont(fmeFrame.letra_bold);			
			jPanel_Projectos = new JPanel();
			jPanel_Projectos.setLayout(null);
			jPanel_Projectos.setBounds(new Rectangle(15, 50, 640, 230));
			jPanel_Projectos.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Projectos.add(jLabel_Projectos, null);
			jPanel_Projectos.add(jButton_ProjectosAdd, null);
			jPanel_Projectos.add(jButton_ProjectosIns, null);
			jPanel_Projectos.add(jButton_ProjectosDel, null);
			jPanel_Projectos.add(getJScrollPane_Projectos(), null);
		}
		return jPanel_Projectos;
	}
	
	public JScrollPane getJScrollPane_Projectos() {
		if (jScrollPane_Projectos == null) {
			jScrollPane_Projectos = new JScrollPane();
			jScrollPane_Projectos.setBounds(new Rectangle(10, 40, 620, 170));
			jScrollPane_Projectos.setViewportView(getJTable_Projectos());
			//jScrollPane_Projectos.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_Projectos.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_Projectos.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_Projectos;
	}
	
	public JTable getJTable_Projectos() {
		if (jTable_Projectos == null) {
			jTable_Projectos = new JTable_Tip(40, jScrollPane_Projectos.getWidth());
			jTable_Projectos.setFont(fmeFrame.letra);
			jTable_Projectos.setRowHeight(18);
			jTable_Projectos.setName("QuadrosTecn_Tabela");
			jTable_Projectos.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_Projectos.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_Projectos;
	}
	void jButton_ProjectosAdd_mouseClicked(MouseEvent e) {
		CBData.ProjIDT.on_add_row();
	}

	void jButton_ProjectosDel_mouseClicked(MouseEvent e) {
		if ( CBData.ProjIDT.del_ins_ok("Apagar")){
			CBData.ProjIDT.on_del_row();
			CTabelas.ProjIDT.refresh();
		}
	}

	void jButton_ProjectosIns_mouseClicked(MouseEvent e) {
		if ( CBData.ProjIDT.del_ins_ok("Inserir")){
			CBData.ProjIDT.on_ins_row();
		}
	}

	private JPanel getJPanel_Fundam() {
		if (jPanel_Fundam == null) {
			jLabel_Fundam = new JLabel();
			jLabel_Fundam.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_Fundam.setText("Objectivos, Metas e Mecanismos de Valorizao dos resultados face ao Mercado (por Projecto)");
			jLabel_Fundam.setFont(fmeFrame.letra_bold);

			jPanel_Fundam = new JPanel();
			jPanel_Fundam.setLayout(null);
			jPanel_Fundam.setBounds(new Rectangle(15, 290, 640, 310));
			jPanel_Fundam.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Fundam.setName("quadros_tecnicos_texto");
			jPanel_Fundam.add(jLabel_Fundam, null);
			jPanel_Fundam.add(getJScrollPane_Fundam(), null);
			
		}
		return jPanel_Fundam;
	}
	
	public JScrollPane getJScrollPane_Fundam() {
		if (jScrollPane_Fundam == null) {
			jScrollPane_Fundam = new JScrollPane();
			jScrollPane_Fundam.setBounds(new Rectangle(15, 36, 606, 255));
			jScrollPane_Fundam.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Fundam.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Fundam.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Fundam.setViewportView(getJTextArea_Fundam());
		}
		return jScrollPane_Fundam;
	}
	public JTextArea getJTextArea_Fundam() {
		if (jTextArea_Fundam == null) {
			jTextArea_Fundam = new JTextArea();
			jTextArea_Fundam.setFont(fmeFrame.letra);
			jTextArea_Fundam.setLineWrap(true);
			jTextArea_Fundam.setWrapStyleWord(true);
			jTextArea_Fundam.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Fundam;
	}

	private JPanel getJPanel_FundamC() {
		if (jPanel_FundamC == null) {
			jLabel_FundamC = new JLabel();
			jLabel_FundamC.setBounds(new Rectangle(12, 10, 609, 18));
			jLabel_FundamC.setText("Descrio dos objectivos dos Projectos de I&DT a desenvolver referindo ainda:");
			jLabel_FundamC.setFont(fmeFrame.letra_bold);
			jLabel_FundamC_ = new JLabel();
			jLabel_FundamC_.setBounds(new Rectangle(23, 30, 598, 46));
			jLabel_FundamC_.setText("<html>a) as caractersticas inovadoras dos produtos/processos/servios<br>b) a sua situao no mercado<br>c) o estado da arte</html>");
			jLabel_FundamC_.setFont(fmeFrame.letra);

			jPanel_FundamC = new JPanel();
			jPanel_FundamC.setLayout(null);
			jPanel_FundamC.setBounds(new Rectangle(15, 610, 640, 310));
			jPanel_FundamC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_FundamC.setName("quadros_tecnicos_texto");
			jPanel_FundamC.add(jLabel_FundamC, null);
			jPanel_FundamC.add(jLabel_FundamC_, null);
			jPanel_FundamC.add(getJScrollPane_FundamC(), null);
			
		}
		return jPanel_FundamC;
	}
	
	public JScrollPane getJScrollPane_FundamC() {
		if (jScrollPane_FundamC == null) {
			jScrollPane_FundamC = new JScrollPane();
			jScrollPane_FundamC.setBounds(new Rectangle(15, 76, 606, 215));
			jScrollPane_FundamC.setPreferredSize(new Dimension(250, 250));
			jScrollPane_FundamC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_FundamC.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_FundamC.setViewportView(getJTextArea_FundamC());
		}
		return jScrollPane_FundamC;
	}
	public JTextArea getJTextArea_FundamC() {
		if (jTextArea_FundamC == null) {
			jTextArea_FundamC = new JTextArea();
			jTextArea_FundamC.setFont(fmeFrame.letra);
			jTextArea_FundamC.setLineWrap(true);
			jTextArea_FundamC.setWrapStyleWord(true);
			jTextArea_FundamC.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_FundamC;
	}

	private JPanel getJPanel_TecnicosC() {
		if (jPanel_TecnicosC == null) {
			jButton_TecnicosCAdd = new JButton(fmeFrame.novaLinha);
		    jButton_TecnicosCAdd.setBounds(new Rectangle(517, 10, 30, 22));
		    jButton_TecnicosCAdd.setBorder(BorderFactory.createEtchedBorder());
		    jButton_TecnicosCAdd.setToolTipText("Nova Linha");
		    jButton_TecnicosCAdd.addMouseListener(new Frame_Projectos_jButton_TecnicosCAdd_mouseAdapter(this));
			jButton_TecnicosCIns = new JButton(fmeFrame.inserirLinha);
		    jButton_TecnicosCIns.setBounds(new Rectangle(557, 10, 30, 22));
		    jButton_TecnicosCIns.setBorder(BorderFactory.createEtchedBorder());
		    jButton_TecnicosCIns.setToolTipText("Inserir Linha");
		    jButton_TecnicosCIns.addMouseListener(new Frame_Projectos_jButton_TecnicosCIns_mouseAdapter(this));
			jButton_TecnicosCDel = new JButton(fmeFrame.apagarLinha);
		    jButton_TecnicosCDel.setBounds(new Rectangle(597, 10, 30, 22));
		    jButton_TecnicosCDel.setBorder(BorderFactory.createEtchedBorder());
		    jButton_TecnicosCDel.setToolTipText("Apagar Linha");
		    jButton_TecnicosCDel.addMouseListener(new Frame_Projectos_jButton_TecnicosCDel_mouseAdapter(this));

			jLabel_TecnicosC = new JLabel();
			jLabel_TecnicosC.setBounds(new Rectangle(12, 10, 469, 18));
			jLabel_TecnicosC.setText("Identificao da equipa tcnica afecta ao Centro de I&DT alvo do projecto");
			jLabel_TecnicosC.setFont(fmeFrame.letra_bold);			
			jPanel_TecnicosC = new JPanel();
			jPanel_TecnicosC.setLayout(null);
			jPanel_TecnicosC.setBounds(new Rectangle(15, 930, 640, 185));
			jPanel_TecnicosC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_TecnicosC.add(jLabel_TecnicosC, null);
		    jPanel_TecnicosC.add(jButton_TecnicosCAdd, null);
		    jPanel_TecnicosC.add(jButton_TecnicosCDel, null);
		    jPanel_TecnicosC.add(jButton_TecnicosCIns, null);
			jPanel_TecnicosC.add(getJScrollPane_TecnicosC(), null);
		}
		return jPanel_TecnicosC;
	}
	public JScrollPane getJScrollPane_TecnicosC() {
		if (jScrollPane_TecnicosC == null) {
			jScrollPane_TecnicosC = new JScrollPane();
			jScrollPane_TecnicosC.setBounds(new Rectangle(14, 36, 610, 134));
			jScrollPane_TecnicosC.setViewportView(getJTable_TecnicosC());
			//jScrollPane_TecnicosC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
			jScrollPane_TecnicosC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_TecnicosC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_TecnicosC;
	}
	public JTable getJTable_TecnicosC() {
		if (jTable_TecnicosC == null) {
			jTable_TecnicosC = new JTable_Tip(40, jScrollPane_TecnicosC.getWidth());
			jTable_TecnicosC.setRowHeight(18);
			jTable_TecnicosC.setFont(fmeFrame.letra);
			jTable_TecnicosC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_TecnicosC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
			//jTable_TecnicosC.setVisible(true);
		}
		return jTable_TecnicosC;
	}



	//	------------------------ print --------------------------------------------
	public void print_page() {
		
		String caption = fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		
		print_handler.dx_expand = jTable_Projectos.getWidth() - jScrollPane_Projectos.getWidth();
		int w = jPanel_Projectos.getWidth() + print_handler.dx_expand;
		print_handler.scaleToWidth ( (int) ( 1.05 * w) );
		print_handler.margem_x = 10;
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		CBData.ProjIDT.Clear();
		CBData.ProjIDTTxt.Clear();
		CBData.ProjIDTTxt2.Clear();
		CBData.TecnicosCentro.Clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.ProjIDT.validar(null));
		if (this.hs.get("centros")!=null && this.hs.get("centros").equals("0")){
			grp.add_grp(CBData.ProjIDTTxt.validar(null));
		}
		if (this.hs.get("centros")!=null && this.hs.get("centros").equals("1")){
			grp.add_grp(CBData.ProjIDTTxt2.validar(null));
			grp.add_grp(CBData.TecnicosCentro.validar(null));
		}
		
		return grp;
	}
	
	void jButton_TecnicosCAdd_mouseClicked(MouseEvent e) {
		CBData.TecnicosCentro.on_add_row();
	}

	void jButton_TecnicosCDel_mouseClicked(MouseEvent e) {
		CBData.TecnicosCentro.on_del_row();
	}

	void jButton_TecnicosCIns_mouseClicked(MouseEvent e) {
		CBData.TecnicosCentro.on_ins_row();
	}

}		


class Frame_Projectos_jButton_ProjectosAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Projectos adaptee;

	Frame_Projectos_jButton_ProjectosAdd_mouseAdapter(Frame_Projectos adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ProjectosAdd_mouseClicked(e);
	}
}

class Frame_Projectos_jButton_ProjectosDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Projectos adaptee;

	Frame_Projectos_jButton_ProjectosDel_mouseAdapter(Frame_Projectos adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ProjectosDel_mouseClicked(e);
	}
}

class Frame_Projectos_jButton_ProjectosIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Projectos adaptee;

	Frame_Projectos_jButton_ProjectosIns_mouseAdapter(Frame_Projectos adaptee) {
	    this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_ProjectosIns_mouseClicked(e);
	}
}

class Frame_Projectos_jButton_TecnicosCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	  Frame_Projectos adaptee;

	  Frame_Projectos_jButton_TecnicosCAdd_mouseAdapter(Frame_Projectos adaptee) {
	    this.adaptee = adaptee;
	  }
	  public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_TecnicosCAdd_mouseClicked(e);
	  }
}

class Frame_Projectos_jButton_TecnicosCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Projectos adaptee;

	Frame_Projectos_jButton_TecnicosCDel_mouseAdapter(Frame_Projectos adaptee) {
		this.adaptee = adaptee;
	}
	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_TecnicosCDel_mouseClicked(e);
	}
}

class Frame_Projectos_jButton_TecnicosCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_Projectos adaptee;

	Frame_Projectos_jButton_TecnicosCIns_mouseAdapter(Frame_Projectos adaptee) {
	    this.adaptee = adaptee;
	}
	public void mouseClicked(MouseEvent e) {
	    adaptee.jButton_TecnicosCIns_mouseClicked(e);
	}
}

