package fme;

import javax.swing.*;
import java.awt.*;
import java.awt.print.*;
import java.awt.event.*;
import java.util.HashMap;
import java.awt.Rectangle;

public class Frame_QuadroSC extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;

	private JPanel jPanel_QuadroSC = null;
	private JLabel jLabel_QuadroSC = null;
	private JScrollPane jScrollPane_QuadroSC = null;
	private JTable_Tip jTable_QuadroSC = null;
	private JButton jButton_QuadroSCCopy = null;
	private JButton jButton_QuadroSCUp = null;
	private JButton jButton_QuadroSCAdd = null;
	private JButton jButton_QuadroSCIns = null;
	private JButton jButton_QuadroSCDel = null;

	//public CBTabela_QuadroSC CBData_QuadroSC = null;
	String tag = "";

	public Frame_QuadroSC() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(1530,470);
	}

	void up_component ( Component c, int n ) {
		Rectangle r = c.getBounds();
		r.y -= n;
		c.setBounds(r);
	}

	public void tirar_titulo () {
		jLabel_Titulo.setVisible(false);
		up_component(jPanel_QuadroSC, 30);
	}

	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
	}

	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
		this.setResizable(false);
		this.setBorder(null);
		this.getContentPane().setLayout(null);
		this.setDebugGraphicsOptions(0);
		this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_Titulo.setText("   "+"CARACTERIZAO DO PROJECTO");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getJPanel_QuadroSC(), null);
		}
		return jContentPane;
	}

	private JPanel getJPanel_QuadroSC() {
		if (jPanel_QuadroSC == null) {
			jLabel_QuadroSC = new JLabel();
			jLabel_QuadroSC.setBounds(new Rectangle(12, 10, 399, 18));
			jLabel_QuadroSC.setText("Tcnicos de entidades de investigao por contrato");
			jLabel_QuadroSC.setFont(fmeFrame.letra_bold);

			jButton_QuadroSCCopy = new JButton(fmeFrame.copiarLinha);
			jButton_QuadroSCCopy.setBorder(BorderFactory.createEtchedBorder());
			jButton_QuadroSCCopy.addMouseListener(new Frame_QuadroSC_jButton_QuadroSCCopy_mouseAdapter(this));
			jButton_QuadroSCCopy.setToolTipText("Copiar Linha");
			jButton_QuadroSCCopy.setBounds(new Rectangle(437, 11, 30, 22));
			jButton_QuadroSCUp = new JButton(fmeFrame.subirLinha);
			jButton_QuadroSCUp.setBorder(BorderFactory.createEtchedBorder());
			jButton_QuadroSCUp.addMouseListener(new Frame_QuadroSC_jButton_QuadroSCUp_mouseAdapter(this));
			jButton_QuadroSCUp.setToolTipText("Trocar Linhas");
			jButton_QuadroSCUp.setBounds(new Rectangle(477, 11, 30, 22));
			jButton_QuadroSCAdd = new JButton(fmeFrame.novaLinha);
			jButton_QuadroSCAdd.setBorder(BorderFactory.createEtchedBorder());
			jButton_QuadroSCAdd.addMouseListener(new Frame_QuadroSC_jButton_QuadroSCAdd_mouseAdapter(this));
			jButton_QuadroSCAdd.setToolTipText("Nova Linha");
			jButton_QuadroSCAdd.setBounds(new Rectangle(517, 11, 30, 22));
			jButton_QuadroSCIns = new JButton(fmeFrame.inserirLinha);
			jButton_QuadroSCIns.setBorder(BorderFactory.createEtchedBorder());
			jButton_QuadroSCIns.addMouseListener(new Frame_QuadroSC_jButton_QuadroSCIns_mouseAdapter(this));
			jButton_QuadroSCIns.setToolTipText("Inserir Linha");
			jButton_QuadroSCIns.setBounds(new Rectangle(557, 11, 30, 22));
			jButton_QuadroSCDel = new JButton(fmeFrame.apagarLinha);
			jButton_QuadroSCDel.setBorder(BorderFactory.createEtchedBorder());
			jButton_QuadroSCDel.addMouseListener(new Frame_QuadroSC_jButton_QuadroSCDel_mouseAdapter(this));
			jButton_QuadroSCDel.setToolTipText("Apagar Linha");
			jButton_QuadroSCDel.setBounds(new Rectangle(597, 11, 30, 22));

			jPanel_QuadroSC = new JPanel();
			jPanel_QuadroSC.setLayout(null);
			jPanel_QuadroSC.setBounds(new Rectangle(15, 50, 1240, 402));
			jPanel_QuadroSC.setBorder(BorderFactory.createEtchedBorder());
			jPanel_QuadroSC.add(jLabel_QuadroSC, null);
//			jPanel_QuadroSC.add(jButton_QuadroSCCopy, null);
//			jPanel_QuadroSC.add(jButton_QuadroSCUp, null);
			jPanel_QuadroSC.add(jButton_QuadroSCAdd, null);
			jPanel_QuadroSC.add(jButton_QuadroSCIns, null);
			jPanel_QuadroSC.add(jButton_QuadroSCDel, null);
			jPanel_QuadroSC.add(getJScrollPane_QuadroSC(), null);
		}
		return jPanel_QuadroSC;
	}
	public JScrollPane getJScrollPane_QuadroSC() {
		if (jScrollPane_QuadroSC == null) {
			jScrollPane_QuadroSC = new JScrollPane();
			jScrollPane_QuadroSC.setBounds(new Rectangle(16, 36, 1206, 350));
			jScrollPane_QuadroSC.setViewportView(getJTable_QuadroSC());
			jScrollPane_QuadroSC.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
			jScrollPane_QuadroSC.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane_QuadroSC.setBorder(BorderFactory.createEtchedBorder());
		}
		return jScrollPane_QuadroSC;
	}
	public JTable getJTable_QuadroSC() {
		if (jTable_QuadroSC == null) {
			jTable_QuadroSC = new JTable_Tip(60, jScrollPane_QuadroSC.getWidth());
			jTable_QuadroSC.setFont(fmeFrame.letra);
			jTable_QuadroSC.setRowHeight(18);
			jTable_QuadroSC.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
			jTable_QuadroSC.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		}
		return jTable_QuadroSC;
	}
	void jButton_QuadroSCCopy_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_copy_row();
	}
	void jButton_QuadroSCUp_mouseClicked(MouseEvent e) {
		//CBData_QuadroSC.on_up_row();
		CBData.QuadroSC.on_up_row();
	}
	void jButton_QuadroSCAdd_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_add_row();
	}
	void jButton_QuadroSCDel_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_del_row();
	}
	void jButton_QuadroSCIns_mouseClicked(MouseEvent e) {
		CBData.QuadroSC.on_ins_row();
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);

		print_handler = new CHPrint( this);
		print_handler.start();

		print_handler.scaleToWidth ( (int) ( 1.05 * jPanel_QuadroSC.getWidth()) );
		print_handler.margem_y = 50;

		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;

		print_handler.print_page();
	}

	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------

	public void clear_page(){
		CBData.QuadroSC.Clear();
	}

	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		grp.add_grp(CBData.QuadroSC.validar(null));
		return grp;
	}
}

class Frame_QuadroSC_jButton_QuadroSCCopy_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadroSC adaptee;
	
	Frame_QuadroSC_jButton_QuadroSCCopy_mouseAdapter(Frame_QuadroSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadroSCCopy_mouseClicked(e);
	}	
}

class Frame_QuadroSC_jButton_QuadroSCUp_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadroSC adaptee;
	
	Frame_QuadroSC_jButton_QuadroSCUp_mouseAdapter(Frame_QuadroSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadroSCUp_mouseClicked(e);
	}
}

class Frame_QuadroSC_jButton_QuadroSCAdd_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadroSC adaptee;

	Frame_QuadroSC_jButton_QuadroSCAdd_mouseAdapter(Frame_QuadroSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadroSCAdd_mouseClicked(e);
	}
}

class Frame_QuadroSC_jButton_QuadroSCDel_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadroSC adaptee;

	Frame_QuadroSC_jButton_QuadroSCDel_mouseAdapter(Frame_QuadroSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadroSCDel_mouseClicked(e);
	}
}

class Frame_QuadroSC_jButton_QuadroSCIns_mouseAdapter extends java.awt.event.MouseAdapter {
	Frame_QuadroSC adaptee;

	Frame_QuadroSC_jButton_QuadroSCIns_mouseAdapter(Frame_QuadroSC adaptee) {
		this.adaptee = adaptee;
	}

	public void mouseClicked(MouseEvent e) {
		adaptee.jButton_QuadroSCIns_mouseClicked(e);
	}
}
