package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;

import java.util.HashMap;

import javax.swing.JInternalFrame;
import javax.swing.JTabbedPane;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import javax.swing.JLabel;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import java.awt.Font;

public class Frame_Texto1B_1_N extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	String tag = "";  //  @jve:decl-index=0:

	public JTabbedPane jTabbedPane = null;

	private JPanel jPanel_1 = null;

	private JLabel jLabel_P01 = null;
	private JLabel jLabel_QREN = null;

	private int n_linhas = 0;
	
	public Frame_Texto1B_1_N() {
		super();
		initialize();
	}

	
	public Dimension getSize () {
		// face  dimenso da pgina base
		return new Dimension(660,730+(n_linhas*18)+35);
	}
	
	public String s_titulo = "";
	public String s_design = "";
	public String s_subdesign = "";
	public String s_l_subdesign = "";
	
	public HashMap s_params;  //  @jve:decl-index=0:
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		s_params = params;
		if ( params.get("L_SUBDESIGN") != null ) {
			n_linhas = Integer.parseInt((String) params.get("L_SUBDESIGN"));
			this.jTabbedPane.setSize(this.jTabbedPane.getWidth(), this.jTabbedPane.getHeight()+(n_linhas*18));
			this.setSize(this.getSize());
			this.setPreferredSize(this.getSize());
		}
	}
	
	private void initialize() {
		this.setSize( getSize());
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout( null );
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));
			jLabel_P01 = new JLabel();
			jLabel_P01.setBounds(new Rectangle(15, 10, 555, 30));
			jLabel_P01.setBorder(BorderFactory.createEtchedBorder());
			jLabel_P01.setText("   CO-PROMOTORES");
			jLabel_P01.setFont(fmeFrame.letra_titulo);
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder());
			jContentPane.add(getJTabbedPane(), null);
			jContentPane.add(jLabel_P01, null);
			jContentPane.add(jLabel_QREN, null);

			//jContentPane.setBackground(Color.green);

		}
		return jContentPane;
	}
	

	//	------------------------ print --------------------------------------------
	public void print_page() {
		int i = this.getJTabbedPane().getSelectedIndex();
		Component p = this.getJTabbedPane().getComponentAt(i);
		p = p.getComponentAt( 100, 100);
		Frame_Texto1B_1 frame = (Frame_Texto1B_1) p;
		frame.tag = this.tag;
		frame.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		for (int i=0;i<CBData.ListaCoop.dados.size();i++){
			if (tag.equals("TxtEvolucao_N"))
				((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtEvolucao.elementAt(i)).Clear();
			if (tag.equals("TxtProdutos_N"))
				((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtProdutos.elementAt(i)).Clear();
		}
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp (fmeFrame.Paginas.getCaption(tag));
		if ( fmeFrame.contexto.equals("toolbar")){
			int i = this.getJTabbedPane().getSelectedIndex();
			String cp = " - co-promotor n. "+(i+1);
			if (tag.equals("TxtEvolucao_N"))
				grp.add_grp ( ((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtEvolucao.elementAt(i)).validar(null, cp));
			if (tag.equals("TxtProdutos_N"))
				grp.add_grp ( ((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtProdutos.elementAt(i)).validar(null, cp));
		}else{
			for (int i=0;i<CBData.ListaCoop.dados.size();i++){
				String cp = " - co-promotor n. "+(i+1);
				if (tag.equals("TxtEvolucao_N"))
					grp.add_grp ( ((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtEvolucao.elementAt(i)).validar(null, cp));
				if (tag.equals("TxtProdutos_N"))
					grp.add_grp ( ((CBRegisto_Texto1B_1) CBData.ListaCoop.Lista_TxtProdutos.elementAt(i)).validar(null, cp));
			}
		}
		return grp;
	}

	public JTabbedPane getJTabbedPane() {
		if (jTabbedPane == null) {
			jTabbedPane = new JTabbedPane();
			jTabbedPane.setBounds(new Rectangle(0, 50, getSize().width+10, getSize().height+(n_linhas*18)-50 ));
			//jTabbedPane.addTab(null, null, getJPanel_1(), null);

			jTabbedPane.setBorder(BorderFactory.createEmptyBorder());
			
			jTabbedPane.setFont(fmeFrame.letra);
			jTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
			jTabbedPane.addChangeListener(new ChangeListener() {
		        // This method is called whenever the selected tab changes
		        public void stateChanged(ChangeEvent evt) {
		            int sel = ((JTabbedPane)evt.getSource()).getSelectedIndex();
					try{CBData.ListaCoop.on_row(sel);}
					catch(Exception ex){}
		        }
		    });

		}
		return jTabbedPane;
	}

	public Frame_Texto1B_1 nova_pagina ( String s, int n ) {

		Frame_Texto1B_1 pg = new Frame_Texto1B_1();
		Dimension d = ((Pagina_Base)pg).getSize();
	    ((JInternalFrame)pg).setPreferredSize( d );
	    ((JInternalFrame)pg).setBounds( new Rectangle(0,0,680,1400));
		((javax.swing.plaf.basic.BasicInternalFrameUI) pg.getUI()).setNorthPane(null);
		pg.setVisible(true);
		//pg.setBackground(Color.green);	
		pg.set_params(tag, s_params);
		pg.tirar_titulo();
		JPanel jp = new JPanel();
		jp.setLayout(null);
		jp.setBounds( new Rectangle(0,0,680,1400));
		//jp.setBackground(Color.red);
		jp.add(pg, null);
		jp.setBorder(BorderFactory.createEmptyBorder());
		jTabbedPane.insertTab(s, null, jp, null, n);
		
		jTabbedPane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);

		return pg;
	}

}		

