package fme;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.Rectangle;

import javax.swing.*;

import java.awt.*;
import java.awt.print.*;
import java.util.HashMap;

public class Frame_Texto1B_2 extends JInternalFrame implements Pagina_Base {

	private static final long serialVersionUID = 1L;

	CHPrint print_handler;
	
	private JPanel jContentPane = null;

	private JLabel jLabel_Titulo = null;
	private JLabel jLabel_QREN = null;
	private JPanel jPanel_Txt = null;
	private JLabel jLabel_Design = null;
	private JLabel jLabel_Subdesign = null;
	private JScrollPane jScrollPane_Txt = null;
	private JTextArea jTextArea_Txt = null;

	String tag = "";
	
	public Frame_Texto1B_2() {
		super();
		initialize();
	}

	public Dimension getSize () {
		return new Dimension(630,730);
	}
	
	public void set_params( String _tag, HashMap params ) {
		tag = _tag;
		if ( params.get("TITULO") != null ) {
			jLabel_Titulo.setText( (String) params.get("TITULO") );
		}
		if ( params.get("DESIGN") != null ) {
			jLabel_Design.setText( (String) params.get("DESIGN") );
		}
		if ( params.get("SUBDESIGN") != null ) {
			jLabel_Subdesign.setText( (String) params.get("SUBDESIGN") );
		}
	}
	
	private void initialize() {
		this.setSize(670, 1000);
		this.setContentPane(getJContentPane());
	    this.setResizable(false);
	    this.setBorder(null);
	    this.getContentPane().setLayout(null);
	    this.setDebugGraphicsOptions(0);
	    this.setMaximumSize(new Dimension(2147483647,2147483647));
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel_QREN = new JLabel();
			jLabel_QREN.setIcon(fmeFrame.logoPagina);
			jLabel_QREN.setBounds(new Rectangle(578, 5, 76, 35));

			jLabel_Titulo = new JLabel();
			jLabel_Titulo.setBounds(new Rectangle(15, 10, 555, 30));
			//jLabel_P03.setText("   CARACTERIZAO DO PROMOTOR");
			jLabel_Titulo.setFont(fmeFrame.letra_titulo);
			jLabel_Titulo.setBorder(BorderFactory.createEtchedBorder());
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.setBorder(BorderFactory.createEmptyBorder(0, 0, 0, 0));
			jContentPane.add(jLabel_Titulo, null);
			jContentPane.add(jLabel_QREN, null);
			jContentPane.add(getjPanel_Txt(), null);
		}
		return jContentPane;
	}
	
	private JPanel getjPanel_Txt() {
		if (jPanel_Txt == null) {
			jLabel_Design = new JLabel();
			jLabel_Design.setBounds(new Rectangle(14, 10, 609, 18));
			jLabel_Design.setFont(fmeFrame.letra_bold);

			jLabel_Subdesign = new JLabel();
			jLabel_Subdesign.setBounds(new Rectangle(25, 33, 598, 18));
			jLabel_Subdesign.setFont(fmeFrame.letra);

			jPanel_Txt = new JPanel();
			jPanel_Txt.setLayout(null);
			jPanel_Txt.setBounds(new Rectangle(15, 50, 640, 690));
			jPanel_Txt.setBorder(BorderFactory.createEtchedBorder());
			jPanel_Txt.setName("evolucao_texto");
			jPanel_Txt.add(jLabel_Design, null);
			jPanel_Txt.add(jLabel_Subdesign, null);
			jPanel_Txt.add(getJScrollPane_Txt(), null);
			
		}
		return jPanel_Txt;
	}
	
	public JScrollPane getJScrollPane_Txt() {
		if (jScrollPane_Txt == null) {
			jScrollPane_Txt = new JScrollPane();
			jScrollPane_Txt.setBounds(new Rectangle(15, 55, 609, 620));
			jScrollPane_Txt.setPreferredSize(new Dimension(250, 250));
			jScrollPane_Txt.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED);
			jScrollPane_Txt.setBorder(BorderFactory.createLineBorder(Color.black));
			jScrollPane_Txt.setViewportView(getJTextArea_Txt());
		}
		return jScrollPane_Txt;
	}
	public JTextArea getJTextArea_Txt() {
		if (jTextArea_Txt == null) {
			jTextArea_Txt = new JTextArea();
			jTextArea_Txt.setFont(fmeFrame.letra);
			jTextArea_Txt.setLineWrap(true);
			jTextArea_Txt.setWrapStyleWord(true);
			jTextArea_Txt.setMargin(new Insets(5, 5, 5, 5));
		}
		return jTextArea_Txt;
	}

	//	------------------------ print --------------------------------------------
	public void print_page() {
		String caption = fme.fmeFrame.Paginas.getCaption(tag);
		
		print_handler = new CHPrint( this);
		print_handler.start();
		

		print_handler.scaleToWidth ( (int) ( 1.05 * getjPanel_Txt().getWidth()) );
		print_handler.margem_y = 50;
		
		print_handler.header = _lib.get_titulo(caption);
		print_handler.footer_medida = fme.fmeFrame.title;
		print_handler.footer_pag = _lib.get_pagina(caption);
		print_handler.footer_promotor = CBData.Promotor.getByName("nome").v;
		
		print_handler.print_page();
	}
	
	public int print ( Graphics g, PageFormat pf, int pageIndex ){
		return print_handler.print( g, pf, pageIndex );
	}
	//----------------------- end print ------------------------------------------
	
	public void clear_page(){
		if (tag.equals("TxtAccoesConj2")) 
			CBData.TxtAccoesConj2.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj3")) 
			CBData.TxtAccoesConj3.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj4")) 
			CBData.TxtAccoesConj4.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj5")) 
			CBData.TxtAccoesConj5.getByName("texto").clear();
		if (tag.equals("TxtAccoesConj7")) 
			CBData.TxtAccoesConj7.getByName("texto").clear();

		if (tag.equals("TxtCritPME")) 
			CBData.TxtCritPME.getByName("texto").clear();

		if (tag.equals("TxtAccoesInov1")) 
			CBData.TxtAccoesInov1.getByName("texto").clear();
		if (tag.equals("TxtAccoesInov2")) 
			CBData.TxtAccoesInov2.getByName("texto").clear();
		if (tag.equals("TxtAccoesInov3")) 
			CBData.TxtAccoesInov3.getByName("texto").clear();
	}
	
	public CHValid_Grp validar_pg( ) {
		CHValid_Grp grp = new CHValid_Grp(fmeFrame.Paginas.getCaption(tag));
		
		if (tag.equals("TxtAccoesConj2")) grp.add_grp(CBData.TxtAccoesConj2.validar(null));
		if (tag.equals("TxtAccoesConj3")) grp.add_grp(CBData.TxtAccoesConj3.validar(null));
		if (tag.equals("TxtAccoesConj4")) grp.add_grp(CBData.TxtAccoesConj4.validar(null));
		if (tag.equals("TxtAccoesConj5")) grp.add_grp(CBData.TxtAccoesConj5.validar(null));
		if (tag.equals("TxtAccoesConj7")) grp.add_grp(CBData.TxtAccoesConj7.validar(null));

		if (tag.equals("TxtCritPME")) grp.add_grp(CBData.TxtCritPME.validar(null));

		if (tag.equals("TxtAccoesInov1")) grp.add_grp(CBData.TxtAccoesInov1.validar(null));
		if (tag.equals("TxtAccoesInov2")) grp.add_grp(CBData.TxtAccoesInov2.validar(null));
		if (tag.equals("TxtAccoesInov3")) grp.add_grp(CBData.TxtAccoesInov3.validar(null));

		return grp;
	}

}
