package fme;

import java.awt.*;

import javax.swing.*;
import java.awt.event.*;
import java.io.*;

import javax.swing.BorderFactory;
import javax.swing.JInternalFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.border.Border;
import javax.swing.plaf.*;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import java.awt.Dimension;
import java.util.Vector;
import java.util.HashMap;

import java.util.*;
import java.awt.print.*;

import java.awt.event.ActionEvent;

public class fmeFrame extends JFrame {

	static PgHandler Paginas;
	
	static String contexto = "";
	
	void init() {
			
		PgHandler paginas = new PgHandler ( );
		Paginas = paginas;
		
		String cfgfilename = "fme-default.xml";
		//String cfgfilename = "fme-config-34.xml";
		
		if ( !this.mount_config(cfgfilename) )
			mount_noconfig();
	
		this.setContentPane(getJContentPane());
		this.setTitle(title);
		this.getJScrollPane();
		this.getJToolBar();
	    this.setJMenuBar(getJJMenuBar());
		
	    jContentPane = (JPanel)this.getContentPane();
	    this.setSize(new Dimension(695, 563));
	    //this.setIconImage(icon);

	    jContentPane.setMaximumSize(new Dimension(2147483647, 2147483647));
	    jContentPane.setLayout( new BorderLayout());
	    jScrollPane.setAlignmentX((float) 0.5);
	    jScrollPane.setAutoscrolls(false);
	    jScrollPane.setDebugGraphicsOptions(0);
	    jScrollPane.setDoubleBuffered(false);
	    jScrollPane.setOpaque(true);
	    
	    jContentPane.add( jScrollPane, BorderLayout.CENTER);
	    jContentPane.add( jToolBar, BorderLayout.NORTH);
	    
	    Paginas.Select(0);
	    updateTitle();
		jScrollPane.getViewport().add( Paginas.getFrame() );
	    updateMenu();	
	}
	
	
	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;
	private JScrollPane jScrollPane = null;

	public static Font letra = new java.awt.Font("Tahoma", 0, 11);
	public static Font letra_pequena = new java.awt.Font("Tahoma", 0, 10);
	public static Font letra_bold = new java.awt.Font("Tahoma", 1, 11);
	public static Font letra_italico = new java.awt.Font("Tahoma", 2, 11);
	public static Font letra_titulo = new java.awt.Font("Tahoma", 1, 12);
	public static Font letra_titulo3 = new java.awt.Font("trebuchet MS", 0, 14);
	public static Font letra_titulo2 = new java.awt.Font("trebuchet MS", 1, 15);
	public static Font letra_titulo1 = new java.awt.Font("trebuchet MS", 1, 18);
	public static Color cinza = new Color(212,208,200);
	//public static Color rosa_cinza = new Color(209,189,186); //rosa
	//public static Color rosa_cinza = new Color(226,239,227); //verde
	public static Color rosa_cinza = new Color(232,242,254); //azul
	
	public static Color color_1 = new Color(51,51,51);
	public static Color color_2 = new Color(153,153,153);

	//public static Image icon = Toolkit.getDefaultToolkit().getImage(fme.fmeFrame.class.getResource("ModCom.jpg"));
		
	public static ImageIcon inserirLinha = new ImageIcon(fme.fmeFrame.class.getResource("inserirlinha.gif"));
	public static ImageIcon copiarLinha = new ImageIcon(fme.fmeFrame.class.getResource("copiarlinha.gif"));
	public static ImageIcon subirLinha = new ImageIcon(fme.fmeFrame.class.getResource("subirlinha.gif"));
	public static ImageIcon novaLinha = new ImageIcon(fme.fmeFrame.class.getResource("novalinha.gif"));
	public static ImageIcon apagarLinha = new ImageIcon(fme.fmeFrame.class.getResource("apagarlinha.gif"));
	public static ImageIcon logoPagina = new ImageIcon(fme.fmeFrame.class.getResource("QREN3.gif"));
	public static ImageIcon logoUE = new ImageIcon(fme.fmeFrame.class.getResource("UE1.gif"));
	public static ImageIcon logoInfo = new ImageIcon(fme.fmeFrame.class.getResource("info.gif"));
	public static ImageIcon logoGuia = new ImageIcon(fme.fmeFrame.class.getResource("guia.gif"));


	ImageIcon image1 = new ImageIcon(fme.fmeFrame.class.getResource("openfile.gif"));; // open
    ImageIcon image2 = new ImageIcon(fme.fmeFrame.class.getResource("limpar.gif")); // close
	ImageIcon image3 = new ImageIcon(fme.fmeFrame.class.getResource("help.png")); // help
	ImageIcon image4 = new ImageIcon(fme.fmeFrame.class.getResource("gobegin.gif")); // primeiro
	ImageIcon image5 = new ImageIcon(fme.fmeFrame.class.getResource("gorev.gif")); // anterior
	ImageIcon image6 = new ImageIcon(fme.fmeFrame.class.getResource("goforw.gif")); // seguinte
	ImageIcon image7 = new ImageIcon(fme.fmeFrame.class.getResource("goend.gif")); // ltimo
	ImageIcon image8 = new ImageIcon(fme.fmeFrame.class.getResource("guardar.gif")); // save
	ImageIcon image9 = new ImageIcon(fme.fmeFrame.class.getResource("impressora.gif")); // print
	ImageIcon image10 = new ImageIcon(fme.fmeFrame.class.getResource("exportar.gif")); // exportar
	ImageIcon image11 = new ImageIcon(fme.fmeFrame.class.getResource("validar.gif")); // validar
	
	public static String title = "Formulrio QREN";

	public static File LastFile = null;

	private JToolBar jToolBar = null;  
	private JButton jButton_Primeiro = null;
	private JButton jButton_Anterior = null;
	private JButton jButton_Seguinte = null;
	private JButton jButton_Ultimo = null;
	private JButton jButton_Abrir = null;
	private JButton jButton_Guardar = null;
	private JButton jButton_Enviar = null;
	private JButton jButton_Validar = null;
	private JButton jButton_Imprimir = null;
	private JButton jButton_Limpar = null;

	private JMenuBar jMenuBar = null;
	
	private JMenu jMenuFile = null;
	private JMenuItem jMenuFile_Exit = null;
	static JMenuItem jMenuFile_Save = null;
	static JMenuItem jMenuFile_SaveAs = null;
	private JMenuItem jMenuFile_Open = null;
	private JMenuItem jMenuFile_ImprimirPagina = null;
	static JMenuItem jMenuFile_Imprimir = null;

	private JMenu jMenuAccoes = null;
	private JMenuItem jMenuAccoes_PrimeiraPagina = null;
	private JMenuItem jMenuAccoes_PaginaAnterior = null;
	private JMenuItem jMenuAccoes_PaginaSeguinte = null;
	private JMenuItem jMenuAccoes_UltimaPagina = null;
	static JMenuItem jMenuAccoes_LimparPagina = null;
	static JMenuItem jMenuAccoes_Limpar = null;
	static JMenuItem jMenuAccoes_ValidarPagina = null;
	static JMenuItem jMenuAccoes_Validar = null;
	static JMenuItem jMenuAccoes_Enviar = null;

	private JMenu jMenuPagina = null;

	private JMenu jMenuHelp = null;
	private JMenuItem jMenuHelp_About = null;
	private JMenuItem jMenuHelp_Manual = null;


	//-------------------------------------------------------
	boolean mount_config ( String cfgfilename ) {
	    DefaultHandler handler = new CParseConfig();
        SAXParserFactory factory = SAXParserFactory.newInstance();
        try {
    	    SAXParser saxParser = factory.newSAXParser();
           // saxParser.parse(new File( cfgfilename ), handler);
    	    saxParser.parse(this.getClass().getResourceAsStream( cfgfilename ), handler);
        }
        catch ( Exception e) {
    	    JOptionPane.showMessageDialog(null, "Erro de configurao: " + cfgfilename);
    	    return false;
        }
        //fmeMain.Config = cfgfilename;
        return true;
	}
	
	void mount_new_config ( String cfgfilename ) {

		clearconfig( );
		mount_config ( cfgfilename);
	    Paginas.Select(0);
	    updateTitle();
		jScrollPane.getViewport().add( Paginas.getFrame() );
		remake_menu();
		updateMenu();
	    
    	CBData db = new CBData( );
    	db.Clear();
    	fmeMain.cb = db;

	    //JOptionPane.showMessageDialog(null, "j est ?");
    	/* no  aqui !
	    String s = CBData_Noconfig.Params.getByName("sistema").v;
	    String x = CTabelas.SistemaIncentivos.lookup(0, s, 1);
	    CBData.Params.getByName("sistema").setStringValue(x);
	    
	    s = CBData_Noconfig.Params.getByName("modalidade").v;
	    x = CTabelas.Modalidades.lookup(0, s, 1);
	    CBData.Params.getByName("modalidade").setStringValue(x);
	   */
	}

	void mount_noconfig() {
 		try {
			Object p = Class.forName("fme.Frame_Params" ).newInstance();
			Dimension d = ((Pagina_Base)p).getSize();
		    ((JInternalFrame)p).setPreferredSize( d );
		    fmeFrame.Paginas.add( (JInternalFrame)p, "Params", "Parametrizao" );
		    //((FrameParams)p).set_noconfig();
		} catch ( Exception e ) {
			JOptionPane.showMessageDialog(null, e.toString());
		}	
	}

	void clearconfig() {
		fmeFrame.Paginas.clear();
	}
	
	
	//--------------------------------------------------------

	public fmeFrame() {
		super();
		//initialize();
		/*NOVO*/
		init();
	}


	void select_page ( String tag ) {
	    //Paginas.SelectTag(tag);
	    Paginas.SelectTag(tag);
	    updateTitle();
	    jScrollPane.getViewport().add( Paginas.getFrame());
	    updateMenu();
	}
	
/*	void updateMenu(){
	    jMenuAccoes_PrimeiraPagina.setEnabled( ! Paginas.isFirst() );
	    jMenuAccoes_PaginaAnterior.setEnabled( ! Paginas.isFirst() );
	    jMenuAccoes_PaginaSeguinte.setEnabled( ! Paginas.isLast() );
	    jMenuAccoes_UltimaPagina.setEnabled( ! Paginas.isLast() );
		jButton_Primeiro.setEnabled( ! Paginas.isFirst() );
	    jButton_Anterior.setEnabled( ! Paginas.isFirst() );
	    jButton_Seguinte.setEnabled( ! Paginas.isLast() );
	    jButton_Ultimo.setEnabled( ! Paginas.isLast() );
	}*/

	void updateMenu(){
	    jMenuAccoes_PrimeiraPagina.setEnabled( ! Paginas.isFirst() );
	    jMenuAccoes_PaginaAnterior.setEnabled( ! Paginas.isFirst() );
	    jMenuAccoes_PaginaSeguinte.setEnabled( ! Paginas.isLast() );
	    jMenuAccoes_UltimaPagina.setEnabled( ! Paginas.isLast() );
		jButton_Primeiro.setEnabled( ! Paginas.isFirst() );
	    jButton_Anterior.setEnabled( ! Paginas.isFirst() );
	    jButton_Seguinte.setEnabled( ! Paginas.isLast() );
	    jButton_Ultimo.setEnabled( ! Paginas.isLast() );
	}

/*	void updateTitle (){
	    String titulo = title + " - " + Paginas.getCaption();
	    if ( this.LastFile != null ){
	      String fileName = this.LastFile.getName();
	      if (!fileName.endsWith( (new XmlFileFilter()).getExtension()))
	        fileName += (new XmlFileFilter()).getExtension();
	      titulo += " - " + fileName;
	    }
	    this.setTitle(titulo);
	}*/

	void updateTitle (){
	    String titulo = title + " - " + Paginas.getCaption();
	    if ( this.LastFile != null ){
	      String fileName = this.LastFile.getName();
	      if (!fileName.endsWith( (new XmlFileFilter()).getExtension()))
	        fileName += (new XmlFileFilter()).getExtension();
	      titulo += " - " + fileName;
	    }
	    this.setTitle(titulo);
	}

	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
		}
		return jContentPane;
	}

	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
		}
		return jScrollPane;
	}

	private JToolBar getJToolBar() {
		if (jToolBar == null) {
			jToolBar = new JToolBar();
			jToolBar.setSize(new Dimension(434, 42));
			jToolBar.add(getJButton_Primeiro());
			jToolBar.add(getJButton_Anterior());
			jToolBar.add(getJButton_Seguinte());
			jToolBar.add(getJButton_Ultimo());
			jToolBar.add(getJButton_Abrir());
			jToolBar.add(getJButton_Guardar());
			jToolBar.add(getJButton_Enviar());
			jToolBar.add(getJButton_Validar());
			jToolBar.add(getJButton_Limpar());
			jToolBar.add(getJButton_Imprimir());
			jToolBar.setFloatable(false);
		}
		return jToolBar;
	}

	private JButton getJButton_Primeiro() {
		if (jButton_Primeiro == null) {
		    jButton_Primeiro = new JButton();
			jButton_Primeiro.setIcon(image4);
			jButton_Primeiro.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
		    jButton_Primeiro.setMaximumSize(new Dimension(35, 37));
		    jButton_Primeiro.setMinimumSize(new Dimension(35, 37));
		    jButton_Primeiro.setToolTipText("Primeira Pgina");
		    jButton_Primeiro.setActionCommand( "Primeiro" );
		}
		return jButton_Primeiro;
	}

	private JButton getJButton_Anterior() {
		if (jButton_Anterior == null) {
			jButton_Anterior = new JButton();
			jButton_Anterior.setIcon(image5);
			jButton_Anterior.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
			jButton_Anterior.setMaximumSize(new Dimension(35, 37));
			jButton_Anterior.setMinimumSize(new Dimension(35, 37));
			jButton_Anterior.setToolTipText("Pgina Anterior");
			jButton_Anterior.setActionCommand( "Anterior" );
		}
		return jButton_Anterior;
	}

	private JButton getJButton_Seguinte() {
		if (jButton_Seguinte == null) {
			jButton_Seguinte = new JButton();
			jButton_Seguinte.setIcon(image6);
			jButton_Seguinte.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
			jButton_Seguinte.setMaximumSize(new Dimension(35, 37));
			jButton_Seguinte.setMinimumSize(new Dimension(35, 37));
			jButton_Seguinte.setToolTipText("Pgina Seguinte");
			jButton_Seguinte.setActionCommand( "Seguinte" );
		}
		return jButton_Seguinte;
	}

	private JButton getJButton_Ultimo() {
		if (jButton_Ultimo == null) {
			jButton_Ultimo = new JButton();
			jButton_Ultimo.setIcon(image7);
			jButton_Ultimo.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
			jButton_Ultimo.setMaximumSize(new Dimension(35, 37));
			jButton_Ultimo.setMinimumSize(new Dimension(35, 37));
			jButton_Ultimo.setToolTipText("ltima Pgina");
			jButton_Ultimo.setActionCommand( "Ultimo" );
		}
		return jButton_Ultimo;
	}

	private JButton getJButton_Abrir() {
		if (jButton_Abrir == null) {
			jButton_Abrir = new JButton();
			jButton_Abrir.setIcon(image1);
			jButton_Abrir.addActionListener(new fmeFrame_jMenuFile_Open_actionAdapter(this));
			jButton_Abrir.setSize(40, 40);
			jButton_Abrir.setMaximumSize(new Dimension(35, 37));
			jButton_Abrir.setMinimumSize(new Dimension(35, 37));
			jButton_Abrir.setToolTipText("Abrir");
		}
		return jButton_Abrir;
	}

	private JButton getJButton_Guardar() {
		if (jButton_Guardar == null) {
			jButton_Guardar = new JButton();
			jButton_Guardar.setIcon(image8);
			jButton_Guardar.addActionListener(new fmeFrame_jMenuFile_Save_actionAdapter(this));
			jButton_Guardar.setSize(40, 40);
			jButton_Guardar.setMaximumSize(new Dimension(35, 37));
			jButton_Guardar.setMinimumSize(new Dimension(35, 37));
			jButton_Guardar.setToolTipText("Guardar");
		}
		return jButton_Guardar;
	}

	private JButton getJButton_Enviar() {
		if (jButton_Enviar == null) {
			jButton_Enviar = new JButton();
			jButton_Enviar.setIcon(image10);
			jButton_Enviar.addActionListener(new fmeFrame_jMenuFile_Send_actionAdapter(this));
			jButton_Enviar.setSize(40, 40);
			jButton_Enviar.setMaximumSize(new Dimension(35, 37));
			jButton_Enviar.setMinimumSize(new Dimension(35, 37));
			jButton_Enviar.setToolTipText("Exportar Candidatura");
		}
		return jButton_Enviar;
	}

	private JButton getJButton_Validar() {
		if (jButton_Validar == null) {
			jButton_Validar = new JButton();
			jButton_Validar.setIcon(image11);
			jButton_Validar.addActionListener(new fmeFrame_jMenuAccoes_ValidarPagina_actionAdapter(this));
			jButton_Validar.setSize(40, 40);
			jButton_Validar.setMaximumSize(new Dimension(35, 37));
			jButton_Validar.setMinimumSize(new Dimension(35, 37));
			jButton_Validar.setToolTipText("Validar Pgina");
		}
		return jButton_Validar;
	}

	private JButton getJButton_Imprimir() {
		if (jButton_Imprimir == null) {
		 	jButton_Imprimir = new JButton();
			jButton_Imprimir.setIcon(image9);
			jButton_Imprimir.addActionListener(new fmeFrame_jMenuFile_ImprimirPagina_actionAdapter(this));
			jButton_Imprimir.setSize(40, 40);
			jButton_Imprimir.setMaximumSize(new Dimension(35, 37));
			jButton_Imprimir.setMinimumSize(new Dimension(35, 37));
			jButton_Imprimir.setToolTipText("Imprimir Pgina");
		}
		return jButton_Imprimir;
	}
	
	private JButton getJButton_Limpar() {
		if (jButton_Limpar == null) {
			jButton_Limpar = new JButton();
			jButton_Limpar.setIcon(image2);
			jButton_Limpar.addActionListener(new fmeFrame_jMenuAccoes_LimparPagina_actionAdapter(this));
			jButton_Limpar.setSize(40, 40);
			jButton_Limpar.setMaximumSize(new Dimension(35, 37));
			jButton_Limpar.setMinimumSize(new Dimension(35, 37));
			jButton_Limpar.setToolTipText("Limpar Pgina");
		}
		return jButton_Limpar;
	}
	
	private JMenuBar getJJMenuBar() {
		if (jMenuBar == null) {
			jMenuBar = new JMenuBar();
			jMenuBar.add(getJMenuFile());
			jMenuBar.add(getJMenuAccoes());
			jMenuBar.add(getJMenuPagina());
			jMenuBar.add(getJMenuHelp());
		}
		return jMenuBar;
	}

	private JMenu getJMenuFile() {
		if (jMenuFile == null) {
			jMenuFile = new JMenu();
		    jMenuFile.setText("Ficheiro");
		    jMenuFile.setMnemonic(KeyEvent.VK_F);
		    jMenuFile.setFont(fmeFrame.letra);
			jMenuFile.add(getJMenuFile_Open());
		    jMenuFile.addSeparator();
		    jMenuFile.add(getJMenuFile_Save());
		    jMenuFile.add(getJMenuFile_SaveAs());
		    jMenuFile.addSeparator();
		    jMenuFile.add(getJMenuFile_ImprimirPagina());
		    jMenuFile.add(getJMenuFile_Imprimir());
		    jMenuFile.addSeparator();
		    jMenuFile.add(getJMenuFile_Exit());
		}
		return jMenuFile;
	}

	private JMenuItem getJMenuFile_Open() {
		if (jMenuFile_Open == null) {
			jMenuFile_Open = new JMenuItem();
		    jMenuFile_Open.setText("Abrir...");
		    jMenuFile_Open.addActionListener(new fmeFrame_jMenuFile_Open_actionAdapter(this));
		    jMenuFile_Open.setFont(fmeFrame.letra);
		}
		return jMenuFile_Open;
	}
	private JMenuItem getJMenuFile_Save() {
		if (jMenuFile_Save == null) {
			jMenuFile_Save = new JMenuItem();
		    jMenuFile_Save.setText("Guardar");
		    jMenuFile_Save.addActionListener(new fmeFrame_jMenuFile_Save_actionAdapter(this));
		    jMenuFile_Save.setFont(fmeFrame.letra);
		}
		return jMenuFile_Save;
	}

	private JMenuItem getJMenuFile_SaveAs() {
		if (jMenuFile_SaveAs == null) {
			jMenuFile_SaveAs = new JMenuItem();
		    jMenuFile_SaveAs.setText("Guardar como...");
		    jMenuFile_SaveAs.addActionListener(new fmeFrame_jMenuFile_SaveAs_actionAdapter(this));
		    jMenuFile_SaveAs.setFont(fmeFrame.letra);
		}
		return jMenuFile_SaveAs;
	}

	private JMenuItem getJMenuFile_ImprimirPagina() {
		if (jMenuFile_ImprimirPagina == null) {
			jMenuFile_ImprimirPagina = new JMenuItem();
		    jMenuFile_ImprimirPagina.setText("Imprimir Pgina");
		    jMenuFile_ImprimirPagina.addActionListener(new fmeFrame_jMenuFile_ImprimirPagina_actionAdapter(this));
		    jMenuFile_ImprimirPagina.setFont(fmeFrame.letra);
		}
		return jMenuFile_ImprimirPagina;
	}

	public JMenuItem getJMenuFile_Imprimir() {
		if (jMenuFile_Imprimir == null) {
			jMenuFile_Imprimir = new JMenuItem();
			jMenuFile_Imprimir.setText("Imprimir...");
		    jMenuFile_Imprimir.addActionListener(new fmeFrame_jMenuFile_Imprimir_actionAdapter(this));
		    jMenuFile_Imprimir.setFont(fmeFrame.letra);
		}
		return jMenuFile_Imprimir;
	}

	private JMenuItem getJMenuFile_Exit() {
		if (jMenuFile_Exit == null) {
			jMenuFile_Exit = new JMenuItem();
		    jMenuFile_Exit.setText("Sair");
		    jMenuFile_Exit.addActionListener(new fmeFrame_jMenuFile_Exit_ActionAdapter(this));
		    jMenuFile_Exit.setFont(fmeFrame.letra);
		}
		return jMenuFile_Exit;
	}

	//ACES
	private JMenu getJMenuAccoes() {
		if (jMenuAccoes == null) {
			jMenuAccoes = new JMenu();
			jMenuAccoes.setText("Aces");
		    jMenuAccoes.setMnemonic(KeyEvent.VK_A);
		    jMenuAccoes.setFont(fmeFrame.letra);
		    jMenuAccoes.add(getJMenuAccoes_PrimeiraPagina());
		    jMenuAccoes.add(getJMenuAccoes_PaginaAnterior());
		    jMenuAccoes.add(getJMenuAccoes_PaginaSeguinte());
		    jMenuAccoes.add(getJMenuAccoes_UltimaPagina());
		    jMenuAccoes.addSeparator();
		    jMenuAccoes.add(getJMenuAccoes_LimparPagina());
		    jMenuAccoes.add(getJMenuAccoes_Limpar());
		    jMenuAccoes.addSeparator();
		    jMenuAccoes.add(getJMenuAccoes_ValidarPagina());
		    jMenuAccoes.add(getJMenuAccoes_Validar());
		    jMenuAccoes.addSeparator();
		    jMenuAccoes.add(getJMenuAccoes_Enviar());
		}
		return jMenuAccoes;
	}

	private JMenuItem getJMenuAccoes_PrimeiraPagina() {
		if (jMenuAccoes_PrimeiraPagina == null) {
			jMenuAccoes_PrimeiraPagina = new JMenuItem();
		    jMenuAccoes_PrimeiraPagina.setText("Primeira Pgina");
		    jMenuAccoes_PrimeiraPagina.setActionCommand( "Primeiro" );
		    jMenuAccoes_PrimeiraPagina.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
		    jMenuAccoes_PrimeiraPagina.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_PrimeiraPagina;
	}
	private JMenuItem getJMenuAccoes_PaginaAnterior() {
		if (jMenuAccoes_PaginaAnterior == null) {
			jMenuAccoes_PaginaAnterior = new JMenuItem();
		    jMenuAccoes_PaginaAnterior.setText("Pgina Anterior");
		    jMenuAccoes_PaginaAnterior.setActionCommand( "Anterior" );
		    jMenuAccoes_PaginaAnterior.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
		    jMenuAccoes_PaginaAnterior.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_PaginaAnterior;
	}
	private JMenuItem getJMenuAccoes_PaginaSeguinte() {
		if (jMenuAccoes_PaginaSeguinte == null) {
			jMenuAccoes_PaginaSeguinte = new JMenuItem();
		    jMenuAccoes_PaginaSeguinte.setText("Pgina Seguinte");
		    jMenuAccoes_PaginaSeguinte.setActionCommand( "Seguinte" );
		    jMenuAccoes_PaginaSeguinte.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
		    jMenuAccoes_PaginaSeguinte.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_PaginaSeguinte;
	}
	private JMenuItem getJMenuAccoes_UltimaPagina() {
		if (jMenuAccoes_UltimaPagina == null) {
			jMenuAccoes_UltimaPagina = new JMenuItem();
		    jMenuAccoes_UltimaPagina.setText("ltima Pgina");
		    jMenuAccoes_UltimaPagina.setActionCommand( "Ultimo" );
		    jMenuAccoes_UltimaPagina.addActionListener(new fmeFrame_jMenuPagina_actionAdapter(this));
		    jMenuAccoes_UltimaPagina.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_UltimaPagina;
	}

	private JMenuItem getJMenuAccoes_LimparPagina() {
		if (jMenuAccoes_LimparPagina == null) {
			jMenuAccoes_LimparPagina = new JMenuItem();
		    jMenuAccoes_LimparPagina.setText("Limpar Pgina");
		    jMenuAccoes_LimparPagina.addActionListener(new fmeFrame_jMenuAccoes_LimparPagina_actionAdapter(this));
		    jMenuAccoes_LimparPagina.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_LimparPagina;
	}
	private JMenuItem getJMenuAccoes_Limpar() {
		if (jMenuAccoes_Limpar == null) {
			jMenuAccoes_Limpar = new JMenuItem();
		    jMenuAccoes_Limpar.setText("Limpar Formulrio");
		    jMenuAccoes_Limpar.addActionListener(new fmeFrame_jMenuAccoes_Limpar_actionAdapter(this));
		    jMenuAccoes_Limpar.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_Limpar;
	}
	private JMenuItem getJMenuAccoes_ValidarPagina() {
		if (jMenuAccoes_ValidarPagina == null) {
			jMenuAccoes_ValidarPagina = new JMenuItem();
		    jMenuAccoes_ValidarPagina.setText("Validar Pgina");
		    jMenuAccoes_ValidarPagina.addActionListener(new fmeFrame_jMenuAccoes_ValidarPagina_actionAdapter(this));
		    jMenuAccoes_ValidarPagina.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_ValidarPagina;
	}
	private JMenuItem getJMenuAccoes_Validar() {
		if (jMenuAccoes_Validar == null) {
			jMenuAccoes_Validar = new JMenuItem();
		    jMenuAccoes_Validar.setText("Validar Formulrio");
		    jMenuAccoes_Validar.addActionListener(new fmeFrame_jMenuAccoes_Validar_actionAdapter(this));
		    jMenuAccoes_Validar.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_Validar;
	}
	private JMenuItem getJMenuAccoes_Enviar() {
		if (jMenuAccoes_Enviar == null) {
			jMenuAccoes_Enviar = new JMenuItem();
		    jMenuAccoes_Enviar.setText("Exportar Candidatura...");
		    jMenuAccoes_Enviar.addActionListener(new fmeFrame_jMenuFile_Send_actionAdapter(this));
		    jMenuAccoes_Enviar.setFont(fmeFrame.letra);
		}
		return jMenuAccoes_Enviar;
	}
	
	private JMenu getJMenuPagina() {
		if (jMenuPagina == null) {
			jMenuPagina = new JMenu();
			jMenuPagina.setText("Pgina");
			jMenuPagina.setMnemonic(KeyEvent.VK_P);
			jMenuPagina.setFont(fmeFrame.letra);
			Paginas.make_menu ( jMenuPagina, new fmeFrame_jMenuPagina_actionAdapter(this) );
		}
		return jMenuPagina;
	}

	public void remake_menu () {
		Paginas.make_menu ( jMenuPagina, new fmeFrame_jMenuPagina_actionAdapter(this) );		
	}
	
	private JMenu getJMenuHelp() {
		if (jMenuHelp == null) {
			jMenuHelp = new JMenu();
			jMenuHelp.setText("Ajuda");
			jMenuHelp.setMnemonic(KeyEvent.VK_J);
			jMenuHelp.add(getJMenuHelp_About());
			jMenuHelp.setFont(fmeFrame.letra);
		}
		return jMenuHelp;
	}

	private JMenuItem getJMenuHelp_About() {
		if (jMenuHelp_About == null) {
			jMenuHelp_About = new JMenuItem();
			jMenuHelp_About.setText("Acerca do Formulrio");
			jMenuHelp_About.addActionListener(new fmeFrame_jMenuHelp_About_ActionAdapter(this));
			jMenuHelp_About.setFont(fmeFrame.letra);
		}
		return jMenuHelp_About;
	}

	
//--------------------------------------------------------	
	void jMenuPagina_actionPerformed(ActionEvent e) {
	    CBData.__garbage_stop_editing();
	    String cmd = e.getActionCommand();
	    if ( cmd.equals("Primeiro")) Paginas.SelectFirst();
	    else if ( cmd.equals("Anterior")) Paginas.SelectPrevious();
	    else if ( cmd.equals("Seguinte")) Paginas.SelectNext();
	    else if ( cmd.equals("Ultimo")) Paginas.SelectLast();
	    else Paginas.SelectTag(cmd);
	    updateTitle();
	    jScrollPane.getViewport().add(Paginas.getFrame());
	    updateMenu();
	}
	public boolean jMenuFile_Exit_actionPerformed(ActionEvent e) {
		Object[] options = {"   Sim   ", "   No   "};
		int n = JOptionPane.showOptionDialog(jContentPane,
		                                         "Pretende encerrar o formulrio?",
		                                         "Sair",
		                                         JOptionPane.YES_NO_OPTION,
		                                         JOptionPane.QUESTION_MESSAGE,
		                                         null,
		                                         options,
		                                         options[0]);
		if (n == JOptionPane.YES_OPTION) {
			System.exit(0);
		    return true;
		}
		return false;
	}

	protected void processWindowEvent(WindowEvent e) {
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			if (jMenuFile_Exit_actionPerformed(null))
		        super.processWindowEvent(e);
		}
	}

	public void jMenuHelp_About_actionPerformed(ActionEvent e) {
		fmeAcerca acerca = new fmeAcerca();
	}

	String jMenuAccoes_ValidarPagina_actionPerformed(ActionEvent e) {
		this.contexto = "toolbar";
		CBData.__garbage_stop_editing();
		CHValid.reset(fme.fmeFrame.title);
		CHValid.add_pg_grp(((Pagina_Base) Paginas.getFrame()).validar_pg());
		return CHValid.show(false);
	}
	
	boolean jMenuFile_Save_actionPerformed(ActionEvent e, boolean saveAs, boolean after_send, boolean export) {
		String path = "";
		XmlFileFilter fileFilter = new XmlFileFilter();
		CBData.__garbage_stop_editing();
		CBData.extract();
		changeUIManager("Save");
		if ( ( CBData.exportado.equals("2") || CBData.ficheiro.equals("1") ) && ! after_send && ! saveAs ) {
			JOptionPane.showMessageDialog(jContentPane, "Esta candidatura j foi exportada!", "Guardar", 2);
		    return false;
		}

		try {
			if ( (this.LastFile == null || saveAs) && ! after_send ) {
		        JFileChooser jFileChooser = new JFileChooser();
		        File f = new File(new File(".").getCanonicalPath());
		        jFileChooser.setCurrentDirectory(f);
		        jFileChooser.setDialogTitle("Guardar Candidatura");
		        jFileChooser.addChoosableFileFilter(fileFilter);
		        int returnVal = jFileChooser.showSaveDialog(this);
		        if (returnVal == JFileChooser.APPROVE_OPTION) {
		          File file = jFileChooser.getSelectedFile();
		          if ( ! file.getAbsolutePath().endsWith(fileFilter.getExtension()) )
		            path = file.getAbsolutePath() + fileFilter.getExtension();
		          else
		            path = file.getAbsolutePath();
		          File file2 = new File (path);
		          if ( file2.exists() ){
		            Object[] options = {"   Sim   ", "   No   "};
		            int n = JOptionPane.showOptionDialog(jContentPane,
		                                                 "J existe um ficheiro com esse nome.\nDeseja sobrepr?",
		                                                 "Guardar como",
		                                                 JOptionPane.YES_NO_OPTION,
		                                                 JOptionPane.QUESTION_MESSAGE,
		                                                 null,
		                                                 options,
		                                                 options[1]);
		            if (n == JOptionPane.NO_OPTION) return false;
		          }
		          if ( saveAs && ! export ) {
		            CBData.exportado = "0";
		            CBData.T = "";
		            CBData.ficheiro = "0";
		            CBData.vs_old = CBData.vs;
		          }
		          CBData.xml_parser.saveInFile(file2);
		          this.LastFile = file2;
		          updateTitle();
		          return true;
		        }
		    }
		    else {
		        CBData.xml_parser.saveInFile(this.LastFile);
		        return true;
		    }
		}
		catch (Exception e3) {
			e3.printStackTrace();
		    JOptionPane.showMessageDialog(null, "Erro a guardar ficheiro!");
		}
		return false;
	}

	void jMenuAccoes_Limpar_actionPerformed(ActionEvent e) {
		this.contexto = "menu";
		Object[] options = {"   Sim   ", "   No   "};
		int n = JOptionPane.showOptionDialog(jContentPane,
		                                         "Os dados do formulrio vo ser eliminados.\nPretende continuar?",
		                                         "Limpar Formulrio",
		                                         JOptionPane.YES_NO_OPTION,
		                                         JOptionPane.QUESTION_MESSAGE,
		                                         null,
		                                         options,
		                                         options[1]);
		if ( n == JOptionPane.YES_OPTION ) {
			CBData.Clear();
		    this.LastFile = null;
		    updateTitle();
		}
	}

	void jMenuAccoes_LimparPagina_actionPerformed(ActionEvent e) {
		this.contexto = "toolbar";
		String msg = "Os dados desta pgina vo ser eliminados.\nPretende continuar?";
		Object[] options = {"   Sim   ", "   No   "};
		int n = JOptionPane.showOptionDialog(jContentPane, msg,
		                                         "Limpar Pgina",
		                                         JOptionPane.YES_NO_OPTION,
		                                         JOptionPane.QUESTION_MESSAGE,
		                                         null,
		                                         options,
		                                         options[1]);
		if (n == JOptionPane.YES_OPTION) {
			((Pagina_Base) Paginas.getFrame()).clear_page();
		    CBData.setDirty();
		    //this.LastFile = null;
		    //updateTitle();
		}
	}

	
	//#01 adaptar para ler antes de CBDATA
	void jMenuFile_Open_actionPerformed(ActionEvent e) {
		if ( CBData.dirty ) {
			Object[] options = {"   Sim   ", "   No   ", " Cancelar "};
		    int n = JOptionPane.showOptionDialog(jContentPane,
		                                         "Pretende guardar as alteraes efectuadas?",
		                                         "Antes de abrir...",
		                                         JOptionPane.YES_NO_CANCEL_OPTION,
		                                         JOptionPane.QUESTION_MESSAGE,
		                                         null,
		                                         options,
		                                         options[0]);
		    if ( n == JOptionPane.CANCEL_OPTION ) return;
		    if ( n == JOptionPane.YES_OPTION )
		    	this.jMenuFile_Save_actionPerformed(e, false, false, false);
		    if ( n == JOptionPane.NO_OPTION )
		        this.LastFile = null;
		    CBData.Clear();
		}

		//if ( fmeMain.Config != null )	//#01
		//	CBData.Clear();
		//changeUIManager("Open");

		JFileChooser jFileChooser = new JFileChooser();
		try {
			File f = new File(new File(".").getCanonicalPath());
		    jFileChooser.setCurrentDirectory(f);
		    jFileChooser.setDialogTitle("Abrir Candidatura");
		    jFileChooser.addChoosableFileFilter(new XmlFileFilter());
		    int returnVal = jFileChooser.showOpenDialog(this);
		    if (returnVal == JFileChooser.APPROVE_OPTION) {
		    	CBData.Clear();
		        File file = jFileChooser.getSelectedFile();

		        if ( fmeMain.Config == null ) {		        
		        	JOptionPane.showMessageDialog(null, "parse noconfig");
		        	CBData_Noconfig.xml_parser.Open(file);
		        	
		        	if  ( fmeMain.Config != null ) {
		        		JOptionPane.showMessageDialog(null, "montar: " + fmeMain.Config);
		        		this.mount_new_config( fmeMain.Config );
		        	}
		        }
		        if ( fmeMain.Config == null ) {
		        	JOptionPane.showMessageDialog(null, "no deu...");
		        	return;
		        }
		        
		        CBData.before_open();
		        CBData.xml_parser.Open(file);
		        CBData.after_open();
		    }
		} catch (Exception e2){
	         e2.printStackTrace();
		      JOptionPane.showMessageDialog(null, "Erro ao abrir o ficheiro!");
		}
		updateTitle();
	}

	void jMenuFile_Imprimir_actionPerformed(ActionEvent e) {
		fmeFrame.contexto = "menu";
		CHPrint.show();
	}

	void jMenuFile_ImprimirPagina_actionPerformed(ActionEvent e) {
		this.contexto = "toolbar";
		((Pagina_Base) Paginas.getFrame()).print_page();
	}

	static String jMenuAccoes_Validar_actionPerformed(ActionEvent e) {
		fmeFrame.contexto = "menu";
		CBData.__garbage_stop_editing();
		CHValid.reset(fme.fmeFrame.title);
		for (int i=0; i<fmeFrame.Paginas.size();i++){
			Pagina_Base p = (Pagina_Base) fmeFrame.Paginas.getPage(i);
			CHValid.add_pg_grp(p.validar_pg());
		}
		/* CHValid.add_pg_grp(P01.validar_pg());
		CHValid.add_pg_grp(P07.validar_pg());
		CHValid.add_pg_grp(P03.validar_pg());
		CHValid.add_pg_grp(P16.validar_pg());
		CHValid.add_pg_grp(P08.validar_pg());
		CHValid.add_pg_grp(P13.validar_pg());
		CHValid.add_pg_grp(P15.validar_pg());
		CHValid.add_pg_grp(P14.validar_pg());
		CHValid.add_pg_grp(P12.validar_pg()); */

		return CHValid.show(true);
	}

	void jMenuFile_Send_actionPerformed(ActionEvent e) {
		if ( !CBData.exportado.equals("2") && CBData.ficheiro.equals("1") &&
				CBData.vs_old.substring(0,4).compareTo(CBData.vs.substring(0,4)) < 0 ){
	      	JOptionPane.showMessageDialog(null, "Foi criado um ficheiro com uma verso anterior  do formulrio actual!\n"+
		                                    "Para exportar a sua candidatura dever:\n"+
		                                    "   1) utilizar a opo \"Ficheiro|Guardar como...\" para gravar um novo ficheiro;\n"+
		                                    "   2) proceder  exportao do mesmo.",
		                                    "Aviso",
		                                    JOptionPane.WARNING_MESSAGE);
	      	return;
	  	}

	   	if ( CBData.exportado.equals("2") || CBData.ficheiro.equals("1") ) {
			CHEnvio.envio(this);
	   		return;
	   	}
	   	String vld = jMenuAccoes_Validar_actionPerformed(e);
	   	if ( CHValid.n_erros > 0 || vld.equals("G")) return;
	   	CBData.exportado = "1";
	   	if ( ! jMenuFile_Save_actionPerformed(e, true, false, true) ) return;
	   	CHEnvio.envio(this);
	}
	
	void changeUIManager (String operacao){
		UIManager.put("FileChooser.font", fmeFrame.letra);

		UIManager.put("FileChooser.fileNameLabelMnemonic", new Integer('N'));
		UIManager.put("FileChooser.fileNameLabelText", "Nome do ficheiro:");

		UIManager.put("FileChooser.filesOfTypeLabelMnemonic", new Integer('T'));
		UIManager.put("FileChooser.filesOfTypeLabelText", "Tipo do ficheiro:");

		UIManager.put("FileChooser.upFolderToolTipText", "Um nvel acima");
		UIManager.put("FileChooser.upFolderAccessibleName", "Um nvel acima");

		UIManager.put("FileChooser.homeFolderToolTipText", "Desktop");
		UIManager.put("FileChooser.homeFolderAccessibleName", "Desktop");

		UIManager.put("FileChooser.newFolderToolTipText", "Criar nova pasta");
		UIManager.put("FileChooser.newFolderAccessibleName", "Criar nova pasta");

		UIManager.put("FileChooser.listViewButtonToolTipText", "Lista");
		UIManager.put("FileChooser.listViewButtonAccessibleName", "Lista");

		UIManager.put("FileChooser.detailsViewButtonToolTipText", "Detalhes");
		UIManager.put("FileChooser.detailsViewButtonAccessibleName", "Detalhes");

		UIManager.put("FileChooser.cancelButtonToolTipText", "");
		UIManager.put("FileChooser.cancelButtonText", "Cancelar");

		//UIManager.put("FileChooser.fileNameHeaderText", "Nome");
		//    UIManager.put("FileChooser.fileSizeHeaderText", "Tamanho");
		//    UIManager.put("FileChooser.fileTypeHeaderText", "Tipo");
		//    UIManager.put("FileChooser.fileDateHeaderText", "Data");
		//    UIManager.put("FileChooser.fileAttrHeaderText", "Atributos");

		if (operacao.equals("Open")) {
			UIManager.put("FileChooser.lookInLabelText", "Procurar em:");
		    UIManager.put("FileChooser.openButtonToolTipText", "Abrir ficheiro seleccionado");
		    UIManager.put("FileChooser.openButtonText", "Abrir");
		}
		if (operacao.equals("Save")) {
		    UIManager.put("FileChooser.saveInLabelText", "Guardar em:");
		    UIManager.put("FileChooser.saveButtonToolTipText", "Guardar ficheiro seleccionado");
		    UIManager.put("FileChooser.saveButtonText", "Guardar");
		}
	}

}

interface Pagina_Base extends Printable {
	  void print_page();
	  void clear_page();
	  CHValid_Grp validar_pg( );
	  Dimension getSize();
	  void set_params ( String tag, HashMap params ); 
}

class PgHandler {
	Vector Paginas = new Vector();
	fmePagina pg = null;
	int npg = 0;
	
	int size(){
		return Paginas.size();
	}
	void clear() {
		Paginas.clear();
		fmePagina pg = null;
		npg = 0;		
	}
	
	void delete ( String tag ) {
		int i;
		for (  i = 0; i < Paginas.size(); i++ ) {
			fmePagina f = (fmePagina) Paginas.elementAt(i);
			if ( f.tag.equals(tag) ) break;
	    }
		Paginas.removeElementAt(i);		
	}
	
	void add ( JInternalFrame frame,  String tag, String caption ) {
		fmePagina p = new fmePagina();
	    p.caption = caption;
	    p.tag = tag;
	    p.frame = frame;

	    // tirar a barra da frame
	    ( (javax.swing.plaf.basic.BasicInternalFrameUI) frame.getUI()).setNorthPane(null);

	    // frame visvel
	    frame.setVisible(true);
	    
	    Paginas.addElement( p );
	}

	void add_after ( String i_tag, JInternalFrame frame,  String tag, String caption ) {

		int i;
		for (  i = 0; i < Paginas.size(); i++ ) {
			fmePagina f = (fmePagina) Paginas.elementAt(i);
			if ( f.tag.equals(i_tag) ) break;
	    }
		fmePagina p = new fmePagina();
	    p.caption = caption;
	    p.tag = tag;
	    p.frame = frame;

	    // tirar a barra da frame
	    ( (javax.swing.plaf.basic.BasicInternalFrameUI) frame.getUI()).setNorthPane(null);

	    // frame visvel
	    frame.setVisible(true);

	    
	    //JOptionPane.showMessageDialog(null, "inserir em " + i );
	    Paginas.insertElementAt( p, i+1 );
	    //JOptionPane.showMessageDialog(null, "inserido!");
	    
	}
	

	void make_menu ( JMenu pg, fmeFrame_jMenuPagina_actionAdapter ac ) {
	    
		//limpar !?
		pg.removeAll();
		
		//
		int n = Paginas.size();
	    JMenuItem item = new JMenuItem();
	    int i = 0;
	    int x = i;
	    int z = 0;
	    for ( i = 0; i < n; i++ ) {
	      fmePagina f = (fmePagina) Paginas.elementAt(i);
	      item = new JMenuItem();
	      f.menuItem = item;
	      //System.out.print(f.tag+"\n");
	      if (f.tag.endsWith("_N")){
	    	  z++;
	      }else{
	    	  x++;
	    	  z = 0;
	      }
	      //f.n_pag = "Pgina " + x+((z>0)?("."+z):"");
	      //item.setText( f.n_pag +" - "+ f.caption );
	      item.setText( f.caption );
	      item.setActionCommand( f.tag );
	      item.addActionListener( ac );
	      item.setFont(fmeFrame.letra);
	      pg.add( item );
	    }
	}

	void SelectTag ( String tag ) {
	    for ( int i = 0; i < Paginas.size(); i++ ) {
	      fmePagina f = (fmePagina) Paginas.elementAt(i);
	      if ( f.tag.equals(tag) ) {
	        Select(i);
	        return;
	      }
	    }
	}

	JInternalFrame getPage ( String tag ) {
	    for ( int i = 0; i < Paginas.size(); i++ ) {
	      fmePagina f = (fmePagina) Paginas.elementAt(i);
	      if ( f.tag.equals(tag) )
	        return f.frame;
	    }
	    return null;
	}
	JInternalFrame getPage ( int n ) {
		fmePagina f = (fmePagina) Paginas.elementAt(n);
	    return f.frame;
	}

	// estranha forma de chegar l ...
	void GoTo ( String tag ) {
	    String s = pg.frame.getParent().getParent().getParent().getParent().getParent().getParent().getClass().getName();
	    //JOptionPane.showMessageDialog( null, "parent: " + s);
	    Object f = pg.frame.getParent().getParent().getParent().getParent().getParent().getParent();
	    if ( f instanceof fmeFrame ) {
	      //JOptionPane.showMessageDialog( null, "Mudar para a pgina " + tag);
	      ((fmeFrame) f).select_page( tag);
	      ((fmeFrame) f).show();
	    }
	}

	void Select ( int n ) {
    	//JOptionPane.showMessageDialog( null, "Seleccionar pgina " + n);
	    pg = (fmePagina) Paginas.elementAt(n);
	    npg = n;
	    
	    for ( int i = 0; i < Paginas.size(); i++ ) {
		    fmePagina f = (fmePagina) Paginas.elementAt(i);
		    f.menuItem.setEnabled( i != npg );
	    }
	}

	void SelectNext() {
	    if ( npg < Paginas.size() -1 ) Select ( npg + 1);
	}

	void SelectPrevious() {
	    if ( npg > 0 ) Select ( npg - 1);
	}

	void SelectFirst() {
	    Select(0);
	}

	void SelectLast() {
	    Select( Paginas.size() -1 );
	}

	JInternalFrame getFrame () {
		return pg.frame;
	}

	String getCaption () {
	    return pg.caption;
	}

	String getTag () {
	    return pg.tag;
	}

	String getNPagina (String tag){
	    for (int i = 0; i < Paginas.size(); i++) {
	    	fmePagina f = (fmePagina) Paginas.elementAt(i);
	    	if ( f.tag.equals(tag) )
		        return f.n_pag;
	    }
	    return "";
	}
	
	String getCaption (String tag) {
	    for (int i = 0; i < Paginas.size(); i++) {
	      fmePagina f = (fmePagina) Paginas.elementAt(i);
	      if ( f.tag.equals(tag) )
	        return f.caption;
	    }
	    return "";
	}


	  // para se fazer a caption para CHValidar
	String getCaption (int n){
	    fmePagina f = (fmePagina) Paginas.elementAt(n);
	    return f.caption;
	}

	String getTag (int n) {
	    fmePagina f = (fmePagina) Paginas.elementAt(n);
	    return f.tag;
	}

	boolean isFirst() {
	    return npg == 0;
	}

	boolean isLast() {
	    return npg == Paginas.size()-1;
	}
}

class fmeFrame_jMenuFile_Exit_ActionAdapter implements ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_Exit_ActionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuFile_Exit_actionPerformed(e);
	}
}

class fmeFrame_jMenuHelp_About_ActionAdapter implements ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuHelp_About_ActionAdapter(fmeFrame adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuHelp_About_actionPerformed(e);
	}
}
class fmeFrame_jMenuFile_Save_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_Save_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuFile_Save_actionPerformed(e, false, false, false);
	}
}

class fmeFrame_jMenuFile_SaveAs_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_SaveAs_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuFile_Save_actionPerformed(e, true, false, false);
	}
}

class fmeFrame_jMenuAccoes_Limpar_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuAccoes_Limpar_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.jMenuAccoes_Limpar_actionPerformed(e);
	}
}

class fmeFrame_jMenuAccoes_LimparPagina_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuAccoes_LimparPagina_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuAccoes_LimparPagina_actionPerformed(e);
	}
}

class fmeFrame_jMenuFile_Open_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_Open_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuFile_Open_actionPerformed(e);
	}
}

class fmeFrame_jMenuFile_ImprimirPagina_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_ImprimirPagina_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
		adaptee.jMenuFile_ImprimirPagina_actionPerformed(e);
	}
}

class fmeFrame_jMenuFile_Imprimir_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_Imprimir_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuFile_Imprimir_actionPerformed(e);
	}
}


class fmeFrame_jMenuFile_Send_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuFile_Send_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	      adaptee.jMenuFile_Send_actionPerformed(e);
	}
}

class fmeFrame_jMenuAccoes_Validar_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuAccoes_Validar_actionAdapter(fmeFrame adaptee) {
	    this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    if (adaptee.jMenuAccoes_Validar_actionPerformed(e).equals("-"))
	      JOptionPane.showMessageDialog(null, "No foram detectados erros.", "Validaes Globais", 1);
	}
}

class fmeFrame_jMenuAccoes_ValidarPagina_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;
	fmeFrame_jMenuAccoes_ValidarPagina_actionAdapter(fmeFrame adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    if ( adaptee.jMenuAccoes_ValidarPagina_actionPerformed(e).equals("-"))
	      JOptionPane.showMessageDialog(null, "No foram detectados erros.", "Validaes da Pgina", 1);
	}
}

class fmeFrame_jMenuPagina_actionAdapter implements java.awt.event.ActionListener {
	fmeFrame adaptee;

	fmeFrame_jMenuPagina_actionAdapter(fmeFrame adaptee) {
		this.adaptee = adaptee;
	}
	public void actionPerformed(ActionEvent e) {
	    adaptee.jMenuPagina_actionPerformed(e);
	}
}

class fmePagina {
  public String tag;
  public String caption;
  public String n_pag;
  public JMenuItem menuItem;
  public JInternalFrame frame;
}

class XmlFileFilter extends javax.swing.filechooser.FileFilter {
	String ext = CParseConfig.hconfig.get("extensao")+"";
	public XmlFileFilter (){
		super();
	}
	
	public boolean accept(File file) {
		boolean accept = file.isDirectory();

		if(! accept) {
			String suffix = getSuffix(file);

			if(suffix != null)
				accept = suffix.equals(ext);
		}
		return accept;
	}

	public String getDescription() {
		return "Candidaturas(."+ext+")";
	}

	public String getExtension() {
		return "."+ext;
	}


	private String getSuffix(File f) {
		String s = f.getPath(), suffix = null;
		int i = s.lastIndexOf('.');

		if(i > 0 && i < s.length() - 1)
			suffix = s.substring(i+1).toLowerCase();

		return suffix;
	}
}

//----------------------------------------------------------------
//
//----------------------------------------------------------------

class CParseConfig extends DefaultHandler {
	
	  static HashMap hconfig = new HashMap();
	
	  StringBuffer textBuffer;
	  int Status;                      // 1 - tag iniciado
	  String a_tag;
	  String path = new String("/");

	  String pagina;
	  String classe;
	  String titulo;
	  HashMap params = null; //new HashMap();
	  
	  public CParseConfig() {
	    Status = 0;
	  }

	  void _path_grow( String tag ) {
	      path = path + "/" + tag;
	      //JOptionPane.showMessageDialog(null,"GROW <" + path + ">");
	  }

	  void _path_back( String tag ) {
	      path = path.substring(0,path.length()-tag.length()-1);
	      //JOptionPane.showMessageDialog(null,"BACK <" + path + ">");
	  }
	public void startDocument() throws SAXException {
	}

	public void endDocument() throws SAXException {
	}

	public void startElement(String namespaceURI,
	                         String sName, // simple name
	                         String qName, // qualified name
	                         Attributes attrs) throws SAXException {
	    if ( Status == 1 ) {
	        _path_grow(a_tag);
	        //JOptionPane.showMessageDialog(null, "begin: " + path );
	    }
	    a_tag = qName;
	    Status = 1;
	    textBuffer = null;  // !?
	}

	public void endElement(String namespaceURI,
	                         String sName, // simple name
	                         String qName // qualified name
	                         ) throws SAXException {
	    if ( Status == 1 && qName == a_tag ) {
	        String v;
	        if ( textBuffer == null ) v = "";
	        else v = textBuffer.toString();
	        //JOptionPane.showMessageDialog(null, "path=" + path + "; tag=" + qName + ";v=" + v );
	        
	        if ( path.equals("//fme-config/paginas/reg") && qName.equals("pagina") ) {
	        	pagina = v;
	        	//JOptionPane.showMessageDialog(null, "Montar " + pagina );
	        }
	        if ( path.equals("//fme-config/paginas/reg") && qName.equals("classe") ) {
	        	classe = v;
	        	//JOptionPane.showMessageDialog(null, "Montar " + pagina );
	        }
	        if ( path.equals("//fme-config/paginas/reg") && qName.equals("titulo") ) {
	        	titulo = v;
	        	//params.clear();
	        	params = new HashMap();
	        }
		    if ( path.equals("//fme-config/paginas/reg/params") ) {
		    	//JOptionPane.showMessageDialog(null, qName + "=" + v);
		        params.put( qName, v);
	        }
		    if ( path.equals("//fme-config/tabelas")) {
		    	//JOptionPane.showMessageDialog(null, "Tab " + qName + "->" + v);
		    	CTabelas.mount_cfg_table(qName, v);
		    }		    
		    if ( path.equals("//fme-config/hconfig")) {
		    	//JOptionPane.showMessageDialog(null, "hconfig " + qName + "->" + v);
		    	this.hconfig.put(qName, v);
		    	
		    	if ( qName.equals("fme-config")) {
		    		fmeMain.Config = v;
		    	}
		    } 
	    }

	    if ( Status == 0 ) {
	        if ( path.equals("//fme-config/paginas/reg")) {
	        	//JOptionPane.showMessageDialog(null, "Add...");
	        	
	            /*----------------MONTAR PAGINA---------------------------------*/	
				try {
					Object p = Class.forName("fme.Frame_" + classe).newInstance();
					Dimension d = ((Pagina_Base)p).getSize();
				    ((JInternalFrame)p).setPreferredSize( d );
				    fmeFrame.Paginas.add( (JInternalFrame)p, pagina, titulo );
				    ((Pagina_Base)p).set_params ( pagina, params );
				} catch ( Exception e ) {
					JOptionPane.showMessageDialog(null, "Config (" + classe + "):"+ e.toString());
				}	
				/*-----------------------------------------------------------*/
	        }	
	        _path_back(qName);
	    }
	    Status = 0;
	    textBuffer = null;
	}

	public void characters(char buf[], int offset, int len) throws SAXException {
	    String s = new String(buf, offset, len);
	    if (textBuffer == null) {
	         textBuffer = new StringBuffer(s);
	    } else {
	      textBuffer.append(s);
	    }
	    //JOptionPane.showMessageDialog(null, "Caracteres: " + textBuffer);
	}
}

